-- ## Imports ## --

local Filter = require "GameEx.Foundations.Filter"

-- ## Imports ## --

local PropertyFilter = class("PropertyFilter", Filter:create())

function PropertyFilter:__equal(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return property_value == value

	else

		return false

	end

end

function PropertyFilter:__unequal(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return not (property_value == value)

	else

		return false

	end

end

function PropertyFilter:__more(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return property_value > value

	else

		return false

	end

end

function PropertyFilter:__less(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return property_value < value

	else

		return false

	end

end

function PropertyFilter:__nomore(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return property_value <= value

	else

		return false

	end

end

function PropertyFilter:__noless(key, value)

	if self.__c_target:get_property(key) then

		local property_value = self.__c_target:get(key) 

		return property_value >= value

	else

		return false

	end

end

return PropertyFilter
