-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local UtilFunction = require "GameEx.Foundations.Utils.Function"

-- ## Imports ## --

local TotalRemover = class("TotalRemover", function() return GameObject:create() end)

function TotalRemover:ctor()

	self:register_listeners_with_config(TotalRemover.LISTENER_CONFIG)
	self:register_properties_with_config(TotalRemover.PROPERTY_CONFIG)

end


function TotalRemover:on_assign(c_msg)

	local task = c_msg.x_param

	local removed = {}

	for i = 1, #task do

		local sugar = task[i]

		if sugar:get("state") == "normal" or "locked" then

			removed[#removed + 1] = sugar

		end

		self:trigger_remove(sugar)

	end

	self.__c_parent:send_message(MessagePool:get_free_ex("finish_remove", removed))

end

function TotalRemover:trigger_remove(sugar)

	self.__c_parent:send_message(MessagePool:get_free_ex("sugar_remove", sugar))
	sugar:send_message(MessagePool:get_free_ex("start_remove", "", Message.N_TUNNEL))

end

function TotalRemover:trigger_ignite(sugar)

	sugar:send_message(MessagePool:get_free_ex("ignite"))

end


TotalRemover.LISTENER_CONFIG = {

	{"assign_remove_task", {before = TotalRemover.on_assign}},

}

TotalRemover.PROPERTY_CONFIG = {
	


}

return TotalRemover