-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local GameGlobals = require "GameEx.GameGlobals"
local TargetHandler = require "GameEx.Components.Scene.TargetHandler"

-- ## Imports ## --

local TargetHandlerTournament = class("TargetHandlerTournament", function() return TargetHandler:create() end)

function TargetHandler:get_goal_color(c_sugar)

	if GameGlobals.Scene:get("has_boss") then

		local boss = GameGlobals.Scene:get_component("boss")

		if boss:get("state") == "disappeared" then

			return 

		end

	end

	local goals = GameGlobals.Scene:get("level_config").reqs

	for color, number in pairs(goals) do

		if c_sugar:get_category():has(color) then

			return color

		end

	end

	return nil

end

return TargetHandlerTournament