local RandomDraw = require "GameEx.Foundations.Utils.RandomDrawArrayWithProb"
local RandomGenerator = require "GameEx.Foundations.Utils.RandomGenerator"



local TournamentProgresser = class("TournamentProgresser")

function TournamentProgresser:ctor()

	self:load_config()

end

function TournamentProgresser:load_config()

	self.__t_tournament_config = require "GameEx.Resources.Levels.Tournament.TournamentConfig"

end

function TournamentProgresser:start()

	self.__n_current_difficulty_index = 0
	self:get_next_difficulty()

end

function TournamentProgresser:stop()



end

function TournamentProgresser:get_next_level()

	local current_difficulty = self.__t_tournament_config["difficulty"][self.__n_current_difficulty_index]

	local distribute = self.__t_tournament_config["distribute"][current_difficulty]

	if self.__n_current_repeat == distribute["repeat"] then

		self:get_next_difficulty()
		return self:get_next_level()

	else

		local index = self.__c_drawer:draw_next_repeat()
print(string.format("TOURNAMENT INDEX : %d", index))
		self.__n_current_repeat = self.__n_current_repeat + 1

		return string.format("GameEx.Resources.Levels.Tournament.%s.week_%d", current_difficulty, index)

	end

end

function TournamentProgresser:get_next_difficulty()

	self.__n_current_difficulty_index = self.__n_current_difficulty_index + 1

	local current_difficulty = self.__t_tournament_config["difficulty"][self.__n_current_difficulty_index]
	local distribute = self.__t_tournament_config["distribute"][current_difficulty]
print(string.format("TOURNAMENT RANDOM : %d", TournamentProgresser.random_generator:rand(1, 100)))
-- ERROR_ASSERT(false, "string")
	self.__c_drawer = RandomDraw:create(TournamentProgresser.random_generator)
	self.__c_drawer:set_target(distribute["prob"])

	self.__n_current_repeat = 0

end

function TournamentProgresser:get_instance()

	if not TournamentProgresser.instance then

		TournamentProgresser.instance = TournamentProgresser:create()
		TournamentProgresser.random_generator = RandomGenerator:create()
		TournamentProgresser.random_generator:seed(os.time())

	end

	return TournamentProgresser.instance

end

return TournamentProgresser
