-- ## Imports ## --

require "core.Section_Data"
require "UI.Layer.GameBackgroundLayer"
local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameGlobals = require "GameEx.GameGlobals"
local StateMachine = require "GameEx.Foundations.Utils.StateMachineRevised"
local UIComponent = require "GameEx.Components.Scene.UIComponent"

-- ## Imports ## --


local UIComponentTournament = class("UIComponentTournament", function() return UIComponent:create() end)


function UIComponentTournament:ctor()

	self:register_listeners_with_config(UIComponentTournament.LISTENER_CONFIG)
	self:register_properties_with_config(UIComponentTournament.PROPERTY_CONFIG)

end

function UIComponentTournament:on_assemble()
-- ERROR_ASSERT(false, "string")
	UIComponent.on_assemble(self)

	local scene = self.__c_parent
	local cc_scene = scene.__c_scene

	-- self.__c_counter_label = cc.Label:createWithTTF("0", "font/zh_CN.TTF", 25)
	-- self.__c_counter_label:setColor(cc.c3b(255, 0, 0))
	-- self.__c_counter_label:setPosition(cc.p(850, 1800))
	-- cc_scene:addChild(self.__c_counter_label, 10)

	self.__c_bg:getChildByName("game_bkg"):setTexture(ResourceManager:getInstance():getPicturePathByKey("GAME_BKG_WATER"))

end

function UIComponentTournament:win()

	self.__c_ui:disable_touch()
	
	local function after_animation()

		-- self.__c_ui:resetGameTournament()

		local delay = cc.DelayTime:create(0.3)
		local call = cc.CallFunc:create(function() GameGlobals.Scene:send_message(MessagePool:get_free_ex("tournament_reward")) end)
		local sequence = cc.Sequence:create(delay, call)

		GameGlobals.Scene:runAction(sequence)		

	end

	self.__c_ui:play_battle_win_animation(after_animation)	

end

-- function UIComponentTournament:lose()

-- 	self.__c_ui:disable_touch()
	
-- 	local function after_animation()
-- -- ERROR_ASSERT(false, "string")
-- 		local delay = cc.DelayTime:create(0.5)
-- 		local call = cc.CallFunc:create(function() self.__c_state_machine:do_transition("bonus") end)
-- 		local sequence = cc.Sequence:create(delay, call)

-- 		GameGlobals.Scene:runAction(sequence)

-- 	end

-- 	self.__c_ui:play_battle_win_animation(after_animation)		

-- end

function UIComponentTournament:on_add_target(c_msg)

	for i = 1, c_msg.x_param do

		self.__c_ui:play_candy_collect_animation("conch")

	end

end

function UIComponentTournament:on_refresh_board(c_msg)

	self.__c_ui:resetGameTournament(c_msg.x_param)

end

UIComponentTournament.LISTENER_CONFIG = {

	{"assemble", {before = UIComponentTournament.on_assemble}},
	{"update_conch", {before = UIComponentTournament.on_update_conch}},
	{"add_target", {before = UIComponentTournament.on_add_target}},
	{"refresh_board", {before = UIComponentTournament.on_refresh_board}},

}

UIComponentTournament.PROPERTY_CONFIG = {
	


}

return UIComponentTournament