-- ## Imports ## --

local GameObject = require "GameObject"

-- ## Imports ## --




local ScriptComponent = class("ScriptComponent", function() return GameObject:create() end)

ScriptComponent.t_listeners = {
	
	{s_event_name = "create", t_listener = {before = ScriptComponent.on_create}}
	{s_event_name = "assemble", t_listener = {before = ScriptComponent.on_assemble}}
	{s_event_name = "disassemble", t_listener = {before = ScriptComponent.on_disassemble}}

}

function ScriptComponent:on_create()

	self.__t_loadedFile = nil

	self:register_listeners_with_config(ScriptComponent.t_listeners)

end

function ScriptComponent:on_assemble()

	self:attachProperties()
	self:attachListeners()

end

function ScriptComponent:on_disassemble()

	self:detachProperties()
	self:detachProperties()

end

function ScriptComponent:init_with_file(s_file_name)

	self.__t_loadedFile = require "s_file_name"

end

function ScriptComponent:attach_properties()

	if self.__t_loadedFile and self.__t_loadedFile.t_config_properties then

		self.__c_parent:register_properties_with_config(self.__t_loadedFile.t_config_properties)

	end

end

function ScriptComponent:attach_listeners()

	if self.__t_loadedFile and self.__t_loadedFile.t_config_listeners then

		self.__c_parent:register_listeners_with_config(self.__t_loadedFile.t_config_listeners)

	end

end

return ScriptComponent