-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local GameGlobals = require "GameEx.GameGlobals"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local ResourceManager = require "GameEx.Foundations.ResourceManager"

-- ## Imports ## --




local MoveSkill = class("MoveSkill", function() return GameObject:create() end)


function MoveSkill:ctor()

	self:register_listeners_with_config(MoveSkill.LISTENER_CONFIG)
	self:register_properties_with_config(MoveSkill.PROPERTY_CONFIG)

end

function MoveSkill:on_perform_skill(c_msg)

    local visible_size = cc.Director:getInstance():getVisibleSize()

    GameGlobals.Scene:send_message(MessagePool:get_free_ex("item_used", "MoveSkill", Message.N_TUNNEL))

	GameGlobals.Scene:send_message(MessagePool:get_free_ex("item_remove_start"))

    GameGlobals.Scene:send_message(MessagePool:get_free_ex("item_add_move", self:get("change_number"), Message.N_TUNNEL))

	GameGlobals.Scene:send_message(MessagePool:get_free_ex("start_action", "", Message.N_TUNNEL))

    local position1 = cc.p(visible_size.width / 2 + 390, 150)
    local position2 = cc.p(visible_size.width / 2 - 370, 1500)
    local light_particle = ResourceManager:get_instance():get_resource_by_key("skill_flying_particle")
    light_particle:setPosition(position1)
    light_particle:setDuration(-1)
    light_particle:setLocalZOrder(99)
    light_particle:setVisible(false)

    light_particle:runAction(cc.Sequence:create(cc.MoveTo:create(29 * 0.033, cc.p(position2.x, position2.y)), cc.CallFunc:create(function()

            local light2_particle = ResourceManager:get_instance():get_resource_by_key("bonus_remove_particle")
            light2_particle:setAutoRemoveOnFinish(true)
            light2_particle:setPosition(cc.p(visible_size.width / 2 - 360, 1580))
            
            GameGlobals.Scene:send_message(MessagePool:get_free_ex("normal_add_child", light2_particle))

            GameGlobals.Scene:send_message(MessagePool:get_free_ex("add_move", 5))

            light_particle:setDuration(0.1)
            light_particle:setAutoRemoveOnFinish(true)

            GameGlobals.Scene:send_message(MessagePool:get_free_ex("finish_action", "", Message.N_TUNNEL))

            GameGlobals.Scene:send_message(MessagePool:get_free_ex("move_skill_hit", "", Message.N_TUNNEL))

    end)))

    GameGlobals.Scene:send_message(MessagePool:get_free_ex("normal_add_child", light_particle))

end


MoveSkill.LISTENER_CONFIG = {

	{"perform", {before = MoveSkill.on_perform_skill}},

}

MoveSkill.PROPERTY_CONFIG = {
	
	{"homing_speed", 30}

}


return MoveSkill