-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"

-- ## Imports ## --




local BarrierSugar = class("BarrierSugar", function() return GameObject:create() end)


function BarrierSugar:ctor()

	local box_collider = ObjectFactory:get_instance():get("BoxCollider")
	self:add_component(box_collider, "collider")

	local visual = ObjectFactory:get_instance():get("BarrierSugarVisual")
	self:add_component(visual, "visual")

	self:register_listeners_with_config(BarrierSugar.LISTENER_CONFIG)
	self:register_properties_with_config(BarrierSugar.PROPERTY_CONFIG)

end

function BarrierSugar:on_destroy()



end

function BarrierSugar:on_reset()



end

function BarrierSugar:on_select()
	


end

function BarrierSugar:on_deselect()



end

function BarrierSugar:on_start_remove()



end

function BarrierSugar:on_finish_remove()



end

function BarrierSugar:after_set_rotation(c_msg)

	self:setRotation(c_msg.x_param.x_new_value)

end

function BarrierSugar:after_set_id(c_msg)

	self:setName(c_msg.x_param.x_new_value)

end

BarrierSugar.LISTENER_CONFIG = {

	

}

BarrierSugar.PROPERTY_CONFIG = {
	
	{"rotation", 0},
	{"id", "barrier"},

}

return BarrierSugar