-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local RandomDraw = require "GameEx.Foundations.Utils.RandomDrawArray"
local GameGlobals = require "GameEx.GameGlobals"

-- ## Imports ## --


local GiftSugarManager = class("GiftSugarManager", function() return GameObject:create() end)


function GiftSugarManager:ctor()

	self:register_listeners_with_config(GiftSugarManager.LISTENER_CONFIG)
	self:register_properties_with_config(GiftSugarManager.PROPERTY_CONFIG)

end

function GiftSugarManager:on_gift_check()

	local param = {

		t_category_filter = {
			type = "and",
			{"gift", "=", true},	
		},

	}

	local msg = MessagePool:get_free()
	msg.c_sender = self
	msg.s_name = "query_filter"
	msg.x_param = param

	GameGlobals.Scene:send_message(msg)

	local select_result = msg.x_result

	for _, gift in ipairs(select_result) do
-- ERROR_ASSERT(false, "string")
		gift:send_message(MessagePool:get_free_ex("open", "", Message.N_TUNNEL))

	end

end

GiftSugarManager.LISTENER_CONFIG = {

	{"gift_check", {before = GiftSugarManager.on_gift_check}}		

}

GiftSugarManager.PROPERTY_CONFIG = {
	


}

return GiftSugarManager