-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local RandomDraw = require "GameEx.Foundations.Utils.RandomDrawArray"
local GameGlobals = require "GameEx.GameGlobals"

-- ## Imports ## --




local FractureManager = class("FractureManager", function() return GameObject:create() end)


function FractureManager:ctor()

	self:register_listeners_with_config(FractureManager.LISTENER_CONFIG)
	self:register_properties_with_config(FractureManager.PROPERTY_CONFIG)

	self.__t_sugars = {}

end

function FractureManager:on_remove_sugar(c_msg)

	self.__t_sugars[c_msg.x_param] = nil

end

function FractureManager:on_add_sugar(c_msg)

	if c_msg.x_param:get_category():has("rimmed") then

		self.__t_sugars[c_msg.x_param] = c_msg.x_param

	end

end

function FractureManager:on_link_remove_start(c_msg)

	for key, value in pairs(self.__t_sugars) do

		value:send_message(c_msg)

	end	

end

function FractureManager:on_link_remove_finish(c_msg)

	for key, value in pairs(self.__t_sugars) do

		value:send_message(c_msg)

	end

end

function FractureManager:on_trigger_indicate(c_msg)

	for key, value in pairs(self.__t_sugars) do

		value:send_message(c_msg)

	end	

end


FractureManager.LISTENER_CONFIG = {

	{"add_sugar", {before = FractureManager.on_add_sugar}},
	{"add_sugar_without_count", {before = FractureManager.on_add_sugar}},
	{"remove_sugar", {before = FractureManager.on_remove_sugar}},
	{"remove_sugar_silent", {before = FractureManager.on_remove_sugar}},
	{"link_remove_start", {before = FractureManager.on_link_remove_start}},
	{"trigger_indicate", {before = FractureManager.on_trigger_indicate}},		
	{"link_remove_finish", {before = FractureManager.on_link_remove_finish}},
	{"lightning_remove_begin", {before = FractureManager.on_link_remove_start}},	
	{"lightning_remove_finish", {before = FractureManager.on_link_remove_finish}},			

}

FractureManager.PROPERTY_CONFIG = {
	


}

return FractureManager