-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local EdgeChainCollider = require "GameEx.Components.Colliders.EdgeChainCollider"
local CircleCollider = require "GameEx.Components.Colliders.CircleCollider"

-- ## Imports ## --




local FrameSugar = class("FrameSugar", function() return GameObject:create() end)


function FrameSugar:ctor()

	local edge_chain_collider = EdgeChainCollider:create()
	self:add_component(edge_chain_collider, "collider")

	local category = self:get_category()
	category:add("frame")

	self:register_listeners_with_config(FrameSugar.LISTENER_CONFIG)
	self:register_properties_with_config(FrameSugar.PROPERTY_CONFIG)

end

function FrameSugar:on_destroy()



end

function FrameSugar:on_reset()



end

function FrameSugar:on_select()
	


end

function FrameSugar:on_deselect()



end

function FrameSugar:on_start_remove()



end

function FrameSugar:on_finish_remove()



end

FrameSugar.LISTENER_CONFIG = {

	{"dynamic", false},

}

FrameSugar.PROPERTY_CONFIG = {
	
	{"material", cc.PhysicsMaterial(0.1, 0.0, 0.0)},

}


return FrameSugar