-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local RandomDraw = require "GameEx.Foundations.Utils.RandomDrawArray"
local GameGlobals = require "GameEx.GameGlobals"

-- ## Imports ## --




local TimingBombManager = class("TimingBombManager", function() return GameObject:create() end)


function TimingBombManager:ctor()

	self:register_listeners_with_config(TimingBombManager.LISTENER_CONFIG)
	self:register_properties_with_config(TimingBombManager.PROPERTY_CONFIG)

	self.__t_sugars = {}

end

function TimingBombManager:on_remove_sugar(c_msg)

	self.__t_sugars[c_msg.x_param] = nil

end

function TimingBombManager:on_add_sugar(c_msg)

	if c_msg.x_param:get_category():has("timing_bomb") then

		self.__t_sugars[c_msg.x_param] = c_msg.x_param

	end

end

function TimingBombManager:on_round_finish(c_msg)

	for key, value in pairs(self.__t_sugars) do

		value:send_message(c_msg)

	end

end


TimingBombManager.LISTENER_CONFIG = {

	{"add_sugar", {before = TimingBombManager.on_add_sugar}},
	{"add_sugar_without_count", {before = TimingBombManager.on_add_sugar}},
	{"remove_sugar", {before = TimingBombManager.on_remove_sugar}},
	{"remove_sugar_silent", {before = TimingBombManager.on_remove_sugar}},
	{"round_finish", {before = TimingBombManager.on_round_finish}},			

}

TimingBombManager.PROPERTY_CONFIG = {
	


}

return TimingBombManager