-- ## Imports ## --

local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local GameScene = require "GameEx.Components.Scene.GameScene"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ObjectFactory = require "GameEx.Foundations.ObjectFactory"
local RandomDraw = require "GameEx.Foundations.Utils.RandomDrawArray"
local GameGlobals = require "GameEx.GameGlobals"

-- ## Imports ## --


local TransformSugarManager = class("TransformSugarManager", function() return GameObject:create() end)


function TransformSugarManager:ctor()

	self:register_listeners_with_config(TransformSugarManager.LISTENER_CONFIG)
	self:register_properties_with_config(TransformSugarManager.PROPERTY_CONFIG)

end

function TransformSugarManager:on_enter_transform()
-- ERROR_ASSERT(false, "string")
	local param = {

		t_category_filter = {
			type = "and",
			{"transform", "=", true},	
		},

	}

	local msg = MessagePool:get_free()
	msg.c_sender = self
	msg.s_name = "query_filter"
	msg.x_param = param

	GameGlobals.Scene:send_message(msg)

	local select_result = msg.x_result

	if #msg.x_result > 0 then

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("start_action"))

		for _, transform in ipairs(select_result) do

			transform:send_message(MessagePool:get_free_ex("transform", "", Message.N_TUNNEL))

		end

		GameGlobals.Scene:runAction(cc.Sequence:create(cc.DelayTime:create(0.5), cc.CallFunc:create(function()

			GameGlobals.Scene:send_message(MessagePool:get_free_ex("finish_action"))

		end)))

	end

end

TransformSugarManager.LISTENER_CONFIG = {

	{"enter_transform", {before = TransformSugarManager.on_enter_transform}}		

}

TransformSugarManager.PROPERTY_CONFIG = {
	


}

return TransformSugarManager