-- ## Imports ## --

local GameGlobals = require "GameEx.GameGlobals"
local GameObject = require "GameEx.Foundations.GameObject"
local Message = require "GameEx.Foundations.Message"
local MessagePool = require "GameEx.Foundations.MessagePool"
local UtilFunction = require "GameEx.Foundations.Utils.Function"
local ResourceManager = require "GameEx.Foundations.ResourceManager"
local GameGlobals = require "GameEx.GameGlobals"

-- ## Imports ## --

local KeySugarVisual = class("KeySugarVisual", function() return GameObject:create() end)

function KeySugarVisual:ctor()

	self.__c_spine = ResourceManager:get_instance():get_resource_by_key("key_sugar_spine", true)
	self.__c_spine:setAnimation(0, "barrier_104", false)
	self:addChild(self.__c_spine)

	self:register_listeners_with_config(KeySugarVisual.LISTENER_CONFIG)
	self:register_properties_with_config(KeySugarVisual.PROPERTY_CONFIG)

end

function KeySugarVisual:on_destroy()

	self.__c_spine:removeFromParent()

end


function KeySugarVisual:on_assemble()

	self.__c_parent:addChild(self)

end

function KeySugarVisual:on_disassemble()

	self.__c_parent:removeChild(self)

end

function KeySugarVisual:on_start_remove()



end

function KeySugarVisual:on_finish_remove()



end

function KeySugarVisual:after_set_width(c_msg)

	self:setScaleX(c_msg.x_param.x_new_value / 150)

end

function KeySugarVisual:after_set_height(c_msg)

	self:setScaleY(c_msg.x_param.x_new_value / 150)

end


KeySugarVisual.LISTENER_CONFIG = {

	{"assemble", {before = KeySugarVisual.on_assemble}},
	{"disassemble", {before = KeySugarVisual.on_disassemble}},
	{"remove_started", {before = KeySugarVisual.on_start_remove}},
	{"remove_finished", {before = KeySugarVisual.on_finish_remove}},
	{"layer_reduce", {before = KeySugarVisual.on_layer_reduce}},
	{"destroy", {before = KeySugarVisual.on_destroy}},

}

KeySugarVisual.PROPERTY_CONFIG = {
	
	{"width", 100},
	{"height", 100},

}

return KeySugarVisual