local Filter = class("Filter")

function Filter:ctor(target)

	self.__c_target = target

end

function Filter:filter(t_filter_config)

	if t_filter_config then

		if t_filter_config.type == "and" then

			return self:and_filter(t_filter_config)

		elseif t_filter_config.type == "or" then

			return self:or_filter(t_filter_config)

		else

			return false

		end

	else

		return true

	end

end

function Filter:or_filter(t_filter_config)

	local result = false

	local itemSize = #t_filter_config

	for i = 1, itemSize do

		if t_filter_config[i].type then

			result = result or self:filter(t_filter_config[i])

		else

			result = result or self:operate_item(t_filter_config[i])

		end

	end

	return result

end

function Filter:and_filter(t_filter_config)

	local result = true

	local itemSize = #t_filter_config

	for i = 1, itemSize do

		if t_filter_config[i].type then

			result = result and self:filter(t_filter_config[i])

		else

			result = result and self:operate_item(t_filter_config[i])

		end

	end

	return result

end

function Filter:operate_item(t_filter_item)

	if t_filter_item[2] == "=" then

		return self:__equal(t_filter_item[1], t_filter_item[3])

	elseif t_filter_item[2] == "~=" then

		return self:__unequal(t_filter_item[1], t_filter_item[3])

	elseif t_filter_item[2] == ">" then

		return self:__more(t_filter_item[1], t_filter_item[3])

	elseif t_filter_item[2] == "<" then

		return self:__less(t_filter_item[1], t_filter_item[3])

	elseif t_filter_item[2] == ">=" then

		return self:__noless(t_filter_item[1], t_filter_item[3])

	elseif t_filter_item[2] == "<=" then

		return self:__nomore(t_filter_item[1], t_filter_item[3])

	else

		return false

	end

end

function Filter:__equal(key, value)

end

function Filter:__unequal(key, value)

end

function Filter:__more(key, value)

end

function Filter:__less(key, value)

end

function Filter:__nomore(key, value)

end

function Filter:__noless(key, value)

end

return Filter