-- ## Imports ## --

local Message = require "GameEx.Foundations.Message"

-- ## Imports ## --




MessagePool = {}

function MessagePool:init()
	
	self.__t_freeList = {}
	self.__n_usedSize = 0
	self.__n_freeSize = 0

	self:refill(100)

end

function MessagePool:get_free()

	-- if self.__n_usedSize == self.__n_freeSize then

	-- 	self:refill(100)

	-- end

	-- self.__n_usedSize = self.__n_usedSize + 1

	-- return self.__t_freeList[self.__n_usedSize]

	return Message:create()

end

function MessagePool:get_free_ex(s_name, x_param, e_transmit, c_sender)

	local msg = self:get_free()

	msg.s_name = s_name
	msg.x_param = x_param
	msg.e_transmit = e_transmit or Message.N_DIRECT
	msg.c_sender = c_sender or Message.T_NO_VALUE

	return msg

end

function MessagePool:refill(n_refill_amount)

	for i = 1, n_refill_amount do

		self.__n_freeSize = self.__n_freeSize + 1
		self.__t_freeList[self.__n_freeSize] = Message:create()

	end

end

function MessagePool:recycle()

	for i = 1, self.__n_usedSize do 

		self.__t_freeList[i]:reset()

	end

	self.__n_usedSize = 0

end

return MessagePool


