local AnimationGenerator = class("AnimationGenerator")

AnimationGenerator.SHAKE_ANIMATION_LEVEL_1 = 1
AnimationGenerator.SHAKE_ANIMATION_LEVEL_2 = 2

function AnimationGenerator:get_shake_action(n_shake_level)

	if n_shake_level == AnimationGenerator.SHAKE_ANIMATION_LEVEL_1 then

		local move_action_list = {}

		move_action_list[1] = cc.MoveBy:create(0.066, cc.p(8, -4))
		move_action_list[2] = cc.MoveBy:create(0.066, cc.p(-12, 8))
		move_action_list[3] = cc.MoveBy:create(0.066, cc.p(4, -12))
		move_action_list[4] = cc.MoveBy:create(0.066, cc.p(-6, 10))
		move_action_list[5] = cc.MoveBy:create(0.066, cc.p(8, -4))
		move_action_list[6] = cc.MoveBy:create(0.066, cc.p(-10, 8))
		move_action_list[7] = cc.MoveBy:create(0.066, cc.p(10, -8))
		move_action_list[8] = cc.MoveBy:create(0.066, cc.p(-2, 2))

		local sequence = cc.Sequence:create(move_action_list)

		return sequence

	elseif n_shake_level == AnimationGenerator.SHAKE_ANIMATION_LEVEL_2 then

		local move_action_list = {}

		move_action_list[1] = cc.MoveBy:create(0.05, cc.p(-4, 3))
		move_action_list[2] = cc.MoveBy:create(0.05, cc.p(6, -2))
		move_action_list[3] = cc.MoveBy:create(0.05, cc.p(-5, 4))
		move_action_list[4] = cc.MoveBy:create(0.05, cc.p(3, -5))

		local sequence = cc.Sequence:create(move_action_list)

		return sequence

	else

		local move = cc.MoveBy:create(0, cc.p(0, 0))
		return move

	end

end

function AnimationGenerator:get_instance()

	if not AnimationGenerator.c_instance then

		AnimationGenerator.c_instance = AnimationGenerator:create()

	end

	return AnimationGenerator.c_instance

end

return AnimationGenerator