local Array = class("Array")

function Array:ctor()

end

function Array:pushBack(element)

	self:insertAfter(#self, element)

end

function Array:pushFront(element)

	self:insertBefore(1, element)

end

function Array:clear()

	local size = #self

	for i = 1, size do

		if self.clearCallback then

			self.clearCallback(self[i])

		end

		self[i] = nil

	end

end

function Array:getSize()

	return #self

end

function Array:getFront()

	return self[1]

end

function Array:getBack()

	return self[#self]

end

function Array:popFront()

	if #self > 0 then

		self:remove(1)

	end

end

function Array:popBack()

	if #self > 0 then

		self:remove(#self)

	end

end

function Array:remove(iter)

	if self.clearCallback then

		self.clearCallback(self[iter])

	end

	local size = #self

	for i = #self, iter + 1, -1 do
		
		self[i - 1] = self[i]

	end

	self[size] = nil

end

function Array:removeData(data)

	for key, value in self:iterate() do

		if value == data then

			self:remove(key)
			
			break

		end

	end

end

function Array:insertAfter(iter, element)

	if self.insertCallback then

		self.insertCallback(element)

	end

	local size = #self + 1

	for i = size, iter + 2, -1 do
		
		self[i] = self[i - 1]

	end

	self[iter + 1] = element

end

function Array:insertBefore(iter, element)

	if self.insertCallback then

		self.insertCallback(element)

	end

	local size = #self + 1

	for i = size, iter + 1, -1 do
		
		self[i] = self[i - 1]

	end

	self[iter] = element

end

function Array:iterate()

	return self.iterFunc, self, 0

end

function Array:iterFunc(iter)

	local next = iter + 1

	if self[next] then

		return next, self[next]

	end

end

function Array:setClearCallback(clearCallback)

	self.clearCallback = clearCallback

end

function Array:setInsertCallback(insertCallback)

	self.insertCallback = insertCallback

end

function Array:copy()

	local copy = Array:create()

	for _, value in self:iterate() do

		copy:pushBack(value)

	end

	return copy

end

return Array