FileManipulator = class("FileManipulator")

function FileManipulator:ctor()

	cc.UserDefault:getInstance()
	local path = CCUserDefault:getXMLFilePath()
	
	local pos = string.find(path, "UserDefault.xml")
	path = string.sub(path, 0, pos - 1)

	self.path = path

	-- package.path = string.format("%s?.lua;%s", self.path, package.path)
	-- package.path = string.format("%ssrc/?.lua;%s", self.path, package.path)    
	-- package.path = string.format("%sres/?.lua;%s", self.path, package.path)

end

function FileManipulator:getPath()

	return self.path

end

function FileManipulator:formatTableToString(tableName, tbl)

	local script = {}

	script[#script + 1] = "local "
	script[#script + 1] = tableName
	script[#script + 1] = " = "
	script[#script + 1] = self:formatTable(tbl, 1)
	script[#script + 1] = "\n"
	script[#script + 1] = "return "
	script[#script + 1] = tableName
	script[#script + 1] = "\n"

	return table.concat(script)

end

function FileManipulator:formatStringToString(string)

	local script = {}

	script[#script + 1] = "local "
	script[#script + 1] = "str"
	script[#script + 1] = " = "
	script[#script + 1] = "\""
	script[#script + 1] = string
	script[#script + 1] = "\""
	script[#script + 1] = "\n"
	script[#script + 1] = "return "
	script[#script + 1] = "str"
	script[#script + 1] = "\n"

	return table.concat(script)

end
    
function FileManipulator:formatTable(tbl, recursionDepth)

	local script = {}

	script[#script + 1] = "{\n"

	for key, value in pairs(tbl) do

		if type(key) == "string" then

			for i = 1, recursionDepth do

				script[#script + 1] = "    "

			end

			script[#script + 1] = tostring(key)
			script[#script + 1] = " = "

			if type(value) == "table" then

				script[#script + 1] = self:formatTable(value, recursionDepth + 1)

			elseif type(value) == "string" then

				script[#script + 1] = "\""
				script[#script + 1] = tostring(value)
				script[#script + 1] = "\""

			else
				
				script[#script + 1] = tostring(value)

			end

			script[#script + 1] = ",\n"

		end

	end

	for key, value in ipairs(tbl) do

		for i = 1, recursionDepth do

			script[#script + 1] = "    "

		end

		script[#script + 1] = "["
		script[#script + 1] = tostring(key)
		script[#script + 1] = "]"
		script[#script + 1] = " = "

		if type(value) == "table" then

			script[#script + 1] = self:formatTable(value, recursionDepth + 1)

		elseif type(value) == "string" then

			script[#script + 1] = "\""
			script[#script + 1] = tostring(value)
			script[#script + 1] = "\""

		else
			
			script[#script + 1] = tostring(value)

		end

		script[#script + 1] = ",\n"

	end

	for i = 1, recursionDepth - 1 do

		script[#script + 1] = "    "

	end

	script[#script + 1] = "}"

	return table.concat(script)

end

function FileManipulator:writeToFile(fileName, tableName, tbl)
	
	local fullPathForFile = string.format("%s%s.lua", self.path, fileName)
	local file = io.open(fullPathForFile, "w+")

	file:write(self:formatTableToString(tableName, tbl))
	file:close()

end

function FileManipulator:writeToFileWithID(fileName, tableName, tbl)
	local _fileName = PLAYER_ID..fileName
	-- local _tableName = PLAYER_ID..tableName

	local fullPathForFile = string.format("%s%s.lua", self.path, _fileName)
	local file = io.open(fullPathForFile, "w+")

	file:write(self:formatTableToString(tableName, tbl))
	file:close()

end

function FileManipulator:writeStringToFile(fileName, str)
	
	local fullPathForFile = string.format("%s%s.lua", self.path, fileName)
	local file = io.open(fullPathForFile, "w+")

	file:write(self:formatStringToString(str))
	file:close()

end

function FileManipulator:getInstance()

	if not FileManipulator.instance then

		FileManipulator.instance = FileManipulator:create()

	end

	return FileManipulator.instance

end

return FileManipulator