local Function = {}

function Function:caculate_distance(t_position_1, t_position_2)

	t_position_2 = t_position_2 or {x = 0, y = 0}
	
	local distX = t_position_1.x - t_position_2.x
	local distY = t_position_1.y - t_position_2.y

	return math.sqrt(distX * distX + distY * distY)

end

function Function:caculate_direction(t_position_1, t_position_2)
	
	t_position_2 = t_position_2 or {x = 0, y = 0}

	local direction = {}
	direction.x = t_position_1.x - t_position_2.x
	direction.y = t_position_1.y - t_position_2.y

	return direction

end

function Function:normalize(t_vec)

	local length = math.sqrt(t_vec.x * t_vec.x + t_vec.y * t_vec.y)
	return cc.p(t_vec.x / length, t_vec.y / length)

end

function Function:caculate_projection(t_source, t_target)

	local distance = self:caculate_distance(t_target)
	local e = { x = t_target.x / distance, y = t_target.y / distance}

	return e.x * t_source.x + e.y * t_source.y

end

function Function:caculate_angle(t_direction)

	

	local radian = math.atan2(t_direction.y, t_direction.x)
	local angle = -radian / math.pi * 180

	return angle

end

function Function:get_relative_position(c_node, c_relativeTarget)

	local positionInParent = cc.p(c_node:getPosition())
	local positionInWorld = node:getParent():convertToWorldSpace(positionInParent)
	return c_relativeTarget:convertToNodeSpace(positionInWorld)

end

function Function:copy(x_value, filter) -- if you want a table typed value to be copied correctly, keys in the table MUST NOT be of a table type

	local filter = filter or {}

	if type(x_value) == "table" then

		local new_table = {}

		for key, value in pairs(x_value) do

			if filter[key] == "ref" then

				new_table[key] = value

			elseif filter[key] == "del" then

				-- do nothing 

			else

				new_table[key] = self:copy(value, filter)

			end

		end

		return new_table

	else

		return x_value

	end

end

return Function