local List = class("List")

function List:ctor()

	self.head = {}
	self.head._next = self.head
	self.head._prev = self.head
	self.head._data = nil

	self.front = self.head
	self.back = self.head

	self.size = 0

end

function List:pushBack(element)

	self:insertBefore(self.head, element)

end

function List:pushFront(element)

	self:insertAfter(self.head, element)

end

function List:clear()

	while self.size > 0 do
		
		self:remove(self.head._next)

	end

end

function List:getSize()

	return self.size

end

function List:getFront()

	return self.front._data

end

function List:getBack()

	return self.back._data

end

function List:popFront()

	if self.size > 0 then

		self:remove(self.front)

	end

end

function List:popBack()

	if self.size > 0 then

		self:remove(self.back)

	end

end

function List:remove(iter)

	if self.clearCallback then

		self.clearCallback(iter._data)

	end

	local next = iter._next
	local prev = iter._prev

	prev._next = next
	next._prev = prev

	iter._next = nil
	iter._prev = nil

	self.front = self.head._next
	self.back = self.head._prev

	self.size = self.size - 1

end

function List:removeData(data)

	for key, value in self:iterate() do

		if value == data then

			self:remove(key)
			
			break

		end

	end

end

function List:insertAfter(iter, element)

	if self.insertCallback then

		self.insertCallback(element)

	end

	local newNode = {}
	newNode._prev = iter
	newNode._next = iter._next
	newNode._data = element

	iter._next._prev = newNode
	iter._next = newNode

	self.front = self.head._next
	self.back = self.head._prev

	self.size = self.size + 1

end

function List:insertBefore(iter, element)

	if self.insertCallback then

		self.insertCallback(element)

	end

	local newNode = {}
	newNode._prev = iter._prev
	newNode._next = iter
	newNode._data = element

	iter._prev._next = newNode
	iter._prev = newNode

	self.front = self.head._next
	self.back = self.head._prev

	self.size = self.size + 1

end

function List:iterate()

	return self.iterFunc, self, self.head

end

function List:iterFunc(iter)

	local next = iter._next

	if next == self.head then

		return nil

	else
	
		return next, next._data

	end

end

function List:setClearCallback(clearCallback)

	self.clearCallback = clearCallback

end

function List:setInsertCallback(insertCallback)

	self.insertCallback = insertCallback

end


return List