local RandomGenerator = require "GameEx.Foundations.Utils.RandomGenerator"

local ProbGetter = class("ProbGetter")

function ProbGetter:ctor(randomGenerator)

	self.holder = {}
	self.randomGenerator = randomGenerator or RandomGenerator:create()
	self.total = 0

end

function ProbGetter:has(key)

	if self.holder[key] then

		return true

	end

end

function ProbGetter:add(key, value, prob)

	self.holder[key] = {value = value, prob = prob}
	self.total = self.total + prob

end

function ProbGetter:modify(key, prob)

	if self.holder[key] then

		self.total = self.total - self.holder[key].prob
		self.holder[key].prob = prob
		self.total = self.total + prob

	end

end

function ProbGetter:remove(key)

	if self.holder[key] then

		self.total = self.total - self.holder[key].prob
		self.holder[key] = nil

	end

end

function ProbGetter:get()

	if self.total == 0 then return end

	local rand = self.randomGenerator:rand()

	local min = 0
	local max = 0

	for key, val in pairs(self.holder) do

		max = max + val.prob 

		if rand > min / self.total and rand <= max / self.total then

			return val.value

		else

			min = max

		end

	end

end

function ProbGetter:clear()

	self.holder = {}
	self.total = 0

end

return ProbGetter
