-- ## Imports ## --

local ListPool = require "GameEx.Utils.ListPool"

-- ## Imports ## --




local RandomDraw = class("RandomDraw")

function RandomDraw:ctor(randomGenerator)

	self.randomGenerator = randomGenerator or RandomGenerator:create()

	self.selected = {}
	setmetatable(self.selected, {__mode = "k"})

	self.targetSize = 0

end

function RandomDraw:setTarget(target)

	self.target = target
	self.targetSize = target:getSize()

	self.selected = {}

end

function RandomDraw:reset()

	self.targetSize = target:getSize()

	self.selected = {}

end

function RandomDraw:drawNext()

	if not (#self.selected == self.targetSize) then

		local rand = self.randomGenerator:rand(1, self.targetSize)

		while self.selected[rand] do

			rand = self.randomGenerator:rand(1, self.targetSize)

		end

		self.selected[rand] = true

		local counter = 1

		for _, value in self.target:iterate() do

			if not (counter == rand) then

				counter = counter + 1

			else

				return value

			end

		end

	end

end

return RandomDraw