-- ## Imports ## --

local RandomGenerator = require "GameEx.Foundations.Utils.RandomGenerator"

-- ## Imports ## --




local RandomDrawArray = class("RandomDrawArray")

function RandomDrawArray:ctor(randomGenerator)

	self.__c_random_generator = randomGenerator or RandomGenerator:create()
	self.__t_candidates = {}
	self.__n_candidate_number = 0
	self.__n_top = 1

end

function RandomDrawArray:set_target(target)

	self:reset()

	for i = 1, target do

		self.__n_candidate_number = self.__n_candidate_number + 1
		self.__t_candidates[self.__n_candidate_number] = i

	end

end

function RandomDrawArray:reset()

	self.__n_candidate_number = 0
	self.__t_candidates = {}
	self.__n_top = 1

end

function RandomDrawArray:draw_next()

	if not (self.__n_top > self.__n_candidate_number) then

		local rand = self.__c_random_generator:rand(self.__n_top, self.__n_candidate_number)
		local return_value = self.__t_candidates[rand]

		self.__t_candidates[rand] = self.__t_candidates[self.__n_top]
		self.__t_candidates[self.__n_top] = return_value

		self.__n_top = self.__n_top + 1

		return return_value

	else

		return nil

	end

end

function RandomDrawArray:draw_next_repeat()

	if not (self.__n_top > self.__n_candidate_number) then

		local rand = self.__c_random_generator:rand(self.__n_top, self.__n_candidate_number)
		local return_value = self.__t_candidates[rand]

		self.__t_candidates[rand] = self.__t_candidates[self.__n_top]
		self.__t_candidates[self.__n_top] = return_value

		self.__n_top = self.__n_top + 1

		return return_value

	else

		self.__n_top = 1

		return self:draw_next_repeat()

	end

end

return RandomDrawArray