-- ## Imports ## --

local ProbGetter = require "GameEx.Foundations.Utils.ProbGetter"

-- ## Imports ## --




local RandomDrawArrayWithProb = class("RandomDrawArrayWithProb")

function RandomDrawArrayWithProb:ctor(random_generator)

	self.__c_prob_getter = ProbGetter:create(random_generator)
	self.__t_candidates = {}
	self.__n_candidate_number = 0
	self.__n_top = 1

end

function RandomDrawArrayWithProb:set_target(target, last_index)

	target = target or {}

	self.__t_candidates = target
	self.__n_candidate_number = #self.__t_candidates
	self.__n_top = 1
	self.__n_last_index = last_index

	self:fill_prob_getter()

end

function RandomDrawArrayWithProb:fill_prob_getter()

	local n_target = 0

	for index, prob in ipairs(self.__t_candidates) do

		if prob > 0 and index ~= self.__n_last_index then

			self.__c_prob_getter:add(index, index, prob)
			n_target = n_target + 1

		end

	end

	self.__n_candidate_number = n_target

end

function RandomDrawArrayWithProb:draw_next()

	if not (self.__n_top > self.__n_candidate_number) then

		local val = self.__c_prob_getter:get()
		
		self.__c_prob_getter:remove(val)
		self.__n_top = self.__n_top + 1
		self.__n_last_index = val

		return val

	else

		return nil

	end

end

function RandomDrawArrayWithProb:draw_next_repeat()

	if not (self.__n_top > self.__n_candidate_number) then

		local val = self.__c_prob_getter:get()
		
		self.__c_prob_getter:remove(val)
		self.__n_top = self.__n_top + 1
		self.__n_last_index = val

		return val

	else

		self.__n_top = 1
		self:fill_prob_getter()

		return self:draw_next_repeat()

	end

end

function RandomDrawArrayWithProb:remove_index(index)

	self.__c_prob_getter:remove(index)
	self.__n_top = self.__n_top + 1

end

function RandomDrawArrayWithProb:set_last_index(index)

	self.__n_last_index = index

end

return RandomDrawArrayWithProb