-- ## Imports ## --

local RandomGenerator = require "GameEx.Foundations.Utils.RandomGenerator"

-- ## Imports ## --




local RandomDrawHash = class("RandomDrawArray")

function RandomDrawHash:ctor(randomGenerator)

	self.__c_randomGenerator = randomGenerator or RandomGenerator:create()
	self.__t_candidates = {}
	self.__n_candidate_number = 0
	self.__n_top = 1

end

function RandomDrawHash:setTarget(target)

	for key, sugar in ipairs(target) do

		self.__n_candidate_number = self.__n_candidate_number + 1
		self.__t_candidates[self.__n_candidate_number] = sugar

	end

	self:reset()

end

function RandomDrawHash:reset()

	self.__n_top = 1

end

function RandomDrawArray:drawNext()

	if not self.__n_top > self.__n_candidate_number then

		local rand = __c_randomGenerator:rand(self.__n_top, self.__n_candidate_number)
		local return_value = self.__t_candidates[rand]

		self.__t_candidates[rand] = self.__t_candidates[self.__n_top]
		self.__t_candidates[self.__n_top] = return_value

		self.__n_top = self.__n_top + 1

		return return_value

	else

		return nil

	end

end

return RandomDrawArray