local ConfigList = {
	
	CircleCollider = {script_path = "GameEx.Components.Colliders.CircleCollider"},
	BoxCollider = {script_path = "GameEx.Components.Colliders.BoxCollider"},
	EdgeChainCollider = {script_path = "GameEx.Components.CollidersEdgeChainCollider"},
	LinkFinder = {script_path = "GameEx.Components.Finders.LinkFinder"},
	CombineGenerator = {script_path = "GameEx.Components.Generators.CombineGenerator"},
	LinkGenerator = {script_path = "GameEx.Components.Generators.LinkGenerator"},
	CircleImpulser = {script_path = "GameEx.Components.Impulsers.CircleImpulser"},
	LinkIndicator = {script_path = "GameEx.Components.Indicators.LinkIndicator"},
	GenerateIndicator = {script_path = "GameEx.Components.Indicators.GenerateIndicator"},
	SpecialIndicator = {script_path = "GameEx.Components.Indicators.SpecialIndicator"},
	FractureIndicator = {script_path = "GameEx.Components.Indicators.FractureIndicator"},
	TouchComponent = {script_path = "GameEx.Components.InputHandlers.TouchComponent"},
	SkillTouchHandler = {script_path = "GameEx.Components.InputHandlers.SkillTouchHandler"},
	BombRemover = {script_path = "GameEx.Components.Removers.BombRemover"},
	LinkRemover = {script_path = "GameEx.Components.Removers.LinkRemover"},
	NormalRemover = {script_path = "GameEx.Components.Removers.NormalRemover"},
	SpecialLinkRemover = {script_path = "GameEx.Components.Removers.SpecialLinkRemover"},
	SpecialRemover = {script_path = "GameEx.Components.Removers.SpecialRemover"},
	LightningRemover = {script_path = "GameEx.Components.Removers.LightningRemover"},
	TotalRemover = {script_path = "GameEx.Components.Removers.TotalRemover"},
	BoxSelector = {script_path = "GameEx.Components.Selectors.BoxSelector"},
	CircleSelector = {script_path = "GameEx.Components.Selectors.CircleSelector"},
	ColorSelector = {script_path = "GameEx.Components.Selectors.ColorSelector"},
	KeySelector = {script_path = "GameEx.Components.Selectors.KeySelector"},
	LinkSelector = {script_path = "GameEx.Components.Selectors.LinkSelector"},
	TotalSelector = {script_path = "GameEx.Components.Selectors.TotalSelector"},
	IceSugarVisual = {script_path = "GameEx.Components.Visuals.IceSugarVisual"},
	MoveableIceSugarVisual = {script_path = "GameEx.Components.Visuals.MoveableIceSugarVisual"},
	ChocolateSugarVisual = {script_path = "GameEx.Components.Visuals.ChocolateSugarVisual"},
	TimingBombSugarVisual = {script_path = "GameEx.Components.Visuals.TimingBombSugarVisual"},
	LinkVisual = {script_path = "GameEx.Components.Visuals.LinkVisual"},
	NormalSugarVisual = {script_path = "GameEx.Components.Visuals.NormalSugarVisual"},
	SpecialSugarVisual = {script_path = "GameEx.Components.Visuals.SpecialSugarVisual"},
	BarrierSugarVisual = {script_path = "GameEx.Components.Visuals.BarrierSugarVisual"},
	ColorfulSugarVisual = {script_path = "GameEx.Components.Visuals.ColorfulSugarVisual"},
	KeySugarVisual = {script_path = "GameEx.Components.Visuals.KeySugarVisual"},
	BossSugarVisual = {script_path = "GameEx.Components.Visuals.BossSugarVisual"},
	FanSugarVisual = {script_path = "GameEx.Components.Visuals.FanSugarVisual"},
	PandaSugarVisual = {script_path = "GameEx.Components.Visuals.PandaSugarVisual"},
	RandomSugarVisual = {script_path = "GameEx.Components.Visuals.RandomSugarVisual"},
	LineSkillVisual = {script_path = "GameEx.Components.Visuals.LineSkillVisual"},
	TargetVisual = {script_path = "GameEx.Components.Visuals.TargetVisual"},
	TargetHandler = {script_path = "GameEx.Components.Scene.TargetHandler"},
	TargetHandlerTournament = {script_path = "GameEx.Components.Scene.TargetHandlerTournament"},
	IdleFinder = {script_path = "GameEx.Components.Finders.IdleFinder"},
	Rearranger = {script_path = "GameEx.Components.Rearrangers.Rearranger"},
	VictorySkill = {script_path = "GameEx.Components.Skills.VictorySkill"},
	MoveSkill = {script_path = "GameEx.Components.Skills.MoveSkill"},
	BombSkill = {script_path = "GameEx.Components.Skills.BombSkill"},
	HammerSkill = {script_path = "GameEx.Components.Skills.HammerSkill"},
	CandySkill = {script_path = "GameEx.Components.Skills.CandySkill"},
	LineSkill = {script_path = "GameEx.Components.Skills.LineSkill"},
	ShinSkill = {script_path = "GameEx.Components.Skills.ShinSkill"},
	AhDaiSkill = {script_path = "GameEx.Components.Skills.AhDaiSkill"},
	NiNiSkill = {script_path = "GameEx.Components.Skills.NiNiSkill"},
	ZhengNanSkill = {script_path = "GameEx.Components.Skills.ZhengNanSkill"},
	FengJianSkill = {script_path = "GameEx.Components.Skills.FengJianSkill"},
	ConchSkill = {script_path = "GameEx.Components.Skills.FengJianSkill"},
	StartSkill = {script_path = "GameEx.Components.Skills.GameStartSkill"},
	TournamentRewardSkill = {script_path = "GameEx.Components.Skills.TournamentRewardSkill"},
	RankHandler = {script_path = "GameEx.Components.Scene.RankHandler"},
	ScoreHandler = {script_path = "GameEx.Components.Scene.ScoreHandler"},
	SoundPerformer = {script_path = "GameEx.Components.Scene.SoundPerformer"},

	TopEmitter = {script_path = "GameEx.Components.Emitters.TopEmitter"},
	KeyEmitter = {script_path = "GameEx.Components.Emitters.KeyEmitter"},
	AdvancedEmitter = {script_path = "GameEx.Components.Emitters.AdvancedEmitter"},
	AdvancedEmitterNozzle = {script_path = "GameEx.Components.Emitters.AdvancedEmitterNozzle"},

	BossSugar = "GameEx.Resources.DefaultConfigs.Sugars.BossSugar",
	BombSugar = "GameEx.Resources.DefaultConfigs.Sugars.BombSugar",
	CrossSugar = "GameEx.Resources.DefaultConfigs.Sugars.CrossSugar",
	LineSugar = "GameEx.Resources.DefaultConfigs.Sugars.LineSugar",
	FrameSugar = "GameEx.Resources.DefaultConfigs.Sugars.FrameSugar",
	IceSugar = "GameEx.Resources.DefaultConfigs.Sugars.IceSugar",
	KeySugar = "GameEx.Resources.DefaultConfigs.Sugars.KeySugar",
	LightningSugar = "GameEx.Resources.DefaultConfigs.Sugars.LightningSugar",
	LinkSugar = "GameEx.Resources.DefaultConfigs.Sugars.LinkSugar",
	NormalSugar = "GameEx.Resources.DefaultConfigs.Sugars.NormalSugar",
	BarrierSugar = "GameEx.Resources.DefaultConfigs.Sugars.BarrierSugar",
	FanSugar = "GameEx.Resources.DefaultConfigs.Sugars.FanSugar",
	FenceSugar = "GameEx.Resources.DefaultConfigs.Sugars.FenceSugar",
	GameScene = "GameEx.Resources.DefaultConfigs.Sugars.GameScene",
	GameSceneTournament = "GameEx.Resources.DefaultConfigs.Sugars.GameSceneTournament",
	MoveableIceSugar = "GameEx.Resources.DefaultConfigs.Sugars.MoveableIceSugar",
	PandaSugar = "GameEx.Resources.DefaultConfigs.Sugars.PandaSugar",
	ChocolateSugar = "GameEx.Resources.DefaultConfigs.Sugars.ChocolateSugar",
	RandomSugar = "GameEx.Resources.DefaultConfigs.Sugars.RandomSugar",
	TimingBombSugar = "GameEx.Resources.DefaultConfigs.Sugars.TimingBombSugar",
	ColorfulSugar = "GameEx.Resources.DefaultConfigs.Sugars.ColorfulSugar",

	UIComponent = "GameEx.Resources.DefaultConfigs.Sugars.UIComponent",
	UIComponentTournament = {script_path = "GameEx.Components.Scene.UIComponentTournament"},

	ChocolateSugarManager = {script_path = "GameEx.Components.Sugars.ChocolateSugarManager"},
	TopEmitterManager = {script_path = "GameEx.Components.Emitters.TopEmitterManager"},
	KeyEmitterManager = {script_path = "GameEx.Components.Emitters.KeyEmitterManager"},
	FractureManager = {script_path = "GameEx.Components.Sugars.FractureManager"},
	TimingBombManager = {script_path = "GameEx.Components.Sugars.TimingBombManager"},
	ColorfulManager = {script_path = "GameEx.Components.Sugars.ColorfulManager"},

	GiftSugar = {script_path = "GameEx.Components.Sugars.GiftSugar"},
	GiftSugarVisual = {script_path = "GameEx.Components.Visuals.GiftSugarVisual"},
	GiftSugarManager = {script_path = "GameEx.Components.Sugars.GiftSugarManager"},

	TransformSugar = {script_path = "GameEx.Components.Sugars.TransformSugar"},
	TransformSugarVisual = {script_path = "GameEx.Components.Visuals.TransformSugarVisual"},
	TransformSugarManager = {script_path = "GameEx.Components.Sugars.TransformSugarManager"},

	CocoSugar = {script_path = "GameEx.Components.Sugars.CocoSugar"},
	CocoSugarVisual = {script_path = "GameEx.Components.Visuals.CocoSugarVisual"},
	CocoSugarManager = {script_path = "GameEx.Components.Sugars.CocoSugarManager"},

	SoilSugar = {script_path = "GameEx.Components.Sugars.SoilSugar"},
	SoilSugarVisual = {script_path = "GameEx.Components.Visuals.SoilSugarVisual"},
	ConchSugar = {script_path = "GameEx.Components.Sugars.ConchSugar"},
	ConchSugarVisual = {script_path = "GameEx.Components.Visuals.ConchSugarVisual"},

	ConchSkill = {script_path = "GameEx.Components.Skills.ConchSkill"},
	ConchSkillVisual = {script_path = "GameEx.Components.Visuals.ConchSkillVisual"},

	AddMoveSugar = {script_path = "GameEx.Components.Sugars.AddMoveSugar"},
	AddMoveSugarVisual = {script_path = "GameEx.Components.Visuals.AddMoveSugarVisual"},

	RewardBagSugar = "GameEx.Resources.DefaultConfigs.Sugars.RewardBagSugar",
	RewardBagSugarVisual = {script_path = "GameEx.Components.Visuals.RewardBagSugarVisual"},
	RewardBagSugarManager = {script_path = "GameEx.Components.Sugars.RewardBagSugarManager"},

}


return ConfigList