local scripts = {
	
	FIRST_START_INVOKE = function()

		print("[Tutorial] -- Script Print -- this is first time invoke !!!!!")

	end,

	FIRST_START_REVOKE = function()

		print("[Tutorial] -- Script Print -- this is first time revoke !!!!!")

	end,

	HAMMER_MODE_SEQUENCE = function(accepter)

		print("[Tutorial] -- Script Print -- hammer turn to sequence mode !!!!!")

		local sequence = {}

		if accepter.interface_config and accepter.interface_config.indication then

			for index, info in ipairs(accepter.interface_config.indication) do

				if info.hand and info.hand_action == "HAND_ACTION_TRAVERSE" then

					sequence[#sequence + 1] = info.routine[#info.routine]

				end

			end

		end


		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local hammer_skill = GameGlobals.Scene:get_component("HammerSkill")
		hammer_skill:set("mode", "fixed")
		hammer_skill:set("sequence", sequence)

		local hammer_touch_handler = hammer_skill:get_component("touch_handler")
		hammer_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

	end,

	HAMMER_MODE_ARBITARY = function(accepter)

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local hammer_skill = GameGlobals.Scene:get_component("HammerSkill")
		hammer_skill:set("mode", "arbitary")

		local hammer_touch_handler = hammer_skill:get_component("touch_handler")
		hammer_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

	end,

	CANDY_MODE_SEQUENCE = function(accepter)

		print("[Tutorial] -- Script Print -- hammer turn to sequence mode !!!!!")

		local sequence = {}

		if accepter.interface_config and accepter.interface_config.indication then

			for index, info in ipairs(accepter.interface_config.indication) do

				if info.hand and info.hand_action == "HAND_ACTION_TRAVERSE" then

					sequence[#sequence + 1] = info.routine[#info.routine]

				end

			end

		end


		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local candy_skill = GameGlobals.Scene:get_component("CandySkill")
		candy_skill:set("mode", "fixed")
		candy_skill:set("sequence", sequence)

		local candy_touch_handler = candy_skill:get_component("touch_handler")
		candy_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

	end,

	CANDY_MODE_ARBITARY = function(accepter)

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local candy_skill = GameGlobals.Scene:get_component("CandySkill")
		candy_skill:set("mode", "arbitary")

		local candy_touch_handler = candy_skill:get_component("touch_handler")
		candy_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))		

	end,

	SHOW_REWARD = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"
		-- require "UI.Layer.LimitGiftLayer_1"
		-- cc.Director:getInstance():getRunningScene():addChild(SpecialGiftLayer_old:create(SpecialGiftLayer_old.Gift_Type.Treasure), 999999)

	end,


	LINK_MODE_SEQUENCE = function(accepter)

		print("[Tutorial] -- Script Print -- link turn to sequence mode !!!!!")

		local sequence = {}

		if accepter.interface_config and accepter.interface_config.indication then

			for index, info in ipairs(accepter.interface_config.indication) do

				if info.hand and info.hand_action == "HAND_ACTION_TRAVERSE" then

					sequence[#sequence + 1] = info.routine[#info.routine]

				end

			end

		end


		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local selector = GameGlobals.Scene:get_component("link_handler"):get_component("selector")
		selector:set("mode", "fixed")
		selector:set("sequence", sequence)

		local selector = GameGlobals.Scene:get_component("LineSkill")
		selector:set("mode", "fixed")
		selector:set("sequence", sequence)

		local selector = GameGlobals.Scene:get_component("link_handler"):get_component("selector")
		local touch_handler = selector:get_component("touch_handler")
		touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))
		local hammer_skill = GameGlobals.Scene:get_component("HammerSkill")
		local hammer_touch_handler = hammer_skill:get_component("touch_handler")
		hammer_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

		local bomb_skill = GameGlobals.Scene:get_component("BombSkill")
		local bomb_touch_handler = bomb_skill:get_component("touch_handler")
		bomb_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

		local candy_skill = GameGlobals.Scene:get_component("CandySkill")
		local candy_touch_handler = candy_skill:get_component("touch_handler")
		candy_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

		local line_skill = GameGlobals.Scene:get_component("LineSkill")
		local line_touch_handler = line_skill:get_component("touch_handler")
		line_touch_handler:send_message(MessagePool:get_free_ex("raise_priority", "", Message.N_TUNNEL))

	end,

	LINK_MODE_ARBITARY = function()

		print("[Tutorial] -- Script Print -- link turn to arbitary mode !!!!!")

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		local selector = GameGlobals.Scene:get_component("link_handler"):get_component("selector")
		selector:set("mode", "arbitary")

		local selector = GameGlobals.Scene:get_component("LineSkill")
		selector:set("mode", "arbitary")

		local selector = GameGlobals.Scene:get_component("link_handler"):get_component("selector")
		local touch_handler = selector:get_component("touch_handler")
		touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

		local hammer_skill = GameGlobals.Scene:get_component("HammerSkill")
		local hammer_touch_handler = hammer_skill:get_component("touch_handler")
		hammer_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

		local bomb_skill = GameGlobals.Scene:get_component("BombSkill")
		local bomb_touch_handler = bomb_skill:get_component("touch_handler")
		bomb_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

		local candy_skill = GameGlobals.Scene:get_component("CandySkill")
		local candy_touch_handler = candy_skill:get_component("touch_handler")
		candy_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

		local line_skill = GameGlobals.Scene:get_component("LineSkill")
		local line_touch_handler = line_skill:get_component("touch_handler")
		line_touch_handler:send_message(MessagePool:get_free_ex("resume_priority", "", Message.N_TUNNEL))

	end,

	REDIRECT_TO_LEVEL_1 = function()

        local level_index = 1
        local mission_info = Mission_Data:getInstance():get_mission_info_by_level(level_index)
        Player:getInstance():set_player_current_level(level_index)
        Player:getInstance():set_player_current_section(mission_info.mission_section)
        
        local current_role_id = Player:getInstance():get_player_cur_role_id()
        local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)
        local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
        local skill_level = Player:getInstance():get_player_skill_level(current_role_id)

        local skill = {}
        skill.name = skill_info.class_name
        skill.change_number = skill_info.change_num[skill_level]
        skill.fill_threshold = skill_info.trigger_condition[skill_level]

        local item = {}
        item.move = false
        item.bomb = false
        item.lightning = false

        local scene_start_param = {}
        scene_start_param.skill_info = skill
        scene_start_param.item_info = item
        scene_start_param.level_index = level_index

        local loadingScene = LoadingScene:create(2)
        loadingScene:load_game_scene_resource(scene_start_param)
        LayerManager:getInstance():clear_layer()
        cc.Director:getInstance():replaceScene(loadingScene)		

	end,

	REDIRECT_TO_MAP = function()

	    local loadingScene = LoadingScene:create(1)
	    loadingScene:load_extern_scene_resource()
	    loadingScene:set_load_finish_callback(function()

	        local player = Player:getInstance()
	        -- 判断下一关是否是新解锁的章节
	        local next_level = player:get_player_next_level()
	        local mission_info = Mission_Data:getInstance():get_mission_info_by_level(next_level)
	        local section_index = mission_info.mission_section
	        local player_section_info = player:get_player_section_info_by_id(section_index)

	        LayerManager:getInstance():clear_layer()
	        local externalScene = ExternalScene:create()
	        externalScene:play_bg_music()
	        if player_section_info.is_animation then
	            externalScene:move_and_enter_section_map(section_index, next_level)
	        else
	            externalScene:switch_to_level_info_without_show(section_index, next_level)
	        end
	        cc.Director:getInstance():replaceScene(externalScene)


	    end)
	    LayerManager:getInstance():clear_layer()
	    cc.Director:getInstance():replaceScene(loadingScene)		

	end,

	FILL_PLAYER_SKILL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("fill_skill", "", Message.N_TUNNEL))

	end,

	CAST_PLAYER_SKILL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("player_skill_start", "", Message.N_TUNNEL))

	end,

	SHOW_GIFT = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		cc.Director:getInstance():getRunningScene():addChild(FirstGiftLayer:create(), 999999)

	end,

	START_ITEM_TUTORIAL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("start_item_tutorial", "", Message.N_TUNNEL))

	end,

	FINISH_ITEM_TUTORIAL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("finish_item_tutorial", "", Message.N_TUNNEL))

	end,

	START_ITEM_TUTORIAL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("start_item_tutorial", "", Message.N_TUNNEL))

	end,

	FINISH_ITEM_TUTORIAL = function()

		local Message = require "GameEx.Foundations.Message"
		local MessagePool = require "GameEx.Foundations.MessagePool"
		local GameGlobals = require "GameEx.GameGlobals"

		GameGlobals.Scene:send_message(MessagePool:get_free_ex("finish_item_tutorial", "", Message.N_TUNNEL))

	end,

	ENABLE_BATTLE_ITEM_FREE = function()

		cc.Director:getInstance():getRunningScene():getChildByName("level_info_layer").is_fish_guide = true

	end,

	DISABLE_BATTLE_ITEM_FREE = function()

		cc.Director:getInstance():getRunningScene():getChildByName("level_info_layer").is_fish_guide = false

	end,
	
}

return scripts