GameInit = {}
GameInit.initiated = false

GameInit.load_game_module = function()

	--[[ Load Modules ]]--

	require "GameEx.Foundations.MessagePool"
	require "GameEx.Foundations.Utils.InternalUtils"
	require "GameEx.Foundations.Utils.FileManipulator"
	require "GameEx.Foundations.ResourceManager"
	require "GameEx.Foundations.ConfigManager"
	require "core.TradeManager"
	require "core.RPC" 
	require "core.AccountManager"
	require "core.GameKernel"
	require "core.Player"
	require "core.MusicManager"
	require "core.ResourceManager"
	require "core.NotificationUtil"
	require "core.Game_Config"
	require "core.TutorialManagerEx"
	require "core.DialogManager"
	require "core.Mission_Data"
	require "core.Bag_Data"
	require "core.LayerManager"
	require "core.TaskManager"
	require "UI.Widget.ButtonWrap"
	require "UI.Widget.CommonUtil"
	require "UI.Widget.CommunicatingMask"
	require "UI.Scene.ExternalScene"
	require "UI.Scene.TestScene"
	require "core.SecuredNumber"
	require "UI.Layer.DeadLineLayer"
	require "SDK.MSDK.MSDK_Interface"
	require "core.RemoteArchiveManager"
	require "SDK.SDKUtil"

end

GameInit.init_game = function()

	if GameInit.initiated then return end

	GameInit.initiated = true

	--[[ Module Initialization ]]--

	RPC:get_instance():init()
    MessagePool:init()
    TradeManager:getInstance()
    FileManipulator:getInstance()
    ResourceManagerEx:get_instance():load_key_path_map()
    ConfigManager:get_instance():load_default_config()

    TutorialManager:get_instance():start()
    DialogManager:get_instance():start()

    GameKernel:getInstance()
    --[[ Load Savings ]]--

    -- GameKernel:getInstance():readPlayerData()


    --[[ Start Timer ]]--

    -- GameKernel:getInstance():run_time()

    -- TaskManager:getInstance():update_date()

end

GameInit.init_account = function()
	-- TutorialManager:get_instance():start()
 --    DialogManager:get_instance():start()

    GameKernel:getInstance():readPlayerData()
    GameKernel:getInstance():run_time()

    TaskManager:getInstance():update_date()

    RemoteArchiveManager:getInstance():clear()
end