MSDK_Interface = class("MSDK_Interface")
local JSON = require "core.JSON"

MSDK_Interface.CallbackFlag = {}
MSDK_Interface.CallbackFlag.eFlag_Succ = 0 
MSDK_Interface.CallbackFlag.eFlag_NotInWhiteList = -3
MSDK_Interface.CallbackFlag.eFlag_Need_Realname_Auth = 0
MSDK_Interface.CallbackFlag.eFlag_Login_NetworkErr = 0
MSDK_Interface.CallbackFlag.eFlag_WX_UserCancel = 2002 --玩家取消微信授权登录	返回登录界面，并告知玩家已取消微信授权登录
MSDK_Interface.CallbackFlag.eFlag_WX_NotInstall = 2000 --玩家设备未安装微信客户端	引导玩家安装微信客户端
MSDK_Interface.CallbackFlag.eFlag_WX_NotSupportApi = 2001 --玩家微信客户端不支持此接口	引导玩家升级微信客户端
MSDK_Interface.CallbackFlag.eFlag_WX_LoginFail = 2004 --微信登录失败	返回登录界面，引导玩家重新登录授权
MSDK_Interface.CallbackFlag.eFlag_Local_Invalid = -2 --账号自动登录失败, 包含本地票据过期, 刷新失败等所有错误	返回登录界面，引导玩家重新登录授权
MSDK_Interface.CallbackFlag.eFlag_AccountRefresh = 3004 --不存在异账号，MSDK已通过刷新接口将本地账号票据刷新	读取LoginRet结构体中的票据进行游戏授权流程
MSDK_Interface.CallbackFlag.eFlag_UrlLogin = 3002 --不存在异账号，游戏通过拉起账号快速登录成功	读取LoginRet结构体中的票据进行游戏授权流程
MSDK_Interface.CallbackFlag.eFlag_NeedSelectAccount = 3003 --游戏本地账号和拉起账号存在异账号	弹出对话框让用户选择登录的账号
MSDK_Interface.CallbackFlag.eFlag_NeedLogin = 3001--游戏本地账号和拉起账号均无法登录	返回登录界面，引导玩家重新登录授权

MSDK_Interface.ePlatform = {}
MSDK_Interface.ePlatform.ePlatform_None = 0
MSDK_Interface.ePlatform.ePlatform_Weixin = 1
MSDK_Interface.ePlatform.ePlatform_QQ = 2

function MSDK_Interface:ctor()

	self:setLoginCallback(function() end)
	self:setWakeupCallback(function() end)

end

function MSDK_Interface:login()



end

function MSDK_Interface:installed()

	return false;

end

function MSDK_Interface:login_QR()



end

function MSDK_Interface:logout()

	if MSDKJava then
		MSDKJava.logout()
	end

end

function MSDK_Interface:login_auto()

	MSDKJava.loginAuto()

end

function MSDK_Interface:setLoginCallback(callback)

	MSDK_Interface._login_callback = callback

end

function MSDK_Interface:setWakeupCallback(callback)

	MSDK_Interface._wakeup_callback = callback

end

function MSDK_Interface:get_platform()

	local info = JSON:decode(MSDKJava.getLoginRecord())

	if info then

		return info.platform

	end

end

function MSDK_Interface:get_open_id()

	local info = JSON:decode(MSDKJava.getLoginRecord())

	if info then

		return info.open_id

	end

end

function MSDK_Interface:switch_user(will_switch)
	--异账号时是否用拉起的账号登录游戏
	return MSDKJava.switchUser(will_switch)

end

function MSDK_Interface:url_login(platform)
	--用拉起的账号登录
	-- local warningLayer = WarningLayer:create()
 --    warningLayer:set_text_string("拉起账号登录")
 --    cc.Director:getInstance():getRunningScene():addChild(warningLayer, 9999)

	if cc.Director:getInstance():getRunningScene():getName() == "HomeScene" then
		local homeScene = HomeScene:create(platform)
	    cc.Director:getInstance():replaceScene(homeScene)
	end
end

function MSDK_Interface:need_select_account(platform)
	--弹出对话框让用户选择登录的账号
	local str2_table = {
		[0] = "游客",
		[1] = "微信",
		[2] = "QQ",
	}
    local commonPopupLayer = CommonPopupLayer:create()
    commonPopupLayer:disable_close()
    local str1 = "异平台提示"
    if platform == LOGIN_PLATFROM then
    	str1 = "异账号提示"
    end
    local str2 = string.format("此%s账号与当前游戏登录的%s账号\n不一致，是否切换账号？", str2_table[platform], str2_table[LOGIN_PLATFROM])
    local str3 = "切换"
    local str4 = "不切换"
    commonPopupLayer:showMessageWithTwoButton(str1, str2, str3, str4, function()
    	AccountManager:getInstance():logout()
    	local homeScene = HomeScene:create(platform)
	    cc.Director:getInstance():replaceScene(homeScene)
        commonPopupLayer:close_self()
    end, function() commonPopupLayer:close_self() end)
end

function MSDK_Interface:need_login(platform)
	--返回登录界面 重新登录
 	AccountManager:getInstance():logout()
 	if platform == MSDK_Interface.ePlatform.ePlatform_Weixin then
	    local homeScene = HomeScene:create(1)
	    cc.Director:getInstance():replaceScene(homeScene)
    elseif platform == MSDK_Interface.ePlatform.ePlatform_QQ then
		local homeScene = HomeScene:create(2)
	    cc.Director:getInstance():replaceScene(homeScene)
 	end
    
end

MSDK_Interface._login_callback = function(platform, ret_code, info) end
MSDK_Interface._wakeup_callback = function(platform, ret_code, info) end

MSDK_Interface.on_login = function(platform, ret_code, info)

	MSDK_Interface._login_callback(platform, ret_code, info)

end

MSDK_Interface.on_wakeup = function(platform, ret_code, info)
	
	MSDK_Interface._wakeup_callback(platform, ret_code, info)

end

return MSDK_Interface