require "core.LayerManager"
require "UI.Widget.MaskLayer"

AboutLayer = class("AboutLayer", function() return cc.Layer:create() end)

function AboutLayer:ctor()

    self:setName("AboutLayer")

	local widget = cc.CSLoader:createNode("about.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("about.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    

    local node = widget:getChildByName("node")

    -- 关闭按钮
    local close_image = node:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function AboutLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()

    self:removeFromParent()
end

function AboutLayer:onEnter()

end

function AboutLayer:onExit()
end

return AboutLayer