require "core.Bag_Data"
require "core.Shop_Item_Data"
require "UI.Layer.CommonPopupLayer"
require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.WarningLayer"
require "core.TalkingDataManager"
require "UI.Layer.SpecialGiftLayer"
BuyItemLayer = class("BuyItemLayer", function() return cc.Layer:create() end)

function BuyItemLayer:ctor()

    self:setName("BuyItemLayer")

    self.buy_num = 0
    self.item_id = ""
    self.shop_callback = nil
    self.buy_callback = nil
    self.energy_top_limit_callback = nil
    self.last_layer = nil
    self.widget = cc.CSLoader:createNode("buy_item.csb")
    self:addChild(self.widget, 1);

    self.widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(self.widget)

    self.animation = cc.CSLoader:createTimeline("buy_item.csb")
    self.widget:runAction(self.animation)

    self.animation:setCurrentFrame(0)
    self.animation:play("buy_item_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "buy_item_in_end" then

        elseif str == "buy_item_out_end" then
            self:removeFromParent()
        end
    end
    self.animation:setFrameEventCallFunc(onFrameEvent)

    -- ui
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
 
    -- 道具标题
    self.text_canopy = image_dia:getChildByName("text_canopy")

    -- 道具图片
    local image_item_dia = image_dia:getChildByName("image_item_dia")
    self.image_item = image_item_dia:getChildByName("image_item")

    -- 数量以及加减
    local image_sign_dia = image_item_dia:getChildByName("image_sign_dia")
    self.text_num = image_sign_dia:getChildByName("text_num")

    local minus_image = image_sign_dia:getChildByName("button_minus")
    local minus_Btn = ButtonWrap:create()
    self.minus_Btn = minus_Btn
    minus_Btn:wrap(minus_image, 1)
    minus_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.item_num  = self.item_num - 1
        self:update_num_and_price()
    end)

    local plus_image = image_sign_dia:getChildByName("button_plus")
    local plus_Btn = ButtonWrap:create()
    self.plus_Btn = plus_Btn
    plus_Btn:wrap(plus_image, 1)
    plus_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.item_num  = self.item_num + 1
        self:update_num_and_price()
    end)

    self.text_num = image_sign_dia:getChildByName("text_num")

    -- 道具描述
    self.text_des = image_item_dia:getChildByName("text_des")
    local image_price_dia = image_item_dia:getChildByName("image_price_dia")
    self.image_gold = image_price_dia:getChildByName("image_gold")
    self.text_gold = image_price_dia:getChildByName("text_gold")
    local player = Player:getInstance()

    local buy_image = image_item_dia:getChildByName("button_buy")
    local buy_Btn = ButtonWrap:create()
    buy_Btn:wrap(buy_image, 1)
    buy_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Buyitem_Audio"), false)
        
        if self.item_id == "item_401" then

            local cur_max_power = player:get_player_max_power()
            local cost = self.energy_toplimit_info[cur_max_power]
            local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id(self.item_id)
            if shop_item_info.currency == "jewel" then

                if self:is_currency_enought(shop_item_info.currency, cost) then
                    self:add_player_currency(shop_item_info.currency, -cost)
                    TalkingDataManager:getInstance():sendOnPurchase(self.item_id, self.item_num, cost)

                    self:buy_energy_top_limit_success()
                else
                    -- self:switch_to_shop_by_currency(shop_item_info.currency)  --113 钻石

                    local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
                    LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
                end
            elseif shop_item_info.currency == "rmb" then
                -- TradeManager:getInstance():raw_pay("购买体力上限"..cur_max_power, self.energy_toplimit_info[cur_max_power],
                --     function() self:buy_energy_top_limit_success() end, nil)
            end
        else
            local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id(self.item_id)
            local shop_cost = shop_item_info.cost
            if shop_item_info.discount < 10 then
                shop_cost = shop_item_info.sale_cost
            end
            local cost = math.ceil(self.item_num * shop_cost / shop_item_info.item_num)
            if self:is_currency_enought(shop_item_info.currency, cost) then
                self:add_player_currency(shop_item_info.currency, -cost)
                if shop_item_info.currency == "jewel" then
                    TalkingDataManager:getInstance():sendOnPurchase(self.item_id, self.item_num, shop_cost/shop_item_info.item_num)
                end

                player:add_player_bag_info_by_id(self.item_id, self.item_num)

                if self.buy_callback then
                    self.buy_callback()
                end
                
                if self.last_layer == "GameBackgroundLayer" then
                    TalkingDataManager:getInstance():send("游戏内道具购买次数统计", {["游戏内道具购买的item_id"] = self.item_id})
                end
                if self.last_layer == "ShopLayer" then
                    TalkingDataManager:getInstance():send("商店内道具购买次数统计", {["商店内道具购买的item_id"] = self.item_id})
                end
                if self.last_layer == "ShopEnergyLayer" then
                    TalkingDataManager:getInstance():send("体力界面各体力恢复方法购买次数统计", {["体力界面购买的item_id"] = self.item_id})
                end

                self:close_self()
            else
                -- self:switch_to_shop_by_currency(shop_item_info.currency) --113
                local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
                LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
            end
        end

    end)

    -- 按钮点击事件
    local closeImage = image_dia:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function BuyItemLayer:buy_energy_top_limit_success()
    local player = Player:getInstance()
    local cur_max_power = player:get_player_max_power()

    TalkingDataManager:getInstance():send("体力上限的购买次数统计", {["当前体力最大值"] = cur_max_power})

    local player_once_up_max_power = player:get_player_once_up_max_power()
    player:set_player_max_power(cur_max_power + player_once_up_max_power)
    
    local commonPopupLayer = CommonPopupLayer:create()
    commonPopupLayer:disable_close()
    local str1 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_4")
    local str2 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_5")
    local str3 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_3")
    commonPopupLayer:showMessage(str1, str2, str3, function()
        commonPopupLayer:close_self()
        self:close_self()
    end, nil)

    local max_power = player:get_player_max_power()
    if max_power >= player:get_player_toplimit_power() then
        local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("energyMax"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer) 
        
        if self.energy_top_limit_callback then
            self.energy_top_limit_callback()
        end
    end

    if self.buy_callback then
        self.buy_callback()
    end
end

function BuyItemLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.animation:play("buy_item_out", false)
end

function BuyItemLayer:add_player_currency(currency, num)
    local player = Player:getInstance()
    if currency == "gold" then
        player:add_player_gold(num)
    elseif currency == "jewel" then
        player:add_player_jewel(num)
    elseif currency == "rmb" then
    end
end

function BuyItemLayer:switch_to_shop_by_currency(currency)
    if currency == "gold" then
        if self.shop_callback then
            self.shop_callback()
        else
            local shopLayer = ShopLayer:create()
            shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
            LayerManager:getInstance():add_layer_to_scene(shopLayer)
            
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needGold"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        end
    elseif currency == "jewel" then
        if self.shop_callback then
            self.shop_callback()
        else
            local shopLayer = ShopLayer:create()
            shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
            LayerManager:getInstance():add_layer_to_scene(shopLayer)
            
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        end
    else

    end
end

function BuyItemLayer:set_shop_layer_callback(shop_callback)
    self.shop_callback = shop_callback
end

function BuyItemLayer:set_buy_callback(buy_callback)
    self.buy_callback = buy_callback
end

function BuyItemLayer:set_energy_top_limit_callback(energy_top_limit_callback)
    self.energy_top_limit_callback = energy_top_limit_callback
end

function BuyItemLayer:set_last_layer(last_layer)
    self.last_layer = last_layer
end

function BuyItemLayer:is_currency_enought(currency, num)
    local player = Player:getInstance()
    if currency == "gold" then
        if player:get_player_gold() >= num then
            return true
        else
            return false
        end
    elseif currency == "jewel" then
        if player:get_player_jewel() >= num then
            return true
        else
            return false
        end
    end
end

function BuyItemLayer:set_item(item_id)
    local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
    local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id(item_id)
    self.item_id = item_id
    self.item_num = shop_item_info.item_num

    self.text_canopy:setString(bag_info.item_name)
    self.image_item:setTexture(bag_info.res_key)
    
    self.text_des:setString(bag_info.description)
    self.image_gold:setTexture(Shop_Item_Data:getInstance():get_res_by_currency(shop_item_info.currency))

    self:update_num_and_price()
end

function BuyItemLayer:update_num_and_price()
    local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id(self.item_id)
    self.text_num:setString(self.item_num)

    local shop_cost = shop_item_info.cost
    if shop_item_info.discount < 10 then
        shop_cost = shop_item_info.sale_cost
    end
    self.text_gold:setString(math.ceil(self.item_num * shop_cost / shop_item_info.item_num))

    if self.item_id == "item_401" then
        local energy_toplimit_info = require "script.energy_toplimit_info"
        self.energy_toplimit_info = energy_toplimit_info
        local cur_max_power = Player:getInstance():get_player_max_power()
        self.text_gold:setString(energy_toplimit_info[cur_max_power])
    end

    if self.item_num > 1 then
        self.minus_Btn:enable()
        self.minus_Btn:setDarkButton(true)
    else
        self.minus_Btn:disable()
        self.minus_Btn:setDarkButton(false)
    end

    if self.item_num >= 10 then
        self.plus_Btn:disable()
        self.plus_Btn:setDarkButton(false)
    else
        self.plus_Btn:enable()
        self.plus_Btn:setDarkButton(true)
    end

end

--隐藏+-号
function BuyItemLayer:hide_minusBtn_and_plusBtn()
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local image_item_dia = image_dia:getChildByName("image_item_dia")

    local image_sign_dia = image_item_dia:getChildByName("image_sign_dia")

    local minus_image = image_sign_dia:getChildByName("button_minus")
    local plus_image = image_sign_dia:getChildByName("button_plus")
    minus_image:setVisible(false)
    plus_image:setVisible(false)
end
--

return BuyItemLayer