require "core.LayerManager"
require "UI.Widget.MaskLayer"

CaptureScreenLayer = class("CaptureScreenLayer", function() return cc.Layer:create() end)

function CaptureScreenLayer:ctor()

    self:setName("CaptureScreenLayer")

	local widget = cc.CSLoader:createNode("game_bkg.csb")
	self:addChild(widget)

	local visible_size = cc.Director:getInstance():getVisibleSize()
    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    local image_black = widget:getChildByName("image_black")
    image_black:setOpacity(0)

    local game_bkg = widget:getChildByName("game_bkg")
    game_bkg:setTexture("res/images/background/game_bkg_wg.jpg")
    game_bkg:setLocalZOrder(100)

    local bg = cc.Sprite:create("images/game/game_area_dia_2.png")
    bg:setPosition(cc.p(visible_size.width/2, visible_size.height/2))
    self:addChild(bg)

    local sp = cc.Sprite:create("images/shop/gold_3.png")
    sp:setPosition(cc.p(200,200))
    bg:addChild(sp)

    
    
    local function test()
        local render = cc.RenderTexture:create(visible_size.width, visible_size.height)
        render:begin()
        bg:visit()
        render:endToLua()
        render:retain()
        
        
        performWithDelay(self,function()
            
            local image = render:newImage()
            local fileName = FileManipulator:getInstance():getPath().."test.jpg"
            image:saveToFile(fileName)
            render:release()
        end, 0.3)
    end

    local  label1 = ccui.Text:create("截图", "images/font/zh_CN.TTF", 60)
    local  item1 = cc.MenuItemLabel:create(label1)
    item1:setPosition(cc.p(-300, 0))
    item1:registerScriptTapHandler(function()
        self:onCaptured()
    end)
    local  label2 = ccui.Text:create("saveToFile", "images/font/zh_CN.TTF", 60)
    local  item2 = cc.MenuItemLabel:create(label2)
    item2:setPosition(cc.p(0, 0))
    item2:registerScriptTapHandler(function()
        test()
        -- self:close_self()
    end)
    local  label3 = ccui.Text:create("关闭", "images/font/zh_CN.TTF", 60)
    local  item3 = cc.MenuItemLabel:create(label3)
    item3:setPosition(cc.p(300, 0))
    item3:registerScriptTapHandler(function()
        self:close_self()
    end)

    require "UI.Layer.ShareStageLayer"
    require "UI.Layer.LuckyMoveLayer"
    local  label4 = ccui.Text:create("最后一步", "images/font/zh_CN.TTF", 50)
    local  item4 = cc.MenuItemLabel:create(label4)
    item4:setPosition(cc.p(-300, -100))
    item4:registerScriptTapHandler(function()
        local luckyMoveLayer = LuckyMoveLayer:create()
        LayerManager:getInstance():add_layer_to_scene(luckyMoveLayer)
    end)
    local  label5 = ccui.Text:create("连续通关", "images/font/zh_CN.TTF", 50)
    local  item5 = cc.MenuItemLabel:create(label5)
    item5:setPosition(cc.p(0, -100))
    item5:registerScriptTapHandler(function()
        local shareStageLayer = ShareStageLayer:create(1)
        LayerManager:getInstance():add_layer_to_scene(shareStageLayer)
    end)
    local  label6 = ccui.Text:create("率先通关", "images/font/zh_CN.TTF", 50)
    local  item6 = cc.MenuItemLabel:create(label6)
    item6:setPosition(cc.p(300, -100))
    item6:registerScriptTapHandler(function()
        local shareStageLayer = ShareStageLayer:create(2)
        LayerManager:getInstance():add_layer_to_scene(shareStageLayer)
    end)

    local  label7 = ccui.Text:create("loadHead", "images/font/zh_CN.TTF", 50)
    local  item7 = cc.MenuItemLabel:create(label7)
    item7:setPosition(cc.p(-300, -200))
    item7:registerScriptTapHandler(function()
        local xhr = cc.XMLHttpRequest:new()

        xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
        xhr:open("GET", "http://q.qlogo.cn/qqapp/1105975780/2EC4A8A9DF54F0B0B15CC4657EC256F8/100")
        --http://q.qlogo.cn/qqapp/1105975780/3798D980FE931050E3F3B0CB2F467855/100
        --http://q.qlogo.cn/qqapp/1105975780/567C6BB8DFF34C6C30A589DA27BEE599/100
        local function onDownloadImage()
            if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
                local fileData = xhr.response
                local fullFileName = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID.."head_00"
                local file = io.open(fullFileName,"wb")
                file:write(fileData)
                file:close()

                -- if TalkingData then
                --     TalkingData.converToPng(fullFileName)
                -- end 
            end
        end
        xhr:registerScriptHandler(onDownloadImage)
        xhr:send()
    end)

    require "core.RemoteArchiveManager"
    local  label8 = ccui.Text:create("remove", "images/font/zh_CN.TTF", 50)
    local  item8 = cc.MenuItemLabel:create(label8)
    item8:setPosition(cc.p(0, -200))
    item8:registerScriptTapHandler(function()
        -- local filePath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID.."head_00"
        -- --print(filePath)
        -- local sp = ccui.ImageView:create(filePath)
        -- sp:setPosition(cc.p(500,500))
        -- sp:setScale(2)
        -- self:addChild(sp,1000)

        -- print(tostring(cc.FileUtils:getInstance():isFileExist(filePath)))

        -- os.execute("rm -rf " .. FileManipulator:getInstance():getPath().."head_cache")
        global_set_user_social_head()
    end)
    
    local  label9 = ccui.Text:create("printMani", "images/font/zh_CN.TTF", 50)
    local  item9 = cc.MenuItemLabel:create(label9)
    item9:setPosition(cc.p(-300, -300))
    item9:registerScriptTapHandler(function()

        -- local ta = RemoteArchiveManager.PARSER[9]()
        -- print(ta)
        -- local at = RemoteArchiveManager.deserialize(ta, ",", RemoteArchiveManager.DESERIALIZE_TYPE.NUMBER)
        -- print("at dump")
        -- print(at)

        -- RemoteArchiveManager:getInstance():load(function()end)

        local tb = SAFE_REQUIRE_NIL("version_manifest")
        local param = ""
        for k,v in pairs(tb) do
            param = string.format("%s%s%s%s%s", param, tostring(k), ":", tostring(v), ",")
        end
        local commonPopupLayer = CommonPopupLayer:create()
        commonPopupLayer:showLog("ccc", param, "enter", function()
            commonPopupLayer:close_self()
        end, nil)
        
    end)

    local  label10 = ccui.Text:create("print", "images/font/zh_CN.TTF", 50)
    local  item10 = cc.MenuItemLabel:create(label10)
    item10:setPosition(cc.p(0, -300))
    item10:registerScriptTapHandler(function()
        -- for i=1,9 do
        --     RemoteArchiveManager.REPLACER[i]()
        -- end

        local tb = SAFE_REQUIRE_NIL("account_data")
        local param = ""
        for k,v in pairs(tb) do
            param = string.format("%s%s%s%s%s", param, tostring(k), ":", tostring(v), ",")
        end
        local commonPopupLayer = CommonPopupLayer:create()
        commonPopupLayer:showLog("ccc", param, "enter", function()
            commonPopupLayer:close_self()
        end, nil)
        
    end)

    local menu = cc.Menu:create(item1, item2, item3, item4, item5, item6, item7, item8, item9, item10)
    menu:setPosition(cc.p(visible_size.width/2, visible_size.height*0.8))
    self:addChild(menu)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function CaptureScreenLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    self:removeFromParent()
end

function CaptureScreenLayer:onCaptured()
	local function afterCaptured(succeed, outputFile)
        if succeed then
        	print(outputFile)
        else
            print("Capture screen failed.")
        end
        
    end
    local fileName = "/mnt/sdcard/android/data/com.tencent.tmgp.lbxxtgsj/CaptureScreenTest.jpg"
    cc.utils:captureScreen(afterCaptured, fileName)
end

function CaptureScreenLayer:onEnter()
	
end

function CaptureScreenLayer:onExit()
end

return CaptureScreenLayer