require "core.LayerManager"
require "UI.Widget.MaskLayer"
CommonPopupLayer = class("CommonPopupLayer", function() return cc.Layer:create() end)

function CommonPopupLayer:ctor()

    self:setName("CommonPopupLayer")

    self.close_callback = nil
    self.get_callback = nil

	local widget = cc.CSLoader:createNode("common_popup.csb")
    self:addChild(widget, 1);
    self.widget = widget

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("common_popup.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("common_popup_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "common_popup_in_end" then

        elseif str == "common_popup_out_end" then
            self:retain()
            self:removeFromParent()
            self:autorelease()

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    self.image_black = node:getChildByName("image_black")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    self.text_title = image_dia:getChildByName("text_title")

    local image_text_dia = image_dia:getChildByName("image_text_dia")
    self.text_word = image_text_dia:getChildByName("text_word")

    -- 确定按钮
    local get_image = image_dia:getChildByName("button_get")
    self.get_image = get_image
    local get_Btn = ButtonWrap:create()
    get_Btn:wrap(get_image, 1)
    get_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if not(self.get_callback == nil) then
            self.get_callback()
        end
    end)
    self.get_Btn = get_Btn
    self.text_get = get_image:getChildByName("text_get")
    self.text_get:setLocalZOrder(1)

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    self.close_image = close_image
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        if not(self.close_callback == nil) then
            self.close_callback()
        end
        self:close_self()
    end)
    self.close_Btn = close_Btn
end

function CommonPopupLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("common_popup_out", false)
end

function CommonPopupLayer:showMessage(title, content, btn_text, get_callback, close_callback)
    self.text_title:setString(title)
    self.text_word:setScale(0.8)
    self.text_word:setString(content)
    self.text_get:setString(btn_text)
    self.get_callback = get_callback
    self.close_callback = close_callback

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    LayerManager:getInstance():add_layer_to_scene(self)
end

function CommonPopupLayer:showMessageWithTwoButton(title, content, btn_text1, btn_text2, get_callback, close_callback)
    self.text_title:setString(title)
    self.text_word:setScale(0.8)
    self.text_word:setString(content)
    self.get_callback = get_callback
    self.close_callback = close_callback

    local cancel_image = self.get_image:clone()
    local text_cancel = cancel_image:getChildByName("text_get")
    self.get_image:getParent():addChild(cancel_image)
    self.text_get:setString(btn_text1)
    text_cancel:setString(btn_text2)

    self.get_image:setPositionX(self.get_image:getPositionX()-200)
    cancel_image:setPositionX(cancel_image:getPositionX()+200)

    local cancel_Btn = ButtonWrap:create()
    cancel_Btn:wrap(cancel_image, 1)
    cancel_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        if not(self.close_callback == nil) then
            self.close_callback()
        end
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    LayerManager:getInstance():add_layer_to_scene(self)
end

function CommonPopupLayer:showLog(title, content, btn_text, get_callback, close_callback)
    self.text_title:setString(title)
    self.text_word:setScale(0.5)
    self.text_word:setString(content)
    self.text_get:setString(btn_text)
    self.get_callback = get_callback
    self.close_callback = close_callback

    local label = CCLabelTTF:create (content, "Arial", 40, CCSizeMake (20*30, 20*30), kCCTextAlignmentLeft)

    self.text_title:addChild(label)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    LayerManager:getInstance():add_layer_to_scene(self)
end

function CommonPopupLayer:showTips(title, content, btn_text, get_callback, close_callback)
    self.widget:setScale(0.5)
    self.image_black:setVisible(false)
    self.text_title:setString(title)
    self.text_word:setString(content)
    self.text_get:setString(btn_text)
    self.get_callback = get_callback
    self.close_callback = close_callback

    local visible_size = cc.Director:getInstance():getVisibleSize()
    self.widget:setPosition(cc.p(-visible_size.width*0.25, -visible_size.height* 0.15))
    LayerManager:getInstance():add_layer_to_scene(self)

    self.image_dia:setTouchEnabled(true)
    local function touchEventCallback(sender,eventType)
        return true
    end
    self.image_dia:addTouchEventListener(touchEventCallback)


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        if not(self.close_callback == nil) then
            self.close_callback()
        end
        self:close_self()
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self.image_dia:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function CommonPopupLayer:show_card_level(title, content, btn_text, get_callback, close_callback)
    self.widget:setScale(0.5)
    self.image_black:setVisible(false)
    self.text_title:setString(title)
    self.text_word:setString(content)
    self.text_get:setString(btn_text)
    self.get_callback = get_callback
    self.close_callback = close_callback

    local visible_size = cc.Director:getInstance():getVisibleSize()
    self.widget:setPosition(cc.p(-visible_size.width*0.25, -visible_size.height* 0.10))
    LayerManager:getInstance():add_layer_to_scene(self)

    self:runAction(cc.Sequence:create(cc.DelayTime:create(3.0), cc.CallFunc:create(function()
        self:close_self()
    end)))

    self.image_dia:setTouchEnabled(true)
    local function touchEventCallback(sender,eventType)
        self:stopAllActions()
        self:runAction(cc.Sequence:create(cc.DelayTime:create(3.0), cc.CallFunc:create(function()
            self.action:play("common_popup_out", false)
        end)))
        return true
    end
    self.image_dia:addTouchEventListener(touchEventCallback)


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        if not(self.close_callback == nil) then
            self.close_callback()
        end
        self.action:play("common_popup_out", false)
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self.image_dia:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function CommonPopupLayer:disable_close()
    self.close_image:setVisible(false)
end

function CommonPopupLayer:disable_get()
    self.get_image:setVisible(false)
end

function CommonPopupLayer:set_get_dark(flag)
    if flag then
        self.get_Btn:setDarkButton(flag)
        self.get_Btn:enable()
        self.text_get:setColor(cc.c3b(255, 255, 255))
        self.text_get:setOpacity(255)
    else
        self.get_Btn:setDarkButton(flag)
        self.get_Btn:disable()
        self.text_get:setColor(cc.c3b(50, 50, 50))
        self.text_get:setOpacity(150)
    end
end

function CommonPopupLayer:set_close_dark(flag)
    if flag then
        self.close_Btn:setDarkButton(flag)
        self.closeBtn:enable()
    else
        self.close_Btn:setDarkButton(flag)
        self.closeBtn:disable()
    end
end

return CommonPopupLayer