require "core.LayerManager"
require "UI.Widget.MaskLayer"

FriendAddLayer = class("FriendAddLayer", function() return cc.Layer:create() end)

function FriendAddLayer:ctor()

    self:setName("FriendAddLayer")
    self.searchResult = nil
    self.is_refresh = false
    self.close_callback = nil

	local widget = cc.CSLoader:createNode("friend_add.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("friend_add.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("friend_add_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "friend_add_in_end" then

        elseif str == "friend_add_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    
    self:init_system_recommend()
    self:init_search_by_id()

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function FriendAddLayer:init_system_recommend()
    local system = self.image_dia:getChildByName("system")
    local system_image = system:getChildByName("button_system")
    local system_triangle = system_image:getChildByName("image_right")
    self.system_triangle = system_triangle
    system_triangle:setRotation(90)
    local system_Btn = ButtonWrap:create()
    system_Btn:wrap(system_image, 1)
    system_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        if self.system_info:isVisible() then
            self.system_info:setVisible(false)
            self.system_triangle:setRotation(0)
            self.id:setPositionY(1080)
        else
            self.system_info:setVisible(true)
            self.system_triangle:setRotation(90)
            self.id:setPositionY(320)

            self.id_info:setVisible(false)
            self.search_triangle:setRotation(0)
        end
    end)

    local system_info = system:getChildByName("system_info")
    self.system_info = system_info
    local refresh_image = system_info:getChildByName("button_refresh")
    if not self.refresh_Btn then
        local refresh_Btn = ButtonWrap:create()
        self.refresh_Btn = refresh_Btn
        refresh_Btn:wrap(refresh_image, 1)
        refresh_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
            if self.is_refresh then
                print("init_system_recommend::")
                self:init_system_recommend()
            end
            
        end)
    end    

    local listview = system_info:getChildByName("listview")
    self.listview = listview
    local panel_1 = listview:getChildByName("panel_1")
    --listview:setScrollBarEnabled(false)
    if panel_1 then
        listview:setItemModel(panel_1:clone())
    end
    
    listview:removeAllItems()

    local function async_callback(list)
        self.is_refresh = true
        local recommendFriendsList = list

        local count = get_table_length(recommendFriendsList)
        for i=1,count do
            listview:pushBackDefaultItem()
        end
        for i=1,count do
            local item = listview:getItem(i -1)
            local image_dia_4 = item:getChildByName("image_dia_4")
            local text_nick_name = image_dia_4:getChildByName("text_name")
            local image_head = image_dia_4:getChildByName("image_id")
            local text_stage_num = image_dia_4:getChildByName("text_stage_num")
            local text_star_num = image_dia_4:getChildByName("text_star_num")
            
            local friend_info = recommendFriendsList[i]

            if friend_info.sex == "0" and friend_info.headUrl and friend_info.headUrl ~= "" then
                
                local function on_create_finish()
                    
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..friend_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(friend_info.guid, friend_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", friend_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end

            text_nick_name:setString(friend_info.name)
            text_stage_num:setString(friend_info.maxChapter+1)
            text_star_num:setString(friend_info.totalStar)

            local add_image = image_dia_4:getChildByName("button_add")
            local image_get = image_dia_4:getChildByName("image_get")
            add_image:setVisible(true)
            image_get:setVisible(false)
            local add_Btn = ButtonWrap:create()
            add_Btn:wrap(add_image, 1)
            add_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                image_get:setVisible(true)
                add_image:setVisible(false)
                 --每日任务事件发送
                local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
                event.param = {task_id = "task_10", finish_count = 1, func = function() end }
                 cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                --print(friend_info.guid)
                self:send_friendRequest(friend_info.guid)
            end)

        end
    end

    self:request_recommendFriends(async_callback)
    self.is_refresh = false

end

function FriendAddLayer:init_search_by_id()
    local id = self.image_dia:getChildByName("id")
    self.id = id
    self.id:setPositionY(320)
    local id_image = id:getChildByName("button_id")
    local search_triangle = id_image:getChildByName("image_right")
    self.search_triangle = search_triangle
    search_triangle:setRotation(0)
    local id_Btn = ButtonWrap:create()
    id_Btn:wrap(id_image, 1)
    id_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        if self.id_info:isVisible() then
            self.id_info:setVisible(false)
            self.search_triangle:setRotation(0)
        else
            self.system_info:setVisible(false)
            self.system_triangle:setRotation(0)
            self.id:setPositionY(1080)

            self.id_info:setVisible(true)
            self.search_triangle:setRotation(90)
        end
    end)

    local id_info = id:getChildByName("id_info")
    id_info:setVisible(false)
    self.id_info = id_info
    local image_inputbox = id_info:getChildByName("image_inputbox")
    local text_inputbox = image_inputbox:getChildByName("text")
    local search_image = id_info:getChildByName("button_search")    
    local image_mynum = id_info:getChildByName("image_mynum")
    local text_friend_num = image_mynum:getChildByName("text_friend_num")   

    local image_dia_5 = id_info:getChildByName("image_dia_5")
    image_dia_5:setVisible(false)
    local text_nick_name = image_dia_5:getChildByName("text_name")
    local image_head = image_dia_5:getChildByName("image_id")
    local text_stage_num = image_dia_5:getChildByName("text_stage_num")
    local invite_image = image_dia_5:getChildByName("button_invite")
    local text_invite = invite_image:getChildByName("text_invite")
    text_invite:setLocalZOrder(1)
    
    -- local head_id = string.format("head_%02d", math.random(1,14))
    -- local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
    -- image_head:loadTexture(head_info.res_key)

    text_friend_num:setString(PLAYER_ID)

    local search_Btn = ButtonWrap:create()
    search_Btn:wrap(search_image, 1)
    search_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        local str = text_inputbox:getString()
        if str == "" then
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("FriendAddLayer_3"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
            return
        end

        local function async_callback(list)
            self.searchResult = list
            if self.searchResult then
                image_dia_5:setVisible(true)
                text_nick_name:setString(self.searchResult.name)
                text_stage_num:setString(self.searchResult.maxChapter+1)

                if self.searchResult.sex == "0" and self.searchResult.headUrl and self.searchResult.headUrl ~= "" then
                
                    local function on_create_finish()
                        local headPath = FileManipulator:getInstance():getPath().."head_cache/"..self.searchResult.guid.."head_00"
                        if cc.FileUtils:getInstance():isFileExist(headPath) then
                            image_head:loadTexture(headPath)
                        end
                    end
                    global_create_social_head(self.searchResult.guid, self.searchResult.headUrl, on_create_finish)

                else
                    local head_id = string.format("head_%02d", self.searchResult.sex+1)
                    local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                    image_head:loadTexture(head_info.res_key)
                end
                

                if self.searchResult.bIsfriend == "1" or tonumber(self.searchResult.guid) == PLAYER_ID then
                    invite_image:setVisible(false)
                    print("你们已经是好友")
                else
                    invite_image:setVisible(true)
                end

                if self.invite_Btn then
                    self.invite_Btn:setDarkButton(true)
                    self.invite_Btn = nil
                    text_invite:setColor(cc.c3b(31, 94, 139))
                    text_invite:setOpacity(255)
                    text_invite:setString("邀请")
                end
                self.invite_Btn = ButtonWrap:create()
                self.invite_Btn:wrap(invite_image, 1)
                self.invite_Btn:addTouchEndCallback(function()
                    MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
                    self.invite_Btn:disable()
                    self.invite_Btn:setDarkButton(false)
                    text_invite:setColor(cc.c3b(0, 0, 0))
                    text_invite:setOpacity(255 * 0.5)
                    text_invite:setString("已发送")
                    
                    --print(self.searchResult.guid)
                    self:send_friendRequest(self.searchResult.guid)
                end)
            end
        end

        self:request_searchFriendById(async_callback, str)

    end)

    --
    local function editBoxTextEventHandle(strEventName, pSender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if strEventName == "began" then
        elseif strEventName == "ended" then
        elseif strEventName == "return" then
            text_inputbox:setString(pSender:getText())
        elseif strEventName == "changed" then
        end
    end
    local box_size = image_inputbox:getContentSize()
    local EditName = cc.EditBox:create(cc.size(box_size.width, box_size.height), image_inputbox:getResourcePath())
    EditName:setPosition(image_inputbox:getPosition())
    EditName:setFontName("images/font/zh_CN.TTF")
    EditName:setFontSize(30)
    EditName:setFontColor(cc.c3b(145,93,32))
    EditName:setPlaceHolder(ResourceManager:getInstance():getTextStringByKey("FriendAddLayer_1"))
    EditName:setPlaceholderFontName("images/font/zh_CN.TTF")
    EditName:setPlaceholderFontSize(30)
    EditName:setPlaceholderFontColor(cc.c3b(145,93,32))
    EditName:setMaxLength(10)
    EditName:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    EditName:setReturnType(cc.KEYBOARD_RETURNTYPE_DEFAULT)
    --Handler
    EditName:registerScriptEditBoxHandler(editBoxTextEventHandle)
    id_info:addChild(EditName, 1)

    EditName:setText(text_inputbox:getString())

    image_inputbox:setVisible(false)

end

function FriendAddLayer:close_self()
    if self.close_callback then
        self.close_callback()
    end

    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("friend_add_out", false)

    set_list_fade_out(self.listview)
end

function FriendAddLayer:set_close_callback(callback)
    self.close_callback = callback
end

function FriendAddLayer:request_recommendFriends(async_callback)
    --request recommendFriends 推荐好友列表
    local rpc_param = {

        PLAYER_ID,

    }

    RPC:call_bind("SHIN/friend/recommendFriends", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            async_callback(response)

        else

            print("request error")

        end

    end)
end

function FriendAddLayer:request_searchFriendById(async_callback, search_id)
    --request searchFriendById 查找好友结果
    local rpc_param = {
        PLAYER_ID,
        search_id,

    }

    RPC:call_bind("SHIN/friend/searchFriendById", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
            async_callback(response)

        else

            print("request error")
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("FriendAddLayer_2"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)

        end

    end)
end

function FriendAddLayer:send_friendRequest(friendid)
    --send 发送好友请求
    local rpc_param = {
        PLAYER_ID,
        friendid,
        1,
        0,

    }

    RPC:call_bind("SHIN/message/newMsg", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            -- print("好友请求发送成功")
            local player = Player:getInstance()
            local today_challenge_num = player:get_player_weekly_challenge_today_challenge_num()
            local go_to_play_times = player:get_player_weekly_challenge_go_to_play_times()
            if today_challenge_num == 0 and go_to_play_times < 0 then
                local add_friend_times = player:get_player_weekly_challenge_add_friend_times() + 1
                player:set_player_weekly_challenge_add_friend_times(add_friend_times)
                if add_friend_times >= 3 then
                    player:set_player_weekly_challenge_today_challenge_num(1)
                    player:set_player_weekly_challenge_add_friend_times(-1)
                    TalkingDataManager:getInstance():send("周赛次数统计", {["玩家完成”添加好友“来获取周赛机会的次数"] = "次数"})
                end
            end

        else

            print("request error")

        end

    end)
end

-- function FriendAddLayer:test_data()
--     local list = {}
--     for i=1,5 do
--         list[i] = {
--             ["guid"] = string.format("id%d", i),
--             ["name"] = string.format("nick_name%d", i),
--             ["maxChapter"] = i,
--             ["totalStar"] = i*2,
--             ["suo_yao"] = false,
--             ["zeng_song"] = false,
--             ["logintime"] = string.format("%d小时", i),
--         }
--     end
--     return list
-- end

function FriendAddLayer:onEnter()
    RPC:register_target(self)
end

function FriendAddLayer:onExit()
    RPC:unregister_target(self)
end

return FriendAddLayer