require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.FriendAddLayer"

FriendLayer = class("FriendLayer", function() return cc.Layer:create() end)

function FriendLayer:ctor()

    self:setName("FriendLayer")
    self.is_show_delete_panel = false
    self.sendgiftnum_limit = 20

	local widget = cc.CSLoader:createNode("friend.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("friend.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("friend_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "friend_in_end" then

        elseif str == "friend_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    
    local add_image = image_dia:getChildByName("button_add")
    local text_add = add_image:getChildByName("text_add")    
    local delete_image = image_dia:getChildByName("button_delete")
    local text_delete = delete_image:getChildByName("text_delete")
    local energy_image = image_dia:getChildByName("button_free")
    self:initListview()

    self.scheduleScriptEntryID = nil

    --添加好友按钮
    local add_Btn = ButtonWrap:create()
    add_Btn:wrap(add_image, 1)
    add_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        if self.is_show_delete_panel then
            
            self.delete_num = 0
            for k,v in pairs(self.image_get_vector) do
                if v:isVisible() then
                    
                    self.delete_num = self.delete_num + 1
                    print(self.friendList[k].guid)
                    self:send_unfriend(self.friendList[k].guid)
                end
            end

            --启动定时器扫描self.delete_num是否为0
            if self.delete_num ~= 0 then
                local function check_delete_num()
                    print("self.delete_num是否为0")
                    if self.delete_num == 0 then

                        self:initListview()
                        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleScriptEntryID)
                        self.scheduleScriptEntryID = nil
                    end
                end
                self.scheduleScriptEntryID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(check_delete_num, 0.1, false)
            end

            self:show_delete_panel(false)
            text_delete:setString("删除好友")
            text_add:setString("添加好友")
            -- performWithDelay(self,function() 
            --     self:initListview()
            -- end, 0.1)
            

        else
            local friendAddLayer = FriendAddLayer:create()
            LayerManager:getInstance():add_layer_to_scene(friendAddLayer) 
        end
    end)
    --删除好友按钮
    local delete_Btn = ButtonWrap:create()
    delete_Btn:wrap(delete_image, 1)
    delete_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        if self.info_Btn_vector then
            if self.is_show_delete_panel then
                self:show_delete_panel(false)
                text_delete:setString("删除好友")
                text_add:setString("添加好友")

                for k,v in pairs(self.image_get_vector) do
                    v:setVisible(false)
                end
            else
                self:show_delete_panel(true)
                text_delete:setString("取消")
                text_add:setString("确定删除")
            end
        end
    end)
    --免费体力按钮
    -- local energy_Btn = ButtonWrap:create()
    -- energy_Btn:wrap(energy_image,1)
    -- energy_Btn:addTouchEndCallback(function()
    --      MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
    --     end)    
    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function FriendLayer:initListview()
    local text_friend_num = self.image_dia:getChildByName("text_friend_num")
    text_friend_num:setVisible(false)
    
    local listview = self.image_dia:getChildByName("listview")
    self.listview = listview
    local panel_1 = listview:getChildByName("panel_1")
    --listview:setScrollBarEnabled(false)
    listview:setItemModel(panel_1:clone())
    listview:removeAllItems()



    local function async_callback(list)

        local friendList = list
        self.friendList = friendList

        local count = get_table_length(friendList)
        self.count = count
        text_friend_num:setString(string.format("当前好友数：%d/99", count - 1))
        text_friend_num:setVisible(true)

        for i=1,count do
            listview:pushBackDefaultItem()
        end
        local rank_res = {
            [1] = "images/section/friend/rank_first.png",
            [2] = "images/section/friend/rank_second.png",
            [3] = "images/section/friend/rank_third.png",
        }
        self.image_info_vector = {}
        self.info_Btn_vector = {}
        self.image_get_vector = {}
        for i=1,count do
            local item = listview:getItem(i -1)
            local image_info = item:getChildByName("image_info")
            local demand_image = image_info:getChildByName("button_demand")
            local text_demand = demand_image:getChildByName("text_demand")
            text_demand:setLocalZOrder(1)
            local give_image = image_info:getChildByName("button_give")
            local text_give = give_image:getChildByName("text_give")
            text_give:setLocalZOrder(1)
            image_info:setVisible(false)
            self.image_info_vector[i] = image_info

            local info = item:getChildByName("info")
            local image_rank_num = info:getChildByName("image_rank_num")
            local text_rank_num = info:getChildByName("text_rank_num")
            local text_nick_name = info:getChildByName("text_name")
            local image_head = info:getChildByName("image_id")
            local text_stage_num = info:getChildByName("text_stage_num")

            local image_star = info:getChildByName("image_star")
            local text_star_num = image_star:getChildByName("text_star_num")
            
            local panel_delete = info:getChildByName("panel_delete")
            panel_delete:setVisible(false)
            local image_select = panel_delete:getChildByName("image_select")
            local text_time = image_select:getChildByName("text_time")
            local image_get = image_select:getChildByName("image_get")
            local image_kong = image_select:getChildByName("image_kong")
            image_kong:setTouchEnabled(false)
            image_get:setTouchEnabled(false)
            image_get:setVisible(false)
            self.image_get_vector[i] = image_get

            --打钩
            local select_Btn = ButtonWrap:create()
            select_Btn:wrap(image_select, 1)
            select_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                if image_get:isVisible() then
                    image_get:setVisible(false)
                else
                    image_get:setVisible(true)
                end
            end)

            --索要体力按钮
            local demand_Btn = ButtonWrap:create()
            demand_Btn:wrap(demand_image, 1)
            demand_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                demand_Btn:disable()
                demand_Btn:setDarkButton(false)
                text_demand:setColor(cc.c3b(0, 0, 0))
                text_demand:setOpacity(255 * 0.5)
                text_demand:setString("已请求")

                
                print(friendList[i].guid)
                self:send_requestGift(friendList[i].guid)

            end)
            --赠送体力按钮
            local give_Btn = ButtonWrap:create()
            give_Btn:wrap(give_image, 1)
            give_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                give_Btn:disable()
                give_Btn:setDarkButton(false)
                text_give:setColor(cc.c3b(0, 0, 0))
                text_give:setOpacity(255 * 0.5)
                text_give:setString("已发送")
                
                print(friendList[i].guid)
                self:send_sendGift(friendList[i].guid)
                  --每日任务事件发送
                local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
                event.param = {task_id = "task_09", finish_count = 1, func = function() end }
                cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)

            end)
            local function place_button()
                if demand_Btn:isDarkButton() then
                    give_image:setPositionX(430)
                    demand_image:setVisible(false)
                end
                if give_Btn:isDarkButton() then
                    demand_image:setPositionX(430)
                    give_image:setVisible(false)
                end
            end

            local info_Btn = ButtonWrap:create()
            self.info_Btn_vector[i] = info_Btn
            info_Btn:wrap(info, 1)
            info_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                --判断其他项是否有显示image_info，没有则显示当前的，有则再判断当前是不是当前项的image_info，是则关闭当前项的image_info，否则先关闭其他项的image_info再显示当前项的image_info
                local is_have = false
                local index = 0
                for j=1,count do
                    if self.image_info_vector[j]:isVisible() then
                        is_have = true
                        index = j
                        break
                    end
                end
                if is_have then
                    if index == i then
                        image_info:setVisible(false)
                        self:move_items_behind(i, true)
                    else
                        self.image_info_vector[index]:setVisible(false)
                        self:move_items_behind(index, true)

                        image_info:setVisible(true)
                        self:move_items_behind(i, false)
                        place_button()
                    end
                else
                    image_info:setVisible(true)
                    self:move_items_behind(i, false)
                    place_button()
                end
            end)


            if i < 4 then
                text_rank_num:setVisible(false)
                image_rank_num:setVisible(true)
                image_rank_num:loadTexture(rank_res[i])
            else
                image_rank_num:setVisible(false)
                text_rank_num:setVisible(true)
                text_rank_num:setString(i)
            end

            local friend_info = friendList[i]

            if friend_info.sex == "0" and friend_info.headUrl and friend_info.headUrl ~= "" then
                
                local function on_create_finish()
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..friend_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(friend_info.guid, friend_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", friend_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end
            
            text_nick_name:setString(friend_info.name)
            text_star_num:setString(friend_info.totalStar)
            text_stage_num:setString(friend_info.maxChapter+1)
            local tab = os.date("%x", friend_info.logintime)
            text_time:setString(tab)
            if friend_info.isRequestGift then
                demand_Btn:disable()
                demand_Btn:setDarkButton(false)
                place_button()
            end
            if friend_info.isSendGift then
                give_Btn:disable()
                give_Btn:setDarkButton(false)
                place_button()
            end
            --我
            if friend_info.guid == PLAYER_ID then
                -- local player_head_id = Player:getInstance():get_player_head_id()
                -- if player_head_id == "head_00" then
                --     local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
                --     image_head:loadTexture(headPath)
                -- else
                --     local head_info = Head_Data:getInstance():get_head_info_by_id(player_head_id)
                --     image_head:loadTexture(head_info.res_key)
                -- end

                info:loadTexture("images/section/friend/friend_rank_2.png")
                give_image:setVisible(false)
                demand_image:setVisible(false)
                image_select:setVisible(false)
            else
                info:loadTexture("images/section/friend/friend_rank_1.png")
                give_image:setVisible(true)
                demand_image:setVisible(true)
                image_select:setVisible(true)
            end

        end

        performWithDelay(self,function() 
            local size = listview:getInnerContainerSize()
            listview:setInnerContainerSize(cc.size(size.width,size.height+120))
            end, 0.1)
    end

    self:request_getFriendlist(async_callback)
end

function FriendLayer:move_items_behind(index, flag)
    for i=index+1,self.count do
        local item = self.listview:getItem(i -1)
        if flag then
            --上移
            --item:setPositionY(item:getPositionY()+100)
            item:runAction(cc.MoveTo:create(0.3, cc.p(item:getPositionX(), item:getPositionY()+100)))
        else
            --下移
            --item:setPositionY(item:getPositionY()-100)
            item:runAction(cc.MoveTo:create(0.3, cc.p(item:getPositionX(), item:getPositionY()-100)))
        end
    end
end

function FriendLayer:show_delete_panel(flag)
    if flag then
        self.is_show_delete_panel = true
        for i=1,self.count do
            local item = self.listview:getItem(i -1)
            local info = item:getChildByName("info")
            local image_star = info:getChildByName("image_star")            
            local panel_delete = info:getChildByName("panel_delete")
            image_star:setVisible(false)
            panel_delete:setVisible(true)

            self.info_Btn_vector[i]:disable()
            local is_have = false
            local index = 0
            for j=1,self.count do
                if self.image_info_vector[j]:isVisible() then
                    is_have = true
                    index = j
                    break
                end
            end
            if is_have then
                self.image_info_vector[index]:setVisible(false)
                self:move_items_behind(index, true)
            end
        end
    else
        self.is_show_delete_panel = false
        for i=1,self.count do
            local item = self.listview:getItem(i -1)
            local info = item:getChildByName("info")
            local image_star = info:getChildByName("image_star")
            local panel_delete = info:getChildByName("panel_delete")
            image_star:setVisible(true)
            panel_delete:setVisible(false)

            self.info_Btn_vector[i]:enable()
        end
    end
    
end

function FriendLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("friend_out", false)

    set_list_fade_out(self.listview)
    if self.scheduleScriptEntryID then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleScriptEntryID)
    end 
end

function FriendLayer:request_getFriendlist(async_callback)
    --request getFriendlist 当前好友列表
    local rpc_param = {

        PLAYER_ID,

    }

    RPC:call_bind("SHIN/friend/getFriendlist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if response == nil then
                response = {}
            end 
            async_callback(response)

        else
            print("request error")

        end

    end)
end

function FriendLayer:send_unfriend(friendid)
    --send unfriend 删除好友
    local rpc_param = {

        PLAYER_ID,
        friendid,

    }

    RPC:call_bind("SHIN/friend/unfriend", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            self.delete_num = self.delete_num - 1
            -- self:initListview()
        else

            print("request error")

        end

    end)
end

function FriendLayer:send_requestGift(friendid)
    --send requestGift 请求体力
    local rpc_param = {
        PLAYER_ID,
        friendid,
        3,
        0,

    }

    RPC:call("SHIN/message/newMsg", rpc_param, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
        else

            print("request error")

        end

    end)
end

function FriendLayer:send_sendGift(friendid)
    --send sendGift 赠送体力
    local rpc_param = {
        PLAYER_ID,
        friendid,
        2,
        0,

    }

    RPC:call_bind("SHIN/message/newMsg", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(string.format(ResourceManager:getInstance():getTextStringByKey("FriendLayer_1"), self.sendgiftnum_limit - response.sendgiftnum))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        else

            print("request error")

        end

    end)
end

function FriendLayer:test_data()
    local list = {}
    for i=1,10 do
        list[i] = {
            ["guid"] = string.format("id%d", i),
            ["name"] = string.format("nick_name%d", i),
            ["sex"] = i,
            ["headUrl"] = nil,
            ["maxChapter"] = i,
            ["totalStar"] = i*2,
            ["sendgiftnum"] = 0,
            ["gotgiftnum"] = 0,
            ["logintime"] = os.time(),
            ["isRequestGift"] = false,
            ["isSendGift"] = false,
        }
    end
    return list
end

function FriendLayer:onEnter()
    RPC:register_target(self)
end

function FriendLayer:onExit()
    RPC:unregister_target(self)
end

return FriendLayer