require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "core.TalkingDataManager"

GameLeaveLayer = class("GameLeaveLayer", function() return cc.Layer:create() end)

function GameLeaveLayer:ctor()

    self:setName("GameLeaveLayer")
    
    self.exit = false
	local widget = cc.CSLoader:createNode("game_leave.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("game_leave.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("exit_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "exit_in_end" then

        elseif str == "exit_continue_end" then
            if self.exit then
                LayerManager:getInstance():remove_top_layer()
                local loadingScene = LoadingScene:create(1)
                loadingScene:load_extern_scene_resource()
                loadingScene:set_load_finish_callback(function()

                    local section_mission = Player:getInstance():get_player_current_section()
                    LayerManager:getInstance():clear_layer()
                    local externalScene = ExternalScene:create()
                    externalScene:add_map(section_mission)
                    externalScene:play_bg_music()
                    cc.Director:getInstance():replaceScene(externalScene)

                end)
                cc.Director:getInstance():replaceScene(loadingScene)
            else
                self:removeFromParent()
            end
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    -- 按钮点击事件
    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    --8.26
    local player = Player:getInstance()
    local text_1 = image_dia:getChildByName("text_1")
    if not player:get_is_player_handle_in_game() then
        local image_shinchan = image_dia:getChildByName("image_shinchan")
        image_shinchan:setVisible(false)
        
        text_1:setString(ResourceManager:getInstance():getTextStringByKey("GameLeaveLayer_1"))
        text_1:setPosition(text_1:getPositionX()+85, text_1:getPositionY()-100)
    else
        text_1:setString(ResourceManager:getInstance():getTextStringByKey("GameLeaveLayer_2"))
    end
    --8.26

    local exitImage = image_dia:getChildByName("button_exit")
    local exitBtn = ButtonWrap:create()
    exitBtn:wrap(exitImage, 1)
    exitBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self.exit = true
        --8.26
        if not player:get_is_player_handle_in_game() then
            player:add_player_power(player:get_play_once_need_power())
        else
            
            local current_level = Player:getInstance():get_player_current_level()
            local str_level = "关卡"..current_level
            TalkingDataManager:getInstance():send("关卡失败原因", {[str_level] = "退出游戏"})
            TalkingDataManager:getInstance():sendMissionInfo("failed", str_level, "退出游戏")

            
            local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
            player:add_player_mission_fail_times(mission_info.mission_id)
        end
        --8.26
        self:close_self()
    end)

    local continueImage = image_dia:getChildByName("button_continue")
    local continueBtn = ButtonWrap:create()
    continueBtn:wrap(continueImage, 1)
    continueBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.exit = false
        self:close_self()
    end)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function GameLeaveLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("exit_continue", false)
end

return GameLeaveLayer

