require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Widget.BagRewardWidget"
require "core.Gift_Data"
require "core.TalkingDataManager"

GetNewSystemLayer = class("GetNewSystemLayer", function() return cc.Layer:create() end)

function GetNewSystemLayer:ctor()

    self:setName("GetNewSystemLayer")
    
    self.close_callback = nil
    self.system_name = nil
    self.is_gift = nil

	local widget = cc.CSLoader:createNode("get_new_system.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    --bag_get_reward
    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 2)

    -- ui
    local text_word = widget:getChildByName("text_word")
    self.title = widget:getChildByName("text_word")
    self.image_icon = widget:getChildByName("image_icon")
    self.text_word_0 = widget:getChildByName("text_word_0")
    self.text_num = widget:getChildByName("text_num")
    self.text_num:setVisible(false)

    -- 关闭按钮
    local close_image = widget:getChildByName("button_close")
    self.text_close = close_image:getChildByName("text_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function GetNewSystemLayer:close_self()
    self:addChild(MaskLayer:create(), 5)

    if self.is_gift then
        local gift_info = Gift_Data:getInstance():get_gift_info_by_id(self.system_name)
        local item_id = gift_info.item_id
        local item_num = gift_info.item_num
        Player:getInstance():add_player_bag_info_by_id(item_id, item_num)
        if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
            if item_id == "item_03" then
                TalkingDataManager:getInstance():sendOnReward(item_num,"关卡礼物")
            end
        else
            local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
            self.bag_reward:setItemTexture(bag_info.res_key)
            self.bag_reward:setTouchEnabled(true)
            self.bag_reward:runAction()
        end

        self:runAction(cc.Sequence:create(cc.DelayTime:create(0.7), cc.CallFunc:create(function()
            if self.close_callback then
                self.close_callback()
            end
            LayerManager:getInstance():remove_top_layer()
            self:removeFromParent()
        end)))    
    else      
        if self.close_callback then
            self.close_callback()
        end  
        LayerManager:getInstance():remove_top_layer()
        self:removeFromParent()
    end
    
end

function GetNewSystemLayer:set_cur_system(system_name)
    self.system_name = system_name
    local text = "sign_system_text"
    if self.system_name == "sign" then
        self.image_icon:setTexture("images/section/sign_in.png")
        text = "sign_system_text"
    elseif self.system_name == "task" then
        self.image_icon:setTexture("images/section/mission.png")
        text = "task_system_text"
    elseif self.system_name == "weekgame" then
        self.image_icon:setTexture("images/section/weekgame.png")
        text = "weekgame_system_text"
    elseif self.system_name == "invite_reward" then
        self.image_icon:setTexture("images/section/invite_reward.png")
        text = "invite_reward_system_text"
    else
        local gift_info = Gift_Data:getInstance():get_gift_info_by_id(self.system_name)
        local bag_info = Bag_Data:getInstance():get_bag_info_by_id(gift_info.item_id)
        self.image_icon:setTexture(bag_info.res_key)
        self.text_num:setVisible(true)
        self.text_num:setString(string.format("x%d",gift_info.item_num))

        text = "gift_text"
        self.title:setString(ResourceManager:getInstance():getTextStringByKey("gift_title"))
        self.text_close:setString(ResourceManager:getInstance():getTextStringByKey("gift_get"))
        self.is_gift = true
    end
    self.text_word_0:setString(ResourceManager:getInstance():getTextStringByKey(text))
end

function GetNewSystemLayer:set_close_callback(callback)
    self.close_callback = callback
end

return GetNewSystemLayer