require "core.LayerManager"
require "core.Role_Data"
require "core.Skin_Data"
require "UI.Widget.MaskLayer"

GetRoleLayer = class("GetRoleLayer", function() return cc.Layer:create() end)

function GetRoleLayer:ctor()

    self:setName("get_role_layer")

    self.role_id = ""
	local widget = cc.CSLoader:createNode("get_role.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("get_role.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("get_role_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "get_role_in_end" then

            self.__c_mask_layer:setEnabled(false)

            local call_func = cc.CallFunc:create(function()

                local event = cc.EventCustom:new("role_aquired")
                event.param = {}   
                cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)

            end)
            local sequence = cc.Sequence:create(delay, call_func)

            self:runAction(sequence)

        elseif str == "get_role_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local panel_info = node:getChildByName("panel_info")
    -- ui
    -- 人物
    local text_word = panel_info:getChildByName("text_word")
    self.image_role = node:getChildByName("image_role")
    self.text_name = node:getChildByName("text_name")

    -- 加成
    local image_atk = panel_info:getChildByName("image_atk")
    self.atk_text_num = image_atk:getChildByName("text_num")

    local image_gold_bonus = panel_info:getChildByName("image_gold_bonus")
    self.gold_text_num = image_gold_bonus:getChildByName("text_num")

    local image_score_bonus = panel_info:getChildByName("image_score_bonus")
    self.score_text_num = image_score_bonus:getChildByName("text_num")

    -- 去看看
    local role_image = node:getChildByName("button_role")
    local role_Btn = ButtonWrap:create()
    role_Btn:wrap(role_image, 1)
    role_Btn:set_cur_scale(1.0, 1.0)
    role_Btn:addTouchEndCallback(function()

        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        local show = function()

            self:close_self()

            local delay = cc.DelayTime:create(0)
            local call_func = cc.CallFunc:create(function()

                self:go_and_see()

            end)
            local sequence = cc.Sequence:create(delay, call_func)
            cc.Director:getInstance():getRunningScene():runAction(sequence)

        end

        local event_config = {

            {["name"] = "ROLE_UNLOCK_GO_CLICK"}

        }

        local call_info = {

            func = show,

        }

        HOOKABLE_CALL(event_config, call_info)

    end)

    -- 按钮点击事件
    local close_image = panel_info:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    self.__c_mask_layer = MaskLayer:create()
    self.__c_mask_layer:setEnabled(true)
    self:addChild(self.__c_mask_layer, 9999)
end

function GetRoleLayer:go_and_see()

    local role_info = Role_Data:getInstance():get_role_info_by_id(self.role_id)
    Player:getInstance():set_player_cur_role_id(role_info.role_id)
    Player:getInstance():set_player_cur_skin_id(role_info.skin_id_list[1])

    local roleInfoLayer = RoleInfoLayer:create()
    roleInfoLayer:set_go_on_enable(false)
    LayerManager:getInstance():add_layer_to_scene(roleInfoLayer)
    self:close_self()

end

function GetRoleLayer:lets_go_and_see()

    local loadingScene = LoadingScene:create(1)
    loadingScene:load_extern_scene_resource()
    loadingScene:set_load_finish_callback(function()

        local player = Player:getInstance()
        -- 判断下一关是否是新解锁的章节
        local next_level = player:get_player_next_level()
        local mission_info = Mission_Data:getInstance():get_mission_info_by_level(next_level)
        local section_index = mission_info.mission_section
        local player_section_info = player:get_player_section_info_by_id(section_index)

        LayerManager:getInstance():clear_layer()
        local externalScene = ExternalScene:create()
        externalScene:play_bg_music()
        print(player_section_info.is_animation)
        if player_section_info.is_animation then
            externalScene:move_and_enter_section_map(section_index, next_level)
        else
            externalScene:switch_to_level_info_without_show(section_index, next_level)
        end
        cc.Director:getInstance():replaceScene(externalScene)


    end)
    LayerManager:getInstance():clear_layer()
    cc.Director:getInstance():replaceScene(loadingScene)

end

function GetRoleLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("get_role_out", false)
end

function GetRoleLayer:set_cur_role(role_id)
    self.role_id = role_id
    local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
    local skin_info = Skin_Data:getInstance():get_skin_info_by_id(role_info.skin_id_list[1])
    self.image_role:setTexture(skin_info.res_key)
    self.text_name:setString(role_info.role_name)
    self.atk_text_num:setString(string.format("+%d", skin_info.init_atk))
    self.gold_text_num:setString(string.format("+%d%%", skin_info.init_gold_add * 100))
    self.score_text_num:setString(string.format("+%d%%", skin_info.init_score_add * 100))

    self:runAction(cc.Sequence:create(cc.DelayTime:create(1.0), cc.CallFunc:create(function()
        
        TRIGGER_EVENT("ROLE_UNLOCK_SHOW", {id = role_id})

    end)))

end

return GetRoleLayer