require "core.Skin_Data"
require "core.Role_Data"
require "core.LayerManager"
require "UI.Widget.MaskLayer"

GetSkinLayer = class("GetSkinLayer", function() return cc.Layer:create() end)

function GetSkinLayer:ctor()

    self:setName("GetSkinLayer")

    self.skin_id = ""
	local widget = cc.CSLoader:createNode("get_skin.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("get_skin.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("get_skin_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "get_skin_in_end" then
        elseif str == "get_skin_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local panel_info = node:getChildByName("panel_info")
    -- ui
    -- 人物
    local text_word = panel_info:getChildByName("text_word")
    self.image_role = node:getChildByName("image_role")
    self.text_name = node:getChildByName("text_name")

    -- 加成
    local image_atk = panel_info:getChildByName("image_atk")
    self.atk_text_num = image_atk:getChildByName("text_num")

    local image_gold_bonus = panel_info:getChildByName("image_gold_bonus")
    self.gold_text_num = image_gold_bonus:getChildByName("text_num")

    local image_score_bonus = panel_info:getChildByName("image_score_bonus")
    self.score_text_num = image_score_bonus:getChildByName("text_num")

    -- 使用
    local use_image = node:getChildByName("button_use")
    local use_Btn = ButtonWrap:create()
    use_Btn:wrap(use_image, 1)
    use_Btn:set_cur_scale(1.0, 1.0)
    use_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local role_info = Skin_Data:getInstance():get_role_by_skin_id(self.skin_id)
        Player:getInstance():set_player_cur_role_id(role_info.role_id)
        Player:getInstance():set_player_cur_skin_id(self.skin_id)
        
        Player:getInstance():set_player_role_skin_map(role_info.role_id, self.skin_id)  --10.8
        self:close_self()
    end)

    -- 按钮点击事件
    local close_image = panel_info:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function GetSkinLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("get_skin_out", false)
end

function GetSkinLayer:set_cur_skin(skin_id)
    self.skin_id = skin_id
    local role_info = Skin_Data:getInstance():get_role_by_skin_id(skin_id)
    local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id)
    self.image_role:setTexture(skin_info.res_key)
    self.text_name:setString(role_info.role_name)
    self.atk_text_num:setString(string.format("+%d", skin_info.init_atk))
    self.gold_text_num:setString(string.format("+%d%%", skin_info.init_gold_add * 100))
    self.score_text_num:setString(string.format("+%d%%", skin_info.init_score_add * 100))
end

return GetSkinLayer