require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.CommonDialogLayer"
require "UI.Widget.BagRewardWidget"
require "core.Invite_Reward_Data"

InviteRewardLayer = class("InviteRewardLayer", function() return cc.Layer:create() end)

function InviteRewardLayer:ctor()

    self:setName("InviteRewardLayer")
    self.invite_num = 0

    local widget = cc.CSLoader:createNode("invite_reward.csb")
    self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("invite_reward.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("friend_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "friend_in_end" then

        elseif str == "friend_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    local tip_text = image_dia:getChildByName("panel_info"):getChildByName("text_1")
    local image_add_social = image_dia:getChildByName("button_add_wechat")
    self.text_add_social = image_add_social:getChildByName("text_add_wechat")
    self.image_wechat_reward = image_add_social:getChildByName("image_wechat_reward")
    self.invite_num_text = image_dia:getChildByName("image_num_dia"):getChildByName("text_num")
    self.image_string = image_dia:getChildByName("image_string")
    local image_dia_down = image_dia:getChildByName("image_dia_down")
    self.image_dia_down = image_dia_down
    local text1 = image_dia_down:getChildByName("text1")
    local image_id = image_dia_down:getChildByName("button_get")
    local image_id_reward = image_id:getChildByName("image_id_reward")

    local image_inputbox = image_dia_down:getChildByName("image_inputbox")
    local name_input = image_inputbox:getChildByName("text")
    name_input:addEventListener(function(sender, eventType)
        if eventType == ccui.TextFiledEventType.attach_with_ime then
            name_input:setPlaceHolder("")
            self.image_dia_down:runAction(cc.MoveTo:create(0.3, cc.p(self.image_dia_down:getPositionX(), 500)))
        elseif eventType == ccui.TextFiledEventType.detach_with_ime then
            -- self.invite_id = sender:getString()
            self.image_dia_down:runAction(cc.MoveTo:create(0.3, cc.p(self.image_dia_down:getPositionX(), -155)))
        end
    end)

    self:init_listview()

    self.invite_num_text:setString(self.invite_num)
    self.image_string:setVisible(false)
    self.image_dia_down:setVisible(false)

    if LOGIN_PLATFROM == 1 then
        self.text_add_social:setString("添加微信好友")
    elseif LOGIN_PLATFROM == 2 then
        self.text_add_social:setString("添加QQ好友")
    end
    move_cycle_action(image_add_social)
    local add_social_Btn = ButtonWrap:create()
    add_social_Btn:wrap(image_add_social, 1)
    add_social_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        
        self:add_social_Btn_click()
    end)
    self.is_share_invite = cc.UserDefault:getInstance():getBoolForKey("is_share_invite", false)
    if self.is_share_invite then
        self.image_wechat_reward:setVisible(false)
    else
        self:add_share_callback_listener(function() self:share_success_callback() end,nil)
    end

    local id_Btn = ButtonWrap:create()
    id_Btn:wrap(image_id, 1)
    id_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        
        self:send_invite_with_id(name_input:getString())
    end)

    --bag_get_reward
    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 2)

    self:request_invite_state()


    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)
    

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function InviteRewardLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("friend_out", false)

    set_list_fade_out(self.listview)
    if self.share_check_handler then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.share_check_handler)
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_SUCCESS")
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_FAILURE")
    end
end

function InviteRewardLayer:end_share()
    self.__s_share_result = "NONE"
    -- cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.share_check_handler)

    -- cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_SUCCESS")
    -- cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_FAILURE")
end

function InviteRewardLayer:add_share_callback_listener(callback_success, callback_failure)
    if not callback_failure then
        callback_failure = function()
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string("发送失败")
            cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
        end
    end
    self._callback_success = callback_success
    self._callback_failure = callback_failure
    self.__s_share_result = "NONE"

    local listener1 = cc.EventListenerCustom:create("SHARE_SUCCESS", function() self:handle_success() end)
    local listener2 = cc.EventListenerCustom:create("SHARE_FAILURE", function() self:handle_failure() end)
    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)

    self.share_check_handler = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function() self:check_share_result() end, 0.033, false)

end

function InviteRewardLayer:handle_success()
    self.__s_share_result = "SHARE_SUCCESS"
end

function InviteRewardLayer:handle_failure()
    self.__s_share_result = "SHARE_FAILURE"
end

function InviteRewardLayer:check_share_result()
    if self.__s_share_result == "SHARE_SUCCESS" then
        self._callback_success()
        self:end_share()
    elseif self.__s_share_result == "SHARE_FAILURE" then
        self._callback_failure()
        self:end_share()
    end
end

function InviteRewardLayer:add_social_Btn_click()

    local filePath = global_get_screenshot_path().."ICON.jpg"
    if not cc.FileUtils:getInstance():isFileExist(filePath) then
        -- 分享的logo图
        local target = cc.RenderTexture:create(10, 10)
        local image = target:newImage()
        image:initWithImageFile("res/images/common/icon.png")
        local fileName = global_get_screenshot_path().."ICON.jpg"
        image:saveToFile(fileName)
    end
    

    local title = "官方正版手游--蜡笔小新糖果世界"
    local desc = "快来和小新感受完全不同的创新消除体验吧！"
    local url = "http://a.app.qq.com/o/simple.jsp?pkgname=com.tencent.tmgp.lbxxtgsj"

    if LOGIN_PLATFROM == 1 then
        --wechat
        MSDKJava.callWGSendToWeixinWithUrl(0, "ICON", title, desc, url)
        -- MSDKJava.callWGSendToWeixin("ICON", title, desc)
    elseif LOGIN_PLATFROM == 2 then
        --qq
        MSDKJava.callWGSendToQQ(2, "ICON", title, desc, url)
    else
        cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE")
    end
    
end

function InviteRewardLayer:share_success_callback()
    if self.image_wechat_reward:isVisible() then
        self.image_wechat_reward:setVisible(false)
        cc.UserDefault:getInstance():setBoolForKey("is_share_invite", true)

        Player:getInstance():add_player_bag_info_by_id("item_101", 1)

        local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_101")
        self.bag_reward:setItemTexture(bag_info.res_key)
        self.bag_reward:setTouchEnabled(true)
        self.bag_reward:runAction()
    end
end

function InviteRewardLayer:init_listview()
    local listview = self.image_dia:getChildByName("listview")
    self.listview = listview
    local panel_1 = listview:getChildByName("panel_1")
    listview:setScrollBarEnabled(false)
    listview:setBounceEnabled(false)
    listview:setItemModel(panel_1:clone())
    listview:removeAllItems()
    for i=1,5 do
        listview:pushBackDefaultItem()
    end

    local invite_reward_vector = Invite_Reward_Data:getInstance():get_invite_reward_vector()
    self.info_Btn_vector = {}

    for i=1,5 do
        local item = listview:getItem(i -1)
        local info = item:getChildByName("info")
        local text_num = info:getChildByName("text_num")
        local image_box = info:getChildByName("image_box")
        local image_get = info:getChildByName("image_get")
        image_get:setVisible(false)

        info:loadTexture(string.format("images/invite/fnum%d.png", i))
        image_box:loadTexture(string.format("images/weekgame/box_%d.png", i))
        local invite_reward_info = invite_reward_vector[i]
        text_num:setString(invite_reward_info.invite_num)

        local info_Btn = ButtonWrap:create()
        info_Btn:wrap(info, 1)
        info_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
            
            image_get:setVisible(true)
            image_box:setVisible(false)
            info_Btn:disable()

            Player:getInstance():set_player_invite_reward_info_is_get(invite_reward_info.invite_id)
            for k,v in pairs(invite_reward_info.reward_item) do
                local item_id = v.item_id
                local item_num = v.item_num
                Player:getInstance():add_player_bag_info_by_id(item_id, item_num)

                local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
                self.bag_reward:setItemTexture(bag_info.res_key)
                self.bag_reward:setTouchEnabled(true)
                self.bag_reward:runAction()
            end

            cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("CHECK_INVITE_REWARD_EVENT")
        end)
        info_Btn:disable()
        self.info_Btn_vector[i] = info_Btn
        
        local box_Btn = ButtonWrap:create()
        box_Btn:wrap(image_box, 1)
        box_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
            local commonDialogLayer = CommonDialogLayer:create()
            commonDialogLayer:show_on_right(invite_reward_info.reward_item)
            commonDialogLayer:setPosition(image_box:getParent():convertToWorldSpace(cc.p(image_box:getPosition())))
        end)
        self.info_Btn_vector[i].box_Btn = box_Btn
    end

end

function InviteRewardLayer:send_invite_with_id(invite_id)
    local rpc_param = {

        PLAYER_ID,
        invite_id,

    }

    RPC:call_bind("SHIN/friend/send_invite_msg", rpc_param, self, function(status, response)
        print("send_invite_msg"..status)
        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
            self.image_string:setVisible(false)
            self.image_dia_down:setVisible(false)

            Player:getInstance():add_player_bag_info_by_id("item_103", 1)

            local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_103")
            self.bag_reward:setItemTexture(bag_info.res_key)
            self.bag_reward:setTouchEnabled(true)
            self.bag_reward:runAction()
        elseif status == RPC.RPC_CALL_FAILURE then
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string("邀请失败")
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        else

            print("request error")

        end

    end)
end

function InviteRewardLayer:request_invite_state()
    local rpc_param = {

        PLAYER_ID,

    }

    RPC:call_bind("SHIN/friend/getPersonalInviteState", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
            if response.is_invited == 0 then
                self.image_string:setVisible(true)
                self.image_dia_down:setVisible(true)
            end
            self.invite_num = tonumber(response.invite_count)
            
            self.invite_num_text:setString(self.invite_num)
            local invite_reward_vector = Invite_Reward_Data:getInstance():get_invite_reward_vector()
            for i=1,5 do
                if self.invite_num >= invite_reward_vector[i].invite_num then
                    self.info_Btn_vector[i]:enable()
                    self.info_Btn_vector[i].box_Btn:disable()
                end
            end
            --已领取奖励的disable掉
            local player_invite_reward_info_vector = Player:getInstance():get_player_invite_reward_info_vector()
            for k,v in pairs(player_invite_reward_info_vector) do
                if v.is_get then
                    self.info_Btn_vector[k]:disable()

                    local info = self.info_Btn_vector[k]:getImage()
                    local image_box = info:getChildByName("image_box")
                    local image_get = info:getChildByName("image_get")
                    image_get:setVisible(true)
                    image_box:setVisible(false)
                end
            end

        else

            print("request error")

        end

    end)
end

function InviteRewardLayer:onEnter()
    RPC:register_target(self)
end

function InviteRewardLayer:onExit()
    RPC:unregister_target(self)
end

return InviteRewardLayer