require "core.LayerManager"
require "UI.Widget.MaskLayer"

ItemInfoLayer = class("ItemInfoLayer", function() return cc.Layer:create() end)

function ItemInfoLayer:ctor()

    self:setName("ItemInfoLayer")

	local widget = cc.CSLoader:createNode("item_info.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("item_info.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("item_info_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "item_info_in_end" then

        elseif str == "item_info_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local text_title = image_dia:getChildByName("text_title")

    local panel_item = image_dia:getChildByName("panel_item")
    panel_item:setScrollBarEnabled(false)
    self.panel_item = panel_item

    local item_map = {[1] = "item_201", [2] = "item_202", [3] = "item_203", }
    for i=1,3 do
        local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_map[i])
        local item = panel_item:getChildByName(string.format("item_%d", i))
        local image_item = item:getChildByName("image_item")
        local text_name = item:getChildByName("text_name")
        local text_des = item:getChildByName("text_des")
        image_item:setTexture(bag_info.res_key)
        text_name:setString(bag_info.item_name)
        text_des:setString(bag_info.description)
    end


    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function ItemInfoLayer:hide_item(out_game_item)
    for i=1,3 do
        if out_game_item[i] == "LOCKED" then
            local item = self.panel_item:getChildByName(string.format("item_%d", i))
            item:setVisible(false)
        end
    end
end

function ItemInfoLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("item_info_out", false)
end

function ItemInfoLayer:onEnter()

end

function ItemInfoLayer:onExit()
end

return ItemInfoLayer