require "core.LayerManager"
require "UI.Widget.MaskLayer"
local ResourceManager1 = require "GameEx.Foundations.ResourceManager"
LoseLayer = class("LoseLayer", function() return cc.Layer:create() end)

function LoseLayer:ctor()

    self:setName("LoseLayer")

	local widget = cc.CSLoader:createNode("balance_lose.csb")
    self:addChild(widget, 1);
    self.widget = widget

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("balance_lose.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("balance_lose_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "balance_lose_in_end" then
            --8.12
            local current_level = Player:getInstance():get_player_current_level()
            local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
            local book_info = Mission_Data:getInstance():get_generate_card_by_mission(mission_info.mission_id)
            if book_info then
                if Player:getInstance():get_player_book_info_by_id(book_info.book_id).is_get == false then
                    self.image_box:setVisible(true)
                    self.text_2:setVisible(true)
                    self.action:play("button_next_cycle", true)
                end
            end
            --8.12
            Player:getInstance():set_continue_pass_stage(0)
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    --每日任务事件发送
    local player = Player:getInstance()
    if player:get_player_cur_role_id() == player:get_player_daily_task_info_by_id("task_12").target_type then
        local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
        event.param = {task_id = "task_12", finish_count = 1, func = function() end }
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    end

    -- 按钮点击事件
    local node = widget:getChildByName("node")
    self.node = node
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    local role_res = {
        ["role_101"] = "images/balance/lose_shin.png",
        ["role_201"] = "images/balance/lose_nene.png",
        ["role_301"] = "images/balance/lose_masao.png",
        ["role_401"] = "images/balance/lose_bo.png",
        ["role_501"] = "images/balance/lose_kazama.png",
    }

    --8.15
    local text_1 = image_dia:getChildByName("text_1")
    text_1:setString(ResourceManager:getInstance():getTextStringByKey("LoseLayer_2"))

    self.image_box = image_dia:getChildByName("image_box")
    self.text_2 = image_dia:getChildByName("text_2")
    self.image_box:setVisible(false)
    self.text_2:setVisible(false)

    local image_stage_dia = image_dia:getChildByName("image_stage_dia")
    local text_stage = image_stage_dia:getChildByName("text_stage")
    text_stage:setString(string.format(ResourceManager:getInstance():getTextStringByKey("LoseLayer_1"), Player:getInstance():get_player_current_level()))

    self.lose_role_spine = {
        ["role_101"] = "images/balance/lose_shin.png",
        ["role_201"] = "images/balance/lose_nene.png",
        ["role_301"] = "images/balance/lose_masao.png",
        ["role_401"] = "images/balance/lose_bo.png",
        ["role_501"] = "images/balance/lose_kazama.png",
    }

    local role = image_dia:getChildByName("role")
    role:setTexture(self.lose_role_spine[Player:getInstance():get_player_cur_role_id()])
    -- role:setVisible(false)

    -- local effect = ResourceManager:getInstance():getSpineByKey(self.lose_role_spine[Player:getInstance():get_player_cur_role_id()], 1)
    -- effect:setAnimation(0, "lose", true)
    -- effect:setPosition(cc.p(role:getPositionX(), role:getPositionY() - role:getContentSize().height * 0.0))
    -- role:getParent():addChild(effect)

    -- local LevelBuilder = require "GameEx.Foundations.LevelBuilder"
    -- local mission_level = Player:getInstance():get_player_current_level()
    -- local level_config = LevelBuilder:get_instance():get_level_config(mission_level)
    -- local is_boss = false
    -- if level_config.boss then
    --     is_boss = true
    -- end
    -- if is_boss then
    --     role:setVisible(false)
    --     image_dia:getChildByName("role_shadow"):setVisible(false)

    --     local animation_name = "idle"   --idle, attack_1, attack_2, attack_3, hurt, hurt_heavy, lose, halo
    --     self.boss_spine = ResourceManager1:get_instance():get_resource_by_key(level_config.boss.texture, true)
    --     self.boss_spine:setAnimation(0, animation_name, true)
    --     --self.boss_spine:setScale(1)
    --     self.boss_spine:setTimeScale(0.5)
    --     self.boss_spine:setPosition(cc.p(role:getPositionX(), role:getPositionY() + role:getContentSize().height * 0.3))
    --     role:getParent():addChild(self.boss_spine)
    -- end


    local closeImage = image_dia:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    -- 再试一次按钮
    local nextImage = image_dia:getChildByName("button_next")
    local nextBtn = ButtonWrap:create()
    nextBtn:wrap(nextImage, 1)
    nextBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local levelInfoLayer = LevelInfoLayer:create()
        levelInfoLayer:set_close_callback(function()
            local loadingScene = LoadingScene:create(1)
            loadingScene:load_extern_scene_resource()
            loadingScene:set_load_finish_callback(function()
                LayerManager:getInstance():clear_layer()
                local section_mission = Player:getInstance():get_player_current_section()
                local externalScene = ExternalScene:create()
                externalScene:add_map(section_mission)
                externalScene:play_bg_music()
                cc.Director:getInstance():replaceScene(externalScene)
            end)
            LayerManager:getInstance():clear_layer()
            cc.Director:getInstance():replaceScene(loadingScene)
        end)
        LayerManager:getInstance():add_layer_to_scene(levelInfoLayer)
        self:removeFromParent()
    end)

    --7.19
    local upgradeImage = image_dia:getChildByName("button_upgrade")
    local upgradeBtn = ButtonWrap:create()
    upgradeBtn:wrap(upgradeImage, 1)
    upgradeBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local roleInfoLayer = RoleInfoLayer:create()
        LayerManager:getInstance():add_layer_to_scene(roleInfoLayer)
        --cc.Director:getInstance():getRunningScene():addChild(roleInfoLayer, 5)
    end)
    --7.19

    --排行榜
    self:init_rank()

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    MusicManager:getInstance().play_bg_music(ResourceManager:getInstance():getAudioPathByKey("Lose_Music"), false)

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function LoseLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    local loadingScene = LoadingScene:create(1)
    loadingScene:load_extern_scene_resource()
    loadingScene:set_load_finish_callback(function()
        local section_mission = Player:getInstance():get_player_current_section()
        LayerManager:getInstance():clear_layer()
        local externalScene = ExternalScene:create()
        externalScene:play_bg_music()
        externalScene:add_map(section_mission)
        cc.Director:getInstance():replaceScene(externalScene)
    end)
    cc.Director:getInstance():replaceScene(loadingScene)
end

function LoseLayer:init_rank()
    local image_rank_dia = self.node:getChildByName("image_rank_dia")
    local panel_friends = image_rank_dia:getChildByName("panel_friends")
    local panel_world = image_rank_dia:getChildByName("panel_world")
    local text_my_score = image_rank_dia:getChildByName("text_my_score")
    text_my_score:setVisible(false)
    local invite_image = image_rank_dia:getChildByName("button_invite")
    local text_friends = panel_friends:getChildByName("text_friends")
    local text_world = panel_world:getChildByName("text_world")
    local world_image = panel_friends:getChildByName("button_world")
    local text_world_ = world_image:getChildByName("text_world")
    local friends_image = panel_world:getChildByName("button_friends")
    local text_friends_ = friends_image:getChildByName("text_friends")
    
    text_friends_:setColor(cc.c3b(21, 102, 164))
    text_world_:setColor(cc.c3b(21, 102, 164))
    panel_friends:setVisible(true)
    panel_world:setVisible(false)
    text_friends:setColor(cc.c3b(148, 55, 51))
    text_world:setColor(cc.c3b(148, 55, 51))

    local invite_Btn = ButtonWrap:create()
    invite_Btn:wrap(invite_image, 1)
    invite_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local friendAddLayer = FriendAddLayer:create()
        LayerManager:getInstance():add_layer_to_scene(friendAddLayer) 
    end)
    local friends_Btn = ButtonWrap:create()
    friends_Btn:wrap(friends_image, 1)
    friends_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        panel_friends:setVisible(true)
        panel_world:setVisible(false)
    end)
    local world_Btn = ButtonWrap:create()
    world_Btn:wrap(world_image, 1)
    world_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        panel_friends:setVisible(false)
        panel_world:setVisible(true)

        if not self.is_request_ranklist then
            self.is_request_ranklist = true
            self:request_getRanklist(self.world_async_callback)
        end
    end)
    self.is_request_ranklist = false

    local rank_res = {
        [1] = "images/section/friend/rank_first.png",
        [2] = "images/section/friend/rank_second.png",
        [3] = "images/section/friend/rank_third.png",
    }

    local rank_friends = panel_friends:getChildByName("rank_friends")
    self.rank_friends = rank_friends
    local panel_1 = rank_friends:getChildByName("panle_1")
    rank_friends:setClippingEnabled(true)
    --rank_friends:setScrollBarEnabled(false)
    rank_friends:setItemModel(panel_1:clone())
    rank_friends:removeAllItems()
    local function friend_async_callback(list)
        local friendRanklist = list
        local count = get_table_length(friendRanklist)
        for i=1,count do
            rank_friends:pushBackDefaultItem()
        end
        for i=1,count do
            local item = rank_friends:getItem(i -1)
            local image_head = item:getChildByName("image_id")
            local text_name = item:getChildByName("text_name")
            local text_score = item:getChildByName("text_score")
            local image_rank_num = item:getChildByName("image_rank_num")
            local text_rank_num = item:getChildByName("text_rank_num")

            if i < 4 then
                text_rank_num:setVisible(false)
                image_rank_num:setVisible(true)
                image_rank_num:loadTexture(rank_res[i])
            else
                image_rank_num:setVisible(false)
                text_rank_num:setVisible(true)
                text_rank_num:setString(i)
            end
            local friendRank_info = friendRanklist[i]
            --text_rank_num:setString(friendRank_info.rank)
            text_name:setString(friendRank_info.name)
            text_score:setString(friendRank_info.score)

            if friendRank_info.sex == "0" and friendRank_info.headUrl and friendRank_info.headUrl ~= "" then
                
                local function on_create_finish()
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..friendRank_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(friendRank_info.guid, friendRank_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", friendRank_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end

            if friendRank_info.guid == PLAYER_ID then
                text_my_score:setVisible(true)
                text_my_score:setString(friendRank_info.score)

                -- local player_head_id = Player:getInstance():get_player_head_id()
                -- if player_head_id == "head_00" then
                --     local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
                --     image_head:loadTexture(headPath)
                -- end
            end
        end
    end
    self:request_getfriendRanklist(friend_async_callback)

    local rank_world = panel_world:getChildByName("rank_world")
    self.rank_world = rank_world
    local panel_1 = rank_world:getChildByName("panle_1")
    rank_world:setClippingEnabled(true)
    --rank_world:setScrollBarEnabled(false)
    rank_world:setItemModel(panel_1:clone())
    rank_world:removeAllItems()
    local function world_async_callback(list)
        local worldRanklist = list
        local count = get_table_length(worldRanklist)
        for i=1,count do
            rank_world:pushBackDefaultItem()
        end
        for i=1,count do
            local item = rank_world:getItem(i -1)
            local image_head = item:getChildByName("image_id")
            local text_name = item:getChildByName("text_name")
            local text_score = item:getChildByName("text_score")
            local image_rank_num = item:getChildByName("image_rank_num")
            local text_rank_num = item:getChildByName("text_rank_num")

            if i < 4 then
                text_rank_num:setVisible(false)
                image_rank_num:setVisible(true)
                image_rank_num:loadTexture(rank_res[i])
            else
                image_rank_num:setVisible(false)
                text_rank_num:setVisible(true)
                text_rank_num:setString(i)
            end
            local worldRank_info = worldRanklist[i]
            --text_rank_num:setString(worldRank_info.rank)
            text_name:setString(worldRank_info.name)
            text_score:setString(worldRank_info.score)

            if worldRank_info.sex == "0" and worldRank_info.headUrl and worldRank_info.headUrl ~= "" then
                
                local function on_create_finish()
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..worldRank_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(worldRank_info.guid, worldRank_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", worldRank_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end

            -- local head_id = string.format("head_%02d", worldRank_info.sex+1)
            -- local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
            -- image_head:loadTexture(head_info.res_key)

            -- if worldRank_info.guid == PLAYER_ID then
            --     local player_head_id = Player:getInstance():get_player_head_id()
            --     if player_head_id == "head_00" then
            --         local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
            --         image_head:loadTexture(headPath)
            --     end
            -- end
        end
    end
    self.world_async_callback = world_async_callback
    -- self:request_getRanklist(world_async_callback)

    rank_friends:setVisible(false)
    rank_world:setVisible(false)
    rank_friends:runAction(cc.Sequence:create(cc.FadeIn:create(0.4),cc.CallFunc:create(function()rank_friends:setVisible(true) end)))
    rank_world:runAction(cc.Sequence:create(cc.FadeIn:create(0.4),cc.CallFunc:create(function()rank_world:setVisible(true) end)))
end

function LoseLayer:request_getfriendRanklist(async_callback)
    --request getfriendRanklist 好友排行
    local level_index = Player:getInstance():get_player_current_level()
    local rpc_param = {

        PLAYER_ID,
        level_index,
    }

    RPC:call_bind("SHIN/chapter/getfriendRanklist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            -- dump(response)
            if response == nil then
                response = {}
            end
            async_callback(response)

        else

            print("request error")

        end

    end)
end

function LoseLayer:request_getRanklist(async_callback)
    --request getRanklist 世界排行
    local level_index = Player:getInstance():get_player_current_level()
    local rpc_param = {
        level_index,
    }

    RPC:call_bind("SHIN/chapterMgr/getRanklist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if response == nil then
                response = {}
            end
            async_callback(response)

        else

            print("request error")

        end

    end)
end

function LoseLayer:setStarGoal(star)
    for index = 1, 3 do
        self.widget:getChildByName(string.format("star_empty_%d", index))
    end
end

function LoseLayer:onEnter()
    RPC:register_target(self)
end

function LoseLayer:onExit()
    RPC:unregister_target(self)
end

return LoseLayer

