require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Widget.BagRewardWidget"
require "core.LuckyGift_Data"
require "core.TalkingDataManager"

LuckyGiftLayer = class("LuckyGiftLayer", function() return cc.Layer:create() end)

function LuckyGiftLayer:ctor()

    self:setName("LuckyGiftLayer")
    self.close_callback = nil
    self.item_id = nil
    self.item_num = nil

    TalkingDataManager:getInstance():send("幸运大礼包", {["幸运大礼包的触发次数"] = "次数"})

	local widget = cc.CSLoader:createNode("luckygift.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("luckygift.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("luckygift_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "luckygift_in_end" then

    	elseif str == "show_shin_end" then
        	self.image_dia_3:setVisible(false)
            self.__c_mask_layer:setVisible(false)
            self.__c_mask_layer:setEnabled(false)
        elseif str == "luckygift_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    self:update_date()

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia

    self:init_gift_listview()
    
    self.image_dia_1 = image_dia:getChildByName("image_dia_1")
    self.image_dia_2 = image_dia:getChildByName("image_dia_2")
    self.image_dia_3 = image_dia:getChildByName("image_dia_3")
    self.image_dia_2:setVisible(false)
    self.image_dia_3:setVisible(false)
    self.text_get_num = self.image_dia_2:getChildByName("get_num")
    self.text_again_num = self.image_dia_2:getChildByName("again_num")
    self.text_get_num:setString(string.format("(%d/%d)", self.num_luckygift_buy, GameKernel:getInstance():get_init_player_data().num_luckygift_buy))
    self.text_again_num:setString(string.format("(%d/%d)", self.num_luckygift_again, GameKernel:getInstance():get_init_player_data().num_luckygift_again))
    local image_helper = self.image_dia_2:getChildByName("image_helper")
    image_helper:loadTexture("images/luckygift/text_helper_1.png")

    --bag_get_reward
    self.__c_mask_layer = MaskLayer:create()
    self.__c_mask_layer:setEnabled(false)
    self:addChild(self.__c_mask_layer, 2)
    self.__c_mask_layer:setVisible(false)

    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 2)

    local get_image = self.image_dia_2:getChildByName("button_get")
    self.get_image = get_image
    
    local get_Btn = ButtonWrap:create()
    get_Btn:wrap(get_image, 1)
    get_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)

        TradeManager:getInstance():pay_buy_currency("幸运大礼包", 6.0,
        function() 

            local player = Player:getInstance()
            player:set_num_luckygift_buy(player:get_num_luckygift_buy()-1)
            TalkingDataManager:getInstance():send("幸运大礼包", {["幸运大礼包购买次数"] = "次数"})
            TalkingDataManager:getInstance():send("幸运大礼包", {["各奖励购买的次数"] = self.item_id})

            local item_id = self.item_id
            local item_num = self.item_num
            Player:getInstance():add_player_bag_info_by_id(item_id, item_num)

            if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
                if item_id == "item_03" then
                    TalkingDataManager:getInstance():sendOnReward(item_num,"幸运大礼包")
                end
            else
                local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
                self.bag_reward:setItemTexture(bag_info.res_key)
                self.bag_reward:setTouchEnabled(true)
                self.bag_reward:runAction()
            end
            self.__c_mask_layer:setVisible(true)
            self.__c_mask_layer:setEnabled(true)
            performWithDelay(self, function() self:close_self() end, 0.6)

        end, nil)
    end)

    local again_image = self.image_dia_2:getChildByName("button_again")
    self.again_image = again_image
    local text_again = again_image:getChildByName("text_again")
    text_again:setString("再抽一次")
    text_again:setLocalZOrder(1)
    local again_Btn = ButtonWrap:create()
    self.again_Btn = again_Btn
    again_Btn:wrap(again_image, 1)
    again_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        if self.num_luckygift_again > 0 then
            self.num_luckygift_again = self.num_luckygift_again - 1
            self:again_init_listview()
            if self.num_luckygift_again <= 0 then
                again_Btn:disable()
                again_Btn:setDarkButton(false)
                text_again:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
            end
        end
    end)

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function LuckyGiftLayer:init_gift_listview()
	local gift_listview = self.image_dia:getChildByName("gift_listview")
	self.gift_listview = gift_listview
	local panel_1 = gift_listview:getChildByName("panel_1")
	gift_listview:setScrollBarEnabled(false)
    gift_listview:setClippingEnabled(false)
    gift_listview:setItemModel(panel_1:clone())
    gift_listview:removeAllItems()
    for i=1,3 do
        gift_listview:pushBackDefaultItem()
    end
    
    local luckygift_info_vector = LuckyGift_Data:getInstance():get_luckygift_info_vector()
    self.luckygift_info_vector = luckygift_info_vector
    self.pack_Btn_vector = {}
    self.pack_dia_vector = {}
    self.image_item_vector = {}
    self.text_num_vector = {}
    local items_count = table.getn(gift_listview:getItems())
    for i=1,items_count do
        local item = gift_listview:getItem(i -1)
        for j=1,3 do
            local cur_index = (i - 1) * 3 + j

            local item_child = item:getChildByName(j)            
            local pack_select = item_child:getChildByName("pack_select")
            local image_light = pack_select:getChildByName("image_light")
            local image_item = item_child:getChildByName("image_item")
            local text_num = item_child:getChildByName("text_num")
            local pack_dia = item_child:getChildByName("pack_dia")
            local original_price = item_child:getChildByName("original_price")
            pack_dia:setVisible(true)
            original_price:setVisible(false)
            self.pack_dia_vector[cur_index] = pack_dia
            self.image_item_vector[cur_index] = image_item
            self.text_num_vector[cur_index] = text_num


            pack_select:setVisible(false)
            local select_Btn = ButtonWrap:create()
		    select_Btn:wrap(item_child, 1)
		    self.pack_Btn_vector[cur_index] = select_Btn
		    select_Btn:addTouchEndCallback(function()
		        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                --spine动画
                local size = item_child:getContentSize()
                local spine_gift = ResourceManager:getInstance():getSpineByKey("SPINE_LUCKYGIFT", 1.0)
                spine_gift:setPosition(cc.p(size.width / 2, size.height / 2))
                spine_gift:setAnimation(0, "luckygift", false)
                --spine_gift:setTimeScale(0.6)
                item_child:addChild(spine_gift,1)
                local open_particle = ResourceManager:getInstance():getParticleByKey("PARTICLE_LUCKYGIFTOPEN")
                open_particle:setAutoRemoveOnFinish(false)
                open_particle:setPosition(cc.p(0,0))
                spine_gift:addChild(open_particle,99)
                pack_dia:setVisible(false)
                image_item:setVisible(false)
                text_num:setVisible(false)

                self.__c_mask_layer:setVisible(true)
                self.__c_mask_layer:setEnabled(true)

                self:runAction(cc.Sequence:create(cc.DelayTime:create(1.2), cc.CallFunc:create(function()
                    spine_gift:removeFromParent()
                    --pack_select:removeChildByTag(99)
                    local get_particle = ResourceManager:getInstance():getParticleByKey("PARTICLE_LUCKYGIFTGET")
                    get_particle:setAutoRemoveOnFinish(false)
                    get_particle:setPosition(cc.p(130,130))
                    pack_select:addChild(get_particle,99,99)

    		        -- pack_dia:setVisible(false)
    		        pack_select:setVisible(true)
                    image_item:setVisible(true)
                    text_num:setVisible(true)
    		        local num_table = self:get_sort_num_table(cur_index)
    		        for k=1,9 do
    		        	--print(num_table[k])
    		        	self:show_item(num_table[k], self.image_item_vector[k], self.text_num_vector[k])
    		        end

    		        image_light:runAction(cc.RepeatForever:create(cc.RotateBy:create(3, 360)))
    		        self:runAction(cc.Sequence:create(cc.DelayTime:create(0.5), cc.CallFunc:create(function()
    		        	
                        self.__c_mask_layer:setVisible(false)
                        self.__c_mask_layer:setEnabled(false)
                        for k=1,9 do
                        	self.image_dia_1:setVisible(false)
                        	self.image_dia_2:setVisible(true)
                        	self.pack_Btn_vector[k]:disable()
                        	if self.pack_dia_vector[k]:isVisible() then
                        		self.pack_dia_vector[k]:setVisible(false)
                        	end
                        end
                    end)))
                end)))
		    end)

        end
    end

end

function LuckyGiftLayer:show_item(index, image_item, text_num)
	local luckygift_info = self.luckygift_info_vector[index]
    local item_id = luckygift_info.item_id
    local item_num = luckygift_info.item_num
    local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
    if item_id == "item_02" then
        image_item:loadTexture("images/item/item_8.png")
    elseif item_id == "item_03" then
        image_item:loadTexture("images/item/item_9.png")
    else
        image_item:loadTexture(bag_info.res_key)
    end
    if item_num >= 1000 then
        local num = math.floor(item_num/1000)
        text_num:setString(string.format("x%dk",num))
    else
        text_num:setString(string.format("x%d",item_num))
    end
end

function LuckyGiftLayer:super_value()
	self:runAction(cc.Sequence:create(cc.DelayTime:create(0.6), cc.CallFunc:create(function()
        origin_cycle_action(self.get_image)
		self.action:play("show_shin", false)
        self.__c_mask_layer:setVisible(true)
        self.__c_mask_layer:setEnabled(true)
		end)))
	self.image_dia_3:setVisible(true)
end

function LuckyGiftLayer:get_sort_num_table(cur_index)
    math.randomseed(os.time())
    local random_num = math.random()

    local index = nil
    local count = get_table_length(self.luckygift_info_vector)
    for i=1,count do
        if random_num <= self.luckygift_info_vector[i].odds then
            index = i
            self.item_id = self.luckygift_info_vector[i].item_id
    		self.item_num = self.luckygift_info_vector[i].item_num
            break
        end
    end
    print("index::"..index)
    if index > 6 then
        self.again_image:stopAllActions()
    	self:super_value()
        self.image_item_vector[cur_index]:getParent():getChildByName("original_price"):setVisible(true)
    else
        self.get_image:stopAllActions()
        if self.num_luckygift_again > 0 then
            origin_cycle_action(self.again_image)
        else
            self.again_image:stopAllActions()
        end
        
    end
    local num_table = {1,2,3,4,5,6,7,8,9}
    table.remove(num_table,index)
    local remain_table = self:upset_table(num_table)
    table.insert(remain_table, cur_index, index)
    return remain_table
end

function LuckyGiftLayer:upset_table(arg)
    local selected={};
    local count = #arg
    math.random(0,#arg);
    math.randomseed(os.time());
    while #selected < count do
        math.random(#arg);
        table.insert(selected,table.remove(arg,math.random(#arg)));
    end
    return selected
end

function LuckyGiftLayer:again_init_listview()
	self:init_gift_listview()
    self.image_dia_1:setVisible(true)
    self.image_dia_2:setVisible(false)
    self.text_again_num:setString(string.format("(%d/%d)", self.num_luckygift_again, GameKernel:getInstance():get_init_player_data().num_luckygift_again))

end

function LuckyGiftLayer:update_date()
    local player = Player:getInstance()
    local tm = os.date("*t")
    local last_luckygift_day = player:get_last_luckygift_day()
    local luckygift_day_diff = tm.yday - last_luckygift_day

    if tm.yday == 1 and last_luckygift_day ~= 1 then
        luckygift_day_diff = 1
    end
    if luckygift_day_diff > 0 then
        player:set_last_luckygift_day(tm.yday)
        local num_luckygift_buy = GameKernel:getInstance():get_init_player_data().num_luckygift_buy
        player:set_num_luckygift_buy(num_luckygift_buy)
    end 
    local num_luckygift_again = GameKernel:getInstance():get_init_player_data().num_luckygift_again
    player:set_num_luckygift_again(num_luckygift_again)

    self.num_luckygift_buy = player:get_num_luckygift_buy()
    self.num_luckygift_again = player:get_num_luckygift_again()
end

function LuckyGiftLayer:close_self()
    if self.close_callback then
        self.close_callback()
    end
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("luckygift_out", false)

    set_list_fade_out(self.gift_listview)
    self.again_Btn:set_fade_out()
end

function LuckyGiftLayer:set_close_callback(callback)
    self.close_callback = callback
end

function LuckyGiftLayer:onEnter()

end

function LuckyGiftLayer:onExit()
end

return LuckyGiftLayer