require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.ShareLayer"

LuckyMoveLayer = class("LuckyMoveLayer", function() return cc.Layer:create() end)

function LuckyMoveLayer:ctor()

    self:setName("LuckyMoveLayer")
    self.close_callback = nil

	local widget = cc.CSLoader:createNode("luckymove.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("luckymove.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("item_info_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "luckymove_in_end" then

        elseif str == "luckymove_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    --炫耀按钮
    local share_image = image_dia:getChildByName("button_share")
    move_cycle_action(share_image)
    local share_Btn = ButtonWrap:create()
    share_Btn:wrap(share_image, 1)
    share_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        
        local shareLayer = ShareLayer:create("LUCKYMOVE")
        shareLayer:set_create_share_pic_callback(function()
                global_create_share_pic(shareLayer, "share_picture_4", "LUCKYMOVE.jpg")
            end)
        shareLayer:add_share_callback_listener(function() self:share_success_callback() end, nil)
        LayerManager:getInstance():add_layer_to_scene(shareLayer)
        
    end)
    if LOGIN_PLATFROM == 0 then
        share_image:setVisible(false)
    end
    self.image_share_reward = share_image:getChildByName("image_share_reward")
    local image_reward = self.image_share_reward:getChildByName("image_reward")

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function LuckyMoveLayer:share_success_callback()
    if self.image_share_reward:isVisible() then
        self.image_share_reward:setVisible(false)

        Player:getInstance():add_player_bag_info_by_id("item_101", 1)
        --bag_get_reward
        local bag_reward = BagRewardWidget:create()
        self:addChild(bag_reward, 2)

        local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_101")
        bag_reward:setItemTexture(bag_info.res_key)
        bag_reward:setTouchEnabled(true)
        bag_reward:runAction()
    end
end

function LuckyMoveLayer:set_close_callback(callback)
    self.close_callback = callback
end

function LuckyMoveLayer:close_self()
	if self.close_callback then
        self.close_callback()
    end
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("item_info_out", false)
end

function LuckyMoveLayer:onEnter()

end

function LuckyMoveLayer:onExit()
end

return LuckyMoveLayer