require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "core.Daily_Task_Data"
require "core.Achv_Data"
require "core.TalkingDataManager"
MissionLayer = class("MissionLayer", function() return cc.Layer:create() end)

function MissionLayer:ctor(timeStamp)

    self:setName("MissionLayer")
    self.sort_daily_task_info_vector = {}
    self.sort_achv_info_vector = {}
    self.close_callback = nil
    self.timeStamp = timeStamp

	local widget = cc.CSLoader:createNode("mission.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("mission.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("mission_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "mission_in_end" then

        elseif str == "mission_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia
    
    self:update_date()
    self:init_listview()

    -- 关闭按钮
    local closeImage = image_dia:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    --bag_get_reward
    self.__c_mask_layer = MaskLayer:create()
    self.__c_mask_layer:init_background(cc.c4b(0, 0, 0, 120))
    self.__c_mask_layer:setEnabled(false)
    self:addChild(self.__c_mask_layer, 2)
    self.__c_mask_layer:setVisible(false)

    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 5)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function MissionLayer:init_listview()
    local player = Player:getInstance()
    local day_listview = self.image_dia:getChildByName("panel_day")
    local achv_listview = self.image_dia:getChildByName("panel_achieve")
    local day_Image = self.image_dia:getChildByName("button_day")
    local achv_Image = self.image_dia:getChildByName("button_achieve")

    self.day_image_mark = day_Image:getChildByName("image_mark")
    self.achv_image_mark = achv_Image:getChildByName("image_mark")

    self.day_listview = day_listview
    self.achv_listview = achv_listview

    day_listview:setVisible(true)
    -- achv_listview:setVisible(false)
    day_Image:setColor(cc.c3b(255, 255, 255))
    achv_Image:setColor(cc.c3b(255 * 0.6, 255 * 0.6, 255 * 0.6))
    

    --每日任务按钮    
    local day_Btn = ButtonWrap:create()
    day_Btn:wrap(day_Image, 1)
    day_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        day_listview:setVisible(true)
        achv_listview:setVisible(false)
        day_Image:setColor(cc.c3b(255, 255, 255))
        achv_Image:setColor(cc.c3b(255 * 0.6, 255 * 0.6, 255 * 0.6))
    end)

    --成就任务按钮    
    local achv_Btn = ButtonWrap:create()
    achv_Btn:wrap(achv_Image, 1)
    achv_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        day_listview:setVisible(false)
        achv_listview:setVisible(true)
        day_Image:setColor(cc.c3b(255 * 0.6, 255 * 0.6, 255 * 0.6))
        achv_Image:setColor(cc.c3b(255, 255, 255))
    end)

    --每日任务列表
    local panel_1 = day_listview:getChildByName("panel_1")
    --day_listview:setScrollBarEnabled(false)
    day_listview:setItemModel(panel_1:clone())
    day_listview:removeAllItems()

    local count = get_table_length(self.sort_daily_task_info_vector)
    for i=1,count do
        day_listview:pushBackDefaultItem()
    end
    self.day_get_Btn = {}
    local function update_day_listview()
        --排序
        local temp_table1 = {}
        local temp_table2 = {}
        local index = 1
        for i=1,count do
            local sort_daily_task_info = self.sort_daily_task_info_vector[i]
            if player:get_player_daily_task_reward_info_is_get_by_id(sort_daily_task_info.task_id) == false then
                temp_table1[index] = sort_daily_task_info
                index = index + 1
            else
                table.insert(temp_table2,sort_daily_task_info)
            end
        end
        for k,v in pairs(temp_table2) do
            table.insert(temp_table1, v)
        end        
        self.sort_daily_task_info_vector = temp_table1
        
        for i=1,count do
            local item = day_listview:getItem(i -1)
            local image_reward = item:getChildByName("image_reward")
            local text_reward = item:getChildByName("text_reward")
            local text_mission_des = item:getChildByName("text_mission_des")
            local progress = item:getChildByName("progress")
            local progress_num = item:getChildByName("progress_num")
            local image_get = item:getChildByName("image_get")
            local button_get = item:getChildByName("button_get")
            local text_get = button_get:getChildByName("text_get")
            text_get:setLocalZOrder(1)

            local sort_daily_task_info = self.sort_daily_task_info_vector[i]
            local player_daily_task_info = player:get_player_daily_task_info_by_id(sort_daily_task_info.task_id)

            if self.day_get_Btn[i] then
                self.day_get_Btn[i]:setDarkButton(true)
                self.day_get_Btn[i] = nil
            end
            self.day_get_Btn[i] = ButtonWrap:create()
            self.day_get_Btn[i]:wrap(button_get, 1)
            self.day_get_Btn[i]:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                player:set_player_daily_task_reward_info_is_get_by_id(sort_daily_task_info.task_id, true)                
                TalkingDataManager:getInstance():send("每日任务", {["任务id"] = sort_daily_task_info.task_id})

                if sort_daily_task_info.task_id == "task_01" then
                    local item_id = sort_daily_task_info.reward_info[player_daily_task_info.target_type].item_id
                    local item_num = sort_daily_task_info.reward_info[player_daily_task_info.target_type].item_num
                    local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)

                    local commonPopupLayer = CommonPopupLayer:create()
                    commonPopupLayer:disable_close()

                    local str1 = "礼盒奖励"
                    local str2 = string.format("恭喜获得%sx%d",bag_info.item_name,item_num)
                    local str3 = "确定"
                    commonPopupLayer:showMessage(str1, str2, str3, function()
                        commonPopupLayer:close_self()
                        
                        player:add_player_bag_info_by_id(item_id,item_num)
                        if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
                            if item_id == "item_03" then
                                TalkingDataManager:getInstance():sendOnReward(item_num,"每日任务")
                            end
                        else
                            self.__c_mask_layer:setVisible(true)
                            local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)                    
                            self.bag_reward:setItemTexture(bag_info.res_key)
                            self.bag_reward:setTouchEnabled(true)
                            self.bag_reward:runAction()

                            self:runAction(cc.Sequence:create(cc.DelayTime:create(34 * 0.033), cc.CallFunc:create(function()
                                self.__c_mask_layer:setVisible(false)
                            end)))
                        end
                    end, nil)
                    
                    
                else
                    local finish_count = player:get_player_daily_task_finish_count_by_id("task_01") + 1
                    player:set_player_daily_task_finish_count_by_id("task_01", finish_count)

                    local item_id = sort_daily_task_info.reward_info.item_id
                    local item_num = sort_daily_task_info.reward_info.item_num
                    player:add_player_bag_info_by_id(item_id, item_num)
                    if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
                        if item_id == "item_03" then
                            TalkingDataManager:getInstance():sendOnReward(item_num,"每日任务")
                        end
                    else
                        self.__c_mask_layer:setVisible(true)
                        local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)                    
                        self.bag_reward:setItemTexture(bag_info.res_key)
                        self.bag_reward:setTouchEnabled(true)
                        self.bag_reward:runAction()

                        self:runAction(cc.Sequence:create(cc.DelayTime:create(34 * 0.033), cc.CallFunc:create(function()
                            self.__c_mask_layer:setVisible(false)
                        end)))
                    end
                end
                performWithDelay(self,function() update_day_listview() end,0.016)
                self:update_daily_task_mark()
                cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.mission_image_mark_event)
            end)
           

            if sort_daily_task_info.task_id == "task_01" then
                image_reward:loadTexture("images/item/mission_gift.png")
                text_reward:setVisible(false)
            else
                local bag_info = Bag_Data:getInstance():get_bag_info_by_id(sort_daily_task_info.reward_info.item_id)            
                if sort_daily_task_info.reward_info.item_id == "item_02" then
                    image_reward:loadTexture("images/item/item_8.png")
                elseif sort_daily_task_info.reward_info.item_id == "item_03" then
                    image_reward:loadTexture("images/item/item_9.png")
                else
                    image_reward:loadTexture(bag_info.res_key)
                end

                text_reward:setString(string.format("x%d", sort_daily_task_info.reward_info.item_num))
            end
            
            local percentage = player_daily_task_info.finish_count/sort_daily_task_info.target_num*100
            if percentage >= 100 then
                if player:get_player_daily_task_reward_info_is_get_by_id(sort_daily_task_info.task_id) then
                    image_get:setVisible(true)
                    button_get:setVisible(false)
                else
                    --button_get:setVisible(true)
                    self.day_get_Btn[i]:enable()
                    self.day_get_Btn[i]:setDarkButton(true)
                    text_get:setColor(cc.c3b(255, 255, 255))
                    text_get:setOpacity(255)
                    image_get:setVisible(false)
                end
            else
                self.day_get_Btn[i]:disable()
                self.day_get_Btn[i]:setDarkButton(false)
                text_get:setColor(cc.c3b(0, 0, 0))
                text_get:setOpacity(255 * 0.5)
                image_get:setVisible(false)
            end
            progress:setPercent(percentage)
            progress_num:setString(string.format("%d/%d",player_daily_task_info.finish_count,sort_daily_task_info.target_num))

            if sort_daily_task_info.task_id == "task_01" then
                text_mission_des:setString(self.sort_daily_task_info_vector[i].task_content)
            elseif sort_daily_task_info.task_id == "task_03" or sort_daily_task_info.task_id == "task_04" or sort_daily_task_info.task_id == "task_12" then
                local target_name = Daily_Task_Data:getInstance():get_target_name_by_id_and_target_type(sort_daily_task_info.task_id, player_daily_task_info.target_type)
                if sort_daily_task_info.task_id == "task_12" then
                    text_mission_des:setString(string.format(sort_daily_task_info.task_content,target_name))
                else
                    text_mission_des:setString(string.format(sort_daily_task_info.task_content,sort_daily_task_info.target_num,target_name))
                end
                
            else
                text_mission_des:setString(string.format(sort_daily_task_info.task_content,sort_daily_task_info.target_num))
            end

        end
    end
    update_day_listview()

    performWithDelay(self,function() 
        local size = day_listview:getInnerContainerSize()
        day_listview:setInnerContainerSize(cc.size(size.width,size.height+30))
    end, 0.1)

    --成就任务列表
    local panel_1 = achv_listview:getChildByName("panel_1")
    --achv_listview:setScrollBarEnabled(false)
    achv_listview:setItemModel(panel_1:clone())
    achv_listview:removeAllItems()

    local achv_info_vector = Achv_Data:getInstance():get_achv_info_vector()    

    local count = get_table_length(achv_info_vector)
    for i=1,count do
        achv_listview:pushBackDefaultItem()
    end
    self.achv_get_Btn = {}
    for i=1,count do
        local function update_achv_item()
            local item = achv_listview:getItem(i -1)
            local image_reward = item:getChildByName("image_reward")
            local text_reward = image_reward:getChildByName("text_reward")
            local panel_star = item:getChildByName("panel_star")
            local image_level = panel_star:getChildByName("image_level")
            local text_mission_des = item:getChildByName("text_mission_des")
            local progress = item:getChildByName("progress")
            local progress_num = item:getChildByName("progress_num")
            local button_get = item:getChildByName("button_get")
            local text_get = button_get:getChildByName("text_get")
            text_get:setLocalZOrder(1)
            local image_get = item:getChildByName("image_get")


            --local achv_info = achv_info_vector[i]
            local sort_achv_info = self.sort_achv_info_vector[i]
            local player_achv_info = player:get_player_achv_info_by_id(sort_achv_info.achv_id)
            --player_achv_info.finish_count 遍历stage_info_vector,is_get == false的阶段
            
            if sort_achv_info.achv_id == "achv_06" then
                self.millionaire_callback = update_achv_item
            end

            local index = 5
            for k,v in ipairs(player_achv_info.stage_info_vector) do
                if v.is_get == false then
                    index = k
                    break
                end
            end

            if self.achv_get_Btn[i] then
                self.achv_get_Btn[i]:setDarkButton(true)
                self.achv_get_Btn[i] = nil 
            end
            self.achv_get_Btn[i] = ButtonWrap:create()
            self.achv_get_Btn[i]:wrap(button_get, 1)
            self.achv_get_Btn[i]:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                
                player:set_player_achv_info_is_get_by_id_and_stage(sort_achv_info.achv_id, index, true)
                local item_id = sort_achv_info.stage_info_vector[index].item_id
                local item_num = sort_achv_info.stage_info_vector[index].item_num
                player:add_player_bag_info_by_id(item_id,item_num)

                performWithDelay(self,function() 
                    update_achv_item()
                    if item_id == "item_02" and self.millionaire_callback then
                        self:runAction(cc.Sequence:create(cc.DelayTime:create(0.85), cc.CallFunc:create(function()
                            self.millionaire_callback()
                        end))) 
                        
                    end
                end,0.016)
                self:update_achv_mark()
                cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.mission_image_mark_event)
                
                if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
                    if item_id == "item_03" then
                        TalkingDataManager:getInstance():sendOnReward(item_num,"成就任务")
                    end
                else
                    self.__c_mask_layer:setVisible(true)
                    local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)                    
                    self.bag_reward:setItemTexture(bag_info.res_key)
                    self.bag_reward:setTouchEnabled(true)
                    self.bag_reward:runAction()

                    self:runAction(cc.Sequence:create(cc.DelayTime:create(34 * 0.033), cc.CallFunc:create(function()
                        self.__c_mask_layer:setVisible(false)
                    end)))
                end
            end)
            
            

            for j=1,5 do
                local star_bottom = panel_star:getChildByName(string.format("star_%d", j))
                local star = star_bottom:getChildByName(string.format("star_%d_1", j))
                if index > j then
                    star:setVisible(true)
                else
                    star:setVisible(false)
                end
                if index == 5 and player:get_player_achv_info_reward_info_is_get_by_id_and_stage(sort_achv_info.achv_id, index) then
                    star:setVisible(true)
                end
            end

            --image_level:loadTexture(sort_achv_info.res_key)
            image_level:setVisible(false)
            local level_pic = ccui.ImageView:create(sort_achv_info.res_key)
            level_pic:setPosition(image_level:getPosition())
            panel_star:addChild(level_pic)

            text_mission_des:setString(string.format(sort_achv_info.achv_content, sort_achv_info.stage_info_vector[index].target_num))

            local percentage = player_achv_info.finish_count/sort_achv_info.stage_info_vector[index].target_num*100
            
            if percentage >= 100 then
                if player:get_player_achv_info_reward_info_is_get_by_id_and_stage(sort_achv_info.achv_id, index) then
                    image_get:setVisible(true)
                    button_get:setVisible(false)
                else
                    --button_get:setVisible(true)
                    self.achv_get_Btn[i]:enable()
                    self.achv_get_Btn[i]:setDarkButton(true)
                    text_get:setColor(cc.c3b(255, 255, 255))
                    text_get:setOpacity(255)
                    image_get:setVisible(false)
                    print(i.."percentage::"..percentage)
                end
            else
                self.achv_get_Btn[i]:disable()
                self.achv_get_Btn[i]:setDarkButton(false)
                text_get:setColor(cc.c3b(0, 0, 0))
                text_get:setOpacity(255 * 0.5)
                image_get:setVisible(false)
            end
            progress:setPercent(percentage)
            progress_num:setString(string.format("%d/%d",player_achv_info.finish_count,sort_achv_info.stage_info_vector[index].target_num))

            local bag_info = Bag_Data:getInstance():get_bag_info_by_id(sort_achv_info.stage_info_vector[index].item_id)            
            if sort_achv_info.stage_info_vector[index].item_id == "item_02" then
                image_reward:loadTexture("images/item/item_8.png")
            elseif sort_achv_info.stage_info_vector[index].item_id == "item_03" then
                image_reward:loadTexture("images/item/item_9.png")
            else
                image_reward:loadTexture(bag_info.res_key)
            end
            text_reward:setString(string.format("x%d", sort_achv_info.stage_info_vector[index].item_num))
        end
        update_achv_item()
    end

    performWithDelay(self,function() 
        local size = achv_listview:getInnerContainerSize()
        achv_listview:setInnerContainerSize(cc.size(size.width,size.height+50))
        achv_listview:setVisible(false)
    end, 0.1)

    self:update_daily_task_mark()
    self:update_achv_mark()
end

function MissionLayer:get_random_num(table)
    math.randomseed(os.time())
    local random_num = math.random()

    local index = nil
    local count = get_table_length(table)
    for i=1,count do
        if random_num <= table[i].odds then
            index = i
            break
        end
    end
    return index
end

function MissionLayer:update_date()
    local player = Player:getInstance()
    local last_daily_task_day = player:get_last_daily_task_day()

    local tm = os.date("*t", self.timeStamp)
    local diff_day = tm.yday - last_daily_task_day
    if tm.yday == 1 and last_daily_task_day ~= 1 then
        diff_day = 1
    end
    if diff_day > 0 then
        player:set_last_daily_task_day(tm.yday)
        --init player_daily_task
        local daily_task_info_vector = Daily_Task_Data:getInstance():get_daily_task_info_vector()
        local player_daily_task_info_vector = {}
        for i=1,#daily_task_info_vector do
            local player_daily_task_info = {
                task_id = daily_task_info_vector[i].task_id,
                finish_count = 0,
                is_get = false,
                is_choose = false,
            }
            if daily_task_info_vector[i].target_type_info then
                local target_type_info = daily_task_info_vector[i].target_type_info
                local index = self:get_random_num(target_type_info)
                if daily_task_info_vector[i].task_id == "task_12" then
                    if player:get_player_role_info_by_id(target_type_info[index].target_type).is_unlock == false then
                        player_daily_task_info.target_type = "role_101"
                    else
                        player_daily_task_info.target_type = target_type_info[index].target_type
                    end
                else
                    player_daily_task_info.target_type = target_type_info[index].target_type
                end
            end
            if i == 1 then
                local index = self:get_random_num(daily_task_info_vector[1].reward_info)
                player_daily_task_info.target_type = index
            end
            player_daily_task_info_vector[i] = player_daily_task_info
        end
        player:set_player_daily_task_info_vector(player_daily_task_info_vector)

        --随机选择任务 1,2,3,4必出,{5,6,7,11,12}选2
        local a,b = self:selectNumber(2,{5,6,7,11,12,9,10})
        
        for i=1,4 do
            self.sort_daily_task_info_vector[i] = daily_task_info_vector[i]
            player:set_player_daily_task_reward_info_is_choose_by_id(daily_task_info_vector[i].task_id, true)
        end
        self.sort_daily_task_info_vector[5] = daily_task_info_vector[a]
        player:set_player_daily_task_reward_info_is_choose_by_id(daily_task_info_vector[a].task_id, true)
        self.sort_daily_task_info_vector[6] = daily_task_info_vector[b]
        player:set_player_daily_task_reward_info_is_choose_by_id(daily_task_info_vector[b].task_id, true)
    else
        local player_daily_task_info_vector = player:get_player_daily_task_info_vector()
        local daily_task_info_vector = Daily_Task_Data:getInstance():get_daily_task_info_vector()
        --player_daily_task_info_vector[5]=daily_task_info_vector[8]
        local index = 1
        local temp_table = {}
        for k,v in ipairs(player_daily_task_info_vector) do
            local daily_task_info = daily_task_info_vector[k]
            local player_daily_task_info = player:get_player_daily_task_info_by_id(daily_task_info.task_id)
            local percentage = player_daily_task_info.finish_count/daily_task_info.target_num*100
            if v.task_id == "task_01" then
                self.sort_daily_task_info_vector[index] = daily_task_info_vector[k]
                index = index + 1
            else
                if v.is_choose and percentage>=100 then
                    self.sort_daily_task_info_vector[index] = daily_task_info_vector[k]
                    index = index + 1
                elseif v.is_choose then
                    table.insert(temp_table,daily_task_info_vector[k])
                end
            end
        end
        for k,v in pairs(temp_table) do
            table.insert(self.sort_daily_task_info_vector, v)
        end
        --self.sort_daily_task_info_vector[7]=daily_task_info_vector[9]
        --self.sort_daily_task_info_vector[6]=daily_task_info_vector[10]
        --player:set_player_daily_task_reward_info_is_choose_by_id(daily_task_info_vector[7].task_id, true)
        --player:set_player_daily_task_reward_info_is_choose_by_id(daily_task_info_vector[6].task_id, true)
    end

    --成就排序，可领取在前
    local player_achv_info_vector = player:get_player_achv_info_vector()
    local achv_info_vector = Achv_Data:getInstance():get_achv_info_vector()

    local index = 1
    local temp_table = {}
    for k,v in ipairs(player_achv_info_vector) do
        local achv_info = achv_info_vector[k]
        local player_achv_info = player:get_player_achv_info_by_id(achv_info.achv_id)

        local i = 5
        for k1,v1 in ipairs(player_achv_info.stage_info_vector) do
            if v1.is_get == false then
                i = k1
                break
            end
        end
        local percentage = player_achv_info.finish_count/achv_info.stage_info_vector[i].target_num*100
        
        if percentage>=100 then
            self.sort_achv_info_vector[index] = achv_info_vector[k]
            index = index + 1
        else
            table.insert(temp_table,achv_info_vector[k])
        end
    end
    for k,v in pairs(temp_table) do
        table.insert(self.sort_achv_info_vector, v)
    end

end

function MissionLayer:update_daily_task_mark()
    local player = Player:getInstance()
    local count = 0
    local daily_task_info_vector = Daily_Task_Data:getInstance():get_daily_task_info_vector()
    for i=1,get_table_length(daily_task_info_vector) do
        local sort_daily_task_info = daily_task_info_vector[i]
        local player_daily_task_info = player:get_player_daily_task_info_by_id(sort_daily_task_info.task_id)
        local percentage = player_daily_task_info.finish_count/sort_daily_task_info.target_num*100
        if percentage >= 100 then
            if player:get_player_daily_task_reward_info_is_get_by_id(sort_daily_task_info.task_id) == false
             and player:get_player_daily_task_reward_info_is_choose_by_id(sort_daily_task_info.task_id) then
                count = count + 1
            end
        end
    end
    if count > 0 then
        self.day_image_mark:setVisible(true)
        self.day_image_mark:getChildByName("text_1"):setString(count)
    else
        self.day_image_mark:setVisible(false)
    end    
end

function MissionLayer:update_achv_mark()
    local player = Player:getInstance()
    local count = 0
    local achv_info_vector = Achv_Data:getInstance():get_achv_info_vector()
    for i=1,get_table_length(achv_info_vector) do
        local achv_info = achv_info_vector[i]
        local player_achv_info = player:get_player_achv_info_by_id(achv_info.achv_id)
        local index = 5
        for k,v in ipairs(player_achv_info.stage_info_vector) do
            if v.is_get == false then
                index = k
                break
            end
        end
        local percentage = player_achv_info.finish_count/achv_info.stage_info_vector[index].target_num*100
        if percentage >= 100 then
            if player:get_player_achv_info_reward_info_is_get_by_id_and_stage(achv_info.achv_id, index) == false then
                count = count + 1
            end
        end
    end
    if count > 0 then
        self.achv_image_mark:setVisible(true)
        self.achv_image_mark:getChildByName("text_1"):setString(count)
    else
        self.achv_image_mark:setVisible(false)
    end
end

function MissionLayer:selectNumber(count,arg)
    local selected={};
    math.random(0,#arg);
    math.randomseed(os.time());
    if #arg<=count then return unpack(arg) end
    while #selected < count do
        math.random(#arg);
        table.insert(selected,table.remove(arg,math.random(#arg)));
    end
    table.sort(selected)
    return unpack(selected);
end

function MissionLayer:set_close_callback(callback)
    self.close_callback = callback
end

function MissionLayer:close_self()
    if self.close_callback then
        self.close_callback()
    end
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("mission_out", false)

    set_list_fade_out(self.day_listview)
    set_list_fade_out(self.achv_listview)
end

return MissionLayer