--
-- Author: Huang Xin
-- Date: 2017-06-05 14:34:35
--
require "UI.Layer.CardLayer"
require "core.LayerManager"
require "UI.Widget.MaskLayer"

OneButtonLayer = class("OneButtonLayer", function() return cc.Layer:create() end)

function OneButtonLayer:ctor()
	
	self:setName("OneButtonLayer")

	local widget = cc.CSLoader:createNode("give_energy.csb")
	self:addChild(widget, 1)

	local node = widget:getChildByName("node")
	local image_dia = node:getChildByName("image_dia")
	self.image_dia = image_dia
    
    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)
    --Label
    local text_title = image_dia:getChildByName("text_title")
    self.text_title = text_title
    local text_time = image_dia:getChildByName("text_time")
    self.text_time = text_time
 
    --发送按钮
    local send_image = image_dia:getChildByName("button_send")
    local button_send = ButtonWrap:create()
    button_send:wrap(send_image,1)
    button_send:addTouchEndCallback(function()
    	MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
    	self:close_self()
    	end)

    local image_energy = send_image:getChildByName("image_energy")
    self.image_energy = image_energy
    
	-- layout:setVisible(true)

	-- local item = layout:getChildByName("1")
	-- item:setVisible(true)


    --动画进去
    -- self.action = cc.CSLoader:createTimeline("give_energy.csb")
    -- widget:runAction(self.action)

    -- self.action:setCurrentFrame(0)
    -- self.action:play("mail_free_in",false)
    
    -- local function onFrameEvent(frame)
    --     if nil == frame then
    --         return
    --     end
    --     local str = frame:getEvent()
    --     if str == "mail_free_in_end" then

    --     elseif str == "mail_free_out_end" then
    --         self:removeFromParent()
    --     end
    -- end
    -- self.action:setFrameEventCallFunc(onFrameEvent)
    
    
	self:initListview()

end

function OneButtonLayer:initListview()
    	 --菜单功能
    local panel_1 = self.image_dia:getChildByName("panel_1")
    self.panel_1 = panel_1
    local layout = panel_1:getChildByName("layout")
    self.panel_1:setItemModel(layout:clone())
    self.panel_1:removeAllItems()
	
    local function async_callback(list)
    	local friendlist = list
    	print("request error")
    	self.friendlist = friendlist
    	local friend_count = get_table_length(friendlist)
    	self.friend_count = friend_count
		
    	-- for i=1,math.ceil(friend_count/4.0) do
    	-- 	self.panel_1:pushBackDefaultItem()

    	-- end
    	for i=1,friend_count do
            panel_1:pushBackDefaultItem()
        end

    	-- local function pageload(num)
    	-- 	local items_count = table.getn(panel_1:getItems())
    	-- 	local count = num*3
    	-- 	if count >= items_count then
    	-- 		count = items_count
    	-- 	end 

    	-- 	for i=1+(num-1)*3,count do
    	-- 		local item = panel_1:getItem(i-1)
    	-- 		for j=1,4 do
    	-- 			local curr_index = (i-1)*4 + j
    	-- 			local curr_friend = item:getChildByName(string.format("%d", j))
    	-- 			curr_friend:setVisible(true)

    	-- 		end
    	-- 	end
    	-- end
    	-- self:pageload(1)
   	end 	
	self:request_getFriendlist(async_callback)
	-- print("request error")
end

function OneButtonLayer:close_self()
    	self:addChild(MaskLayer:create(), 5)
    	LayerManager:getInstance():remove_top_layer()
    	self:removeFromParent()
    	-- self.action:play("mail_free__out",false)
    
    	-- set_list_fade_out(self.panel_book)    
    	-- self:set_all_card_is_see()
end

function OneButtonLayer:request_getFriendlist(async_callback)
    --request getFriendlist 当前好友列表
    local rpc_param = {

        PLAYER_ID,

    }

    RPC:call_bind("SHIN/friend/getFriendlist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if response == nil then
            	
                response = {}
            end
            async_callback(response)

        else

            print("request error")

        end

    end)
end

function OneButtonLayer:onEnter()
    RPC:register_target(self)
end

function OneButtonLayer:onExit()
    RPC:unregister_target(self)
end
return OneButtonLayer