require "UI.Widget.MaskLayer"
require "UI.Layer.GameLeaveLayer"

local GameGlobals = require "GameEx.GameGlobals"

PauseLayer = class("PauseLayer", function() return cc.Layer:create() end)

function PauseLayer:ctor()

    self:setName("PauseLayer")

	local widget = cc.CSLoader:createNode("pause.csb")
    self:addChild(widget, 1)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("pause.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("pause_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "pause_in_end" then

        elseif str == "pause_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)


    --暂停界面的按钮
    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    --退出按钮
    local  exitImage = image_dia:getChildByName("button_exit")
    local exitBtn = ButtonWrap:create()
    exitBtn:wrap(exitImage, 1)
    exitBtn:addTouchEndCallback(function(sender)

        if GameGlobals.Scene:get("is_tournament") then

            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click_Audio"), false)
            self:close_self()

            local weekgameWinLayer = WeekgameWinLayer:create()
            weekgameWinLayer:setConchNumber(GameGlobals.Scene:get("conch_collected"))
            cc.Director:getInstance():getRunningScene():addChild(weekgameWinLayer, 9)
            --LayerManager:getInstance():add_layer_to_scene(weekgameWinLayer)
        else

            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click_Audio"), false)
            self:close_self()
            local gameLeaveLayer = GameLeaveLayer:create()
            LayerManager:getInstance():add_layer_to_scene(gameLeaveLayer)
            gameLeaveLayer:setLocalZOrder(6)

        end

        
    end)

    local mm = MusicManager:getInstance()
    --音效按钮
    local audio_image = image_dia:getChildByName("button_audio")
    local text_audio = audio_image:getChildByName("text_audio")
    text_audio:setLocalZOrder(1)
    local audio_Btn = ButtonWrap:create()
    audio_Btn:wrap(audio_image, 1)
    audio_Btn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
    	if mm.getEffectEnable() then
    		mm.setEffectEnable(false)
            audio_Btn:setDarkButton(false)
            text_audio:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    	else
    		mm.setEffectEnable(true)
            audio_Btn:setDarkButton(true)
            text_audio:setTextColor(cc.c4b(25, 117, 158, 255))
    	end
    end)
    self.audio_Btn = audio_Btn

    --背景音乐按钮
    local music_image = image_dia:getChildByName("button_music")
    local text_music = music_image:getChildByName("text_music")
    text_music:setLocalZOrder(1)
    local music_Btn = ButtonWrap:create()
    music_Btn:wrap(music_image, 1)
    music_Btn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
    	if mm.getBgMusicEnable() then
    		mm.setBgMusicEnable(false)
            music_Btn:setDarkButton(false)
            text_music:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    	else
    		mm.setBgMusicEnable(true)
            music_Btn:setDarkButton(true)
            text_music:setTextColor(cc.c4b(25, 117, 158, 255))
    	end
    end)
    self.music_Btn = music_Btn

    if mm.getEffectEnable() == false then
        audio_Btn:setDarkButton(false)
        text_audio:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    end

    if mm.getBgMusicEnable() == false then
        music_Btn:setDarkButton(false)
        text_music:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    end

    --重来游戏按钮
    local replay_image = image_dia:getChildByName("button_replay")
    local replay_Btn = ButtonWrap:create()
    replay_Btn:wrap(replay_image, 1)
    replay_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:close_self()
        local levelInfoLayer = LevelInfoLayer:create()
        levelInfoLayer:set_close_callback(function()

            local loadingScene = LoadingScene:create(1)
            loadingScene:load_extern_scene_resource()
            loadingScene:set_load_finish_callback(function()
                local section_mission = Player:getInstance():get_player_current_section()
                local externalScene = ExternalScene:create()
                externalScene:add_map(section_mission)
                externalScene:play_bg_music()
                LayerManager:getInstance():clear_layer()
                cc.Director:getInstance():replaceScene(externalScene)

                display.removeUnusedSpriteFrames()

            end)
            LayerManager:getInstance():clear_layer()
            cc.Director:getInstance():replaceScene(loadingScene)
            
        end)
        LayerManager:getInstance():add_layer_to_scene(levelInfoLayer)
        --8.26
        local player = Player:getInstance()
        if not player:get_is_player_handle_in_game() then
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("GameLeaveLayer_1"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer) 
            
            player:add_player_power(player:get_play_once_need_power())
        else
            levelInfoLayer:set_close_callback(function() end)

            local current_level = player:get_player_current_level()
            local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
            player:add_player_mission_fail_times(mission_info.mission_id)
        end
        --8.26
    end)
    if GameGlobals.Scene:get("is_tournament") then
        replay_image:setVisible(false)
    end

    --继续游戏按钮
    local continueImage = image_dia:getChildByName("button_continue")
    local continueBtn = ButtonWrap:create()
    continueBtn:wrap(continueImage, 1)
    continueBtn:addTouchEndCallback(function(sender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function PauseLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("pause_out", false)

    self.audio_Btn:set_fade_out()
    self.music_Btn:set_fade_out()
end

return PauseLayer