require "UI.Layer.UnlockRoleLayer"
require "UI.Layer.UnlockSkinLayer"
require "UI.Layer.GetSkinLayer"
require "UI.Layer.GetRoleLayer"
require "UI.Layer.TopBarViceLayer"
require "core.Skill_Data"
require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.WarningLayer"
require "UI.Layer.SkillInfoLayer"
require "core.TalkingDataManager"

RoleInfoLayer = class("RoleInfoLayer", function() return cc.Layer:create() end)

function RoleInfoLayer:ctor()

    self:setName("role_info_layer")

    self.role_image_vector = {}
    self.role_name_vector = {}    
    self.role_vector = {}
    self.is_first_in = true
    self.card_enable = true

    local topBarViceLayer = TopBarViceLayer:create()
    self:addChild(topBarViceLayer, 1)

	local widget = cc.CSLoader:createNode("role_info.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("role_info.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("role_info_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "role_info_in_end" then
        elseif str == "role_info_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    -- ui
    local node = widget:getChildByName("node")
    self.image_skin_1 = node:getChildByName("image_dia"):getChildByName("image_skin_1")
    local text_title_role = node:getChildByName("text_title_role")

    local image_role_title = node:getChildByName("image_dia"):getChildByName("panel_mask"):getChildByName("image_role_title")
    self.text_role_name = image_role_title:getChildByName("text_role_name") -- 角色名字

    -- 角色信息
    local panel_role_info = node:getChildByName("image_dia"):getChildByName("panel_role_info")
    self.panel_role_info = panel_role_info
    self.panel_bonus_num = panel_role_info:getChildByName("panel_bonus_num")

    local atk = panel_role_info:getChildByName("atk")
    self.atk_text_name =  atk:getChildByName("text_name")
    self.atk_text_num = atk:getChildByName("text_num")
    self.image_atk = atk:getChildByName("image_atk")

    local score_bonus = panel_role_info:getChildByName("score_bonus")
    self.score_text_name = score_bonus:getChildByName("text_name")
    self.score_text_num = score_bonus:getChildByName("text_num")
    self.image_score_bonus = score_bonus:getChildByName("image_score_bonus")

    local gold_bonus = panel_role_info:getChildByName("gold_bonus")
    self.gold_text_name = gold_bonus:getChildByName("text_name")
    self.gold_text_num = gold_bonus:getChildByName("text_num")
    self.image_gold_bonus = gold_bonus:getChildByName("image_gold_bonus")

    -- self.skill_des_is_hide = true
    local skill = panel_role_info:getChildByName("skill")
    local skill_Btn = ButtonWrap:create()
    skill_Btn:wrap(skill, 1)
    skill_Btn:addTouchEndCallback(function()

        local event = cc.EventCustom:new("skill_desc_button_pressed")
        event.param = {}   
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)    

        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local skillInfoLayer = SkillInfoLayer:create()
        LayerManager:getInstance():add_layer_to_scene(skillInfoLayer)

    end)
    local button_des = skill:getChildByName("button_des")
    local des_Btn = ButtonWrap:create()
    des_Btn:wrap(button_des, 1)
    des_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        
        local skillInfoLayer = SkillInfoLayer:create()
        LayerManager:getInstance():add_layer_to_scene(skillInfoLayer)
    end)

    self.skill_text_name = skill:getChildByName("text_name")
    self.skill_text_name:setPositionY(self.skill_text_name:getPositionY()-15)
    self.skill_text_num = skill:getChildByName("text_num")
    self.skill_text_num:setVisible(false)
    self.image_skill = skill:getChildByName("image_skill")
    -- self.skill_des = panel_role_info:getChildByName("skill_des")

    self.text_role_level = panel_role_info:getChildByName("text_role_level")
    -- self.text_skill_des = self.skill_des:getChildByName("text_skill_des")

    -- 角色按钮
    local panel_btn_role = node:getChildByName("image_dia"):getChildByName("panel_btn_role")
    self.panel_btn_role = panel_btn_role
    panel_btn_role:setTouchEnabled(false)
    panel_btn_role:setMagneticAllowedOutOfBoundary(true)---？
    local role_sample = panel_btn_role:getChildByName("button_role_1")
    panel_btn_role:setItemModel(role_sample:clone())
    panel_btn_role:removeAllItems()

    local player_role_info_vector = Player:getInstance():get_player_role_info_vector()
    local role_count = get_table_length(player_role_info_vector)
    for i=1,role_count do
        panel_btn_role:pushBackDefaultItem()
    end

    local items_count = table.getn(panel_btn_role:getItems())
    for i=1,items_count do
        local role_info = Role_Data:getInstance():get_role_info_by_id(player_role_info_vector[i].role_id)

        local item = panel_btn_role:getItem(i -1)
        item:setName(string.format("button_role_%d", i - 1))

        local image_role = item:getChildByName("image_role")
        local text_name = item:getChildByName("text_name")
        self.role_image_vector[role_info.role_id] = item
        self.role_name_vector[role_info.role_id] = text_name
        self.role_vector[role_info.role_id] = image_role

        image_role:loadTexture(role_info.res_key)
        text_name:setString(role_info.role_name)
        text_name:setColor(cc.c3b(0x0B, 0x81, 0x77))
        text_name:setFontSize(30)

        -- 按钮
        local role_Btn = ButtonWrap:create()
        role_Btn:wrap(item, 1)
        role_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
            if Player:getInstance():get_player_cur_role_id() ~= "role_101" and role_info.role_id == "role_101" then
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("VOICE_xin"), false)
            end
            if player_role_info_vector[i].is_unlock == false then
                local unlockRoleLayer = UnlockRoleLayer:create()
                unlockRoleLayer:set_cur_role(role_info.role_id)
                unlockRoleLayer:set_go_on_enable(self.card_enable)
                unlockRoleLayer:set_swtich_callback(function()
                    self:close_self()
                end)
                LayerManager:getInstance():add_layer_to_scene(unlockRoleLayer)
                return
            end
print("role_select_pressed")
            local event = cc.EventCustom:new("role_select_pressed")
            event.param = {}   
            cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)  

            self:send_role_change_event()

            self.action:play("role_title", false)
            -- self.skill_des:stopAllActions()
            -- self.skill_des_is_hide = true
            self:chose_role(role_info.role_id)

            TRIGGER_EVENT("ROLE_BUTTON_PRESSED", {id = player_role_info_vector[i].role_id})

        end)
    end

    -- 皮肤栏目
    local panel_skin = node:getChildByName("image_dia"):getChildByName("panel_skin")
    self.panel_skin = panel_skin
    local list_skin = panel_skin:getChildByName("panel_skin")

    local panel_1 = list_skin:getChildByName("panel_1")
    list_skin:setItemModel(panel_1:clone())
    list_skin:removeAllItems()
    self.list_skin = list_skin

    --
    -- list_skin:setTouchEnabled(true)
    -- list_skin:setSwallowTouches(true)
    self.startX = 0
    self.endX = 0
    local function touchEventCallback(sender,eventType)
        if eventType == ccui.TouchEventType.began then
            self.startX = list_skin:getInnerContainerPosition().x
            return true
        elseif eventType == ccui.TouchEventType.moved then
        elseif eventType == ccui.TouchEventType.ended then
            self.endX = list_skin:getInnerContainerPosition().x
            local diff = self.endX - self.startX
            if diff > 0 then
                performWithDelay(self, function() self:scoll_list_view(false) end, 0.016)
            elseif diff < 0 then
                performWithDelay(self, function() self:scoll_list_view(true) end, 0.016)
            end
        end

    end
    list_skin:addTouchEventListener(touchEventCallback)

    -- local function listViewEvent(sender, eventType)
    -- print(eventType)
    --     -- if eventType == ccui.ListViewEventType.ONSELECTEDITEM_START then
    --     --     --print("select child index = ",sender:getCurSelectedIndex())
    --     --     local s1 = list_skin:getContentSize().width
    --     --     local s2 = list_skin:getInnerContainerSize().width
    --     --     local s3 = list_skin:getInnerContainerPosition().x
    --     --     print(string.format("!!!%d,%d,%d", s1,s2,s3))
    --     -- elseif eventType == ccui.ListViewEventType.ONSELECTEDITEM_END then
    --     --     --todo
    --     -- end
    -- end
    -- list_skin:addEventListener(listViewEvent)

    -- local function scrollViewEvent(sender, evenType)
    -- --print(evenType)
    --     -- if evenType == ccui.ScrollviewEventType.scrollToBottom then
    --     --     print("SCROLL_TO_BOTTOM")
    --     -- elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
    --     --     print("SCROLL_TO_TOP")
    --     -- end
    -- end

    -- list_skin:addScrollViewEventListener(scrollViewEvent)

    -- 左右滑动皮肤
    local right_image = panel_skin:getChildByName("button_right")
    local right_Btn = ButtonWrap:create()
    right_Btn:wrap(right_image, 1)
    right_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:scoll_list_view(true)
    end)

    local left_image = panel_skin:getChildByName("button_left")
    local left_Btn = ButtonWrap:create()
    left_Btn:wrap(left_image, 1)
    left_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:scoll_list_view(false)
    end)


    -- 升级按钮
    local upgrade_image = panel_role_info:getChildByName("button_upgrade")
    local upgrade_Btn = ButtonWrap:create()
    upgrade_Btn:wrap(upgrade_image, 1)
    upgrade_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:up_level_role()

        local event = cc.EventCustom:new("role_levelup_pressed")
        event.param = {}   
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)  

        self:send_role_levelup_event() 

        TRIGGER_EVENT("ROLE_UPGRADE_PRESSED")  

    end)
    self.upgrade_image = upgrade_image
    self.upgrade_Btn = upgrade_Btn

    local image_price = panel_role_info:getChildByName("image_price")
    self.image_price = image_price
    local image_gold = image_price:getChildByName("image_gold")
    self.text_gold = image_price:getChildByName("text_gold")
    local image_jewel = image_price:getChildByName("image_jewel")
    self.text_jewel = image_price:getChildByName("text_jewel")

    local player = Player:getInstance()
    self.cur_role_id = player:get_player_cur_role_id()
    self:chose_role(self.cur_role_id)

	-- 退出按钮
	local close_image = node:getChildByName("image_dia"):getChildByName("button_close")
	local close_Btn = ButtonWrap:create()
	close_Btn:wrap(close_image, 1)
	close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
		self:close_self()
	end)


	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    self:trigger_enter_event()

    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.4), cc.CallFunc:create(function()
        
        TRIGGER_EVENT("ROLE_INFO_SHOW", {id = role_id})

    end)))

end

-- function RoleInfoLayer:show_skill_description()

--     self.action:play("skill_des_in", false)
--     self.skill_des_is_hide = false
--     self.skill_des:stopAllActions()
--     self.skill_des:runAction(cc.Sequence:create(cc.DelayTime:create(6.0), cc.CallFunc:create(function()
--         self.skill_des_is_hide = true
--         self.action:play("skill_des_out", false)
--     end)))

-- end

function RoleInfoLayer:send_role_levelup_event()

    local delay = cc.DelayTime:create(0.6)
    local call_func = cc.CallFunc:create(function()

        local event = cc.EventCustom:new("role_levelup")
        event.param = {}   
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)     

    end)
    local sequence = cc.Sequence:create(delay, call_func)

    self:runAction(sequence)

end

function RoleInfoLayer:send_role_change_event()

    local delay = cc.DelayTime:create(0.3)
    local call_func = cc.CallFunc:create(function()

        local event = cc.EventCustom:new("role_changed")
        event.param = {}   
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)     

    end)
    local sequence = cc.Sequence:create(delay, call_func)

    self:runAction(sequence)

end

function RoleInfoLayer:trigger_enter_event()

    local delay = cc.DelayTime:create(0.3)
    local call_func = cc.CallFunc:create(function()

        local event = cc.EventCustom:new("role_layer_entered")
        event.param = {}   
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)        

    end)

    local sequence = cc.Sequence:create(delay, call_func)

    self:runAction(sequence)

end

function RoleInfoLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("role_info_out", false)
    -- self.skill_des:stopAllActions()
    --8.4
    set_list_fade_out(self.panel_skin)
    set_list_fade_out(self.panel_btn_role)
end

function RoleInfoLayer:chose_role(role_id)
    self.cur_role_id = role_id
    Player:getInstance():set_player_cur_role_id(role_id)
    for k,v in pairs(self.role_image_vector) do
        if k == role_id then
            self.role_image_vector[k]:loadTexture("images/role_info/role_btn_select.png")
            self.role_vector[k]:setOpacity(255)
            self.role_name_vector[k]:setColor(cc.c3b(0xFF, 0xFF, 0xFF))
            self.role_name_vector[k]:setFontSize(40)
        else
            self.role_image_vector[k]:loadTexture("images/role_info/role_btn_dia.png")
            self.role_vector[k]:setOpacity(255 * 0.5)
            self.role_name_vector[k]:setColor(cc.c3b(0x0B, 0x81, 0x77))
            self.role_name_vector[k]:setFontSize(30)
        end
    end
    self:show_skin(role_id)
end

function RoleInfoLayer:up_level_role()
    local player = Player:getInstance()
    local player_role_info = player:get_player_role_info_by_id(self.cur_role_id)
    local role_info = Role_Data:getInstance():get_role_info_by_id(self.cur_role_id)
    local role_level_info = Role_Data:getInstance():get_role_level_by_id_level(self.cur_role_id, player_role_info.role_level)

    if player_role_info.role_level >= role_info.max_level then
        return
    end
    if role_level_info.gold_cost > player:get_player_gold() then
        -- local shopLayer = ShopLayer:create()
        -- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
        -- LayerManager:getInstance():add_layer_to_scene(shopLayer)
        --113
        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Gold)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)

        local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needGold"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer)
        return
    end
    if role_level_info.jewel_cost > player:get_player_jewel() then
        local function callback()
            -- local shopLayer = ShopLayer:create()
            -- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
            -- LayerManager:getInstance():add_layer_to_scene(shopLayer)
            --113
            local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
            LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)

            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        end
        player:check_is_buy_gift(callback)
        return
    end

    
    local current_role_id = Player:getInstance():get_player_cur_role_id()    
    TalkingDataManager:getInstance():send("每个角色升级次数统计", {[current_role_id] = player_role_info.role_level})

    --每日任务事件发送
    local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
    event.param = {task_id = "task_11", finish_count = 1, func = function() end }
    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)

    if player_role_info.role_level >= role_info.max_level-1 then
        --成就任务事件发送
        local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
        event.param = {achv_id = "achv_02", finish_count = 1, func = function() end }
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    end

    -- 动画
    -- self.skill_des:stopAllActions()
    -- self.skill_des_is_hide = true
    self.action:play("role_level_up", false)
    -- 粒子效果
    local atk = self.panel_role_info:getChildByName("atk")
    local score_bonus = self.panel_role_info:getChildByName("score_bonus")
    local gold_bonus = self.panel_role_info:getChildByName("gold_bonus")
    local skill = self.panel_role_info:getChildByName("skill")
    local attribute_panel = {[1] = atk, [2] = score_bonus, [3] = gold_bonus, [4] = skill,}
    for i=1,#attribute_panel do
        local level_up_particle = ResourceManager:getInstance():getParticleByKey("PARTICLE_LEVEL_UP")
        level_up_particle:setAutoRemoveOnFinish(false)
        local attribute = attribute_panel[i]
        level_up_particle:setPosition(cc.p(get_node_width(attribute)/2, get_node_height(attribute)/2))
        attribute:addChild(level_up_particle, 1)
    end


    player:add_player_gold(-role_level_info.gold_cost)
    player:add_player_jewel(-role_level_info.jewel_cost)
    if role_level_info.jewel_cost > 0 then
        TalkingDataManager:getInstance():sendOnPurchase("角色升级",1,role_level_info.jewel_cost)
    end

    player:upgrade_player_role(self.cur_role_id, 1)
    self:update_role_info()
end

function RoleInfoLayer:show_skin(role_id)
    local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
    local player_role_info = Player:getInstance():get_player_role_info_by_id(role_info.role_id)

    local skin_id_vector = role_info.skin_id_list
    self.list_skin:removeAllItems()

    for i=1,#skin_id_vector + 2 do
        self.list_skin:pushBackDefaultItem()
    end

    self.role_select = {}
    for i=1,#skin_id_vector + 2 do
        local item = self.list_skin:getItem(i-1)
        self.role_select[i] = ccui.ImageView:create("images/role_info/role_select.png")
        self.role_select[i]:setPosition(cc.p(get_node_width(item)/2, -150))
        item:addChild(self.role_select[i])
        self.role_select[i]:setVisible(false)

        if i == 1 or i == #skin_id_vector + 2 then
            item:setVisible(false)
        else
            local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id_vector[i-1])
            local player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_id_vector[i-1])
            local image_skin = item:getChildByName("image_skin")
            local image_lock = item:getChildByName("image_lock")
            image_skin:loadTexture(skin_info.res_key)
            if player_skin_info.is_unlock then
                image_lock:setVisible(false)
            end
            local skin_Btn = ButtonWrap:create()
            skin_Btn:wrap(image_skin, 0)
            skin_Btn:addTouchEndCallback(function()
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
                if player_skin_info.is_unlock then
                    self:select_skin(skin_info.skin_id, i)
                else
                    local unlockSkinLayer = UnlockSkinLayer:create()
                    unlockSkinLayer:set_cur_skin(self.cur_role_id, skin_info.skin_id)
                    unlockSkinLayer:set_swtich_callback(function()
                        self:close_self()
                    end)
                    unlockSkinLayer:set_go_on_enable(self.card_enable)
                    LayerManager:getInstance():add_layer_to_scene(unlockSkinLayer)
                end
            end)

        end
    end
    local skin_id = player_role_info.skin_id 
    self.cur_skin_id = skin_id 
    self:select_skin(skin_id, self:get_cur_skin_index() + 1)

end

function RoleInfoLayer:get_cur_skin_index()
    local role_info = Role_Data:getInstance():get_role_info_by_id(self.cur_role_id)
    local skin_id_vector = role_info.skin_id_list
    local index  = 1
    for i=1,#skin_id_vector do
        if self.cur_skin_id == skin_id_vector[i] then
            index = i
        end
    end
    return index 
end

function RoleInfoLayer:scoll_list_view(is_next)
    local role_info = Role_Data:getInstance():get_role_info_by_id(self.cur_role_id)
    local skin_id_vector = role_info.skin_id_list
    local index  = self:get_cur_skin_index()

    if is_next then
        index = math.max((index + 1)%(#skin_id_vector + 1), 1)
        local player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_id_vector[index])
        while player_skin_info.is_unlock == false do
            index = math.max((index + 1)%(#skin_id_vector + 1), 1)
            player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_id_vector[index])
        end
    else
        index = index - 1
        if index == 0 then
            index = #skin_id_vector
        end
        local player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_id_vector[index])
        while player_skin_info.is_unlock == false do
            index = index - 1
            if index == 0 then
                index = #skin_id_vector
            end
            player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_id_vector[index])
        end
    end
    self:select_skin(skin_id_vector[index], index + 1)
end

function RoleInfoLayer:select_skin(skin_id, index)
    self.cur_skin_id = skin_id 
    local role_info = Role_Data:getInstance():get_role_info_by_id(self.cur_role_id)
    local skin_id_vector = role_info.skin_id_list
    local skin_count = #skin_id_vector

    -- 滚动条
    if self.is_first_in then
        self.is_first_in = false
        self.list_skin:jumpToPercentHorizontal(100.0 * (index -2) / (skin_count + 2 - 3))
    else
        self.list_skin:scrollToPercentHorizontal(100.0 * (index -2) / (skin_count + 2 - 3), 0.2, false)
    end
    for j = 1,#self.role_select do
        if j == index then
            self.role_select[j]:setVisible(true)
        else
            self.role_select[j]:setVisible(false)
        end
    end
    self:update_role_info()
end

function RoleInfoLayer:update_role_info()
    local role_id = self.cur_role_id
    local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
    local player_role_info = Player:getInstance():get_player_role_info_by_id(role_id)
    local pre_role_level_info = Role_Data:getInstance():get_role_level_by_id_level(role_id, player_role_info.role_level - 1)
    local role_level_info = Role_Data:getInstance():get_role_level_by_id_level(role_id, player_role_info.role_level)
    local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)

    self.text_role_name:setString(role_info.role_name)
    self.text_role_level:setString(string.format("LV.%d", player_role_info.role_level))
    --self.image_skill:setTexture(skill_info.res_key)
    self.skill_text_name:setString(skill_info.skill_name)
    -- self.skill_text_num:setString(string.format("Lv.%d", Player:getInstance():get_player_skill_level(role_id)))
    -- self.text_skill_des:setString(skill_info.description)

    local text_upgrade = self.upgrade_image:getChildByName("text_upgrade")
    local image_level_full = self.panel_role_info:getChildByName("image_level_full")
    if player_role_info.role_level >= role_info.max_level then
        self.image_price:setVisible(false)
        self.upgrade_Btn:disable()
        text_upgrade:setString(ResourceManager:getInstance():getTextStringByKey("RoleInfoLayer_1"))
        self.upgrade_image:setVisible(false)
        image_level_full:setVisible(true)
    else
        self.image_price:setVisible(true)
        self.upgrade_Btn:enable()
        text_upgrade:setString(ResourceManager:getInstance():getTextStringByKey("RoleInfoLayer_2"))
        self.text_gold:setString(string.format("%d", role_level_info.gold_cost))
        self.text_jewel:setString(string.format("%d", role_level_info.jewel_cost))
        self.upgrade_image:setVisible(true)
        image_level_full:setVisible(false)
    end

    local skin_id = self.cur_skin_id
    local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id)

    local score_add = skin_info.init_score_add + role_level_info.score_add
    self.score_text_num:setString(string.format("%2d%%", score_add * 100))
    local total_atk = skin_info.init_atk + role_level_info.atk_add
    self.atk_text_num:setString(string.format("%d", total_atk))
    local gold_add = skin_info.init_gold_add + role_level_info.gold_add
    self.gold_text_num:setString(string.format("%2d%%", gold_add * 100))
    self.image_skin_1:setTexture(skin_info.res_key)

    local text_atk_num = self.panel_bonus_num:getChildByName("text_atk_num")
    local text_score_num = self.panel_bonus_num:getChildByName("text_score _num")
    local text_gold_num = self.panel_bonus_num:getChildByName("text_gold _num")
    local text_des_num = self.panel_bonus_num:getChildByName("text_des _num")
    text_atk_num:setString(string.format("+%d", role_level_info.atk_add - pre_role_level_info.atk_add))
    text_score_num:setString(string.format("+%.0f%%", (role_level_info.score_add - pre_role_level_info.score_add) * 100))
    text_gold_num:setString(string.format("+%.0f%%", (role_level_info.gold_add- pre_role_level_info.gold_add) * 100))

    if Player:getInstance():is_player_up_skill_level(role_id) then
        text_des_num:setString("+1")
    else
        text_des_num:setString("+0")
    end

    Player:getInstance():set_player_role_skin_map(self.cur_role_id, self.cur_skin_id)
    Player:getInstance():set_player_cur_skin_id(self.cur_skin_id)
end

function RoleInfoLayer:set_go_on_enable(flag)
    self.card_enable = flag
end

function RoleInfoLayer:onEnter()

end

function RoleInfoLayer:onExit()
end

return RoleInfoLayer