require "UI.Layer.RoleInfoLayer"
require "UI.Layer.BagLayer"
require "UI.Layer.BookLayer"
require "UI.Layer.ShopLayer"
require "UI.Layer.MissionLayer"
require "UI.Layer.StarRewardLayer"
require "UI.Layer.SettingLayer"
require "core.LayerManager"
require "UI.Layer.LoseLayer"
require "UI.Layer.ReliveLayer"
require "UI.Layer.SignBoardLayer"
require "UI.Layer.WheelLayerEx"
require "UI.Layer.WeeklyChallengeLayer"
require "UI.Layer.SpringsaleLayer"
require "UI.Layer.LimitGiftLayer"
require "UI.Layer.FriendLayer"
require "UI.Layer.MailLayer"
require "UI.Layer.InviteRewardLayer"
require "UI.Layer.ShareLayer"
require "UI.Layer.SharePictureLayer"
require "UI.Layer.ShareStageLayer"

SectionBottomLayer = class("SectionBottomLayer", function() return cc.Layer:create() end)

function SectionBottomLayer:ctor()

	self:setName("section_bottom_layer")
	self.scheduleScriptEntryID = nil
	self.back_home = nil
	self.is_pack_open = false
	local player = Player:getInstance()
	local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
	self:update_date()

	local widget = cc.CSLoader:createNode("section_button.csb")
	self:addChild(widget)
	self.widget = widget

	local visible_size = cc.Director:getInstance():getVisibleSize()
	widget:setContentSize(visible_size)
    ccui.Helper:doLayout(widget)

	local action = cc.CSLoader:createTimeline("section_button.csb")
	widget:runAction(action)
	self.action = action
	self.action:gotoFrameAndPlay(0, 0, false)

	

	-- 按钮
	-- 星星奖励
	local star_box_image = widget:getChildByName("button_star_box")
	local star_box_Btn = ButtonWrap:create()
	star_box_Btn:wrap(star_box_image, 1)
	star_box_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)

		local starRewardLayer = StarRewardLayer:create()
		LayerManager:getInstance():add_layer_to_scene(starRewardLayer)
	 	-- local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Energy)
   --      LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
        
	end)
	self.star_box_image = star_box_image
	self.star_progress = star_box_image:getChildByName("progress")
	self.star_progress_num = star_box_image:getChildByName("progress_num")
	self.star_image_mark = star_box_image:getChildByName("image_mark")

	--抽奖按钮
	local luckyroller_image = widget:getChildByName("button_luckyroller")
	local luckyroller_image_Btn = ButtonWrap:create()
	luckyroller_image_Btn:wrap(luckyroller_image, 1)
	luckyroller_image_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback(timeStamp)
			local wheel = WheelLayerEx:create(timeStamp)
			wheel:set_luck_free_callback(function() 
				self.luckyroller_image_mark:setVisible(false) end)
			LayerManager:getInstance():add_layer_to_scene(wheel)
		end

		GameKernel:getInstance():get_is_link_net(link_callback)
	end)

	local luckyroller_image_mark = luckyroller_image:getChildByName("image_mark")
	luckyroller_image_mark:getChildByName("text_1"):setVisible(false)
	local today_is_wheel = player:get_today_is_wheel()
    if today_is_wheel then
    	luckyroller_image_mark:setVisible(false)
    end
    self.luckyroller_image_mark = luckyroller_image_mark

    --作业本
    local mission_image = widget:getChildByName("button_mission")
    local mission_Btn = ButtonWrap:create()
	mission_Btn:wrap(mission_image, 1)
	mission_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback(timeStamp)
			local missionLayer = MissionLayer:create(timeStamp)
			LayerManager:getInstance():add_layer_to_scene(missionLayer)
		end
		GameKernel:getInstance():get_is_link_net(link_callback)
	end)
	self.mission_image_mark = mission_image:getChildByName("image_mark")
	self.mission_image = mission_image
	local function update_mission_image_mark()
		
		local count = 0
		--从日常那里获得日常任务信息
		local daily_task_info_vector = Daily_Task_Data:getInstance():get_daily_task_info_vector()
		for i=1,get_table_length(daily_task_info_vector) do
			local sort_daily_task_info = daily_task_info_vector[i]
	        local player_daily_task_info = player:get_player_daily_task_info_by_id(sort_daily_task_info.task_id)
	        local percentage = player_daily_task_info.finish_count/sort_daily_task_info.target_num*100
	        if percentage >= 100 then
	            if player:get_player_daily_task_reward_info_is_get_by_id(sort_daily_task_info.task_id) == false
	             and player:get_player_daily_task_reward_info_is_choose_by_id(sort_daily_task_info.task_id) then
	            	--task显示mask
	            	count = count + 1
	            end
	        end
		end

		local achv_info_vector = Achv_Data:getInstance():get_achv_info_vector()
		for i=1,get_table_length(achv_info_vector) do
			local achv_info = achv_info_vector[i]
            local player_achv_info = player:get_player_achv_info_by_id(achv_info.achv_id)
            local index = 5
            for k,v in ipairs(player_achv_info.stage_info_vector) do
                if v.is_get == false then
                    index = k
                    break
                end
            end
            local percentage = player_achv_info.finish_count/achv_info.stage_info_vector[index].target_num*100
            if percentage >= 100 then
                if player:get_player_achv_info_reward_info_is_get_by_id_and_stage(achv_info.achv_id, index) == false then
                	count = count + 1
                end
            end
		end

		if count > 0 then
			self.mission_image_mark:setVisible(true)
			self.mission_image_mark:getChildByName("text_1"):setString(count)
		else
			self.mission_image_mark:setVisible(false)
		end
	end
	update_mission_image_mark()
	local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.mission_image_mark_event, update_mission_image_mark)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)

    --每周挑战
    local weekgame_image = widget:getChildByName("button_weekgame")
    local weekgame_Btn = ButtonWrap:create()
	weekgame_Btn:wrap(weekgame_image, 1)
	weekgame_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback(timeStamp)
			local weeklyChallengeLayer = WeeklyChallengeLayer:create(timeStamp)
			LayerManager:getInstance():add_layer_to_scene(weeklyChallengeLayer)
		end

		GameKernel:getInstance():get_is_link_net(link_callback)
	end)
	self.weekgame_image_mark = weekgame_image:getChildByName("image_mark")
	self.weekgame_image = weekgame_image

	local function update_weekgame_image_mark()
		
		local count = 0
		local today_challenge_num = player:get_player_weekly_challenge_today_challenge_num()
		count = today_challenge_num

		if count > 0 then
			----?
			elastic_action(weekgame_image)
			self.weekgame_image_mark:setVisible(true)
			self.weekgame_image_mark:getChildByName("text_1"):setString(count)
		else
			weekgame_image:stopAllActions()
			self.weekgame_image_mark:setVisible(false)
		end
	end
	update_weekgame_image_mark()
	local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.weekgame_image_mark_event, update_weekgame_image_mark)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)

	--春季特卖
	local springsale_image = widget:getChildByName("button_springsale")
	springsale_action(springsale_image)
	local springsale_Btn = ButtonWrap:create()
	springsale_Btn:wrap(springsale_image,1)
	springsale_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		
	    local function link_callback()
			-- if player:get_is_buy_springsale() then
			-- 	local limitGiftLayer = LimitGiftLayer:create()
		 --    	LayerManager:getInstance():add_layer_to_scene(limitGiftLayer)
			-- else			
				local springsaleLayer = SpringsaleLayer:create()
		    	LayerManager:getInstance():add_layer_to_scene(springsaleLayer)
		    -- end
		end
		GameKernel:getInstance():get_is_link_net(link_callback)
	end)
	springsale_image:getChildByName("image_mark"):setVisible(false)
	local springsale_text_time = springsale_image:getChildByName("text_time")
	springsale_text_time:setPositionX(springsale_text_time:getPositionX()+10)

	if GameKernel:getInstance():get_gift_visible() == false then
		springsale_image:setVisible(false)
	end

	local icon_springsale = springsale_image:getChildByName("image_springsale")
	local text_springsale = springsale_image:getChildByName("text_springsale")
	self.springsale_image = springsale_image
	springsale_image:setVisible(false)--特殊处理
	local function add_limit_gift_event_listener()
		-- icon_springsale:loadTexture("images/section/limit_gift.png")
		-- text_springsale:setString("限购礼包")
		-- springsale_text_time:setVisible(false)

		local function update_limit_gift_visible()
			springsale_image:setVisible(false)
			-- player:set_is_buy_limit_gift(true)
		end
		local listener3 = cc.EventListenerCustom:create(NotificationUtil.EventType.limit_gift_event, update_limit_gift_visible)
		eventDispatcher:addEventListenerWithSceneGraphPriority(listener3, self)
	end

	-- if player:get_is_buy_springsale() then
	-- 	springsale_image:setVisible(false)   ---初始化的时候 生成不了下面的方法
	-- else
		local function uuuupdate_springsale()
			local function update_springsale_image_visible()
				-- add_limit_gift_event_listener()
				springsale_image:setVisible(false)
				player:set_is_buy_springsale(true)
				if self.scheduleScriptEntryID then
					cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleScriptEntryID)
					self.scheduleScriptEntryID = nil
				end
			end
			local listener4 = cc.EventListenerCustom:create(NotificationUtil.EventType.springsale_image_event, update_springsale_image_visible)
			eventDispatcher:addEventListenerWithSceneGraphPriority(listener4, self)

			local function get_springsale_countdown_time()
				local start_time = player:get_springsale_start_time()
				local diff_time = os.time() - start_time
				if diff_time >= 3600*2 then
					-- icon_springsale:loadTexture("images/section/limit_gift.png")
					-- text_springsale:setString("限购礼包")
					-- springsale_text_time:setVisible(false)
					springsale_image:setVisible(false)  --时间过期 隐藏图片
					eventDispatcher:dispatchCustomEvent(NotificationUtil.EventType.springsale_image_event)
				end
			    -- local day = math.floor((3600*24*7-diff_time)/(24*3600))
			    -- local hour = math.floor((3600*24*7-diff_time)%(24*3600)/3600)
			    -- local min = math.floor((3600*24*7-diff_time)%(24*3600)%3600/60)
			    -- local sec = math.floor((3600*24*7-diff_time)%(24*3600)%3600%60)

			    local hour = math.floor((3600 * 2-diff_time)/3600) 
			    local min = math.floor((3600 * 2-diff_time)%3600/60) 
			    local sec = math.floor((3600 * 2-diff_time)%3600%60) 

				-- return string.format("%d天%02d小时%02d分钟%02d秒", day, hour, min, sec)
				-- print(string.format("%02d小时%02d分钟%02d秒", hour, min, sec))
				return string.format("%02d小时%02d分钟%02d秒", hour, min, sec)
			end
			local function update_springsale_countdown_time()
		        springsale_text_time:setString(get_springsale_countdown_time())
		    end
		   	update_springsale_countdown_time()
		    self.scheduleScriptEntryID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update_springsale_countdown_time, 1.0, false)
		end
		local listener11 = cc.EventListenerCustom:create("uuuupdate_springsale", uuuupdate_springsale)
		eventDispatcher:addEventListenerWithSceneGraphPriority(listener11, self)
	-- end

	--邀请奖励
	local invite_image = widget:getChildByName("button_invite")
	local invite_Btn = ButtonWrap:create()
	invite_Btn:wrap(invite_image,1)
	invite_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
			
    	local function link_callback()
			local inviteRewardLayer = InviteRewardLayer:create()
    		LayerManager:getInstance():add_layer_to_scene(inviteRewardLayer)
		end
		GameKernel:getInstance():get_is_link_net(link_callback)

	end)
	invite_image:getChildByName("image_mark"):setVisible(false)

	if LOGIN_PLATFROM == 0 then
        invite_image:setVisible(false)
    end
    
    local function check_invite_reward()	
		if player:get_is_all_get_player_invite_reward_info() then
	    	invite_image:setVisible(false)
	    end
	end
	check_invite_reward()
	local listener6 = cc.EventListenerCustom:create("CHECK_INVITE_REWARD_EVENT", check_invite_reward)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener6, self)

	local node = widget:getChildByName("node")

	-- 春日部
	local role_image = node:getChildByName("button_role")
	local role_Btn = ButtonWrap:create()
	role_Btn:wrap(role_image, 1)
	role_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		if player:get_player_cur_role_id() == "role_101" then
			MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("VOICE_xin"), false)
		end
		local roleInfoLayer = RoleInfoLayer:create()
		LayerManager:getInstance():add_layer_to_scene(roleInfoLayer)
        --自定义事件 并分发事件
		local event = cc.EventCustom:new("role_button_pressed")
        event.param = {}   
        eventDispatcher:dispatchEvent(event)

	end)
	self.role = role_image:getChildByName("image_role")
	self:update_role_image()

	--好友
	local friend_image = node:getChildByName("button_friend")
	local friend_Btn = ButtonWrap:create()
	friend_Btn:wrap(friend_image, 1)
	friend_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback()
			local friendLayer = FriendLayer:create()
			LayerManager:getInstance():add_layer_to_scene(friendLayer)
		end
		GameKernel:getInstance():get_is_link_net(link_callback)
	end)

	--邮件
	local mail_image = node:getChildByName("button_mail")
	local mail_Btn = ButtonWrap:create()
	mail_Btn:wrap(mail_image, 1)
	mail_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback()
			local mailLayer = MailLayer:create()
			LayerManager:getInstance():add_layer_to_scene(mailLayer)
		end
		GameKernel:getInstance():get_is_link_net(link_callback)
	end)
	self.mail_image_mark = mail_image:getChildByName("image_mark" )
	self.mail_image_mark:setVisible(false)
	-- self.mail_mark_count = 0
	local function update_mail_image_mark()	
		self:request_MsgList()
	end
	update_mail_image_mark()
	local listener5 = cc.EventListenerCustom:create(NotificationUtil.EventType.mail_image_mark_event, update_mail_image_mark)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener5, self)


	-- 商店
	local shop_image = node:getChildByName("button_shop")
	local shop_Btn = ButtonWrap:create()
	shop_Btn:wrap(shop_image, 1)
	shop_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local shopLayer = ShopLayer:create()
		shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GIFT)
		LayerManager:getInstance():add_layer_to_scene(shopLayer)
	end)

	if TEST_MODE  == 1 then

        local  label = ccui.Text:create("测试模式", "images/font/zh_CN.TTF", 60)
        label:setColor(cc.c3b(0, 0, 0))
        local  item5 = cc.MenuItemLabel:create(label)
        item5:registerScriptTapHandler(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
            local testScene = TestScene:create()
            LayerManager:getInstance():clear_layer()
            cc.Director:getInstance():replaceScene(testScene)
        end)

        local s = cc.Director:getInstance():getWinSize()
        local menu = cc.Menu:create()
        menu:addChild(item5)
        menu:setPosition(cc.p(180, s.height * 0.93))
        self:addChild(menu, 9999)
	end

	

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self:init_pack()
    self:update_star_mark()
	self:update_book_mark()

    local  listenner = cc.EventListenerTouchOneByOne:create()
    --listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
    	if self.is_pack_open then
    		self.action:play("pack_packup", false)
			self.is_pack_open = false
			self.pack_open_image:loadTexture("images/section/button_open.png")
    	end
    	
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    
	--获得最新的最高通关的关卡号
    local newest_mission_id = player:get_player_newest_mission_id()
    local mission_info = Mission_Data:getInstance():get_mission_info_by_id(newest_mission_id)
    local newest_level = mission_info.mission_level
    
	local open_system_map = {}
	local mission_info_vector = Mission_Data:getInstance():get_mission_info_vector()
	for i,v in ipairs(mission_info_vector) do
		if v.new_system then
			local player_mission_info = player:get_player_mission_info_by_id(v.mission_id)
			local is_move_action = player_mission_info.is_move_action
			open_system_map[v.new_system] = {v.mission_level, is_move_action}
		end
	end

	if open_system_map["sign"] then
	
		if newest_level<open_system_map["sign"][1] or open_system_map["sign"][2] then
			self.sign_in_image:setVisible(false)
			local function handle_open_sign(event)
				self.sign_in_image:setVisible(true)

		        self:show_back()
		        self.action:play("pack_open", false)
				self.is_pack_open = true
				self.pack_open_image:loadTexture("images/section/button_packup.png")
				
		        eventDispatcher:removeCustomEventListeners(NotificationUtil.EventType.open_sign_system)
		    end
	        local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.open_sign_system, handle_open_sign)
	    	eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
		end
	end
    
    if open_system_map["task"] then
		
		if newest_level<open_system_map["task"][1] or open_system_map["task"][2] then
			mission_image:setVisible(false)
			local function handle_open_task(event)
		        mission_image:setVisible(true)
		        eventDispatcher:removeCustomEventListeners(NotificationUtil.EventType.open_task_system)
		    end
		    local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.open_task_system, handle_open_task)
		    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)
		end	
	end

	if open_system_map["weekgame"] then
		
		if newest_level<open_system_map["weekgame"][1] or open_system_map["weekgame"][2] then
			weekgame_image:setVisible(false)
			local function handle_open_weekgame(event)
		        weekgame_image:setVisible(true)
		        eventDispatcher:removeCustomEventListeners(NotificationUtil.EventType.open_weekgame_system)
		    end
		    local listener3 = cc.EventListenerCustom:create(NotificationUtil.EventType.open_weekgame_system, handle_open_weekgame)
		    eventDispatcher:addEventListenerWithSceneGraphPriority(listener3, self)
		end	
	end

	if open_system_map["invite_reward"] then
		
		if newest_level<open_system_map["invite_reward"][1] or open_system_map["invite_reward"][2] then
			invite_image:setVisible(false)
			local function open_invite_reward(event)
		        invite_image:setVisible(true)
		        eventDispatcher:removeCustomEventListeners(NotificationUtil.EventType.open_invite_reward_system)
		    end
		    local listener4 = cc.EventListenerCustom:create(NotificationUtil.EventType.open_invite_reward_system, open_invite_reward)
		    eventDispatcher:addEventListenerWithSceneGraphPriority(listener4, self)
		end	
	end

    self:runAction(cc.Sequence:create(cc.DelayTime:create(0), cc.CallFunc:create(function()
		
		TRIGGER_EVENT("SECTION_BOTTOM_SHOW")

	end)))
		
end


function SectionBottomLayer:request_MsgList()
    --request 消息列表和邮件列表

    local back_count = 0
    local msg_count = 0

    local function call_bind_call_back()

    	if back_count == 2 then
    		
    		if msg_count > 0 then
				self.mail_image_mark:setVisible(true)
				self.mail_image_mark:getChildByName("text_1"):setString(msg_count)
			else
				self.mail_image_mark:setVisible(false)
			end
    	end

    end

    local rpc_param = {

        PLAYER_ID,

    }

    RPC:call_bind("SHIN/message/getMsgList", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if response == nil then
                response = {}
            end

			local count = get_table_length(response)
			msg_count = msg_count + count

			back_count = back_count + 1
			call_bind_call_back()

        else

            print("request error")

        end

    end)

    RPC:call_bind("SHIN/message/getMailList", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            if response == nil then
                response = {}
            end

			-- msg_count = get_table_length(response)
			for k,v in pairs(response) do
				if tonumber(v.isValid) == 1 then
					msg_count = msg_count + 1
				end
			end

			back_count = back_count + 1
			call_bind_call_back()
			
        else

            print("request error")

        end

    end)

end

function SectionBottomLayer:update_date()

	local function async_callback(timestamp)

		local player = Player:getInstance()
		local tm = os.date("*t", timestamp)
		
		local last_sign_day = player:get_last_sign_day()	
	    local sign_day_diff = tm.day - last_sign_day
	    local last_wheel_day = player:get_last_wheel_day()
	    local wheel_day_diff = tm.yday - last_wheel_day
	    local last_luckygift_day = player:get_last_luckygift_day()
	    local luckygift_day_diff = tm.yday - last_luckygift_day

	    local last_share_day = player:get_last_share_day()
	    local share_day_diff = tm.yday - last_share_day
	    if tm.yday == 1 and last_share_day ~= 1 then
	        share_day_diff = 1
	    end
	    if share_day_diff>0 then
	        player:set_num_share(1)
	        player:set_last_share_day(tm.yday)
	    end

	    if tm.day == 1 and last_sign_day ~= 1 then
	        sign_day_diff = 1
	    end
	    if sign_day_diff>0 and player:get_num_sign() <28 then
	        player:set_today_is_sign(false)     
	    end
	    --
		if Player:getInstance():get_today_is_sign() then
			self.sign_in_image:getChildByName("image_mark"):setVisible(false)
		else
			if self.sign_in_image:isVisible() then
				self.sign_in_image:getChildByName("image_mark"):setVisible(true)
				local signBoardLayer = SignBoardLayer:create()
				LayerManager:getInstance():add_layer_to_scene(signBoardLayer)
			end
		end
		--跟签到一样判断时间，每日更新
		local spring_sale_time = player:get_springsale_start_time()
		local tm_spring = os.date("*t", spring_sale_time)
		local spring_sale_day_diff = tm.day - tm_spring.day
		if tm.day == 1 and tm_spring.day ~= 1 then
	        spring_sale_day_diff = 1
	    end
	    print("sign_day_diff:"..spring_sale_day_diff)
		--
		if spring_sale_day_diff>0 then
			print("spring_sale_day_diff")
	       	player:set_springsale_start_time(os.time()) -- 更新每日登陆时间
          	player:set_is_buy_springsale(false) -- 更新每日领取开关
	    end
	    if player:get_is_buy_springsale() then
			self.springsale_image:setVisible(false)
		else
			self.springsale_image:setVisible(true)
			local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
	    	eventDispatcher:dispatchCustomEvent("uuuupdate_springsale")
		end  
	    

	    --
	    if tm.yday == 1 and last_wheel_day ~= 1 then
	        wheel_day_diff = 1
	    end
	    if wheel_day_diff>0 then
	        player:set_today_is_wheel(false)
	    end

	    if tm.yday == 1 and last_luckygift_day ~= 1 then
	    	luckygift_day_diff = 1
	    end
	    if luckygift_day_diff > 0 then
	    	local num_luckygift_buy = GameKernel:getInstance():get_init_player_data().num_luckygift_buy
	    	player:set_num_luckygift_buy(num_luckygift_buy)
	    end

	    local week = os.date("%W", timestamp)
	    week = week - 0
	    local lase_challenge_week = player:get_player_weekly_challenge_lase_challenge_week()
	    local diff_week = week - lase_challenge_week
	    if week == 1 and lase_challenge_week ~= 1 then
	        diff_week = 1
	    end
	    if diff_week > 0 then
	    	player:set_player_weekly_challenge_today_challenge_num(2)
	    end
	end

    GameKernel:getInstance():getNetworkTime(async_callback)
end

function SectionBottomLayer:init_pack()
	local panel_pack = self.widget:getChildByName("panel_pack")
	local pack_open_image = panel_pack:getChildByName("button_open")
	self.pack_open_image = pack_open_image
	local pack_open_Btn = ButtonWrap:create()
	pack_open_Btn:wrap(pack_open_image, 1)
	pack_open_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click_Audio"), false)
		if self.is_pack_open then
			self.action:play("pack_packup", false)
			self.is_pack_open = false
			pack_open_image:loadTexture("images/section/button_open.png")
		else
			self.action:play("pack_open", false)
			self.is_pack_open = true
			pack_open_image:loadTexture("images/section/button_packup.png")
		end
	end)

	local pack_image_dia = panel_pack:getChildByName("image_dia")
	self.pack_image_dia = pack_image_dia
	local pack_listview = pack_image_dia:getChildByName("listview_1")
	self.pack_listview = pack_listview
	pack_listview:setScrollBarEnabled(false)
	pack_listview:setBounceEnabled(false)
	pack_listview:setTouchEnabled(false)
	pack_listview:setClippingEnabled(false)
	local panel_1 = pack_listview:getChildByName("panel_1")
	local back_image = pack_listview:getChildByName("button_back"):getChildByName("button_back_0")
	local setting_image = pack_listview:getChildByName("button_setting"):getChildByName("button_setting_0")
	

	-- 返回按钮
	self.back_image = back_image
	self.back_image:setVisible(false)
	local back_Btn = ButtonWrap:create()
	back_Btn:wrap(back_image, 1)
	back_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click_Audio"), false)
		self:getParent():back_scene()
		self:show_setting()
	end)

	-- 设置按钮
	self.setting_image = setting_image
	local setting_Btn = ButtonWrap:create()
	setting_Btn:wrap(setting_image, 1)
	setting_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local settingLayer = SettingLayer:create()
		LayerManager:getInstance():add_layer_to_scene(settingLayer)
	end)

	pack_listview:setItemModel(panel_1:clone())
    pack_listview:removeItem(1)
    pack_listview:setPositionY(pack_listview:getPositionY()+380)
    for i=1,3 do
    	pack_listview:insertDefaultItem(i)
    end

    local icon_res = {
			    [1] = "images/section/button_bag.png",
			    [2] = "images/section/button_book.png",
			    [3] = "images/section/sign_in.png",
			}
	local icon_text = {
				[1] = "背包",
				[2] = "纪念册",
				[3] = "每日签到",
			}
    local pack_button = {}
    for i=1,3 do
    	local item = pack_listview:getItem(i)
    	local button = item:getChildByName("button")
    	pack_button[i] = button
    	local image_icon = button:getChildByName("image_icon")
    	local image_mask = button:getChildByName("image_mask")
    	image_mask:setLocalZOrder(1)
    	local text = button:getChildByName("text")
    	text:setString(icon_text[i])
    	text:setLocalZOrder(1)
    	local image_mark = button:getChildByName("image_mark")
    	image_mark:setLocalZOrder(1)
    	image_mark:setVisible(false)

    	image_icon:setVisible(false)
        local icon_pic = ccui.ImageView:create(icon_res[i])
        icon_pic:setScale(0.9)
        icon_pic:setPosition(image_icon:getPosition())
        button:addChild(icon_pic)
    end
    
    -- 背包
	local bag_image = pack_button[1]
	local bag_Btn = ButtonWrap:create()
	bag_Btn:wrap(bag_image, 1)
	bag_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local bagLayer = BagLayer:create()
		LayerManager:getInstance():add_layer_to_scene(bagLayer)
	end)

    -- 纪念册
	local book_image = pack_button[2]
	local book_Btn = ButtonWrap:create()
	book_Btn:wrap(book_image, 1)
	book_Btn:addTouchEndCallback(function()
		TRIGGER_EVENT("BOOK_BUTTON_PRESSED")
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		Player:getInstance():set_player_card_unsee(0)
		local booLayer = BookLayer:create()
		LayerManager:getInstance():add_layer_to_scene(booLayer)		
	end)
	self.book_image_mark = book_image:getChildByName("image_mark")
	self.book_image = book_image

	

    --签到按钮
	local sign_in_image = pack_button[3]
	self.sign_in_image = sign_in_image
	local sign_in_Btn = ButtonWrap:create()
	sign_in_Btn:wrap(sign_in_image, 1)
	sign_in_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
		local function link_callback(timeStamp)
			local signBoardLayer = SignBoardLayer:create(timeStamp)
			LayerManager:getInstance():add_layer_to_scene(signBoardLayer)
		end
		GameKernel:getInstance():get_is_link_net(link_callback)
	end)
	local sign_in_image_mark = sign_in_image:getChildByName("image_mark")
	sign_in_image_mark:getChildByName("text_1"):setVisible(false)

	local function update_sign_in_image_mark()
		sign_in_image_mark:setVisible(false)
	end

	local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
	local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.sign_in_image_mark_event, update_sign_in_image_mark)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
	
	-- local today_is_sign = Player:getInstance():get_today_is_sign()
	-- if today_is_sign then
	-- 	sign_in_image_mark:setVisible(false)
	-- else
	-- 	performWithDelay(self,function()
	-- 		if self.sign_in_image:isVisible() then
	-- 			local signBoardLayer = SignBoardLayer:create()
	-- 			LayerManager:getInstance():add_layer_to_scene(signBoardLayer)
	-- 		end
	-- 	end,0.25)
	-- end
	
end

function SectionBottomLayer:show_setting()
	-- print("show_setting:::")
	self.back_image:setVisible(false)
	if self.sign_in_image:isVisible() then
		performWithDelay(self,function()
			for i=1,2 do
    			local item = self.pack_listview:getItem(i)
    			item:setPositionY(self.setting_image:getPositionY()-170*i+570)
    		end
		end,0.016)
		self.pack_image_dia:setContentSize(cc.size(189, 910))
	else
		performWithDelay(self,function()
			for i=1,2 do
    			local item = self.pack_listview:getItem(i)
    			item:setLocalZOrder(100)
    			item:setPositionY(self.setting_image:getPositionY()-170*i+570-150)
    		end
		end,0.016)
		self.pack_image_dia:setContentSize(cc.size(189, 740))
	end
	
	if self.back_home then
		self.back_home:setVisible(true)
	end

	local home_scene_in = cc.UserDefault:getInstance():getBoolForKey("home_scene_in", false)
	if home_scene_in then
		cc.UserDefault:getInstance():setBoolForKey("home_scene_in", false)
			self:runAction(cc.Sequence:create(cc.DelayTime:create(0.25), cc.CallFunc:create(function()
			self.action:play("button_in", false)

    		TradeManager:getInstance():showStartAdView()
		end)))
	else
		self.action:gotoFrameAndPlay(32, 32, false)
		self.is_pack_open = false
		self.pack_open_image:loadTexture("images/section/button_open.png")
	end

end

function SectionBottomLayer:show_back()
	self.back_image:setVisible(true)
	if self.sign_in_image:isVisible() then
		performWithDelay(self,function() 
			self.back_image:setPositionY(self.setting_image:getPositionY()-50)
			for i=1,2 do
    			local item = self.pack_listview:getItem(i)
    			item:setPositionY(self.setting_image:getPositionY()-170*i+570)
    		end
		end,0.016)
		self.pack_image_dia:setContentSize(cc.size(189, 1080))
	else
		performWithDelay(self,function()
			self.back_image:setPositionY(self.setting_image:getPositionY()+150-350)
			for i=1,2 do
    			local item = self.pack_listview:getItem(i)
    			item:setLocalZOrder(100)
    			item:setPositionY(self.setting_image:getPositionY()-170*i+570-150)
    		end
		end,0.016)
		self.pack_image_dia:setContentSize(cc.size(189, 910))
	end
	if self.back_home then
		self.back_home:setVisible(true)
	end

	local home_scene_in = cc.UserDefault:getInstance():getBoolForKey("home_scene_in", false)
	if home_scene_in then
		cc.UserDefault:getInstance():setBoolForKey("home_scene_in", false)
			self:runAction(cc.Sequence:create(cc.DelayTime:create(0.25), cc.CallFunc:create(function()
			self.action:play("button_in", false)
		end)))
	else
		self.action:gotoFrameAndPlay(32, 32, false)
		self.is_pack_open = false
		self.pack_open_image:loadTexture("images/section/button_open.png")
	end
end

function SectionBottomLayer:update_role_image()
	local role_info = Role_Data:getInstance():get_role_info_by_id(Player:getInstance():get_player_cur_role_id())
	self.role:loadTexture(role_info.res_key)
end

function SectionBottomLayer:update_book_mark()
	local card_unsee = Player:getInstance():get_player_card_unsee()
	if card_unsee > 0 then
		self.book_image_mark:setVisible(true)
		local text_1 = self.book_image_mark:getChildByName("text_1")
		text_1:setString(card_unsee)
	else
		self.book_image_mark:setVisible(false)
	end
end

function SectionBottomLayer:update_star_mark()
	local star_reward_count = Player:getInstance():get_count_star_reward_can_get()
	if star_reward_count > 0 then
		self.star_image_mark:setVisible(true)
		local text_1 = self.star_image_mark:getChildByName("text_1")
		text_1:setString(star_reward_count)
	else
		self.star_image_mark:setVisible(false)
	end

	local player = Player:getInstance()
    local player_star_reward_info = player:get_unget_player_star_reward_info()
    local star_reward_info = Star_Reward_Data:getInstance():get_star_reward_info_by_id(player_star_reward_info.reward_id)
    local player_star_count = player:get_player_star_count()
	self.star_progress_num:setString(string.format("%d/%d", player_star_count, star_reward_info.star_count))
	local percent = player_star_count * 100 / star_reward_info.star_count
    self.star_progress:setPercent(percent)
    if percent >= 100 then
    	if self.star_box_image:getNumberOfRunningActions() == 0 then
    		move_cycle_action(self.star_box_image)
    	end
    	
    else
    	self.star_box_image:stopAllActions()
    end
end

function SectionBottomLayer:onEnter()
	RPC:register_target(self)

	local function update_role(event) self:update_role_image() end
	local function update_book(event) self:update_book_mark() end
	local function update_star(event) self:update_star_mark() end

	local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_role_change, update_role)
	local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_card_get, update_book)
	local listener3 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_star_get, update_star)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener3, self)
end

function SectionBottomLayer:onExit()
	RPC:unregister_target(self)
	
	if self.scheduleScriptEntryID then
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleScriptEntryID)
	end	
end

return SectionBottomLayer