require "core.LayerManager"
require "core.Head_Data"
require "UI.Widget.MaskLayer"
require "UI.Layer.AboutLayer"
require "UI.Layer.CdkeyLayer"
require "core.WarnStrFunc"

SettingLayer = class("SettingLayer", function() return cc.Layer:create() end)

function SettingLayer:ctor()

    self:setName("SettingLayer")
    
    self.warnStrFunc = nil
    self.head_index = 0

    self.is_show_head = false
	local widget = cc.CSLoader:createNode("setting.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("setting.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("setting_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "setting_in_end" then
            
        elseif str == "setting_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    

    -- 人物信息
    local panel_info = image_dia:getChildByName("panel_info")
    local image_name_dia = panel_info:getChildByName("image_name_dia")

    -- 名字
    image_name_dia:setTouchEnabled(false)    

    self.image_name_dia = image_name_dia
    self.name_input = image_name_dia:getChildByName("name_input")
    -- self.name_input:setString(Player:getInstance():get_player_nick_name())
    -- self.name_input:addEventListener(function(ref, type)
    --     if type == 0 then
    --     elseif type == 1 then
    --         Player:getInstance():set_player_nick_name(self.name_input:getString())
    --     end
    -- end)
    self.name_input:setTouchEnabled(false)
    self.name_input:setVisible(false)

    local function editBoxTextEventHandle(strEventName, pSender)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if strEventName == "began" then
        elseif strEventName == "ended" then
        elseif strEventName == "return" then
            local str = pSender:getText()
            local name_str = Player:getInstance():get_player_nick_name()
            if str ~= name_str then
                self.warnStrFunc = WarnStrFunc:getInstance()
                
                local flag = self.warnStrFunc:isWarningInPutStr(str)

                if flag or str == "" then
                    pSender:setText(name_str)
                else
                    Player:getInstance():set_player_nick_name(str)
                    --2.24
                    local function hint()
                        local warningLayer = WarningLayer:create()
                        warningLayer:set_text_string("修改昵称成功")
                        LayerManager:getInstance():add_layer_to_scene(warningLayer)
                    end
                    self:request_modifyName(str, hint)
                end
            end
        elseif strEventName == "changed" then
        end
    end

    local function delay_create_editBox()
        local box_size = image_name_dia:getContentSize()
        local EditName = cc.EditBox:create(cc.size(box_size.width, box_size.height), image_name_dia:getResourcePath())
        EditName:setPosition(image_name_dia:getParent():convertToWorldSpace(cc.p(image_name_dia:getPosition())))
        EditName:setFontName("images/font/zh_CN.TTF")
        EditName:setFontSize(40)
        EditName:setFontColor(cc.c3b(145,93,32))
        EditName:setPlaceHolder(ResourceManager:getInstance():getTextStringByKey("SettingLayer_1"))
        EditName:setPlaceholderFontName("images/font/zh_CN.TTF")
        EditName:setPlaceholderFontSize(40)
        EditName:setPlaceholderFontColor(cc.c3b(145,93,32))
        EditName:setMaxLength(10)
        EditName:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
        EditName:setReturnType(cc.KEYBOARD_RETURNTYPE_DEFAULT)
        --Handler
        EditName:registerScriptEditBoxHandler(editBoxTextEventHandle)
        self:addChild(EditName, 2, 3)
        self.EditName = EditName

        EditName:setText(Player:getInstance():get_player_nick_name())

        self.image_name_dia:setVisible(false)

    end
    performWithDelay(self, function() delay_create_editBox() end, 0.33)

    -- 玩家头像
    self.image_head = panel_info:getChildByName("image_head")
    local image_head_dia = self.image_head:getChildByName("image_head_dia")
    image_head_dia:setTouchEnabled(false)
    local head_Btn = ButtonWrap:create()
    head_Btn:wrap(self.image_head, 1)
    head_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if self.is_show_head then
            self.is_show_head = false
            self.image_id_dia:setVisible(false)
        else
            self.is_show_head = true
            self.image_id_dia:setVisible(true)
        end
    end)
    local player_head_id = Player:getInstance():get_player_head_id()
    self:update_head(player_head_id)

    -- 账号id
    local text_id = panel_info:getChildByName("text_id")
    text_id:setString(PLAYER_ID)

    -- 声音配置
    local mm = MusicManager:getInstance()
    local image_button_dia = image_dia:getChildByName("image_button_dia")
    local audio_image = image_button_dia:getChildByName("button_audio")
    local text_audio = audio_image:getChildByName("text_audio")
    text_audio:setLocalZOrder(1)
    local audio_Btn = ButtonWrap:create()
    audio_Btn:wrap(audio_image, 1)
    self.audio_Btn = audio_Btn
    audio_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if mm.getEffectEnable() then
            mm.setEffectEnable(false)
            audio_Btn:setDarkButton(false)
            text_audio:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
        else
            mm.setEffectEnable(true)
            audio_Btn:setDarkButton(true)
            text_audio:setTextColor(cc.c4b(25, 117, 158, 255))
        end
    end)

    local music_image = image_button_dia:getChildByName("button_music")
    local text_music =  music_image:getChildByName("text_music")
    text_music:setLocalZOrder(1)
    local music_Btn = ButtonWrap:create()
    music_Btn:wrap(music_image, 1)
    self.music_Btn = music_Btn
    music_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if mm.getBgMusicEnable() then
            mm.setBgMusicEnable(false)
            music_Btn:setDarkButton(false)
            text_music:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
        else
            mm.setBgMusicEnable(true)
            music_Btn:setDarkButton(true)
            text_music:setTextColor(cc.c4b(25, 117, 158, 255))
        end
    end)
    if mm.getEffectEnable() == false then
        audio_Btn:setDarkButton(false)
        text_audio:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    end

    if mm.getBgMusicEnable() == false then
        music_Btn:setDarkButton(false)
        text_music:setTextColor(cc.c4b(96, 96, 96, 255 * 0.9))
    end

    --cdkey
    local cdkey_image = image_dia:getChildByName("button_cdkey")
    local cdkey_btn = ButtonWrap:create()
    cdkey_btn:wrap(cdkey_image, 1)
    cdkey_btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local cdkeyLayer = CdkeyLayer:create()
        LayerManager:getInstance():add_layer_to_scene(cdkeyLayer)
    end)

    --about us
    local about_image = image_dia:getChildByName("button_about")
    local about_btn = ButtonWrap:create()
    about_btn:wrap(about_image, 1)
    about_btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local aboutLayer = AboutLayer:create()
        LayerManager:getInstance():add_layer_to_scene(aboutLayer)
    end)

    --logout
    local logout_image = image_dia:getChildByName("button_logout")
    logout_image:setVisible(false)
    local logout_btn = ButtonWrap:create()
    logout_btn:wrap(logout_image, 1)
    logout_btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        AccountManager:getInstance():logout()
        --homeScene
        local homeScene = HomeScene:create()
        LayerManager:getInstance():clear_layer()
        cc.Director:getInstance():replaceScene(homeScene)
    end)
    -- logout_image:setVisible(false)

    local text_text_qq = image_dia:getChildByName("text_text_qq")
    text_text_qq:setString("欢迎加入QQ群：20855149")

    local text_text_qq = image_dia:getChildByName("text_text_qq")
    text_text_qq:setString("欢迎加入QQ群：20855149")

    -- 人物头像
    self.image_id_dia = image_dia:getChildByName("image_id_dia")
    self.image_id_dia:setVisible(false)

    self.list = self.image_id_dia:getChildByName("list")
    local panel_1 = self.list:getChildByName("panel_1")
    self.list:setItemModel(panel_1:clone())
    self.list:removeAllItems()
    self.list:setScrollBarEnabled(false)
    self:show_all_head()

    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        if self.is_show_head then
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
            self.is_show_head = false
            self.image_id_dia:setVisible(false)
        end
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = widget:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, widget)

    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.3), cc.CallFunc:create(function()
        
        TRIGGER_EVENT("SETTING_LAYER_SHOW")

    end)))

    

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

end

function SettingLayer:onEnter()
    RPC:register_target(self)
end

function SettingLayer:onExit()
    RPC:unregister_target(self)
end

function SettingLayer:request_modifyName(nick_name, async_callback)
    --request 改名
    local rpc_param = {

        PLAYER_ID,
        nick_name,
        self.head_index,
    }

    RPC:call_bind("SHIN/account/modifyName", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if async_callback then
                async_callback()
            end

        else

            print("request error")

        end

    end)
end

function SettingLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.image_name_dia:setVisible(true)
    self.EditName:setVisible(false)
    self.action:play("setting_out", false)
    self.audio_Btn:set_fade_out()
    self.music_Btn:set_fade_out()
    set_list_fade_out(self.list)

end

function SettingLayer:show_all_head()
    local head_info_vector = Head_Data:getInstance():get_head_info_vector()
    local head_count = #head_info_vector
    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID.."head_00"
    if cc.FileUtils:getInstance():isFileExist(headPath) then
        head_count = head_count + 1
    end

    local row = math.ceil(head_count/4.0)
    for i=1,row do
        self.list:pushBackDefaultItem()
    end

    for i=1,row do
        local panel = self.list:getItem(i - 1)
        for j=1,4 do
            local button = panel:getChildByName(string.format("button_%d", j))
            local button_dia = button:getChildByName(string.format("button_%d_dia", j))
            button_dia:setTouchEnabled(false)
            local cur_index = (i - 1) * 4 + j
            if cur_index <= head_count then
                local head_info = head_info_vector[cur_index]
                local head_id
                if cur_index == head_count and cc.FileUtils:getInstance():isFileExist(headPath) then
                    button:loadTexture(headPath)
                    head_id = "head_00"
                else
                    button:loadTexture(head_info.res_key)
                    head_id = head_info.head_id
                end

                local head_Btn = ButtonWrap:create()
                head_Btn:wrap(button, 1)
                head_Btn:addTouchEndCallback(function()
                    MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
                    self:update_head(head_id)
                    self.is_show_head = false
                    self.image_id_dia:setVisible(false)

                    self:request_modifyName(Player:getInstance():get_player_nick_name(), nil)
                end)
            else
                button:setVisible(false)
            end
        end
    end

end

function SettingLayer:update_head(head_id)
    Player:getInstance():set_player_head_id(head_id)
    if head_id == "head_00" then
        local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..head_id
        self.image_head:loadTexture(headPath)
    else
        local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
        self.image_head:loadTexture(head_info.res_key)
    end
    

    self.head_index = Head_Data:getInstance():get_head_index_by_id(head_id)  --0~15
end

return SettingLayer