require "core.LayerManager"
require "UI.Widget.MaskLayer"

ShareLayer = class("ShareLayer", function() return cc.Layer:create() end)

function ShareLayer:ctor(share_type)

    self:setName("ShareLayer")
    self.create_share_pic_callback = nil

    local widget = cc.CSLoader:createNode("share.csb")
    self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("share.csb")
    widget:runAction(self.action)
    self.action:play("share_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "springsale_in_end" then

        elseif str == "share_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local session_text = image_dia:getChildByName("text_price_0")
    local zone_text = image_dia:getChildByName("text_price_0_0")
    local session_image = image_dia:getChildByName("image_bar")
    local zone_image = image_dia:getChildByName("image_bar_0")

    session_image:loadTexture("images/common/QQF.png")
    zone_image:loadTexture("images/common/QQZ.png")

    local session_callback = function() cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE") end
    local zone_callback = function() cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE") end

    if LOGIN_PLATFROM == 1 then
        session_image:loadTexture("images/common/wechat.png")
        zone_image:loadTexture("images/common/wechatfriends.png")
        session_text:setString("微信好友")
        zone_text:setString("朋友圈")
        session_callback = function()
            if MSDKJava.WeiXinInstalled() then
                --talkingdata
                TalkingDataManager:getInstance():send("分享", {["分享入口"] = "微信好友"})
                MSDKJava.callWGSendToWeixinWithPhoto(0, share_type)
            else
                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string("安装手机微信客户端才能分享哦！")
                cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
                performWithDelay(self, function() 
                    cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE")
                end, 0.5)
            end
        end
        zone_callback = function()
            if MSDKJava.WeiXinInstalled() then
                --talkingdata
                TalkingDataManager:getInstance():send("分享", {["分享入口"] = "微信朋友圈"})
                MSDKJava.callWGSendToWeixinWithPhoto(1, share_type)
            else
                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string("安装手机微信客户端才能分享哦！")
                cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
                performWithDelay(self, function() 
                    cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE")
                end, 0.5)
            end
        end
    elseif LOGIN_PLATFROM == 2 then
        session_image:loadTexture("images/common/QQF.png")
        zone_image:loadTexture("images/common/QQZ.png")
        session_text:setString("QQ好友")
        zone_text:setString("QQ空间")
        session_callback = function()
            if MSDKJava.QQInstalled() then
                --talkingdata
                TalkingDataManager:getInstance():send("分享", {["分享入口"] = "QQ好友"})
                MSDKJava.callWGSendToQQWithPhoto(2, share_type)
            else
                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string("安装手机qq客户端才能分享哦！")
                cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
            end
            
        end
        zone_callback = function()
            if MSDKJava.QQInstalled() then
                --talkingdata
                TalkingDataManager:getInstance():send("分享", {["分享入口"] = "QQ空间"})
                MSDKJava.callWGSendToQQWithPhoto(1, share_type)
            else
                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string("安装手机qq客户端才能分享哦！")
                cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
            end
        end
    end

    local session_Btn = ButtonWrap:create()
    session_Btn:wrap(session_image, 1)
    session_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:start_share()
        if self.create_share_pic_callback then
            self.create_share_pic_callback()
            self.create_share_pic_callback = nil

            performWithDelay(self,function()
                session_callback()
                self:remove_mask()
            end, 0.032)
        else
            session_callback()
            self:remove_mask()
        end
    end)

    local zone_Btn = ButtonWrap:create()
    zone_Btn:wrap(zone_image, 1)
    zone_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:start_share()
        if self.create_share_pic_callback then
            self.create_share_pic_callback()
            self.create_share_pic_callback = nil

            performWithDelay(self,function()
                zone_callback()
                self:remove_mask()
            end, 0.032)
        else
            zone_callback()
            self:remove_mask()
        end
        
    end)

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)


    image_dia:setTouchEnabled(true)
    local function touchEventCallback(sender,eventType)
        return true
    end
    image_dia:addTouchEventListener(touchEventCallback)
    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:end_share()
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function ShareLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("share_out", false)
end

function ShareLayer:add_mask()

    self.__c_mask = MaskLayer:create()
    self.__c_mask:init_background(cc.c4b(0, 0, 0, 0))
    self.__c_mask:setEnabled(true)

    cc.Director:getInstance():getRunningScene():addChild(self.__c_mask, 99999)

end

function ShareLayer:remove_mask()

    self.__c_mask:removeFromParent()

end

function ShareLayer:start_share()
    self:add_mask()

end

function ShareLayer:end_share()
    self.__s_share_result = "NONE"
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.share_check_handler)

    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_SUCCESS")
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SHARE_FAILURE")
    self:close_self()
end

function ShareLayer:set_create_share_pic_callback(callback)
    self.create_share_pic_callback = callback
end

function ShareLayer:add_share_callback_listener(callback_success, callback_failure)
    if not callback_failure then
        callback_failure = function()
            -- local warningLayer = WarningLayer:create()
            -- warningLayer:set_text_string("分享失败")
            -- cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
        end
    end
    self._callback_success = callback_success
    self._callback_failure = callback_failure
    self.__s_share_result = "NONE"
    local listener1 = cc.EventListenerCustom:create("SHARE_SUCCESS", function() self:handle_success() end)
    local listener2 = cc.EventListenerCustom:create("SHARE_FAILURE", function() self:handle_failure() end)
    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)

    self.share_check_handler = cc.Director:getInstance():getScheduler():scheduleScriptFunc(function() self:check_share_result() end, 0.033, false)

end

function ShareLayer:handle_success()
    self.__s_share_result = "SHARE_SUCCESS"
end

function ShareLayer:handle_failure()
    self.__s_share_result = "SHARE_FAILURE"
end

function ShareLayer:check_share_result()
    if self.__s_share_result == "SHARE_SUCCESS" then
        
        self:send_stats_share_count()

        self._callback_success()
        self:end_share()
    elseif self.__s_share_result == "SHARE_FAILURE" then
        self._callback_failure()
        self:end_share()
    end
end

function ShareLayer:send_stats_share_count()
    --统计每天分享次数 
    local rpc_param = {
        PLAYER_ID,

    }

    RPC:call("SHIN/share/statsShareCount", rpc_param, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)
        else

            print("request error")

        end

    end)
end

function ShareLayer:onEnter()

end

function ShareLayer:onExit()
end

return ShareLayer