require "core.LayerManager"
require "UI.Widget.MaskLayer"

SharePictureLayer = class("SharePictureLayer", function() return cc.Layer:create() end)

function SharePictureLayer:ctor()

	local widget = cc.CSLoader:createNode("share_picture.csb")
	self:addChild(widget)

    local node = widget:getChildByName("node")
    local image_game_pic = node:getChildByName("image_game_pic")
    local image_dia = node:getChildByName("image_dia")

    local image_id = image_dia:getChildByName("image_id")
    local text_name = image_dia:getChildByName("text_name")
    local image_qrcode = image_dia:getChildByName("image_qrcode")
    local text_stage_num = image_dia:getChildByName("text_stage_num")

    local player = Player:getInstance()
    local player_name_str = player:get_player_nick_name()
    text_name:setString(player_name_str)
    local player_head_id = player:get_player_head_id()
    local head_info = Head_Data:getInstance():get_head_info_by_id(player_head_id)
    if player_head_id == "head_00" then
        local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
        image_id:loadTexture(headPath)
    else
        local head_info = Head_Data:getInstance():get_head_info_by_id(player_head_id)
        image_id:loadTexture(head_info.res_key)
    end
    
    local current_level = player:get_player_current_level()
    text_stage_num:setString(current_level)

    image_qrcode:loadTexture("images/common/share_picture/test.png")

    image_game_pic:setVisible(false)
    local fileName = global_get_screenshot_path().."board.jpg"
    local board_image = ccui.ImageView:create(fileName)
    board_image:setScale(0.5)
    board_image:setRotation(19)
    board_image:setPosition(image_game_pic:getPosition())
    node:addChild(board_image, -1)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function SharePictureLayer:onEnter()

end

function SharePictureLayer:onExit()
end

return SharePictureLayer