require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.ShareLayer"

ShareStageLayer = class("ShareStageLayer", function() return cc.Layer:create() end)

function ShareStageLayer:ctor(share_way)

	local widget = cc.CSLoader:createNode("share_stage.csb")
    self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("share_stage.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("light", true)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "light_end" then

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local panel_stage_ten = node:getChildByName("panel_stage_ten")
    local panel_stage_first = node:getChildByName("panel_stage_first")
    local image_share = nil
    local image_share_reward = nil
    local image_reward = nil
    local text_reward = nil
    local click_callback = function() end

    if share_way == 1 then
    	panel_stage_ten:setVisible(true)
    	panel_stage_first:setVisible(false)

    	self.item_id = "item_02"
        self.item_num = 1000

    	image_share = panel_stage_ten:getChildByName("button_share")
	    image_share_reward = image_share:getChildByName("image_share_reward")
	    image_reward = image_share_reward:getChildByName("image_reward")
	    text_reward = image_share_reward:getChildByName("text_reward")
        image_reward:loadTexture("images/shop/gold.png")
        text_reward:setString("x1k")
	    click_callback = function()
    
	        local shareLayer = ShareLayer:create("TENSTAGE")
	        shareLayer:set_create_share_pic_callback(function()
                global_create_share_pic(shareLayer, "share_picture_2", "TENSTAGE.jpg")
            end)
            shareLayer:add_share_callback_listener(function() self:share_success_callback() end, nil)
	        LayerManager:getInstance():add_layer_to_scene(shareLayer)
		end
    else
    	panel_stage_ten:setVisible(false)
    	panel_stage_first:setVisible(true)

        self.item_id = "item_03"
        self.item_num = 10

    	image_share = panel_stage_first:getChildByName("button_share")
	    image_share_reward = image_share:getChildByName("image_share_reward")
	    image_reward = image_share_reward:getChildByName("image_reward")
	    text_reward = image_share_reward:getChildByName("text_reward")
        image_reward:loadTexture("images/shop/jewel.png")
        text_reward:setString("x10")
	    click_callback = function()
    
	        local shareLayer = ShareLayer:create("FIRSTPASS")
	        shareLayer:set_create_share_pic_callback(function()
                global_create_share_pic(shareLayer, "share_picture_3", "FIRSTPASS.jpg")
            end)
            shareLayer:add_share_callback_listener(function() self:share_success_callback() end, nil)
	        LayerManager:getInstance():add_layer_to_scene(shareLayer)
		end
    end
    self.image_share_reward = image_share_reward

    -- 炫耀按钮
    move_cycle_action(image_share)
    local share_Btn = ButtonWrap:create()
    share_Btn:wrap(image_share, 1)
    share_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        click_callback()
    end)
    if LOGIN_PLATFROM == 0 then
        image_share:setVisible(false)
    end

    -- 关闭按钮
    local closeImage = node:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function ShareStageLayer:share_success_callback()
    if self.image_share_reward:isVisible() then
        self.image_share_reward:setVisible(false)

        Player:getInstance():add_player_bag_info_by_id(self.item_id, self.item_num)
        --bag_get_reward
        -- local bag_reward = BagRewardWidget:create()
        -- self:addChild(bag_reward, 2)

        -- local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_101")
        -- bag_reward:setItemTexture(bag_info.res_key)
        -- bag_reward:setTouchEnabled(true)
        -- bag_reward:runAction()
    end
end

function ShareStageLayer:close_self()

    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self:removeFromParent()
end

return ShareStageLayer