require "core.Bag_Data"
require "core.Shop_Item_Data"
require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.WarningLayer"
require "core.TalkingDataManager"

ShopEnergyLayer = class("ShopEnergyLayer", function() return cc.Layer:create() end)  --113 整个界面

function ShopEnergyLayer:ctor()

    self:setName("ShopEnergyLayer")

	local widget = cc.CSLoader:createNode("shop_energy.csb")
    self:addChild(widget, 1);
    self.widget = widget

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("shop_energy.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("shop_energy_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "shop_energy_in_end" then

        elseif str == "shop_energy_out_end" then
            self:removeFromParent()

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    -- ui
    local player = Player:getInstance()
    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local text_title = image_dia:getChildByName("text_title")

    -- 钻石购买体力
    local panel_1 = image_dia:getChildByName("panel_1")
    local buy_image = panel_1:getChildByName("button_buy")
    self.buy_image = buy_image
    if not player:is_full_power() then
        move_cycle_action(self.buy_image)
    end
    local buy_Btn = ButtonWrap:create()
    buy_Btn:wrap(buy_image, 1)
    buy_Btn:addTouchEndCallback(function()
        
        if player:is_full_power() then
            self.action:play("shop_energy_out", false)
        else
            --7.15
            local lose_power = player:get_player_max_power() - player:get_player_power()
            local need_jewel = lose_power*5
            --7.15
            if player:get_player_jewel() >= need_jewel then
                player:set_player_power(player:get_player_max_power())
                player:add_player_jewel(-need_jewel)
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Energy_Audio"), false)

                TalkingDataManager:getInstance():sendOnPurchase("补满体力",1,need_jewel)
            else
                MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
                
                local shopLayer = ShopLayer:create()
                shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
                LayerManager:getInstance():add_layer_to_scene(shopLayer)

                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
                LayerManager:getInstance():add_layer_to_scene(warningLayer)
            end
        end
    end)

    local image_energy = panel_1:getChildByName("image_energy")
    self.text_time = panel_1:getChildByName("text_time")
    local image_num_dia = panel_1:getChildByName("image_num_dia")
    self.text_energy = image_num_dia:getChildByName("text_energy")

    self.image_infinity = image_num_dia:getChildByName("image_infinity")
    self.image_infinity:setVisible(false)

    self:update_player_power()
    
    -- 索要体力
    local blag_image = panel_1:getChildByName("button_blag")
    local blag_Btn = ButtonWrap:create()
    blag_Btn:wrap(blag_image, 1)
    blag_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
    end)
    blag_image:setVisible(false)
    self.text_time:setPosition(blag_image:getPosition())

    -- 道具使用和体力购买
    self.energy_item_map = {
        [1] = "item_101",
        [2] = "item_102",
        [3] = "item_103",
    }

    self.use_item_image_vector = {}
    self.use_item_image_vector_1 = {}
    local panel_2 = image_dia:getChildByName("panel_2")
    local text_ues_item = panel_2:getChildByName("text_ues_item")
    for i=1,3 do
        local use_item_image = panel_2:getChildByName(string.format("button_use_item_%d", i))
        self.use_item_image_vector[i] = use_item_image

        local use_item_Btn = ButtonWrap:create()
        use_item_Btn:wrap(use_item_image, 1)
        use_item_Btn:addTouchEndCallback(function()
            self:button_callback(self.energy_item_map[i], i)
        end) 

        local use_item_image_1 = panel_2:getChildByName(string.format("button_use_item+%d", i))
        self.use_item_image_vector_1[i] = use_item_image_1
        local use_item_Btn_1 = ButtonWrap:create()
        use_item_Btn_1:wrap(use_item_image_1, 1)
        use_item_Btn_1:addTouchEndCallback(function()
            self:button_callback(self.energy_item_map[i], i)
        end)
    end

    self:update_player_item()

    local panel_3 = image_dia:getChildByName("panel_3")
    local image_dia_2 = panel_3:getChildByName("image_dia_2")
    self.text_energy_max = panel_3:getChildByName("text_energy_max")
    self.text_energy_max:setVisible(false)
    local buy_rmb_image = image_dia_2:getChildByName("button_buy_rmb")
    self.image_dia_2 = image_dia_2

    local image_price = buy_rmb_image:getChildByName("image_price")
    image_price:setTexture("images/shop/jewel.png")
    self.rmb_text_price = buy_rmb_image:getChildByName("text_price")

    local image_num_dia_15 = image_dia_2:getChildByName("image_num_dia_15")
    self.text_15 = image_num_dia_15:getChildByName("text_15")

    local image_num_dia_18 = image_dia_2:getChildByName("image_num_dia_18")
    self.text_18 = image_num_dia_18:getChildByName("text_18")

    local buy_rmb_Btn = ButtonWrap:create()
    buy_rmb_Btn:wrap(buy_rmb_image, 1)
    buy_rmb_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        
        local player = Player:getInstance()
        local cur_max_power = player:get_player_max_power()
        local cost = self.energy_toplimit_info[cur_max_power]
        local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id("item_401")
        if shop_item_info.currency == "jewel" then

            if player:get_player_jewel() >= cost then
                player:add_player_jewel(-cost)
                TalkingDataManager:getInstance():sendOnPurchase("购买体力上限"..cur_max_power, 1, cost)

                self:buy_energy_top_limit_success()
            else
                local shopLayer = ShopLayer:create()
                shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
                LayerManager:getInstance():add_layer_to_scene(shopLayer)
                
                local warningLayer = WarningLayer:create()
                warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
                LayerManager:getInstance():add_layer_to_scene(warningLayer)
            end

        elseif shop_item_info.currency == "rmb" then

            -- TradeManager:getInstance():raw_pay("购买体力上限"..cur_max_power,self.energy_toplimit_info[cur_max_power],
            --     function() self:buy_energy_top_limit_success() end, nil)
        end

        move_cycle_action(self.buy_image)

    end)
    self:update_up_energy()

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self:add_role_spine()

end

function ShopEnergyLayer:buy_energy_top_limit_success()
    local player = Player:getInstance()
    local cur_max_power = player:get_player_max_power()
    TalkingDataManager:getInstance():send("体力上限的购买次数统计", {["当前体力最大值"] = cur_max_power})

    local player_once_up_max_power = player:get_player_once_up_max_power()
    player:set_player_max_power(cur_max_power + player_once_up_max_power)

    self:update_up_energy()
    
    local commonPopupLayer = CommonPopupLayer:create()
    commonPopupLayer:disable_close()
    local str1 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_4")
    local str2 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_5")
    local str3 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_3")
    commonPopupLayer:showMessage(str1, str2, str3, function()
        local level_up_particle = ResourceManager:getInstance():getParticleByKey("PARTICLE_LEVEL_UP")
        level_up_particle:setAutoRemoveOnFinish(true)
        level_up_particle:setPosition(cc.p(0,0))
        self.text_energy:addChild(level_up_particle,5)
        commonPopupLayer:close_self()
    end, nil)
    
    local max_power = player:get_player_max_power()
    if max_power >= player:get_player_toplimit_power() then
        local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("energyMax"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer) 
    end
end

--7.15
function ShopEnergyLayer:update_up_energy()
    local player = Player:getInstance()
    local cur_max_power = player:get_player_max_power()
    if cur_max_power >= player:get_player_toplimit_power() then
        self.image_dia_2:setVisible(false)
        self.text_energy_max:setVisible(true)
    else 
        local energy_toplimit_info = require "script.energy_toplimit_info"
        self.energy_toplimit_info = energy_toplimit_info

        local max_power = player:get_player_max_power()
        self.rmb_text_price:setString(string.format("%d",energy_toplimit_info[max_power]))
        self.text_15:setString(string.format("%d",cur_max_power))
        local player_once_up_max_power = player:get_player_once_up_max_power()
        self.text_18:setString(string.format("%d",cur_max_power + player_once_up_max_power))

    end

end
--7.15

function ShopEnergyLayer:add_role_spine()

    local current_role_id = Player:getInstance():get_player_cur_role_id()
    local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)

    local role_spine = ResourceManager:getInstance():getSpineByKey(role_info.ui_spine_name, 1.0)
    role_spine:setAnimation(0, "HP", true)
    -- role_spine:setTimeScale(2)

    local node = self.widget:getChildByName("node")
    local node_role = node:getChildByName("node_role")
    node_role:addChild(role_spine)

    -- local rep = cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(1.5), cc.CallFunc:create(function() role_spine:setAnimation(0, "HP", false) end)))

    -- self:runAction(rep)

end

function ShopEnergyLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("shop_energy_out", false)
end

function ShopEnergyLayer:button_callback(item_id, index)
    local player = Player:getInstance()
    local player_bag_info = player:get_player_bag_info_by_id(item_id)
    if player:is_full_power() then
        local commonPopupLayer = CommonPopupLayer:create()
        commonPopupLayer:disable_close()
        local str1 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_1")
        local str2 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_2")
        local str3 = ResourceManager:getInstance():getTextStringByKey("ShopEnergyLayer_3")
        commonPopupLayer:showMessage(str1, str2, str3, function()
            commonPopupLayer:close_self()
        end, nil)
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
    else

        if player_bag_info.item_num > 0 then
            
            TalkingDataManager:getInstance():send("道具的使用次数统计", {["道具使用的item_id"] = item_id})
            TalkingDataManager:getInstance():sendOnUse(item_id,1)

            player:use_player_bag_info_by_id(item_id, -1)
            self.action:play(string.format("use_%d", index), false)
            self:update_player_item()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Energy_Audio"), false)
        
        else
            local buyItemLayer = BuyItemLayer:create()
            buyItemLayer:set_item(item_id)
            buyItemLayer:set_last_layer("ShopEnergyLayer")
            --7.14
            buyItemLayer:hide_minusBtn_and_plusBtn()
            buyItemLayer:set_buy_callback(function()
                        self:button_callback(item_id,index)
                        self:update_player_item()
                        end)
            --7.14
            LayerManager:getInstance():add_layer_to_scene(buyItemLayer) 
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        end
    end
end

function ShopEnergyLayer:update_player_power()
    local player = Player:getInstance()
    local panel_energy_full = self.buy_image:getChildByName("panel_energy_full")
    local panel_energy_buy = self.buy_image:getChildByName(" panel_energy_buy")
    local text_buy = panel_energy_buy:getChildByName("text_buy")
    text_buy:setString("立即补满")

    local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
    if player:is_full_power() and is_Unlimit_Power == false then
        -- self.text_time:setString(get_electronic_clock_h_m_s(0))
        self.text_time:setString("体力已满")
        panel_energy_full:setVisible(true)
        panel_energy_buy:setVisible(false)

        self.buy_image:stopAllActions()
    else
        self.text_time:setString(get_electronic_clock_h_m_s(player:get_player_left_recover_time()))
        panel_energy_full:setVisible(false)
        panel_energy_buy:setVisible(true)
        
        if player:is_full_power() and is_Unlimit_Power then
            panel_energy_full:setVisible(true)
            panel_energy_buy:setVisible(false)
        end

        --7.14
        local text_price = panel_energy_buy:getChildByName("text_price")
        local lose_power = player:get_player_max_power() - player:get_player_power()
        text_price:setString(string.format("%d", lose_power*5))
        --7.14
    end

    local current_power = player:get_player_power()
    local max_power = player:get_player_max_power()
    self.text_energy:setString(string.format("%d/%d", current_power, max_power))

    if is_Unlimit_Power then
        self.text_energy:setVisible(false)
        self.image_infinity:setVisible(true)
    else
        self.text_energy:setVisible(true)
        self.image_infinity:setVisible(false)
    end
    

end

function ShopEnergyLayer:update_player_item()
    for i=1,3 do
        local player_bag_info = Player:getInstance():get_player_bag_info_by_id(self.energy_item_map[i])
        local bag_info = Bag_Data:getInstance():get_bag_info_by_id(player_bag_info.item_id)
        local shop_item_info = Shop_Item_Data:getInstance():get_shop_item_info_by_id(bag_info.item_id)
        local panel_use = self.use_item_image_vector[i]:getChildByName("panel_use")
        local panel_buy = self.use_item_image_vector[i]:getChildByName("panel_buy")

        local image_jewel = panel_buy:getChildByName("image_jewel")
        image_jewel:setTexture(Shop_Item_Data:getInstance():get_res_by_currency(shop_item_info.currency))

        if player_bag_info.item_num > 0 then
            panel_use:setVisible(true)
            panel_buy:setVisible(false)
        else
            panel_use:setVisible(false)
            panel_buy:setVisible(true)
        end

        -- 上面栏道具的内容
        local image_mark = self.use_item_image_vector_1[i]:getChildByName("image_mark")
        local text_num = image_mark:getChildByName("text_num")
        text_num:setString(string.format("%d", player_bag_info.item_num))
        if player_bag_info.item_num > 0 then
            image_mark:loadTexture("images/game/item_mark.png")
            text_num:setVisible(true)
        else
            image_mark:loadTexture("images/game/item_buy.png")
            text_num:setVisible(false)
        end
    end
end

function ShopEnergyLayer:update_player_time()
    local player = GameKernel:getInstance():getPlayer()
    local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
    if player:is_full_power() and is_Unlimit_Power == false then
        self.text_time:setString(get_electronic_clock_h_m_s(0))
    else
        self.text_time:setString(get_electronic_clock_h_m_s(player:get_player_left_recover_time()))
    end
end


function ShopEnergyLayer:onEnter()
    local function update_power(event) self:update_player_power() end
    local function update_time(event) self:update_player_time() end
    local function update_item(event) self:update_player_item() end

    local listener3 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_power_change, update_power)
    local listener4 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_time_change, update_time)
    local listener5 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_item_change, update_item)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener3, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener4, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener5, self)
end

function ShopEnergyLayer:onExit()
end

return ShopEnergyLayer