require "UI.Layer.TopBarViceLayer"
require "core.Bag_Data"
require "core.LayerManager"
require "UI.Widget.BagRewardWidget"
require "UI.Widget.MaskLayer"
require "UI.Layer.WarningLayer"
require "core.TalkingDataManager"
require "core.TradeManager"

ShopLayer = class("ShopLayer", function() return cc.Layer:create() end)

ShopLayer.SHOP_TYPE = {
    GIFT = 1,
    ITEM = 2,
    GOLD = 3,
    JEWEL = 4,
}

function ShopLayer:ctor()
    MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("VOICE_buy"), false)

    self:setName("ShopLayer")

    self.list = {}
    local topBarViceLayer = TopBarViceLayer:create()
    topBarViceLayer:run_in_action()
    topBarViceLayer:set_shop_layer(true)
    self:addChild(topBarViceLayer, 2)

    self.close_callback = nil

	local widget = cc.CSLoader:createNode("shop.csb")
    self:addChild(widget, 1);
    self.widget = widget

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    --商店动画
    self.action = cc.CSLoader:createTimeline("shop.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("shop_in", false)
    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "shop_in_end" then

        elseif str == "shop_out_end" then
            if self.close_callback then
                self.close_callback()
            end
            self:removeFromParent()

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    --bag_get_reward
    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 2)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    -- 标题
    local text_title = image_dia:getChildByName("text_title")

    -- 商店种类按钮
    local gift_image = image_dia:getChildByName("button_gift")
    local gift_Btn = ButtonWrap:create()
    gift_Btn:wrap(gift_image, 1)
    gift_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.GIFT)
    end)

    local item_image = image_dia:getChildByName("button_item")
    local item_Btn = ButtonWrap:create()
    item_Btn:wrap(item_image, 1)
    item_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.ITEM)
    end)

    local gold_image = image_dia:getChildByName("button_gold")
    local gold_Btn = ButtonWrap:create()
    gold_Btn:wrap(gold_image, 1)
    gold_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
    end)

    local jewel_image = image_dia:getChildByName("button_jewel")
    local jewel_Btn = ButtonWrap:create()
    jewel_Btn:wrap(jewel_image, 1)
    jewel_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
    end)
    self.button_image = {}
    self.button_image[ShopLayer.SHOP_TYPE.GIFT] = gift_image
    self.button_image[ShopLayer.SHOP_TYPE.ITEM] = item_image
    self.button_image[ShopLayer.SHOP_TYPE.GOLD] = gold_image
    self.button_image[ShopLayer.SHOP_TYPE.JEWEL] = jewel_image

    local panel_gift = image_dia:getChildByName("panel_gift")
    local panel_item = image_dia:getChildByName("panel_item")
    local panel_gold = image_dia:getChildByName("panel_gold")
    local panel_jewel = image_dia:getChildByName("panel_jewel")
    self.panel_gift = panel_gift
    self.panel_item = panel_item
    self.panel_gold = panel_gold
    self.panel_jewel = panel_jewel
    panel_gift:getChildByName("list"):setVisible(false)
    panel_item:getChildByName("list"):setVisible(false)
    panel_gold:getChildByName("list"):setVisible(false)
    panel_jewel:getChildByName("list"):setVisible(false)

    --7.14
    if false then
        gift_image:setVisible(false)
        item_image:setPositionX(item_image:getPositionX()-100)
        gold_image:setPositionX(gold_image:getPositionX()-100)
        jewel_image:setPositionX(jewel_image:getPositionX()-100)

        -- jewel_image:setVisible(false)   --8.19
        -- panel_jewel:setVisible(false)
    end

    --7.14

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    self:add_role_spine()

end

function ShopLayer:add_role_spine()

    local current_role_id = Player:getInstance():get_player_cur_role_id()
    local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)

    local role_spine = ResourceManager:getInstance():getSpineByKey(role_info.ui_spine_name, 1.0)
    role_spine:setAnimation(0, "shop", true)
    -- role_spine:setTimeScale(2)

    local node = self.widget:getChildByName("node")
    local node_role = node:getChildByName("node_role")
    node_role:addChild(role_spine)

    -- local rep = cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(1.5), cc.CallFunc:create(function() role_spine:setAnimation(0, "shop", false) end)))

    -- self:runAction(rep)
end

function ShopLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("shop_out", false)

    set_list_fade_out(self.panel_gift)
    set_list_fade_out(self.panel_item)
    set_list_fade_out(self.panel_gold)
    set_list_fade_out(self.panel_jewel)
end

function ShopLayer:show_goods_by_type(shop_type)
    if self.list[shop_type] == nil  then
        self:init_goods_by_type(shop_type)
    end
    for key, value in pairs(self.button_image) do
        if key == shop_type then
            self.button_image[key]:setColor(cc.c3b(255, 255, 255))
        else
            self.button_image[key]:setColor(cc.c3b(255 * 0.6, 255 * 0.6, 255 * 0.6))
        end
    end

    for key,value in pairs(self.list) do
        if key == shop_type then
            self.list[key]:setVisible(true)
        else
            self.list[key]:setVisible(false)
        end
    end

end

function ShopLayer:init_goods_by_type(shop_type)
    if shop_type == ShopLayer.SHOP_TYPE.GIFT then
        self:init_gift()
    elseif shop_type == ShopLayer.SHOP_TYPE.ITEM then
        self:init_item()
    elseif shop_type == ShopLayer.SHOP_TYPE.GOLD then
        self:init_gold()
    elseif shop_type == ShopLayer.SHOP_TYPE.JEWEL then
        self:init_jewel()
    end
end

function ShopLayer:init_gift()
    local player = Player:getInstance()
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local panel_gift = image_dia:getChildByName("panel_gift")
    local list = panel_gift:getChildByName("list")
    list:setScrollBarEnabled(false)

    self.list[ShopLayer.SHOP_TYPE.GIFT] = list

    local shop_gift_vector = require "script.shop_gift"
    self.shop_gift_vector = shop_gift_vector

    for i=1,3 do
        local panel_ = list:getChildByName(string.format("panel_%d",i))
        local gift_1 = panel_:getChildByName("gift_1")
        local gift_Btn = ButtonWrap:create()
        gift_Btn:wrap(gift_1, 1)
        gift_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

            local shop_gift_info = shop_gift_vector[i]
            if i == 1 and player:get_is_buy_fish_gift() then
                shop_gift_info = shop_gift_vector[4]
            end

            local function buy_gift_success()
                local gift_item = shop_gift_info.gift_item
                for k,v in pairs(gift_item) do
                    local item_id = v.item_id
                    local item_num = v.item_num
                    if item_id == "item_02" or item_id == "item_03" then
                        player:add_player_currency_by_id(item_id, item_num)
                        if item_id == "item_03" then
                            TalkingDataManager:getInstance():sendOnReward(item_num,"商店礼包")
                        end
                    else
                        player:add_player_bag_info_by_id(item_id, item_num)
                    end
                end

                local commonPopupLayer1 = CommonPopupLayer:create()
                local visible_size = cc.Director:getInstance():getVisibleSize()

                commonPopupLayer1:disable_close()
                local str1 = "购买成功"
                local str2 = string.format("购买%s成功",shop_gift_info.gift_name)
                local str3 = ResourceManager:getInstance():getTextStringByKey("ShopLayer_5")
                commonPopupLayer1:showMessage(str1, str2, str3, function()
                    commonPopupLayer1:close_self()
                end, nil)

                if i == 1 and not player:get_is_buy_fish_gift() then
                    player:set_is_buy_fish_gift(true)
                    local text_times = gift_1:getChildByName("text_times")
                    text_times:setVisible(false)
                    performWithDelay(self, function() self:init_gift() end, 0.016)
                end
            end

            if shop_gift_info.currency == "jewel" then
                if shop_gift_info.cost <= player:get_player_jewel() then
                    self:add_player_currency(shop_gift_info.currency, -shop_gift_info.cost)
                    TalkingDataManager:getInstance():sendOnPurchase(shop_gift_info.gift_name,1,shop_gift_info.cost)

                    buy_gift_success()
                else
                    self:switch_shop_type(shop_gift_info.currency)
                end

            elseif shop_gift_info.currency == "rmb" then

                  TradeManager:getInstance():pay_buy_currency(shop_gift_info.gift_name, shop_gift_info.cost,
                    function() buy_gift_success() end, nil)
            end

        end)

        local shop_gift_info = shop_gift_vector[i]

        if i == 1 and player:get_is_buy_fish_gift() then
            local text_times = gift_1:getChildByName("text_times")
            text_times:setVisible(false)
            shop_gift_info = shop_gift_vector[4]
        end

        local price = gift_1:getChildByName("price")
        local image_price = price:getChildByName("image_price")
        local image_price_0 = price:getChildByName("image_price_0")
        image_price:loadTexture(self:get_res_by_currency(shop_gift_info.currency))
        image_price_0:loadTexture(self:get_res_by_currency(shop_gift_info.currency))

        local text_price = price:getChildByName("text_price")
        text_price:setString(shop_gift_info.cost)
        local text_price_0 = price:getChildByName("text_price_0")
        text_price_0:setString(shop_gift_info.original_cost)

        local gift_item = shop_gift_info.gift_item
        for k,v in pairs(gift_item) do
            local bag_info = Bag_Data:getInstance():get_bag_info_by_id(v.item_id)

            local item = gift_1:getChildByName(string.format("%d",k))
            local image_item = item:getChildByName("image_item")
            if v.item_id == "item_02" then
                image_item:loadTexture("images/item/item_8.png")
            elseif v.item_id == "item_03" then
                image_item:loadTexture("images/item/item_9.png")
            else
                image_item:loadTexture(bag_info.res_key)
            end

            local text_num = item:getChildByName("text_num")
            text_num:setString(string.format("x%d",v.item_num))
        end
    end

end

function ShopLayer:init_item()
    local player = Player:getInstance()
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local panel_item = image_dia:getChildByName("panel_item")
    local list = panel_item:getChildByName("list")
    local panel_1 = list:getChildByName("panel_1")
    list:setItemModel(panel_1:clone())
    list:setScrollBarEnabled(false)
    list:removeAllItems()
    --list:setBounceEnabled(false)
    self.list[ShopLayer.SHOP_TYPE.ITEM] = list

    local shop_item_vector = require "script.shop_item"
    
    --7.18  对shop_item_vector遍历，is_show==ture的放入shop_item_show_vector,且编号从1开始
    local shop_item_show_vector = {}
    local index = 1
    for i=1,#shop_item_vector do
        local shop_item_1 = shop_item_vector[i]
        if shop_item_1.is_show then
            shop_item_show_vector[index] = shop_item_vector[i]
            index = index + 1
        end
    end
    --7.18
    local count_vector = get_table_length(shop_item_show_vector)
    local row = math.ceil(count_vector/3.0)
    for i=1, row do
        list:pushBackDefaultItem()
    end

    local items_count = table.getn(list:getItems())
    for i=1,items_count do
        local item = list:getItem(i -1)
        for j=1,3 do
            local cur_index = (i - 1) * 3 + j

            local item_child = item:getChildByName(string.format("item_%d", j))
            local image_item = item_child:getChildByName("image_item")
            local image_jewel = item_child:getChildByName("image_jewel")
            local text_price = image_jewel:getChildByName("text_price")
            local text_num = item_child:getChildByName("text_num")
            local text_name = item_child:getChildByName("text_name")
            if count_vector >= cur_index then
                local shop_item = shop_item_show_vector[cur_index]
                local bag_info = Bag_Data:getInstance():get_bag_info_by_id(shop_item.item_id)
                image_item:loadTexture(bag_info.res_key)
                text_name:setString(bag_info.item_name)
                text_num:setString(string.format("x%d", shop_item.item_num))
                text_price:setString(shop_item.cost)
                image_jewel:loadTexture(self:get_res_by_currency(shop_item.currency))

                local image_sale = item_child:getChildByName("image_sale")
                local sale_price = item_child:getChildByName("sale_price")
                if shop_item.discount < 10 then                    
                    local text_sale_num = image_sale:getChildByName("text_sale_num")
                    text_sale_num:setString(shop_item.discount)
                    
                    local text_price = sale_price:getChildByName("text_price")
                    text_price:setString(shop_item.sale_cost)
                else
                    image_sale:setVisible(false)
                    sale_price:setVisible(false)
                end

                if shop_item.item_id == "item_401" then
                    local energy_toplimit_info = require "script.energy_toplimit_info"
                    local cur_max_power = player:get_player_max_power()
                    text_price:setString(energy_toplimit_info[cur_max_power])
                    if cur_max_power >= player:get_player_toplimit_power() then
                        item_child:setVisible(false)
                    end
                end

                local item_Btn = ButtonWrap:create()
                item_Btn:wrap(item_child, 1)
                item_Btn:addTouchEndCallback(function()
                    MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
                    local buyItemLayer = BuyItemLayer:create()
                    buyItemLayer:set_item(bag_info.item_id)
                    buyItemLayer:set_last_layer("ShopLayer")
                    
                    if shop_item.item_id == "item_401" then
                        buyItemLayer:hide_minusBtn_and_plusBtn()
                        buyItemLayer:set_buy_callback(function()
                            local energy_toplimit_info = require "script.energy_toplimit_info"
                            local cur_max_power = player:get_player_max_power()
                            text_price:setString(energy_toplimit_info[cur_max_power])
                        end)
                        buyItemLayer:set_energy_top_limit_callback(function()
                            item_child:setVisible(false)
                        end)   
                    else
                        buyItemLayer:set_shop_layer_callback(function()
                            self:switch_shop_type(shop_item.currency)
                            buyItemLayer:close_self()
                        end)
                        buyItemLayer:set_buy_callback(function()
                            self.bag_reward:setTouchEnabled(true)
                            self.bag_reward:setItemTexture(bag_info.res_key)
                            self.bag_reward:runAction()
                        end)                        
                    end                    
                   
                    LayerManager:getInstance():add_layer_to_scene(buyItemLayer)
                end)

            else
                item_child:setVisible(false)
            end

        end
    end

end

function ShopLayer:init_gold()
    local player = Player:getInstance()
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local panel_gold = image_dia:getChildByName("panel_gold")
    local list = panel_gold:getChildByName("list")
    local panel_1 = list:getChildByName("panel_1")
    list:setScrollBarEnabled(false)
    list:setItemModel(panel_1:clone())
    list:removeAllItems()
    self.list[ShopLayer.SHOP_TYPE.GOLD] = list

    local shop_gold_vector = require "script.shop_gold"
    local count_vector = get_table_length(shop_gold_vector)
    for i=1,count_vector do
        list:pushBackDefaultItem()
    end
    for i=1,count_vector do
        local item = list:getItem(i -1)
        local gold_1 = item:getChildByName("gold_1")
        local image_sale = gold_1:getChildByName("image_sale")
        --image_sale:setVisible(false)
        local text_num = gold_1:getChildByName("text_num")
        local button_buy = gold_1:getChildByName(" button_buy")
        local image_jewel = button_buy:getChildByName("image_jewel")
        local text_price = button_buy:getChildByName("text_price")

        local shop_gold = shop_gold_vector[i]
        local gold_pic = ccui.ImageView:create(shop_gold.res_key)
        gold_pic:setPosition(cc.p(get_node_width(gold_1) * 0.22, get_node_height(gold_1) *0.5))
        gold_1:addChild(gold_pic)

        --8.10
        if not shop_gold.is_sell_well then
            image_sale:setVisible(false)
        end
        if i == count_vector then
            local text_sale = image_sale:getChildByName("text_sale")
            text_sale:setString("划算")
        end

        local image_extra = gold_1:getChildByName("image_extra")
        if shop_gold.give_gold_num > 0 then
            local give_text_price = image_extra:getChildByName("text_price")
            give_text_price:setString(shop_gold.give_gold_num)
        else
            image_extra:setVisible(false)
        end

        text_num:setString(string.format(ResourceManager:getInstance():getTextStringByKey("ShopLayer_1"), shop_gold.gold_num))
        local buy_Btn = ButtonWrap:create()
        buy_Btn:wrap(button_buy, 1)
        buy_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
            if shop_gold.currency == "jewel" then            
                if shop_gold.cost <= player:get_player_jewel() then
                    self:add_player_currency(shop_gold.currency, -shop_gold.cost)
                    TalkingDataManager:getInstance():sendOnPurchase(string.format(ResourceManager:getInstance():getTextStringByKey("ShopLayer_1"), shop_gold.gold_num),1,shop_gold.cost)

                    TalkingDataManager:getInstance():send("金币购买方式的购买次数统计",
                         {["金币"] = string.format(ResourceManager:getInstance():getTextStringByKey("ShopLayer_1"), shop_gold.gold_num)})
                    player:add_player_currency_by_id("item_02",shop_gold.gold_num + shop_gold.give_gold_num)
                   
                else
                    self:switch_shop_type(shop_gold.currency)
                end
            elseif shop_gold.currency == "rmb" then
                TradeManager:getInstance():pay_buy_currency(string.format("%d金币",shop_gold.gold_num), shop_gold.cost,
                function() 
                    TalkingDataManager:getInstance():send("金币购买方式的购买次数统计",
                     {["金币"] = string.format(ResourceManager:getInstance():getTextStringByKey("ShopLayer_1"), shop_gold.gold_num)})
                    
                    local item_num = shop_gold.gold_num + shop_gold.give_gold_num
                    Player:getInstance():add_player_currency_by_id("item_02",item_num)
                    TalkingDataManager:getInstance():sendOrderJewelAmount(item_num)

                end,
            nil)
                -- TradeManager:getInstance():pay_buy_currency(springsale_info.sale_name, springsale_info.cost,
                -- function() self:buy_springsale_success() end, nil)
            end
        end)

        image_jewel:loadTexture(self:get_res_by_currency(shop_gold.currency))
        text_price:setString(string.format("%d", shop_gold.cost))
        -- if i == 1 then
        --     text_price:setString("0.01")
        -- end 
    end

    performWithDelay(self,function() 
        local size = list:getInnerContainerSize()
        list:setInnerContainerSize(cc.size(size.width,size.height+60))
    end, 0.1)
end

function ShopLayer:init_jewel()
    local node = self.widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    local panel_jewel = image_dia:getChildByName("panel_jewel")
    local list = panel_jewel:getChildByName("list")
    local panel_1 = list:getChildByName("panel_1")
    list:setScrollBarEnabled(false)
    list:setItemModel(panel_1:clone())
    list:removeAllItems()

    self.list[ShopLayer.SHOP_TYPE.JEWEL] = list

    local shop_jewel_vector = require "script.shop_jewel"
    local count_vector = get_table_length(shop_jewel_vector)
    for i=1,count_vector do
        list:pushBackDefaultItem()
    end

    local items_count = table.getn(list:getItems())
    for i=1,items_count do
        local item = list:getItem(i -1)
        local jewel_1 = item:getChildByName("jewel_1")

        local image_sale = jewel_1:getChildByName("image_sale")
        --image_sale:setVisible(false)
        local text_num = jewel_1:getChildByName("text_num")
        local button_buy = jewel_1:getChildByName(" button_buy")
        local image_jewel = button_buy:getChildByName("image_jewel")
        local text_price = button_buy:getChildByName("text_price")

        local shop_jewel = shop_jewel_vector[i]
        local jewel_pic = ccui.ImageView:create(shop_jewel.res_key)
        jewel_pic:setPosition(cc.p(get_node_width(jewel_1) * 0.22, get_node_height(jewel_1) *0.5))
        jewel_1:addChild(jewel_pic)

        --8.10
        if not shop_jewel.is_sell_well then
            image_sale:setVisible(false)
        end
        if i == items_count then
            local text_sale = image_sale:getChildByName("text_sale")
            text_sale:setString("划算")
        end

        local image_extra = jewel_1:getChildByName("image_extra")
        if shop_jewel.give_jewel_num > 0 then
            local give_text_price = image_extra:getChildByName("text_price")
            give_text_price:setString(shop_jewel.give_jewel_num)
        else
            image_extra:setVisible(false)
        end

        text_num:setString(string.format("%d钻石", shop_jewel.jewel_num))
        local buy_Btn = ButtonWrap:create()
        buy_Btn:wrap(button_buy, 1)
        buy_Btn:addTouchEndCallback(function()
            MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

            TradeManager:getInstance():pay_buy_currency(string.format("%d钻石", shop_jewel.jewel_num), shop_jewel.cost,
                function() 
                    TalkingDataManager:getInstance():send("钻石购买方式的购买次数统计",
                     {["钻石"] = string.format(ResourceManager:getInstance():getTextStringByKey("ShopLayer_2"), shop_jewel.jewel_num)})
                    
                    local item_num = shop_jewel.jewel_num + shop_jewel.give_jewel_num
                    Player:getInstance():add_player_currency_by_id("item_03",item_num)
                    TalkingDataManager:getInstance():sendOrderJewelAmount(item_num)

                end,
            nil)

        end)

        image_jewel:loadTexture(self:get_res_by_currency(shop_jewel.currency))
        text_price:setString(string.format("%d", shop_jewel.cost))
    end

    performWithDelay(self,function() 
        local size = list:getInnerContainerSize()
        list:setInnerContainerSize(cc.size(size.width,size.height+60))
    end, 0.1)
end

function ShopLayer:switch_shop_type(currency)
    local player = Player:getInstance()
    if currency == "gold" then
        local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needGold"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer) 
        
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
    elseif currency == "jewel" then
        local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer) 
        
        self:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
    end
end

function ShopLayer:get_res_by_currency(currency)
    if currency == "gold" then
        return "images/shop/gold.png"
    elseif currency == "jewel" then
        return "images/shop/jewel.png"
    elseif currency == "rmb" then
        return "images/shop/rmb.png"
    end
end

function ShopLayer:add_player_currency(currency, num)
    local player = Player:getInstance()
    if currency == "gold" then
        player:add_player_gold(num)
    elseif currency == "jewel" then
        player:add_player_jewel(num)
    elseif currency == "rmb" then
    end
end

--8.9
function ShopLayer:set_close_callback(callback)
    self.close_callback = callback
end

return ShopLayer