require "core.LayerManager"
require "UI.Widget.BagRewardWidget"
require "UI.Widget.SignPenWidget"
require "UI.Layer.CommonDialogLayer"
require "core.TalkingDataManager"
SignBoardLayer = class("SignBoardLayer", function() return cc.Layer:create() end)

function SignBoardLayer:ctor(timeStamp)

    self:setName("SignBoardLayer")

	local widget = cc.CSLoader:createNode("sign_board.csb")
    self:addChild(widget, 1);
    self.close_callback = nil

    --动画
    self.action = cc.CSLoader:createTimeline("sign_board.csb")
    widget:runAction(self.action)

    self.action:play("sign_board_in", false)
    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "book_in_end" then

        elseif str == "book_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    local listview = image_dia:getChildByName("listview_1")
    self.listview = listview
    local panel_1 = listview:getChildByName("panel_1")
    listview:setScrollBarEnabled(false)
    listview:setItemModel(panel_1:clone())
    listview:removeAllItems()

    for i=1,5 do
        listview:pushBackDefaultItem()
    end

    local sign_info_vector = require "script/sign_info.lua"
    self.image_get = {}
    local items_count = table.getn(listview:getItems())
    for i=1,items_count do
        local item = listview:getItem(i -1)
        for j=1,6 do
            local cur_index = (i - 1) * 6 + j

            local item_child = item:getChildByName(string.format("day_%d", j))
            local image_get = item_child:getChildByName("image_get")            
            local text_day = item_child:getChildByName("text_day")
            local info = item_child:getChildByName("info")
            local image_1 = info:getChildByName("image_1")
            local text_num = info:getChildByName("text_num")
            local image_pen = info:getChildByName("image_pen")
            image_pen:setVisible(false)

            if cur_index <= 28 then
                local sign_info = sign_info_vector[cur_index]
                image_get:setVisible(false)
                self.image_get[cur_index] = image_get
                text_day:setString(cur_index)
                if cur_index % 7 ~= 0 then
                    local item_id = sign_info.add_item[1].item_id
                    local item_num = sign_info.add_item[1].item_num
                    local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
                    if item_id == "item_02" then
                        image_1:loadTexture("images/item/item_8.png")
                    elseif item_id == "item_03" then
                        image_1:loadTexture("images/item/item_9.png")
                    else
                        image_1:loadTexture(bag_info.res_key)
                    end
                    if item_num >= 1000 then
                        local num = math.floor(item_num/1000)
                        text_num:setString(string.format("x%dk",num))
                    else
                        text_num:setString(string.format("x%d",item_num))
                    end
                else
                    if cur_index == 7 then
                        item_child:loadTexture("images/section/sign_red_left.png")
                    else
                        item_child:loadTexture("images/section/sign_red.png")
                    end
                    image_1:loadTexture(string.format("images/section/sign_box_%d.png", i))
                    text_num:setVisible(false)

                    local box_Btn = ButtonWrap:create()
                    box_Btn:wrap(image_1, 1)
                    box_Btn:addTouchEndCallback(function()
                        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
                        local commonDialogLayer = CommonDialogLayer:create()
                        commonDialogLayer:show_on_right(sign_info.add_item)
                        commonDialogLayer:setPosition(image_1:getParent():convertToWorldSpace(cc.p(image_1:getPosition())))
                        
                    end)
                end
            else
                item_child:setVisible(false)
            end

        end
    end

    local player = Player:getInstance()

    local tm = os.date("*t", timeStamp)
    if tm.day == 1 and player:get_last_sign_day() ~= 1 then
        player:set_num_sign(0)
        player:set_today_is_sign(false)
        player:set_last_sign_day(1)
    end

    self.last_sign_day = player:get_last_sign_day()
    self.num_sign = player:get_num_sign()

    local diff_day = tm.day - self.last_sign_day

    if diff_day>0 and self.num_sign <28 then

        player:set_today_is_sign(false)
    end

    self.today_is_sign = player:get_today_is_sign()
    
    local text_month = image_dia:getChildByName("text_month")
    text_month:setString(tm.month)

    --显示各天的已领取字样self.image_get[i]
    for i=1,self.num_sign do
        self.image_get[i]:setVisible(true)
    end
    if self.num_sign<28 then
        self.image_get[self.num_sign + 1]:getParent():getChildByName("info"):getChildByName("image_pen"):setVisible(true)
    end

    --bag_get_reward
    self.bag_reward = BagRewardWidget:create()
    self:addChild(self.bag_reward, 2)

    local get_image = image_dia:getChildByName("button_get")
    local text_get = get_image:getChildByName("text_get")
    text_get:setString("领取")
    self.get_image = get_image
    local get_Btn = ButtonWrap:create()
    get_Btn:wrap(get_image, 1)
    get_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click2_Audio"), false)
        --领取奖励
        local num_sign = self.num_sign + 1
        cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.sign_in_image_mark_event)
        player:set_last_sign_day(tm.day)
        player:set_today_is_sign(true)
        player:set_num_sign(num_sign)

        self.close_image:setVisible(true)
        self.get_image:setVisible(false)

        performWithDelay(self, function()
            local signPenWidget = SignPenWidget:create()
            signPenWidget:setPosition(self.image_get[num_sign]:getParent():getChildByName("info"):getChildByName("image_1"):getPosition())
            self.image_get[num_sign]:getParent():addChild(signPenWidget, 1)

            self.image_get[num_sign]:setVisible(true)
            self.image_get[num_sign]:getChildByName("image_get_0"):setVisible(false)
            self.image_get[num_sign]:getParent():getChildByName("info"):getChildByName("image_pen"):setVisible(false)
          end, 0.6)        

        local sign_info = sign_info_vector[num_sign]
        for k,v in pairs(sign_info.add_item) do
            local item_id = v.item_id
            local item_num = v.item_num
            player:add_player_bag_info_by_id(item_id, item_num)

            if item_id == "item_01" or item_id == "item_02" or item_id == "item_03" then
                if item_id == "item_03" then
                    TalkingDataManager:getInstance():sendOnReward(item_num,"签到")
                end
            else
                local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
                self.bag_reward:setItemTexture(bag_info.res_key)
                self.bag_reward:setTouchEnabled(true)
                self.bag_reward:runAction()
            end
        end
        self:addChild(MaskLayer:create(), 5)
        performWithDelay(self, function() self:close_self() end, 0.6+0.5)
    end)

    local close_image = image_dia:getChildByName("button_close")
    self.close_image = close_image
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)
    close_image:setVisible(false)

    if self.today_is_sign then
        self.close_image:setVisible(true)
        self.get_image:setVisible(false)
    end


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function SignBoardLayer:set_close_callback(callback)
    self.close_callback = callback
end

function SignBoardLayer:close_self()
    if self.close_callback then
        self.close_callback()
    end
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("sign_board_out", false)
    set_list_fade_out(self.listview)

end

return SignBoardLayer