require "core.LayerManager"
require "UI.Widget.MaskLayer"

SkillInfoLayer = class("SkillInfoLayer", function() return cc.Layer:create() end)

function SkillInfoLayer:ctor()

    self:setName("SkillInfoLayer")

	local widget = cc.CSLoader:createNode("skill_info.csb")
	self:addChild(widget)

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("skill_info.csb")
    widget:runAction(self.action)
    self.action:setCurrentFrame(0)
    self.action:play("item_info_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "skill_info_in_end" then

        elseif str == "skill_info_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    local text_skill = image_dia:getChildByName("text_skill")
    local image_role = image_dia:getChildByName("image_role")
    local text_des = image_dia:getChildByName("text_des")
    local level_5 = image_dia:getChildByName("level_5")
    local level_10 = image_dia:getChildByName("level_10")
    local level_15 = image_dia:getChildByName("level_15")
    local level_20 = image_dia:getChildByName("level_20")
    local skill_lv_des_text = {}
    skill_lv_des_text[1] = level_5:getChildByName("text_1")
    skill_lv_des_text[2] = level_10:getChildByName("text_1")
    skill_lv_des_text[3] = level_15:getChildByName("text_1")
    skill_lv_des_text[4] = level_20:getChildByName("text_1")

    local role_id = Player:getInstance():get_player_cur_role_id()
    -- local skill_level = Player:getInstance():get_player_skill_level(role_id) 	--1~5
    local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
    local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)

    text_skill:setString(skill_info.skill_name)
    image_role:loadTexture(skill_info.res_key)
    text_des:setString(skill_info.description)
    for i=1,4 do
    	skill_lv_des_text[i]:setString(skill_info.skill_lv_des[i])
    end
    

    -- 关闭按钮
    local close_image = image_dia:getChildByName("button_close")
    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close_image, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end

function SkillInfoLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("item_info_out", false)

    local event = cc.EventCustom:new("skill_info_hide")
    event.param = {}   
    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)   
end

function SkillInfoLayer:onEnter()

end

function SkillInfoLayer:onExit()
end

return SkillInfoLayer