require "UI.Layer.ShopEnergyLayer"
require "UI.Layer.ShopLayer"
require "UI.Widget.SweepLightLayer"
require "core.LayerManager"
TopBarLayer = class("TopBarLayer", function() return cc.Layer:create() end)

function TopBarLayer:ctor()

	self:setName("top_bar_layer")
	self.is_play_light = false

	local rm = ResourceManager:getInstance()

	local widget = cc.CSLoader:createNode("top_bar.csb")
	self:addChild(widget)

	widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

	local action = cc.CSLoader:createTimeline("top_bar.csb")
	self.action = action
	widget:runAction(action)

	action:setCurrentFrame(0)
	action:play("top_bar_in", false)

	local player = GameKernel:getInstance():getPlayer()

	local node = widget:getChildByName("node")
	local image_dia = node:getChildByName("image_dia")
	
	-- 金币
	local gold = image_dia:getChildByName("gold")
	local gold_buy_Btn_1 = ButtonWrap:create()
	gold_buy_Btn_1:wrap(gold, 1)
	gold_buy_Btn_1:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopLayer = ShopLayer:create()
		-- --点击整个图片都会产生一个layer（根据值产生不同的商店）
		-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
		-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
		--113
		--113
        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Gold)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	self.text_gold = gold:getChildByName("text_gold")
	local gold_buy_image = gold:getChildByName("button_buy")
	local gold_buy_Btn = ButtonWrap:create()
	gold_buy_Btn:wrap(gold_buy_image, 1)
	gold_buy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopLayer = ShopLayer:create()
		-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
		-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
		--113
        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Gold)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	-- 金币扫光
	local image_gold = gold:getChildByName("image_gold")
	local gold_light = SweepLightLayer:create()
	
    gold_light:generate_sweep(cc.Sprite:createWithTexture(image_gold:getTexture()), 5, 135, cc.c4b(1, 1, 1, 0.5), 0.5, 2)
    local gold_size = image_gold:getContentSize()
    gold_light:setPosition(cc.p(gold_size.width/2, gold_size.height/2))
    image_gold:addChild(gold_light)

    -- 金币粒子
    local gold_particle = rm:getParticleByKey("PARTICLE_JINBI")
	gold_particle:setAutoRemoveOnFinish(false)
	gold_particle:setPosition(cc.p(gold_size.width/2, gold_size.height/2))
	image_gold:addChild(gold_particle, 5)

	-- 宝石
	local jewel = image_dia:getChildByName("jewel")
	local jewel_buy_Btn_1 = ButtonWrap:create()
	jewel_buy_Btn_1:wrap(jewel, 1)
	jewel_buy_Btn_1:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopLayer = ShopLayer:create()
		-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
		-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
		--113
        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	self.text_jewel = jewel:getChildByName("text_jewel")
	local jewel_buy_image = jewel:getChildByName("button_buy")
	local jewel_buy_Btn = ButtonWrap:create()
	jewel_buy_Btn:wrap(jewel_buy_image, 1)
	jewel_buy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopLayer = ShopLayer:create()
		-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
		-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
		--113
        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	local image_jewel = jewel:getChildByName("image_jewel")

	-- 宝石扫光
	local jewel_light = SweepLightLayer:create()
    jewel_light:generate_sweep(cc.Sprite:createWithTexture(image_jewel:getTexture()), 5, 135, cc.c4b(1, 1, 1, 0.5), 0.5, 2)
    local jewel_size = image_jewel:getContentSize()
    jewel_light:setPosition(cc.p(jewel_size.width/2, jewel_size.height/2))
    image_jewel:addChild(jewel_light)

    -- 宝石粒子
	local jewel_particle = rm:getParticleByKey("PARTICLE_ZUANSHI")
	jewel_particle:setAutoRemoveOnFinish(false)
	jewel_particle:setPosition(cc.p(jewel_size.width/2, jewel_size.height/2))
	image_jewel:addChild(jewel_particle, 5)

	-- 体力
	local energy = image_dia:getChildByName("energy")
	local energy_Btn = ButtonWrap:create()
	energy_Btn:wrap(energy, 1)
	energy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopEnergyLayer = ShopEnergyLayer:create()
		-- LayerManager:getInstance():add_layer_to_scene(shopEnergyLayer) --113
		local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Energy)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	self.text_energy = energy:getChildByName("text_energy")
	self.image_infinity = energy:getChildByName("image_infinity")	--7.25
	local energy_buy_image = energy:getChildByName("button_buy")
	local energy_buy_Btn = ButtonWrap:create()
	energy_buy_Btn:wrap(energy_buy_image, 1)
	energy_buy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		-- local shopEnergyLayer = ShopEnergyLayer:create()
		-- LayerManager:getInstance():add_layer_to_scene(shopEnergyLayer) --113
		local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Energy)
        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
	end)

	self.text_time = energy:getChildByName(" text_time")

	-- 显示数值
	self.text_gold:setString(string.format("%d", player:get_player_gold()))
	self.text_jewel:setString(string.format("%d", player:get_player_jewel()))
	self.text_energy:setString(string.format("%d", player:get_player_power()))
	local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
	if is_Unlimit_Power then
		self.text_energy:setVisible(false)
		self.image_infinity:setVisible(true)
	else
		self.text_energy:setVisible(true)
		self.image_infinity:setVisible(false)
	end
	self.text_time:setString(get_electronic_clock_m_s(player:get_player_left_recover_time()))

	-- if player:is_full_power() then
	-- 	self.text_time:setVisible(false)
	-- end
	self:update_player_time()

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function TopBarLayer:update_player_gold()
	self.text_gold:setString(string.format("%d", Player:getInstance():get_player_gold()))
end

function TopBarLayer:update_player_jewel()
	self.text_jewel:setString(string.format("%d", Player:getInstance():get_player_jewel()))
end

function TopBarLayer:update_player_power()
	self.text_energy:setString(string.format("%d", Player:getInstance():get_player_power()))
	local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
	if is_Unlimit_Power then
		self.text_energy:setVisible(false)
		self.image_infinity:setVisible(true)
		else
		self.text_energy:setVisible(true)
		self.image_infinity:setVisible(false)
	end
	if GameKernel:getInstance():getPlayer():is_full_power() and is_Unlimit_Power == false then
		self.text_time:setVisible(false)
	end
end

function TopBarLayer:update_player_time()
	local player = GameKernel:getInstance():getPlayer()
	local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
	if player:is_full_power() and is_Unlimit_Power == false then
		self.text_time:setVisible(false)
		if self.is_play_light then
			print("self.is_play_light::true")
			self.is_play_light = false
			self.action:gotoFrameAndPlay(8, 8, false)
		end
	else
		self.text_time:setVisible(true)
		if is_Unlimit_Power then
			self.action:play("energy_light", true)
			self.is_play_light = true
			self.text_time:setString(get_electronic_clock_h_m_s(player:get_player_left_recover_time()))
		else
			self.text_time:setString(get_electronic_clock_m_s(player:get_player_left_recover_time()))
		end

	end	
end

function TopBarLayer:onEnter()
	local function update_gold(event) print(event._userdata) self:update_player_gold() end
    local function update_jewel(event) self:update_player_jewel() end
    local function update_power(event) self:update_player_power() end
    local function update_time(event) self:update_player_time() end

	local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_gold_change, update_gold)
	local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_jewel_change, update_jewel)
	local listener3 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_power_change, update_power)
	local listener4 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_time_change, update_time)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener3, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener4, self)
end

function TopBarLayer:onExit()
end

return TopBarLayer