require "UI.Widget.SweepLightLayer"
require "core.LayerManager"
TopBarViceLayer = class("TopBarViceLayer", function() return cc.Layer:create() end)

function TopBarViceLayer:ctor()

	self:setName("TopBarViceLayer")

	self.is_shop_layer = false
	local rm = ResourceManager:getInstance()

	local widget = cc.CSLoader:createNode("top_bar_2.csb")
	self:addChild(widget)

	widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

	self.action = cc.CSLoader:createTimeline("top_bar_2.csb")
	widget:runAction(self.action)
	self.action:gotoFrameAndPlay(8, 8, false)

	local player = GameKernel:getInstance():getPlayer()

	local node = widget:getChildByName("node")
	local image_dia = node:getChildByName("image_dia")
	
	-- 金币
	local gold = image_dia:getChildByName("gold")
	local gold_buy_Btn_1 = ButtonWrap:create()
	gold_buy_Btn_1:wrap(gold, 1)
	gold_buy_Btn_1:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		if self.is_shop_layer then
			self:getParent():show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
		else
			-- local shopLayer = ShopLayer:create()
			-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
			-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
			--113
	        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Gold)
	        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
		end
	end)

	self.text_gold = gold:getChildByName("text_gold")
	local gold_buy_image = gold:getChildByName("button_buy")
	local gold_buy_Btn = ButtonWrap:create()
	gold_buy_Btn:wrap(gold_buy_image, 1)
	gold_buy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		if self.is_shop_layer then
			self:getParent():show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
		else
			-- local shopLayer = ShopLayer:create()
			-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.GOLD)
			-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
			--113
	        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Gold)
	        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
		end
	end)

	-- 金币扫光
	local image_gold = gold:getChildByName("image_gold")
	local gold_light = SweepLightLayer:create()
    gold_light:generate_sweep(cc.Sprite:createWithTexture(image_gold:getTexture()), 5, 135, cc.c4b(1, 1, 1, 0.5), 0.5, 2)
    local gold_size = image_gold:getContentSize()
    gold_light:setPosition(cc.p(gold_size.width/2, gold_size.height/2))
    image_gold:addChild(gold_light)

    -- 金币粒子
    local gold_particle = rm:getParticleByKey("PARTICLE_JINBI")
	gold_particle:setAutoRemoveOnFinish(false)
	gold_particle:setPosition(cc.p(gold_size.width/2, gold_size.height/2))
	image_gold:addChild(gold_particle, 5)

	-- 宝石
	local jewel = image_dia:getChildByName("jewel")
	local jewel_buy_Btn_1 = ButtonWrap:create()
	jewel_buy_Btn_1:wrap(jewel, 1)
	jewel_buy_Btn_1:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		if self.is_shop_layer then
			self:getParent():show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
		else
			-- local shopLayer = ShopLayer:create()
			-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
			-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
			--113
	        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
	        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
		end
	end)

	self.text_jewel = jewel:getChildByName("text_jewel")
	local jewel_buy_image = jewel:getChildByName("button_buy")
	local jewel_buy_Btn = ButtonWrap:create()
	jewel_buy_Btn:wrap(jewel_buy_image, 1)
	jewel_buy_Btn:addTouchEndCallback(function()
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
		if self.is_shop_layer then
			self:getParent():show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
		else
			-- local shopLayer = ShopLayer:create()
			-- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
			-- LayerManager:getInstance():add_layer_to_scene(shopLayer)
			--113
	        local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
	        LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
		end
	end)

	local image_jewel = jewel:getChildByName("image_jewel")

	-- 宝石扫光
	local jewel_light = SweepLightLayer:create()
    jewel_light:generate_sweep(cc.Sprite:createWithTexture(image_jewel:getTexture()), 5, 135, cc.c4b(1, 1, 1, 0.5), 0.5, 2)
    local jewel_size = image_jewel:getContentSize()
    jewel_light:setPosition(cc.p(jewel_size.width/2, jewel_size.height/2))
    image_jewel:addChild(jewel_light)

    -- 宝石粒子
	local jewel_particle = rm:getParticleByKey("PARTICLE_ZUANSHI")
	jewel_particle:setAutoRemoveOnFinish(false)
	jewel_particle:setPosition(cc.p(jewel_size.width/2, jewel_size.height/2))
	image_jewel:addChild(jewel_particle, 5)

	-- 显示数值
	self.text_gold:setString(string.format("%d", player:get_player_gold()))
	self.text_jewel:setString(string.format("%d", player:get_player_jewel()))

	local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function TopBarViceLayer:run_in_action()
	self.action:play("dia_in", false)
end

function TopBarViceLayer:update_player_gold()
	self.text_gold:setString(string.format("%d", Player:getInstance():get_player_gold()))
end

function TopBarViceLayer:update_player_jewel()
	self.text_jewel:setString(string.format("%d", Player:getInstance():get_player_jewel()))
end

function TopBarViceLayer:set_shop_layer(is_shop_layer)
	self.is_shop_layer = is_shop_layer
end

function TopBarViceLayer:onEnter()
	local function update_gold(event) self:update_player_gold() end
    local function update_jewel(event) self:update_player_jewel() end

	local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_gold_change, update_gold)
	local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_jewel_change, update_jewel)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)
end

function TopBarViceLayer:onExit()
end

return TopBarViceLayer