require "core.LayerManager"
WarningLayer = class("WarningLayer", function() return cc.Layer:create() end)

function WarningLayer:ctor()

    self:setName("WarningLayer")

	local widget = cc.CSLoader:createNode("warning.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    --动画
    self.action = cc.CSLoader:createTimeline("warning.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("warning", false)
    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "warning_end" then
            self:close_self()

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")
    self.image_dia = image_dia

    self.text_warning = image_dia:getChildByName("text_warning")


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(false)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function WarningLayer:close_self()
    LayerManager:getInstance():remove_top_layer()
    self:removeFromParent()
end

function WarningLayer:set_text_string(string)
    self.text_warning:setString(string)
end

return WarningLayer