require "core.LayerManager"
require "UI.Widget.MaskLayer"
WeekgameActivityLayer = class("WeekgameActivityLayer", function() return cc.Layer:create() end)

function WeekgameActivityLayer:ctor()

    self:setName("WeekgameActivityLayer")

	local widget = cc.CSLoader:createNode("weekgame_activity.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("weekgame_activity.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("activity_in", false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "activity_in_end" then

        elseif str == "activity_out_end" then
            self:removeFromParent()
        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local image_dia = node:getChildByName("image_dia")

    local text_all = image_dia:getChildByName("text_all")
    text_all:setString(ResourceManager:getInstance():getTextStringByKey("WeekgameActivityLayer_0"))

    local info_scroll_view = image_dia:getChildByName("info")
    info_scroll_view:setBounceEnabled(true)
    --info_scroll_view:setInnerContainerSize(cc.size(843,2100))
    
    for i=1,3 do
        local image = info_scroll_view:getChildByName(string.format("image_%d", i))
        local image_des = image:getChildByName(string.format("image_des_%d", i))
        --image_des:loadTexture()
        local text = image:getChildByName(string.format("text_%d", i))
        local text_str = string.format("WeekgameActivityLayer_%d", i)
        text:setString(ResourceManager:getInstance():getTextStringByKey(text_str))
    end

    local text_des = info_scroll_view:getChildByName("text_des")
    text_des:setString(ResourceManager:getInstance():getTextStringByKey("WeekgameActivityLayer_4"))


    -- 关闭按钮
    local closeImage = image_dia:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function WeekgameActivityLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self.action:play("activity_out", false)
end

return WeekgameActivityLayer