require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.FriendAddLayer"
require "core.TalkingDataManager"
WeekgameTimeLayer = class("WeekgameTimeLayer", function() return cc.Layer:create() end)

function WeekgameTimeLayer:ctor()

    self:setName("WeekgameTimeLayer")
    self.add_challenge_num_callback = nil
    self.go_to_play_callback = nil
    self.close_callback = nil

	local widget = cc.CSLoader:createNode("weekgame_time.csb")
    self:addChild(widget, 1);

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("weekgame_time.csb")
    widget:runAction(self.action)


    local node = widget:getChildByName("node")
    local panel_info = node:getChildByName("panel_info")
    self.panel_info = panel_info
    local text_1 = panel_info:getChildByName("text_1")
    text_1:setString("满足以下条件，\n即可获得每周挑战的闯关次数！")

    self:update_times()

    -- 关闭按钮
    local closeImage = panel_info:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function WeekgameTimeLayer:update_times()
    local player = Player:getInstance()
    local image_green = self.panel_info:getChildByName("image_green")
    local text_title = image_green:getChildByName("text_title")
    local font_time_green = image_green:getChildByName("font_time_green")
    local start_image = image_green:getChildByName("button_start")
    local font_time_yellow = image_green:getChildByName("font_time_yellow")
    text_title:setString("玩3次任意\n普通关卡")
    font_time_yellow:setString("+2")
    local text_start = start_image:getChildByName("text_start")
    text_start:setLocalZOrder(1)

    local go_to_play_times = player:get_player_weekly_challenge_go_to_play_times()
    -- local add_friend_times = player:get_player_weekly_challenge_add_friend_times()

    local start_Btn = ButtonWrap:create()
    start_Btn:wrap(start_image, 1)
    start_Btn:addTouchEndCallback(function()
        if self.go_to_play_callback and go_to_play_times >= 0 then
            self.go_to_play_callback()
            self:close_self()
        end
        if self.close_callback then
            self.close_callback()
        end
        
    end)
    

    local image_share = image_green:getChildByName("image_share")
    image_share:setVisible(false)

    if go_to_play_times >= 0 then

        font_time_green:setString(string.format("%d/3", go_to_play_times))

    else

        local function add_friend_callback()
            local add_friend_times = player:get_player_weekly_challenge_add_friend_times()
            text_title:setString("添加3个好友")
            font_time_yellow:setString("+1")
            if add_friend_times >= 0 then
                
                text_start:setString("添加好友")
                font_time_green:setString(string.format("%d/3", add_friend_times))
                local function callback()
                    local friendAddLayer = FriendAddLayer:create()
                    friendAddLayer:set_close_callback(function()
                            add_friend_callback()
                        end)
                    LayerManager:getInstance():add_layer_to_scene(friendAddLayer) 
                end
                self.close_callback = callback
            else
                if self.add_challenge_num_callback then
                    self.add_challenge_num_callback()
                end
                text_start:setString("已完成")
                text_start:setColor(cc.c3b(0, 0, 0))
                text_start:setOpacity(255 * 0.5)
                start_Btn:disable()
                start_Btn:setDarkButton(false)
                font_time_green:setString(string.format("%d/3", 3))
            end
        end
        add_friend_callback()
    end

    -- elseif LOGIN_PLATFROM ~= 0 then

    --     local share_pic_times = player:get_player_weekly_challenge_share_pic_times()
    --     font_time_yellow:setString("+1")
    --     font_time_green:setVisible(false)
    --     image_share:setVisible(true)
    --     text_start:setString("分享")

    --     if LOGIN_PLATFROM == 1 then                  
    --         image_share:loadTexture("images/common/wechatfriends.png") 
    --         text_title:setString("分享到微信朋友圈")
    --         -- button_share:addImage(image_share, 1)  
    --         -- button_share:addTouchEndCallback(session)
    --         -- session_callback = function()
    --         --     if MSDKJava.WeiXinInstalled() then
    --         --         MSDKJava.callWGSendToWeixinWithPhotoPath(1, share_type)
    --         --     else
    --         --         local warningLayer = WarningLayer:create()
    --         --         warningLayer:set_text_string("安装手机微信客户端才能分享哦！")
    --         --         cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
    --         --         performWithDelay(self, function() 
    --         --         cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE")
    --         --         end, 0.5)
    --         --     end
    --         -- end
    --     elseif LOGIN_PLATFROM == 2 then                   
    --         image_share:loadTexture("images/common/QQZ.png")
    --         text_title:setString("分享到QQ空间")  

    --         -- button_share:addImage(image_share, 1)  
    --         -- button_share:addTouchEndCallback(session)
    --         -- session_callback = function()
    --         --     if MSDKJava.QQInstalled() then
    --         --         MSDKJava.callWGSendToQQWithPhoto(1, share_type)
    --         --     else
    --         --         local warningLayer = WarningLayer:create()
    --         --         warningLayer:set_text_string("安装手机qq客户端才能分享哦！")
    --         --         cc.Director:getInstance():getRunningScene():addChild(warningLayer, 999)
    --         --         performWithDelay(self, function() 
    --         --         cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent("SHARE_FAILURE")
    --         --     end, 0.5)
    --         -- end
    --     end


    -- else

    --     if self.add_challenge_num_callback then
    --         self.add_challenge_num_callback()
    --     end
    --     text_start:setString("已完成")
    --     text_start:setColor(cc.c3b(0, 0, 0))
    --     text_start:setOpacity(255 * 0.5)
    --     start_Btn:disable()
    --     start_Btn:setDarkButton(false)
    --     font_time_green:setString(string.format("%d/3", 3))

    -- end


    local image_blue = self.panel_info:getChildByName("image_blue")
    local text_title = image_blue:getChildByName("text_title")
    local font_time_blue = image_blue:getChildByName("font_time_blue")
    font_time_blue:setString("60")
    local font_time_yellow = image_blue:getChildByName("font_time_yellow")
    font_time_yellow:setString("+1")

    local buy_image = image_blue:getChildByName("button_buy")
    local text_price = buy_image:getChildByName("text_price")
    text_price:setString("60")
    local buy_Btn = ButtonWrap:create()
    buy_Btn:wrap(buy_image, 1)
    buy_Btn:addTouchEndCallback(function()
        if player:get_player_jewel() >= 60 then
            player:add_player_jewel(-60)
            TalkingDataManager:getInstance():send("周赛次数统计", {["玩家花费钻石购买周赛机会的次数"] = "次数"})
            TalkingDataManager:getInstance():sendOnPurchase("周赛购买次数",1,60)

            local today_challenge_num = player:get_player_weekly_challenge_today_challenge_num() + 1
            player:set_player_weekly_challenge_today_challenge_num(today_challenge_num)
            if self.add_challenge_num_callback then
                self.add_challenge_num_callback()
            end
            self:close_self()
        else
            -- local shopLayer = ShopLayer:create()
            -- shopLayer:show_goods_by_type(ShopLayer.SHOP_TYPE.JEWEL)
            -- LayerManager:getInstance():add_layer_to_scene(shopLayer)
            --113
            local SpecialGiftLayer = SpecialGiftLayer:create(SpecialGiftLayer.Gift_Type.Jewel)
            LayerManager:getInstance():add_layer_to_scene(SpecialGiftLayer)
            
            local warningLayer = WarningLayer:create()
            warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
            LayerManager:getInstance():add_layer_to_scene(warningLayer)
        end
        
    end)
end

function WeekgameTimeLayer:set_add_challenge_num_callback(callback)
    self.add_challenge_num_callback = callback
end

function WeekgameTimeLayer:set_go_to_play_callback(callback)
    self.go_to_play_callback = callback
end

function WeekgameTimeLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self:removeFromParent()
end

return WeekgameTimeLayer