require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "UI.Layer.ShareLayer"

WeekgameWinLayer = class("WeekgameWinLayer", function() return cc.Layer:create() end)

function WeekgameWinLayer:ctor()

    self:setName("WeekgameWinLayer")
    self.close_callback = nil

	local widget = cc.CSLoader:createNode("weekgame_win.csb")
    self:addChild(widget, 1);

    self.widget = widget

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.action = cc.CSLoader:createTimeline("weekgame_win.csb")
    widget:runAction(self.action)

    self.action:setCurrentFrame(0)
    self.action:play("light", true)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "light_end" then

        end
    end
    self.action:setFrameEventCallFunc(onFrameEvent)

    local node = widget:getChildByName("node")
    local text_num = node:getChildByName("text_num")

    self.text_num = text_num

    -- 炫耀按钮 首次分享奖励
    local share_Image = node:getChildByName("button_share")
    move_cycle_action(share_Image)
    local share_Btn = ButtonWrap:create()
    share_Btn:wrap(share_Image, 1)
    share_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        local shareLayer = ShareLayer:create("WEEKWIN")
        shareLayer:set_create_share_pic_callback(function()
                global_create_share_pic(shareLayer, "share_picture_5", "WEEKWIN.jpg")
            end)
        shareLayer:add_share_callback_listener(function() self:share_success_callback() end, nil)
        LayerManager:getInstance():add_layer_to_scene(shareLayer)
    end)

    if LOGIN_PLATFROM == 0 then
        share_Image:setVisible(false)
    end

    self.image_share_reward = share_Image:getChildByName("image_share_reward")
    local image_reward = self.image_share_reward:getChildByName("image_reward")
    local text_reward = self.image_share_reward:getChildByName("text_reward")

    local share_index = Player:getInstance():get_num_share()
    local share_reward_info_vector = require "script/share_reward_info.lua"
    local share_reward_info = share_reward_info_vector[share_index]
    if share_reward_info then
        
        self.item_num = share_reward_info.item_num
        self.item_id = share_reward_info.item_id
        image_reward:loadTexture(share_reward_info.res_key)
        text_reward:setString(string.format("x%d", share_reward_info.item_num))

    else
        self.image_share_reward:setVisible(false)
    end

    -- if cc.UserDefault:getInstance():getBoolForKey("is_share_week_win", false) then
    --     self.image_share_reward:setVisible(false)
    -- end

    -- 关闭按钮
    local closeImage = node:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)


    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function WeekgameWinLayer:share_success_callback()

    if self.image_share_reward:isVisible() then
        self.image_share_reward:setVisible(false)
        
        local player = Player:getInstance()
        --炫耀次数+1
        local num_share = player:get_num_share()
        player:set_num_share(num_share + 1)
        -- local tm = os.date("*t")
        -- player:set_last_share_day(tm.yday)
        TalkingDataManager:getInstance():send("分享", {["分享次数"] = num_share})

        player:add_player_bag_info_by_id(self.item_id, self.item_num)

        -- cc.UserDefault:getInstance():setBoolForKey("is_share_week_win", true)

        --bag_get_reward
        -- local bag_reward = BagRewardWidget:create()
        -- self:addChild(bag_reward, 2)

        -- local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_101")
        -- bag_reward:setItemTexture(bag_info.res_key)
        -- bag_reward:setTouchEnabled(true)
        -- bag_reward:runAction()
    end
end

function WeekgameWinLayer:setConchNumber(num)
    self:update_Venture_score(num)
    self.text_num:setString(tostring(num))

    local player = Player:getInstance()
    player:add_player_weekly_challenge_conch_count(num)
    player:set_player_weekly_challenge_conch_once_num(num)

    require "core.TalkingDataManager"
    TalkingDataManager:getInstance():send_for_stats_conch_once_num(num)
end

function WeekgameWinLayer:set_close_callback(close_callback)
    self.close_callback = close_callback
end

function WeekgameWinLayer:close_self()
    if self.close_callback then
        self.close_callback()
    end
    local loadingScene = LoadingScene:create(1)
    loadingScene:load_extern_scene_resource()
    loadingScene:set_load_finish_callback(function()
        local externalScene = ExternalScene:create()
        LayerManager:getInstance():clear_layer()
        externalScene:play_bg_music()
        externalScene:move_section_map()
        externalScene:add_WeeklyChallengeLayer()
        cc.Director:getInstance():replaceScene(externalScene)
    end)
    cc.Director:getInstance():replaceScene(loadingScene)

    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    self:removeFromParent()
end

function WeekgameWinLayer:update_Venture_score(score)
    local rpc_param = {

        PLAYER_ID,
        score,
    }

    RPC:call("SHIN/seaVenture/doVenture", rpc_param, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then

            --dump(response)

        else

            print("request error")

        end

    end)
end

return WeekgameWinLayer