require "core.Book_Data"
require "UI.Layer.CardLayer"
require "UI.Layer.GetRoleLayer"
require "UI.Layer.GetSkinLayer"
require "core.LayerManager"
require "UI.Widget.MaskLayer"
require "core.TalkingDataManager"
require "UI.Layer.ShareLayer"
require "UI.Layer.SharePictureLayer"
local ResourceManager1 = require "GameEx.Foundations.ResourceManager"

WinLayer = class("WinLayer", function() return cc.Layer:create() end)

function WinLayer:ctor()

    self:setName("WinLayer")

    self.star = 1
    self.game_score = 0
	local widget = cc.CSLoader:createNode("balance_win.csb")
    self:addChild(widget, 1);
    self.widget = widget 

    widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(widget)

    self.animation = cc.CSLoader:createTimeline("balance_win.csb")
    self.widget:runAction(self.animation)

    self.animation:setCurrentFrame(0)
    self.animation:play("balance_win_in", false)

    local function show_star()
        if self.star == 1 then
            self.star_image[2]:setVisible(false)
            self.star_shine[2]:setVisible(false)
            self.star_shine_0[2]:setVisible(false)
            self.star_image[3]:setVisible(false)
            self.star_shine[3]:setVisible(false)
            self.star_shine_0[3]:setVisible(false)
        elseif self.star == 2 then
            self.star_image[3]:setVisible(false)
            self.star_shine[3]:setVisible(false)
            self.star_shine_0[3]:setVisible(false)
        end
    end
    --7.28
    local player = Player:getInstance()
    self.is_Show_Chest = false
    local current_level = player:get_player_current_level()
    local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
    local book_info = Mission_Data:getInstance():get_generate_card_by_mission(mission_info.mission_id)
    if book_info then
        if player:get_player_book_info_by_id(book_info.book_id).is_get == false then
            self.is_Show_Chest = true
            self.mask = MaskLayer:create()
            self:addChild(self.mask,5)
        else
            self.mask_no_reward = MaskLayer:create()
            self:addChild(self.mask_no_reward,5)
        end
    else
        self.mask_no_reward = MaskLayer:create()
        self:addChild(self.mask_no_reward,5)
    end
    --7.28

    local player_mission_info = player:get_player_mission_info_by_id(mission_info.mission_id)
    if player_mission_info and player_mission_info.pass_count  == 0 then
        
        local LevelBuilder = require "GameEx.Foundations.LevelBuilder"
        local level_config = LevelBuilder:get_instance():get_level_config(current_level)
        local is_boss = false
        if level_config.boss then
            is_boss = true
        end
        if is_boss then
            performWithDelay(self,function()
            
                local lucky_gift_odds_info = require "script/lucky_gift_odds_info"
                local info = lucky_gift_odds_info[current_level]
                math.randomseed(os.time())
                local random_num = math.random()
                print("star~~~"..self.star)
                print(random_num)
                
                if info and random_num <= info[self.star] then
                    player:set_is_create_lucky_gift(true)
                end

            end, 0.3)
            
        end

        local player_continue_pass_stage = player:get_continue_pass_stage()
        player:set_continue_pass_stage(player_continue_pass_stage + 1)
    end


    
    local str_level = "关卡"..current_level
    TalkingDataManager:getInstance():send("每关通关次数统计", {["通关关卡id"] = str_level})
    TalkingDataManager:getInstance():sendMissionInfo("completed", str_level)

    player:set_player_mission_fail_times(mission_info.mission_id, 0)


    --获得最新的最高通关的关卡号
    local player = Player:getInstance()
    local newest_mission_id = player:get_player_newest_mission_id()
    local mission_info = Mission_Data:getInstance():get_mission_info_by_id(newest_mission_id)
    local newest_level = mission_info.mission_level
    local main_level = player:get_player_achv_finish_count_by_id("achv_01")
    if newest_level > main_level then
        --成就任务事件发送
        local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
        local pass_mission_count = player:get_player_pass_mission_count()
        event.param = {achv_id = "achv_01", finish_count = pass_mission_count, func = function() end }
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    end
    --每日任务事件发送
    local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
    event.param = {task_id = "task_02", finish_count = 1, func = function() end }
    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    --每日任务事件发送
    if player:get_player_cur_role_id() == player:get_player_daily_task_info_by_id("task_12").target_type then
        local event = cc.EventCustom:new(NotificationUtil.EventType.daily_task_event)
        event.param = {task_id = "task_12", finish_count = 1, func = function() end }
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    end

    local today_challenge_num = player:get_player_weekly_challenge_today_challenge_num()
    if today_challenge_num == 0 then
        local go_to_play_times = player:get_player_weekly_challenge_go_to_play_times() + 1
        player:set_player_weekly_challenge_go_to_play_times(go_to_play_times)
        if go_to_play_times >= 3 then
            player:set_player_weekly_challenge_today_challenge_num(2)
            player:set_player_weekly_challenge_go_to_play_times(-1)
            TalkingDataManager:getInstance():send("周赛次数统计", {["玩家完成”通关三次“来获取周赛机会的次数"] = "次数"})
        end
    end
    

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "balance_win_in_end" then
            if self.star == 1 then
                self.animation:play("balance_win_star_1", false)
               
            elseif self.star == 2 then
                self.animation:play("balance_win_star_2", false)
                
            else
                self.animation:play("balance_win_star_3", false)
               
                --7.28  获得卡片
                if self.is_Show_Chest then
                    Player:getInstance():set_player_book_is_get(book_info.book_id)
                end                
                --7.28
            end
            for i=1,self.star do
                self:runAction(cc.Sequence:create(cc.DelayTime:create(0.35 + 0.3 * (i -1)), cc.CallFunc:create(function()
                    MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Star_Audio"), false)

                    local particle = ResourceManager:getInstance():getParticleByKey("PARTICLE_STARS")
                    particle:setAutoRemoveOnFinish(true)
                    particle:setPosition(cc.p(get_node_width(self.star_image[i])/2, get_node_width(self.star_image[i])/2))
                    self.star_image[i]:addChild(particle)

                    local particle1 = ResourceManager:getInstance():getParticleByKey("PARTICLE_STARS_2")
                    particle1:setAutoRemoveOnFinish(false)
                    particle1:setDuration(-1)
                    particle1:setPosition(cc.p(get_node_width(self.star_image[i])/2, get_node_width(self.star_image[i])/2))
                    self.star_image[i]:addChild(particle1)
                end)))
            end
        elseif str == "balance_win_star_1_end" then
            show_star()
            -- self.animation:play("button_move_cycle", true)
          
            if self.is_Show_Chest then
                self:playChestAnimation(false)
            else
                self.mask_no_reward:removeFromParent()
            end

        elseif str == "balance_win_star_2_end" then
            show_star()
            -- self.animation:play("button_move_cycle", true)
    
            if self.is_Show_Chest then
                self:playChestAnimation(false)
            else
                self.mask_no_reward:removeFromParent()
            end

        elseif str == "balance_win_star_3_end" then
            show_star()
            self.animation:play("button_move_cycle", true)
           
            if self.is_Show_Chest  then
                self:playChestAnimation(true)
            else
                self.mask_no_reward:removeFromParent()
            end

        end
    end
    self.animation:setFrameEventCallFunc(onFrameEvent)

    local player = GameKernel:getInstance():getPlayer()

    local node = widget:getChildByName("node")
    self.node = node
    local image_dia = node:getChildByName("image_dia")

    self.text_score = image_dia:getChildByName("text_score")
    self.text_score:setString(string.format("%d", self.game_score))

    -- 奖励
    local reward = image_dia:getChildByName("reward")
    self.text_gold = reward:getChildByName("text_gold")
    self.text_energy = reward:getChildByName("text_energy")
    self.image_gold = reward:getChildByName("image_gold")
    self.image_energy = reward:getChildByName("image_energy")

    --人物角色
    self.win_role_spine = {
        ["role_101"] = "images/balance/win_shin.png",
        ["role_201"] = "images/balance/win_nene.png",
        ["role_301"] = "images/balance/win_masao.png",
        ["role_401"] = "images/balance/win_bo.png",
        ["role_501"] = "images/balance/win_kazama.png",
    }

    self.role = image_dia:getChildByName("role")
    self.role:setTexture(self.win_role_spine[Player:getInstance():get_player_cur_role_id()])
    -- self.role:setVisible(false)

    -- local effect = ResourceManager:getInstance():getSpineByKey(self.win_role_spine[Player:getInstance():get_player_cur_role_id()], 1)
    -- effect:setAnimation(0, "win", true)
    -- effect:setPosition(cc.p(self.role:getPositionX(), self.role:getPositionY() - self.role:getContentSize().height * 0.0))
    -- self.role:getParent():addChild(effect)

    -- local LevelBuilder = require "GameEx.Foundations.LevelBuilder"
    -- local mission_level = Player:getInstance():get_player_current_level()
    -- local level_config = LevelBuilder:get_instance():get_level_config(mission_level)
    -- local is_boss = false
    -- if level_config.boss then
    --     is_boss = true
    -- end
    -- if is_boss then
    --     self.role:setVisible(false)
    --     image_dia:getChildByName("role_shadow"):setVisible(false)

    --     local animation_name = "halo"
    --     self.boss_spine = ResourceManager1:get_instance():get_resource_by_key(level_config.boss.texture, true)
    --     self.boss_spine:setAnimation(0, animation_name, true)
    --     --self.boss_spine:setScale(1)
    --     self.boss_spine:setTimeScale(0.5)
    --     self.boss_spine:setPosition(cc.p(self.role:getPositionX(), self.role:getPositionY() - self.role:getContentSize().height * 0.0))
    --     self.role:getParent():addChild(self.boss_spine)
    -- end


    -- 关卡
    local image_stage_dia = image_dia:getChildByName("image_stage_dia")
    local text_stage = image_stage_dia:getChildByName("text_stage")
    local current_level = player:get_player_current_level()
    text_stage:setString(string.format(ResourceManager:getInstance():getTextStringByKey("WinLayer_1"), current_level))

    -- 星星
    image_dia:getChildByName("particle_ribbon"):setLocalZOrder(2)
    self.star_image = {}
    self.star_shine = {}
    self.star_shine_0 = {}
    local panel_star = image_dia:getChildByName("panel_star")
    panel_star:setLocalZOrder(1)
    for i=1,3 do
        local star = panel_star:getChildByName(string.format("star_full_%d", i))
        local star_shine = panel_star:getChildByName(string.format("star_shine_%d", i))
        local star_shine_0 = panel_star:getChildByName(string.format("star_shine_%d_0", i))
        self.star_image[i] = star
        self.star_shine[i] = star_shine
        self.star_shine_0[i] = star_shine_0
    end

    -- 按钮点击事件
    local closeImage = image_dia:getChildByName("button_close")
    local closeBtn = ButtonWrap:create()
    closeBtn:wrap(closeImage, 1)
    closeBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        self:close_self()
    end)

    -- 下一关
    local nextImage = image_dia:getChildByName("button_next")
    local text_next = nextImage:getChildByName("text_next")
    if current_level == 1 then
        text_next:setString("开始冒险")
    end
    self.nextImage = nextImage
    local nextBtn = ButtonWrap:create()
    nextBtn:wrap(nextImage, 1)
    nextBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if Mission_Data:getInstance():is_last_level(current_level) then
            self:close_self()
        else
            local loadingScene = LoadingScene:create(1)
            loadingScene:load_extern_scene_resource()
            loadingScene:set_load_finish_callback(function()
                local player = Player:getInstance()
                -- 判断下一关是否是新解锁的章节
                local next_level = player:get_player_next_level()
                local mission_info = Mission_Data:getInstance():get_mission_info_by_level(next_level)
                local section_index = mission_info.mission_section
                local player_section_info = player:get_player_section_info_by_id(section_index)

                LayerManager:getInstance():clear_layer()
                local externalScene = ExternalScene:create()
                externalScene:play_bg_music()
                --print(player_section_info.is_animation)
                if player_section_info then
                    if player_section_info.is_animation then
                        externalScene:move_and_enter_section_map(section_index, next_level)
                    else
                        externalScene:switch_to_level_info(section_index, next_level)
                    end
                else
                    local section_mission = Player:getInstance():get_player_current_section()
                    externalScene:add_map(section_mission)
                end
                cc.Director:getInstance():replaceScene(externalScene)
            end)
            LayerManager:getInstance():clear_layer()
            cc.Director:getInstance():replaceScene(loadingScene)
        end
    end)

    -- 重来
    local againImage = image_dia:getChildByName("button_again")
    local againBtn = ButtonWrap:create()
    self.againImage = againImage
    againBtn:wrap(againImage, 1)
    againBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local levelInfoLayer = LevelInfoLayer:create()
        levelInfoLayer:set_close_callback(function()
            local loadingScene = LoadingScene:create(1)
            loadingScene:load_extern_scene_resource()
            loadingScene:set_load_finish_callback(function()
                local section_mission = Player:getInstance():get_player_current_section()
                local externalScene = ExternalScene:create()
                externalScene:play_bg_music()
                externalScene:add_map(section_mission)
                LayerManager:getInstance():clear_layer()
                cc.Director:getInstance():replaceScene(externalScene)
            end)
            LayerManager:getInstance():clear_layer()
            cc.Director:getInstance():replaceScene(loadingScene)
        end)
        LayerManager:getInstance():add_layer_to_scene(levelInfoLayer)
        self:removeFromParent()
    end)
    -- if self.star == 1 or self.star == 2 then  --118
    --     print("print(self.star)print(self.star)print(self.star)"..self.star)
    --     againImage:setPositionX(650)
    --     nextImage:setPositionX(350)
    --     origin_cycle_action(againImage)
    -- else
    --     print("print(self.star)print(self.star)print(self.star)"..self.star)
    --     againImage:setVisible(false)
    --     origin_cycle_action(nextImage)
    -- end
    -- 炫耀 首次分享奖励
    local shareImage = image_dia:getChildByName("button_share")
    local shareBtn = ButtonWrap:create()
    shareBtn:wrap(shareImage, 1)
    shareBtn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local function callback()
            local sp = SharePictureLayer:create()
            sp:setPosition(cc.p(0, 0))
            sp:setAnchorPoint(0,0)
            sp:retain()

            local render = cc.RenderTexture:create(960, 960)
            render:begin()
            sp:visit()
            render:endToLua()
            render:retain()
            
            performWithDelay(self,function()
                local image = render:newImage()
                local image_name = "WIN.jpg"
                local fileName = global_get_screenshot_path()..image_name
                image:saveToFile(fileName)
                render:release()
                sp:release()
            end, 0.016)
        end

        local shareLayer = ShareLayer:create("WIN")
        shareLayer:set_create_share_pic_callback(callback)
        shareLayer:add_share_callback_listener(function() self:share_success_callback() end, nil)
        LayerManager:getInstance():add_layer_to_scene(shareLayer)
    end)

    if LOGIN_PLATFROM == 0 then
        shareImage:setVisible(false)
    end

    self.image_share_reward = shareImage:getChildByName("image_share_reward")
    local image_reward = self.image_share_reward:getChildByName("image_reward")
    local text_reward = ccui.Text:create("", "images/font/zh_CN.TTF", 40)
    -- text_reward:setString(string.format("x%d", 10))
    text_reward:setPosition(cc.p(50, 20))
    self.image_share_reward:addChild(text_reward)
    self.image_share_reward:setScale(1)

    -- image_reward:loadTexture("images/item/item_9.png")
    image_reward:setScale(0.5)
    image_reward:setPosition(cc.p(image_reward:getPositionX()-10, image_reward:getPositionY()-10))

    local share_index = Player:getInstance():get_num_share()
    local share_reward_info_vector = require "script/share_reward_info.lua"
    local share_reward_info = share_reward_info_vector[share_index]
    if share_reward_info then
        
        move_cycle_action(shareImage)
        self.item_num = share_reward_info.item_num
        self.item_id = share_reward_info.item_id
        image_reward:loadTexture(share_reward_info.res_key)
        text_reward:setString(string.format("x%d", share_reward_info.item_num))

    else
        self.image_share_reward:setVisible(false)
    end

    
    local current_level = player:get_player_current_level()
    local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
    local pass_count = player:get_player_mission_pass_count(mission_info.mission_id)

    -- if pass_count ~= 0 then
    --     self.image_share_reward:setVisible(false)
    -- end

    --排行榜
    self:init_rank()

    -- 吃掉点击事件
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "exit" == event then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function WinLayer:share_success_callback()

    if self.image_share_reward:isVisible() then
        self.image_share_reward:setVisible(false)

        local player = Player:getInstance()
        --炫耀次数+1
        local num_share = player:get_num_share()
        player:set_num_share(num_share + 1)
        -- local tm = os.date("*t")
        -- player:set_last_share_day(tm.yday)
        TalkingDataManager:getInstance():send("分享", {["分享次数"] = num_share})

        player:add_player_bag_info_by_id(self.item_id, self.item_num)
        --bag_get_reward
        -- local bag_reward = BagRewardWidget:create()
        -- self:addChild(bag_reward, 2)

        -- local bag_info = Bag_Data:getInstance():get_bag_info_by_id("item_101")
        -- bag_reward:setItemTexture(bag_info.res_key)
        -- bag_reward:setTouchEnabled(true)
        -- bag_reward:runAction()
    end
end

function WinLayer:playChestAnimation(open_flag)

    local current_level = Player:getInstance():get_player_current_level()
    local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
    local book_info = Mission_Data:getInstance():get_generate_card_by_mission(mission_info.mission_id)

    if book_info then

        self.__c_card_spine = sp.SkeletonAnimation:create("res/spine/chest.json", "res/spine/chest.atlas", 1.0)

        local node = self.widget:getChildByName("node")
        local Chest_node = node:getChildByName("Chest_node")
        --self.__c_card_spine:setPosition(cc.p(posx, 1280))
        self.__c_card_spine:setAnimation(0, "chest", true)
        self.__c_card_spine:setScale(0)
        Chest_node:addChild(self.__c_card_spine, 99)

        local ui_text = ccui.Text:create("拿到三星才能\n打开我哦！", "images/font/zh_CN.TTF", 30)
        --ui_text:setColor(cc.c3b(120,120,120))
        ui_text:setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
        ui_text:enableOutline(cc.c4b(125,61,0,255))
        ui_text:setPositionY(-50)
        Chest_node:addChild(ui_text, 100)
        ui_text:setVisible(false)

        local scale_1 = cc.ScaleTo:create(3 * 0.033, 1.05)
        local scale_2 = cc.ScaleTo:create(2 * 0.033, 1.0)
        local finish_call = cc.CallFunc:create(function()

            if open_flag then                

                self.__c_card_spine:setAnimation(0, "chest_open", false)

                local delay = cc.DelayTime:create(1.0)
                local call_func = cc.CallFunc:create(function()
                        self:show_card()
                        self.mask:removeFromParent()
                end)
                local sequence = cc.Sequence:create(delay, call_func)

                self:runAction(sequence)
            else
                ui_text:setVisible(true)
            end

        end)
        local sequence = cc.Sequence:create(scale_1, scale_2, finish_call)

        self.__c_card_spine:runAction(sequence)

    end
    if not open_flag then
        self.mask:removeFromParent()
    end
    

end

function WinLayer:show_card()

   local current_level = Player:getInstance():get_player_current_level()
    local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(current_level)
    local book_info = Mission_Data:getInstance():get_generate_card_by_mission(mission_info.mission_id)
    if book_info then
        -- if Player:getInstance():get_player_book_info_by_id(book_info.book_id).is_get then
        --     return
        -- end
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Shaizi_Audio"), false)
        --Player:getInstance():set_player_book_is_get(book_info.book_id)

        local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
        event.param = {achv_id = "achv_08", finish_count = 1, func = function() end }
        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)

        local cardLayer = CardLayer:create()
        cardLayer:set_cur_card(book_info.book_id)
        cardLayer:set_show_type(2)
        cardLayer:set_finish_callback(function()
            local skin_info = Book_Data:getInstance():get_skin_info_by_book_id(book_info.book_id)
            if not skin_info then
                return
            end
            local player_skin_info = Player:getInstance():get_player_skin_info_by_id(skin_info.skin_id)
            if player_skin_info.is_get then
                return
            else
                local unlock_condition_list = skin_info.unlock_condition
                for k,v in pairs(unlock_condition_list) do
                    local player_book_info = Player:getInstance():get_player_book_info_by_id(v)
                    if player_book_info.is_get == false then
                        return
                    end
                end
                local role_info = Skin_Data:getInstance():get_role_by_skin_id(skin_info.skin_id)
                Player:getInstance():set_player_skin_info_unlock(skin_info.skin_id)
                if role_info.skin_id_list[1] == skin_info.skin_id then
                    -- 解锁角色
                    Player:getInstance():set_player_role_unlock(role_info.role_id)
                    local getRoleLayer = GetRoleLayer:create()
                    getRoleLayer:set_cur_role(role_info.role_id)
                    LayerManager:getInstance():add_layer_to_scene(getRoleLayer)
                else
                    -- 解锁皮肤
                    local getSkinLayer = GetSkinLayer:create()
                    getSkinLayer:set_cur_skin(skin_info.skin_id)
                    LayerManager:getInstance():add_layer_to_scene(getSkinLayer)
                end
            end
        end)
        
        LayerManager:getInstance():add_layer_to_scene(cardLayer)
    end

end

function WinLayer:close_self()
    self:addChild(MaskLayer:create(), 5)
    LayerManager:getInstance():remove_top_layer()
    local loadingScene = LoadingScene:create(1)
    loadingScene:load_extern_scene_resource()
    loadingScene:set_load_finish_callback(function()
        local section_mission = Player:getInstance():get_player_current_section()
        LayerManager:getInstance():clear_layer()
        local externalScene = ExternalScene:create()
        externalScene:play_bg_music()
        externalScene:add_map(section_mission)
        cc.Director:getInstance():replaceScene(externalScene)
    end)
    cc.Director:getInstance():replaceScene(loadingScene)
end

function WinLayer:init_rank()
    local image_rank_dia = self.node:getChildByName("image_rank_dia")
    local panel_friends = image_rank_dia:getChildByName("panel_friends")
    local panel_world = image_rank_dia:getChildByName("panel_world")
    local text_my_score = image_rank_dia:getChildByName("text_my_score")
    text_my_score:setVisible(false)
    local invite_image = image_rank_dia:getChildByName("button_invite")
    local text_friends = panel_friends:getChildByName("text_friends")
    local text_world = panel_world:getChildByName("text_world")
    local world_image = panel_friends:getChildByName("button_world")
    local text_world_ = world_image:getChildByName("text_world")
    local friends_image = panel_world:getChildByName("button_friends")
    local text_friends_ = friends_image:getChildByName("text_friends")
    
    text_friends_:setColor(cc.c3b(21, 102, 164))
    text_world_:setColor(cc.c3b(21, 102, 164))
    panel_friends:setVisible(true)
    panel_world:setVisible(false)
    text_friends:setColor(cc.c3b(148, 55, 51))
    text_world:setColor(cc.c3b(148, 55, 51))
    
    local invite_Btn = ButtonWrap:create()
    invite_Btn:wrap(invite_image, 1)
    invite_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local friendAddLayer = FriendAddLayer:create()
        LayerManager:getInstance():add_layer_to_scene(friendAddLayer) 
    end)
    local friends_Btn = ButtonWrap:create()
    friends_Btn:wrap(friends_image, 1)
    friends_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        panel_friends:setVisible(true)
        panel_world:setVisible(false)
    end)
    local world_Btn = ButtonWrap:create()
    world_Btn:wrap(world_image, 1)
    world_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        panel_friends:setVisible(false)
        panel_world:setVisible(true)

        if not self.is_request_ranklist then
            self.is_request_ranklist = true
            self:request_getRanklist(self.world_async_callback)
        end
    end)
    self.is_request_ranklist = false

    local rank_res = {
        [1] = "images/section/friend/rank_first.png",
        [2] = "images/section/friend/rank_second.png",
        [3] = "images/section/friend/rank_third.png",
    }

    local rank_friends = panel_friends:getChildByName("rank_friends")
    self.rank_friends = rank_friends
    local panel_1 = rank_friends:getChildByName("panle_1")
    rank_friends:setClippingEnabled(true)
    --rank_friends:setScrollBarEnabled(false)
    rank_friends:setItemModel(panel_1:clone())
    rank_friends:removeAllItems()
    local function friend_async_callback(list)
        local friendRanklist = list
        local count = get_table_length(friendRanklist)
        for i=1,count do
            rank_friends:pushBackDefaultItem()
        end
        for i=1,count do
            local item = rank_friends:getItem(i -1)
            local image_head = item:getChildByName("image_id")
            local text_name = item:getChildByName("text_name")
            local text_score = item:getChildByName("text_score")
            local image_rank_num = item:getChildByName("image_rank_num")
            local text_rank_num = item:getChildByName("text_rank_num")

            if i < 4 then
                text_rank_num:setVisible(false)
                image_rank_num:setVisible(true)
                image_rank_num:loadTexture(rank_res[i])
            else
                image_rank_num:setVisible(false)
                text_rank_num:setVisible(true)
                text_rank_num:setString(i)
            end
            local friendRank_info = friendRanklist[i]
            --text_rank_num:setString(friendRank_info.rank)
            text_name:setString(friendRank_info.name)
            text_score:setString(friendRank_info.score)

            if friendRank_info.sex == "0" and friendRank_info.headUrl and friendRank_info.headUrl ~= "" then
                
                local function on_create_finish()
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..friendRank_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(friendRank_info.guid, friendRank_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", friendRank_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end

            if friendRank_info.guid == PLAYER_ID then
                text_my_score:setVisible(true)
                text_my_score:setString(friendRank_info.score)

                -- local player_head_id = Player:getInstance():get_player_head_id()
                -- if player_head_id == "head_00" then
                --     local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
                --     image_head:loadTexture(headPath)
                -- end
            end
        end
    end
    self.friend_async_callback = friend_async_callback
    -- self:request_getfriendRanklist(friend_async_callback)

    local rank_world = panel_world:getChildByName("rank_world")
    self.rank_world = rank_world
    local panel_1 = rank_world:getChildByName("panle_1")
    rank_world:setClippingEnabled(true)
    --rank_world:setScrollBarEnabled(false)
    rank_world:setItemModel(panel_1:clone())
    rank_world:removeAllItems()
    local function world_async_callback(list)
        local worldRanklist = list
        local count = get_table_length(worldRanklist)
        for i=1,count do
            rank_world:pushBackDefaultItem()
        end
        for i=1,count do
            local item = rank_world:getItem(i -1)
            local image_head = item:getChildByName("image_id")
            local text_name = item:getChildByName("text_name")
            local text_score = item:getChildByName("text_score")
            local image_rank_num = item:getChildByName("image_rank_num")
            local text_rank_num = item:getChildByName("text_rank_num")

            if i < 4 then
                text_rank_num:setVisible(false)
                image_rank_num:setVisible(true)
                image_rank_num:loadTexture(rank_res[i])
            else
                image_rank_num:setVisible(false)
                text_rank_num:setVisible(true)
                text_rank_num:setString(i)
            end
            local worldRank_info = worldRanklist[i]
            --text_rank_num:setString(worldRank_info.rank)
            text_name:setString(worldRank_info.name)
            text_score:setString(worldRank_info.score)

            if worldRank_info.sex == "0" and worldRank_info.headUrl and worldRank_info.headUrl ~= "" then
                
                local function on_create_finish()
                    local headPath = FileManipulator:getInstance():getPath().."head_cache/"..worldRank_info.guid.."head_00"
                    if cc.FileUtils:getInstance():isFileExist(headPath) then
                        image_head:loadTexture(headPath)
                    end
                end
                global_create_social_head(worldRank_info.guid, worldRank_info.headUrl, on_create_finish)

            else
                local head_id = string.format("head_%02d", worldRank_info.sex+1)
                local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
                image_head:loadTexture(head_info.res_key)
            end

            -- local head_id = string.format("head_%02d", worldRank_info.sex+1)
            -- local head_info = Head_Data:getInstance():get_head_info_by_id(head_id)
            -- image_head:loadTexture(head_info.res_key)

            -- if worldRank_info.guid == PLAYER_ID then
            --     local player_head_id = Player:getInstance():get_player_head_id()
            --     if player_head_id == "head_00" then
            --         local headPath = FileManipulator:getInstance():getPath().."head_cache/"..PLAYER_ID..player_head_id
            --         image_head:loadTexture(headPath)
            --     end
            -- end
        end
    end
    self.world_async_callback = world_async_callback
    -- self:request_getRanklist(world_async_callback)

    rank_friends:setVisible(false)
    rank_world:setVisible(false)
    rank_friends:runAction(cc.Sequence:create(cc.FadeIn:create(0.5),cc.CallFunc:create(function()rank_friends:setVisible(true) end)))
    rank_world:runAction(cc.Sequence:create(cc.FadeIn:create(0.5),cc.CallFunc:create(function()rank_world:setVisible(true) end)))
end

function WinLayer:request_getfriendRanklist(async_callback)
    --request getfriendRanklist 好友排行
    local level_index = Player:getInstance():get_player_current_level()
    local rpc_param = {

        PLAYER_ID,
        level_index,
    }

    RPC:call_bind("SHIN/chapter/getfriendRanklist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            -- dump(response)
            if response == nil then
                response = {}
            end
            async_callback(response)

        else

            print("request error")

        end

    end)
end

function WinLayer:request_getRanklist(async_callback)
    --request getRanklist 世界排行
    local level_index = Player:getInstance():get_player_current_level()
    local rpc_param = {
        level_index,
    }

    RPC:call_bind("SHIN/chapterMgr/getRanklist", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            if response == nil then
                response = {}
            end
            async_callback(response)

        else

            print("request error")

        end

    end)
end

function WinLayer:update_Chapter(level, star, score)
    local rpc_param = {

        PLAYER_ID,
        level,
        star,
        score,
    }

    RPC:call_bind("SHIN/chapter/updateChapter", rpc_param, self, function(status, response)

        if status == RPC.RPC_CALL_SUCCESS then
            local function on_check_finish()
                if self.is_Show_Chest then
                    performWithDelay(cc.Director:getInstance():getRunningScene(),function() 
                        RemoteArchiveManager:getInstance():save(function()end)
                    end, 0.75)
                else
                    RemoteArchiveManager:getInstance():save(function()end)
                end
                
            end
            global_check_remote_archive(on_check_finish)

            self:request_getfriendRanklist(self.friend_async_callback)
            -- self:request_getRanklist(self.world_async_callback)
        else

            print("request error")

        end

    end)
end

function WinLayer:onEnter()
    RPC:register_target(self)

    MusicManager:getInstance().play_bg_music(ResourceManager:getInstance():getAudioPathByKey("Win_Music"), false)
    -- local function update_role(event) 
    --     self.role:setTexture(self.role_res[Player:getInstance():get_player_cur_role_id()])
    -- end

    -- local listener1 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_skin_change, update_role)
    -- local listener2 = cc.EventListenerCustom:create(NotificationUtil.EventType.player_role_change, update_role)

    -- local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    -- eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self)
    -- eventDispatcher:addEventListenerWithSceneGraphPriority(listener2, self)
end

function WinLayer:onExit()
    RPC:unregister_target(self)

    if self.count_entry then

        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.count_entry)

    end

end

function WinLayer:setStarGoal(star)


    self.star = math.min(star, 3)
    self.star = math.max(1, self.star)
    if self.star == 1 or self.star == 2 then  --118
        print("print(self.star)print(self.star)print(self.star)"..self.star)
        self.againImage:setPositionX(700)
        self.nextImage:setPositionX(300)
        origin_cycle_action(self.againImage)
    else
        print("print(self.star)print(self.star)print(self.star)"..self.star)
        self.againImage:setVisible(false)
        --origin_cycle_action(self.nextImage)
    end
    local player = Player:getInstance()
    local level_index = player:get_player_current_level()
    local mission_info =  Mission_Data:getInstance():get_mission_info_by_level(level_index)
    local player_mission_info = player:get_player_mission_info_by_id(mission_info.mission_id)
    local mission_id = mission_info.mission_id

    --上传到服务器
    self:update_Chapter(level_index, star, self.game_score)

    if player_mission_info then
        --判断是否已经拿过三星
        if player_mission_info.star_count < 3 then
            local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
            event.param = {achv_id = "achv_07", finish_count = 1, func = function() end }
            cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
        end

        local reward_rate_vector = mission_info.reward_rate

        local old_star_count = player:get_player_mission_star_by_id(mission_id)
        player:set_player_mission_is_pass(mission_id)
        player:set_player_mission_star_by_id(mission_id, self.star)
        player:set_player_mission_score_by_id(mission_id, self.game_score)

        local gold_add = player:get_player_gold_add()
        local gold_num = 0
        if player_mission_info.pass_count  == 0 then
            gold_num = mission_info.reward_gold * (1 + gold_add)
            --

        elseif player_mission_info.pass_count  == 1 then
            gold_num = mission_info.second_gold * (1 + gold_add)
        else
            gold_num = mission_info.third_gold * (1 + gold_add)
        end

        local function no_power_reward(gold_num)
            local reward_gold = gold_num * reward_rate_vector[self.star]
            self.text_gold:setString(string.format("%d", reward_gold))
            self.text_energy:setVisible(false)
            self.image_energy:setVisible(false)
            self.image_gold:setPositionX(self.image_gold:getPositionX()+50)
            self.text_gold:setPositionX(self.image_gold:getPositionX()+50)
            player:add_player_gold(reward_gold)
        end
        local function power_reward(gold_num, energy_num)
            local reward_gold = gold_num * reward_rate_vector[self.star]
            self.text_gold:setString(string.format("%d", reward_gold))
            self.text_energy:setString(string.format("%d", energy_num))
            player:add_player_gold(reward_gold)

            player:add_player_power(energy_num)
        end
        local star_count = self.star
        if old_star_count < star_count then        
            if star_count == 1 then
                no_power_reward(gold_num)
            elseif star_count == 2 then
                --1点体力
                power_reward(gold_num, 1)
            elseif star_count == 3 then
                
                if old_star_count < 2 then
                    --3点体力
                    power_reward(gold_num, 3)
                else
                    --2点体力
                    power_reward(gold_num, 2)
                end
            end
        else
            no_power_reward(gold_num)
        end

        player:add_player_mission_pass_count(mission_id)
    end
end

function WinLayer:set_game_score(score)
    local level_index = Player:getInstance():get_player_current_level()
    TalkingDataManager:getInstance():send_for_score(level_index, score)

    self.game_score = score
    local effect_id = 0
    self:runAction(cc.Sequence:create(cc.DelayTime:create(1.0), cc.CallFunc:create(function()
        effect_id = MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Scoreinc_Audio"), false)
        self.count_entry = text_count_action(self.text_score, 0, self.game_score, 0.8)
    end)))
end

return WinLayer