local TournamentProgresser = require "GameEx.Components.Scene.TournamentProgresser"

require "core.Mission_Data"
--require "core.GuideManager"
require "core.LayerManager"
require "core.TalkingDataManager"
require "UI.Layer.OneButtonLayer"
TestScene = class("TestScene", function() return cc.Scene:create() end)

function TestScene:ctor()
	local visible_size = cc.Director:getInstance():getVisibleSize()

    local bg = cc.Sprite:create("images/background/game_bkg_3.jpg")
    bg:setPosition(cc.p(visible_size.width/2, visible_size.height/2))
    self:addChild(bg)
    bg:setScale(2.0)
    

    -- local ResourceManager1 = require "GameEx.Foundations.ResourceManager"
    -- local animation_name = "bag"   --anger,attack_1,attack_2,attack_3,halo,hurt,hurt_heavy,idle,lose,victory
    -- self.boss_spine = ResourceManager1:get_instance():get_resource_by_key("reward_bag_spine", true)
    -- self.boss_spine:setAnimation(0, "reward_bag_tishi", true)
    -- --self.boss_spine:setScale(1)
    -- -- self.boss_spine:setTimeScale(0.5)
    -- self.boss_spine:setPosition(cc.p(visible_size.width*0.5, visible_size.height*0.5))
    -- self:addChild(self.boss_spine,99)


    local close = ccui.ImageView:create("images/button/button_close.png")
    close:setPosition(cc.p(visible_size.width - 150, visible_size.height - 150))
    self:addChild(close)

    local close_Btn = ButtonWrap:create()
    close_Btn:wrap(close, 1)
    close_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Ui_Cancelitem_Audio"), false)
        local externalScene = ExternalScene:create()
        LayerManager:getInstance():clear_layer()
        externalScene:move_section_map()
        cc.Director:getInstance():replaceScene(externalScene)    
    end)

    -- 清除数据
    local str_clear_data = ResourceManager:getInstance():getTextStringByKey("TestScene_1")
    self:add_test_menu(str_clear_data, function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        GameKernel:getInstance():clear_player_data()
        --清除无限体力
        cc.UserDefault:getInstance():setBoolForKey("is_Unlimit_Power", false)
        cc.UserDefault:getInstance():setBoolForKey("is_share_invite", false)
        local player = Player:getInstance()
        player:set_player_left_cover_time(player:get_player_recover_time())
        player:set_player_power(player:get_player_max_power())

        DialogManager:get_instance():clear_progress()

        RemoteArchiveManager:getInstance():clear()

    end, cc.p(250, visible_size.height * 0.95))

    -- 显示的关卡
    local sign_dia = ccui.ImageView:create("images/button/button_blue_0.png")
    sign_dia:setPosition(cc.p(250, visible_size.height * 0.85))
    self:addChild(sign_dia)


    self.level_number = 1
    local level_text = ccui.Text:create("1", "images/font/zh_CN.TTF", 60)
    level_text:setPosition(cc.p(250, visible_size.height * 0.85))
    self:addChild(level_text)
    self.level_text = level_text
    self.level_text:setString(string.format("%d", self.level_number))

    -- 加减1关卡
    local minus = ccui.ImageView:create("images/shop/minus.png")
    minus:setPosition(cc.p(100, visible_size.height * 0.75))
    self:addChild(minus)

    local minus_Btn = ButtonWrap:create()
    minus_Btn:wrap(minus, 1)
    minus_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.level_number = self.level_number - 1
        self:update_level()
    end)

    local plus = ccui.ImageView:create("images/shop/plus.png")
    plus:setPosition(cc.p(400, visible_size.height * 0.75))
    self:addChild(plus)

    local plus_Btn = ButtonWrap:create()
    plus_Btn:wrap(plus, 1)
    plus_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.level_number = self.level_number + 1
        self:update_level()
    end)

    -- 加减10关卡
    local minus1 = ccui.ImageView:create("images/shop/minus.png")
    minus1:setPosition(cc.p(100, visible_size.height * 0.65))
    self:addChild(minus1)

    local minus_Btn1 = ButtonWrap:create()
    minus_Btn1:wrap(minus1, 1)
    minus_Btn1:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.level_number = self.level_number - 10
        self:update_level()
    end)

    local plus1 = ccui.ImageView:create("images/shop/plus.png")
    plus1:setPosition(cc.p(400, visible_size.height * 0.65))
    self:addChild(plus1)

    local plus_Btn1 = ButtonWrap:create()
    plus_Btn1:wrap(plus1, 1)
    plus_Btn1:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        self.level_number = self.level_number + 10
        self:update_level()
    end)


    --进入测试关卡
    local str_enter_test_levle = "测试关卡"
    self:add_test_menu(str_enter_test_levle, function()
        local level_index = self.level_number
        local mission_info = Mission_Data:getInstance():get_mission_info_by_level(level_index)
        if mission_info == nil then
            return
        end
        Player:getInstance():set_player_current_level(level_index)
        Player:getInstance():set_player_current_section(mission_info.mission_section)

        local current_role_id = Player:getInstance():get_player_cur_role_id()
        local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)
        local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
        local skill_level = Player:getInstance():get_player_skill_level(current_role_id)

        local skill = {}
        skill.name = skill_info.class_name
        skill.change_number = skill_info.change_num[skill_level]
        skill.fill_threshold = skill_info.trigger_condition[skill_level]

        local item = {}
        item.move = false
        item.bomb = false
        item.lightning = false

        local scene_start_param = {}
        scene_start_param.skill_info = skill
        scene_start_param.item_info = item
        scene_start_param.level_index = level_index

        local loadingScene = LoadingScene:create(2)
        loadingScene:load_game_scene_resource(scene_start_param)
        LayerManager:getInstance():clear_layer()
        cc.Director:getInstance():replaceScene(loadingScene)

    end, cc.p(850, visible_size.height * 0.85), 40)


    -- 进入关卡
    local enter = ccui.ImageView:create("images/button/button_green_0.png")
    enter:setPosition(cc.p(600, visible_size.height * 0.85))
    self:addChild(enter)

    local enter_text = ccui.Text:create(ResourceManager:getInstance():getTextStringByKey("TestScene_2"), "images/font/zh_CN.TTF", 40)
    enter_text:setPosition(cc.p(get_node_width(enter)/2, get_node_height(enter)/2))
    enter:addChild(enter_text)

    local enter_Btn = ButtonWrap:create()
    enter_Btn:wrap(enter, 1)
    enter_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        local level_index = self.level_number
        local mission_info = Mission_Data:getInstance():get_mission_info_by_level(level_index)
        if mission_info == nil then
            return
        end
        Player:getInstance():set_player_current_level(level_index)
        Player:getInstance():set_player_current_section(mission_info.mission_section)

        for i=1,self.level_number - 1 do
            local mission_info = Mission_Data:getInstance():get_mission_info_by_level(i)
            Player:getInstance():set_player_mission_is_pass(mission_info.mission_id)
            Player:getInstance():set_player_mission_move_action(mission_info.mission_id,false)
        end
        
        local current_role_id = Player:getInstance():get_player_cur_role_id()
        local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)
        local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
        local skill_level = Player:getInstance():get_player_skill_level(current_role_id)

        local skill = {}
        skill.name = skill_info.class_name
        skill.change_number = skill_info.change_num[skill_level]
        skill.fill_threshold = skill_info.trigger_condition[skill_level]

        local item = {}
        item.move = false
        item.bomb = false
        item.lightning = false

        local scene_start_param = {}
        scene_start_param.skill_info = skill
        scene_start_param.item_info = item
        scene_start_param.level_index = level_index

        local loadingScene = LoadingScene:create(2)
        loadingScene:load_game_scene_resource(scene_start_param)
        LayerManager:getInstance():clear_layer()
        cc.Director:getInstance():replaceScene(loadingScene)
        
    end)

    -- 开启关卡
    local open = ccui.ImageView:create("images/button/button_green_0.png")
    open:setPosition(cc.p(600, visible_size.height * 0.75))
    self:addChild(open)

    local open_text = ccui.Text:create(ResourceManager:getInstance():getTextStringByKey("TestScene_3"), "images/font/zh_CN.TTF", 40)
    open_text:setPosition(cc.p(get_node_width(open)/2, get_node_height(open)/2))
    open:addChild(open_text)

    local open_Btn = ButtonWrap:create()
    open_Btn:wrap(open, 1)
    open_Btn:addTouchEndCallback(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        local player = Player:getInstance()
        if self.level_number < 1 then
            return
        end

        for i=1,self.level_number - 1 do
            local mission_info = Mission_Data:getInstance():get_mission_info_by_level(i)
            player:set_player_mission_is_pass(mission_info.mission_id)
            player:set_player_mission_move_action(mission_info.mission_id,false)     --7.28
        end

    end)

   


    -- 游戏截图
    require "UI.Layer.CaptureScreenLayer"
    local str_captureScreen = "截图"
    self:add_test_menu(str_captureScreen, function()
        local captureScreenLayer = CaptureScreenLayer:create()
        cc.Director:getInstance():getRunningScene():addChild(captureScreenLayer, 5)

    end, cc.p(500, visible_size.height * 0.45), 45)


    -- 重置新手
    local str_reset_fish = ResourceManager:getInstance():getTextStringByKey("TestScene_4")
    self:add_test_menu(str_reset_fish, function()
        local TutorialManager = require "core.TutorialManagerEx"
        TutorialManager:get_instance():reset()
        TutorialManager:get_instance():start()

    end, cc.p(250, visible_size.height * 0.45), 45)
    
    -- 获取金币钻石
    local str_get_coin = "获取金币钻石"
    self:add_test_menu(str_get_coin, function()
        local player = Player:getInstance()
        player:add_player_bag_info_by_id("item_02", 9999999)
        player:add_player_bag_info_by_id("item_03", 9999)
        TalkingDataManager:getInstance():sendOnReward(9999,"测试场景获得")
        

    end, cc.p(750, visible_size.height * 0.45), 45)

    -- 测试开始对话
    local str_start_dialog = "开始对话"
    self:add_test_menu(str_start_dialog, function()
        
        local config = require "GameEx.Resources.DialogConfigs.DialogConfigList"

        for i = 1, #config do

            if config[i].toggle_condition.type == "LEVEL_START" and 
                config[i].toggle_condition.constraint == self.level_number then

                    local config = require(string.format("GameEx.Resources.DialogConfigs.%s", config[i].config_file))
                    local DialogLayer = require "UI.Layer.DialogLayer"
                    local _dialogLayer = DialogLayer:create()
                    _dialogLayer:init_with_config(config)
                    _dialogLayer:start()

                    cc.Director:getInstance():getRunningScene():addChild(_dialogLayer, 99999)

            end

        end

    end, cc.p(750, visible_size.height * 0.3))

    -- 测试结束对话
    local str_end_dialog = "结束对话"
    self:add_test_menu(str_end_dialog, function()
        
        local config = require "GameEx.Resources.DialogConfigs.DialogConfigList"

        for i = 1, #config do

            if config[i].toggle_condition.type == "LEVEL_FINISH" and 
                config[i].toggle_condition.constraint == self.level_number then

                    local config = require(string.format("GameEx.Resources.DialogConfigs.%s", config[i].config_file))
                    local DialogLayer = require "UI.Layer.DialogLayer"
                    local _dialogLayer = DialogLayer:create()
                    _dialogLayer:init_with_config(config)
                    _dialogLayer:start()

                    cc.Director:getInstance():getRunningScene():addChild(_dialogLayer, 99999)

            end

        end

    end,cc.p(750, visible_size.height * 0.2))


    local str_weekly_challenge = "周赛模式"
    self:add_test_menu(str_weekly_challenge, function()
        
        local progresser = TournamentProgresser:get_instance()
        progresser:start()
        local next_level = progresser:get_next_level()

        local current_role_id = Player:getInstance():get_player_cur_role_id()
        local role_info = Role_Data:getInstance():get_role_info_by_id(current_role_id)
        local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
        local skill_level = Player:getInstance():get_player_skill_level(current_role_id)

        local skill = {}
        skill.name = skill_info.class_name
        skill.change_number = skill_info.change_num[skill_level]
        skill.fill_threshold = skill_info.trigger_condition[skill_level]

        local item = {}
        item.move = false
        item.bomb = false
        item.lightning = false

        local scene_start_param = {}
        scene_start_param.skill_info = skill
        scene_start_param.item_info = item
        scene_start_param.level_index = next_level

        local loadingScene = LoadingScene:create(2)
        loadingScene:load_game_scene_tournament_resource(scene_start_param)
        LayerManager:getInstance():clear_layer()
        cc.Director:getInstance():replaceScene(loadingScene)        

    end, cc.p(750, visible_size.height * 0.1))


    -- 解锁所有卡片
    local str_unlock_all_card = ResourceManager:getInstance():getTextStringByKey("TestScene_9")
    self:add_test_menu(str_unlock_all_card, function()

        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)

        local book_info_vetor = Book_Data:getInstance():get_book_info_vector()
        for i=1,#book_info_vetor do
            local book_info = book_info_vetor[i]
            Player:getInstance():set_player_book_is_get(book_info.book_id)
        end
        Player:getInstance():unlock_all_player_role()
        Player:getInstance():unlock_all_player_skin()
        
    end, cc.p(750, visible_size.height * 0.4))

    -- 解锁所有角色
    local str_unlock_all_role = ResourceManager:getInstance():getTextStringByKey("TestScene_6")
    self:add_test_menu(str_unlock_all_role, function()

        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        Player:getInstance():unlock_all_player_role()
    end, cc.p(250, visible_size.height * 0.3))

    -- 解锁所有皮肤
    local str_unlock_all_skin = ResourceManager:getInstance():getTextStringByKey("TestScene_7")
    self:add_test_menu(str_unlock_all_skin, function()

        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        Player:getInstance():unlock_all_player_skin()
    end, cc.p(250, visible_size.height * 0.2))

    -- 解锁所有关卡
    local str_unlock_all_mission = ResourceManager:getInstance():getTextStringByKey("TestScene_8")
    self:add_test_menu(str_unlock_all_mission, function()
        Player:getInstance():unlock_all_player_mission()
    end, cc.p(250, visible_size.height * 0.1))
end

function TestScene:add_test_menu(text, callback, pos, text_size)
    if text_size == nil then
        text_size = 60
    end
    local  label = cc.Label:createWithTTF(text, "font/zh_CN.TTF", text_size)
    local  item = cc.MenuItemLabel:create(label)
    item:registerScriptTapHandler(function()
        MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Click1_Audio"), false)
        if callback then
            callback()
        end
    end)

    local menu = cc.Menu:create()
    menu:addChild(item)
    menu:setPosition(pos)
    self:addChild(menu)
end

function TestScene:update_level()
    self.level_text:setString(string.format("%d", self.level_number))
end


return TestScene

