BagRewardWidget = class("BagRewardWidget", function() return cc.Layer:create() end)

function BagRewardWidget:ctor()
    self.is_touchable = false
    self.reward_widget = cc.CSLoader:createNode("bag_get_reward.csb")
    self:addChild(self.reward_widget, 2);
    self.reward_widget:setContentSize(cc.Director:getInstance():getVisibleSize())
    ccui.Helper:doLayout(self.reward_widget)

    local node = self.reward_widget:getChildByName("node")
    self.image_reward = node:getChildByName("image_reward")

    self.reward_action = cc.CSLoader:createTimeline("bag_get_reward.csb")
    self.reward_widget:runAction(self.reward_action)
    self.reward_action:gotoFrameAndPlay(33, 34, false)

    local function onFrameEvent(frame)
        if nil == frame then
            return
        end
        local str = frame:getEvent()
        if str == "bag_get_reward_end" then
            self.is_touchable = false
        end
    end
    self.reward_action:setFrameEventCallFunc(onFrameEvent)

    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        return self.is_touchable
    end, cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)

end

function BagRewardWidget:setTouchEnabled(flag)
    self.is_touchable = flag 
end

function BagRewardWidget:setItemTexture(res_key)
    self.image_reward:loadTexture(res_key)
end

function BagRewardWidget:runAction()
    self.reward_action:play("bag_get_reward", false)
end

return BagRewardWidget