SweepLightLayer = class("SweepLightLayer", function() return cc.Layer:create() end)

function SweepLightLayer:ctor()

end

function SweepLightLayer:generate_sweep(node, width, rotation, color, move_time, delay_time)
    local clippingNode = cc.ClippingNode:create()
    clippingNode:setStencil(node)
    clippingNode:setAlphaThreshold(0.4)
    clippingNode:setInverted(false)
    clippingNode:setPosition(cc.p(0, 0))
    self:addChild(clippingNode)

    local size = node:getContentSize()
    local r = (size.width + size.height)/2;
    local radius = - rotation/180 * math.pi

    local star_pos = cc.p(0, 0)
    local end_pos = cc.p(-2 * r * math.cos(radius) + star_pos.x, -2 *r * math.sin(radius) + star_pos.y)

    local line = cc.DrawNode:create()
    line:drawSegment(cc.p(r, -r), cc.p(r, r), width, color)
    line:setRotation(rotation)
    line:setPosition(star_pos)

    local moveTo = cc.MoveTo:create(move_time, end_pos)
    local moveBack = cc.MoveTo:create(0, star_pos)
    local sequence = cc.Sequence:create(moveTo, moveBack, cc.DelayTime:create(delay_time))
    line:runAction(cc.RepeatForever:create(sequence))

    clippingNode:addChild(line)
end

function SweepLightLayer:add_whiting(node)
    local clippingNode = cc.ClippingNode:create()
    clippingNode:setStencil(node)
    clippingNode:setAlphaThreshold(0.5)
    clippingNode:setInverted(false)
    clippingNode:setPosition(cc.p(0, 0))
    self:addChild(clippingNode)

    local size = node:getContentSize()
    local node1 = cc.DrawNode:create()
    local nodes = {cc.p(0, 0), cc.p(size.width, 0), cc.p(size.width, size.height), cc.p(0, size.height)}
    node1:drawPolygon(nodes, 4, cc.c4b(1, 1, 1, 0.3), 0, cc.c4b(1, 1, 1, 0.5))
    node1:setPosition(cc.p(-size.width/2, -size.height/2))
    clippingNode:addChild(node1)
end

function SweepLightLayer:clipping_node(node)
    local clippingNode = cc.ClippingNode:create()
    clippingNode:setStencil(node)
    clippingNode:setAlphaThreshold(0.5)
    clippingNode:setInverted(false)
    clippingNode:setPosition(cc.p(0, 0))
    self:addChild(clippingNode)

    local size = node:getContentSize()
    local skill_light = cc.Sprite:create("images/role_info/skill_light.png")
    skill_light:setPosition(cc.p(0, 0))
    clippingNode:addChild(skill_light)

end

return SweepLightLayer