require "core.Skin_Data"
Book_Data = class("Book_Data")

function Book_Data:ctor()
	self.book_info_vector = require "script/book_info.lua"
    table.sort(self.book_info_vector, function(a, b)
		local id1 = a.generate_mission_id
		local id2 = b.generate_mission_id
		return id1 < id2 
    end)

	self.book_info_vector_id = {}
	for k,v in pairs(self.book_info_vector) do
		self.book_info_vector_id[v.book_id] = v 
	end

	-- 品级底图
	self.card_rank = {
        [1] = "images/book/book_101.png",
        [2] = "images/book/book_102.png",
        [3] = "images/book/book_103.png",
    }
end

function Book_Data:get_book_info_vector()
	return self.book_info_vector
end

function Book_Data:get_book_info_by_id(book_id)
	return self.book_info_vector_id[book_id]
end

function Book_Data:get_rank_res_by_res(rank)
    return self.card_rank[rank]
end

function Book_Data:get_book_unlock_res()
	return "images/book/book_100.png"
end

function Book_Data:get_skin_info_by_book_id(book_id)
	local skin_info_vector = Skin_Data:getInstance():get_skin_info_vector()
	for i=1,#skin_info_vector do
		local unlock_condition_list = skin_info_vector[i].unlock_condition
		for k,v in pairs(unlock_condition_list) do
			if v == book_id then
				return skin_info_vector[i]
			end
		end
	end
	return nil
end

function Book_Data:getInstance()
	Book_Data.instance = Book_Data.instance or Book_Data:create()
	return Book_Data.instance
end

return Book_Data 