Daily_Task_Data = class("Daily_Task_Data")

function Daily_Task_Data:ctor()
	self.daily_task_info_vector = require "script/daily_task_info.lua"
	self.daily_task_info_vector_id = {}
	for k,v in pairs(self.daily_task_info_vector) do
		self.daily_task_info_vector_id[v.task_id] = v 
	end

	self:add_table_odds(self.daily_task_info_vector[1].reward_info)
	self:add_table_odds(self.daily_task_info_vector[3].target_type_info)
	self:add_table_odds(self.daily_task_info_vector[4].target_type_info)
	self:add_table_odds(self.daily_task_info_vector[12].target_type_info)
end

function Daily_Task_Data:get_daily_task_info_vector()
	return self.daily_task_info_vector
end

function Daily_Task_Data:get_daily_task_info_by_id(task_id)
	return self.daily_task_info_vector_id[task_id]
end

function Daily_Task_Data:get_target_name_by_id_and_target_type(task_id, target_type)
	
	for i,v in ipairs(self.daily_task_info_vector_id[task_id].target_type_info) do
		if v.target_type == target_type then
			return v.name
		end
	end
	return 
end

function Daily_Task_Data:getInstance()
	Daily_Task_Data.instance = Daily_Task_Data.instance or Daily_Task_Data:create()
	return Daily_Task_Data.instance
end

function Daily_Task_Data:add_table_odds(table)
	local odds = 0
	local count = get_table_length(table)
    for i=1,count do
        odds = odds + table[i].odds
        table[i].odds = odds
    end
end

return Daily_Task_Data 