LayerManager = class("LayerManager")

function LayerManager:ctor()
	self.layer_table = {}
end

function LayerManager:getInstance()
	LayerManager.instance = LayerManager.instance or LayerManager:create()
	return LayerManager.instance
end

function LayerManager:add_layer_to_scene(layer)
	self.layer_table[#self.layer_table + 1] = layer
	cc.Director:getInstance():getRunningScene():addChild(layer, 10)
end

function LayerManager:get_top_layer()
	if #self.layer_table == 0 then
		return nil
	end
	local layer = self.layer_table[#self.layer_table]
	return layer
end

function LayerManager:remove_top_layer()
	table.remove(self.layer_table, #self.layer_table)
end

function LayerManager:clear_layer()
	self.layer_table = {}
end

function LayerManager:get_top_layer_name()
	local layer = self:get_top_layer()
	if layer then
		return layer:getName()
	end
	return nil
end

return LayerManager 