require "core.Role_Data"
require "core.Skin_Data"
require "core.Book_Data"
require "core.Star_Reward_Data"
require "core.Section_Data"
require "core.Daily_Task_Data"
require "core.Achv_Data"
require "core.Invite_Reward_Data"

Player = class("Player")

function Player:ctor()

	-- 游戏存储数据
	self.player_base_data = {
		player_gold  = 0,             	--玩家的金币
		player_jewel = 0,             	--玩家的宝石
		player_power = 0,            	--玩家的体力
		player_left_recover_time = 1, 	--玩家的剩余恢复时间
		player_cur_role_id = "role_101",--玩家当前选择的游戏角色
		player_cur_skin_id = "skin_101",--玩家当前选择的角色皮肤
		player_head_id = "head_01",  	--玩家的头像
		player_nick_name = "小新",    	--玩家的昵称 
		player_card_unsee = 0,        	--玩家收集并且还未查看的卡片
		player_addition_max_power = 0, 	--玩家最大体力值增值
	}

	-- 游戏非存储数据
	self.player_max_power = 1           -- 玩家的最大体力值
	self.player_recover_time = 1        -- 玩家恢复一点体力的时间，second
	self.player_current_level = 1       -- 当前关卡值
	self.player_current_section = 1     -- 当前章节
	self.player_last_time = 1

	self.player_toplimit_power = 30 	--能提升到的最大体力上限值
	self.play_once_need_power = 3 		--开始一局需要的体力
	self.player_once_up_max_power = 3 	--每次提升体力上限的增值

	self.is_player_handle_in_game = false 	--玩家是否在游戏中对棋盘有所操作
	self.open_luckygift_level = 8		--解锁幸运大礼包的关卡

	-- 游戏玩家背包数据
	self.player_bag_info_vector = {}
	-- 游戏玩家角色数据
	self.player_role_info_vector = {}
	-- 游戏玩家皮肤数据
	self.player_skin_info_vector = {}
	-- 游戏玩家纪念册数据
	self.player_book_info_vector = {}
	-- 游戏玩家关卡数据
	self.player_mission_info_vector = {}
	-- 游戏玩家的章节数据
	self.player_section_info_vector = {}
	--游戏玩家的星星奖励数据
	self.player_star_reward_info_vector = {}

	--游戏玩家的周赛数据
	self.player_weekly_challenge_info = {}

	--游戏玩家的每日任务数据
	self.player_daily_task_info_vector = {}
	--游戏玩家的成就任务数据
	self.player_achv_info_vector = {}

	--游戏玩家的邀请奖励数据
    self.player_invite_reward_info_vector = {}
end

function Player:init_player_data()
	local init_player_data = GameKernel:getInstance():get_init_player_data()
	self.player_base_data.player_gold = init_player_data.player_gold
	self.player_base_data.player_jewel = init_player_data.player_jewel
	self.player_base_data.player_power = init_player_data.player_power
	self.player_base_data.player_left_recover_time = init_player_data.player_recover_time

	local player_last_time = cc.UserDefault:getInstance():getIntegerForKey("player_last_time", 1)
	self:init_player_last_time(player_last_time)

	self.player_base_data.player_cur_role_id = init_player_data.player_cur_role_id
	self.player_base_data.player_cur_skin_id = init_player_data.player_cur_skin_id
	self.player_base_data.player_head_id = init_player_data.player_head_id
	self.player_base_data.player_nick_name = init_player_data.player_nick_name
	self.player_base_data.player_card_unsee = init_player_data.player_card_unsee

	self.player_base_data.player_addition_max_power = init_player_data.player_addition_max_power 	--7.15
	--8.22
	self.player_base_data.today_is_sign = init_player_data.today_is_sign
	self.player_base_data.num_sign = init_player_data.num_sign
	self.player_base_data.last_sign_day = init_player_data.last_sign_day
	--8.22
	--9.2
	self.player_base_data.today_is_wheel = init_player_data.today_is_wheel
	self.player_base_data.num_wheel = init_player_data.num_wheel
	self.player_base_data.last_wheel_day = init_player_data.last_wheel_day

	self.player_base_data.num_view = init_player_data.num_view
	self.player_base_data.last_view_time = init_player_data.last_view_time
	--9.2
	self.player_base_data.is_buy_fish_gift = init_player_data.is_buy_fish_gift
	self.player_base_data.is_buy_springsale = init_player_data.is_buy_springsale
	self.player_base_data.is_buy_limit_gift = init_player_data.is_buy_limit_gift

	self.player_base_data.last_daily_task_day = init_player_data.last_daily_task_day
	--
	self.player_base_data.last_luckygift_day = init_player_data.last_luckygift_day
	self.player_base_data.num_luckygift_buy = init_player_data.num_luckygift_buy
	self.player_base_data.is_create_lucky_gift = init_player_data.is_create_lucky_gift
	self.player_base_data.continue_pass_stage = init_player_data.continue_pass_stage
	if self.player_base_data.springsale_start_time == nil then
		self.player_base_data.springsale_start_time = init_player_data.springsale_start_time
	end

	--炫耀次数
	self.player_base_data.num_share = 1
	self.player_base_data.last_share_day = 0

	self.player_max_power = init_player_data.player_max_power
	self.player_recover_time = init_player_data.player_recover_time
	self.player_current_level = 1
	self.player_current_section = 1

	-- 游戏玩家初始背包数据
	local init_bag_info_vector = init_player_data.init_bag_info_vector
	local bag_index = 1
	for i=1,#init_bag_info_vector do
		local player_bag_info
		--8.31限时道具
		if init_bag_info_vector[i].item_id == "item_501" or
		init_bag_info_vector[i].item_id == "item_502" or
		init_bag_info_vector[i].item_id == "item_503" or
		init_bag_info_vector[i].item_id == "item_504" then
			player_bag_info = {
				item_id = init_bag_info_vector[i].item_id, 
				item_num = init_bag_info_vector[i].item_num,
				limited_time_item_vector = {}
			}
		else
			player_bag_info = {
				item_id = init_bag_info_vector[i].item_id, 
				item_num = init_bag_info_vector[i].item_num,
			}
		end
		self.player_bag_info_vector[i] = player_bag_info
	end

	-- 游戏玩家初始角色数据
	local init_role_info_vector = init_player_data.init_role_info_vector
	local role_info_vector = Role_Data:getInstance():get_role_info_vector()
	for i=1,#role_info_vector do
		local player_role_info = {
			role_id = role_info_vector[i].role_id, 
			skin_id = init_role_info_vector[role_info_vector[i].role_id].skin_id,  --当前角色对应的皮肤
			role_level = init_role_info_vector[role_info_vector[i].role_id].role_level, 
			is_unlock =  init_role_info_vector[role_info_vector[i].role_id].is_unlock,
		}
		self.player_role_info_vector[i] = player_role_info
	end

	-- 游戏玩家的皮肤数据
	local init_skin_info_vector = init_player_data.init_skin_info_vector
	local skin_info_vector = Skin_Data:getInstance():get_skin_info_vector()
	for i=1,#skin_info_vector do
		local player_skin_info = {
			skin_id = skin_info_vector[i].skin_id,
			is_unlock = init_skin_info_vector[skin_info_vector[i].skin_id].is_unlock,
		}
		self.player_skin_info_vector[i] = player_skin_info
	end

	-- 游戏玩家的纪念册数据
	local book_info_vetor = Book_Data:getInstance():get_book_info_vector()
	for i=1,#book_info_vetor do
		local player_book_info = {
			book_id = book_info_vetor[i].book_id,
			is_get = false,
			is_see = false,
		}
		self.player_book_info_vector[i] = player_book_info
	end

	-- 游戏玩家的章节数据
	local section_info_vector = Section_Data:getInstance():get_section_info_vector()
	for i=1,#section_info_vector do
		local player_section_info = {
			section_id = section_info_vector[i].section_id,
			is_enable = false,
			is_animation = false,
		}
		if section_info_vector[i].section_id == 1 then
			player_section_info.is_enable = true
		end
		if UNLOCK_ALL_SECTION  == 1 then
			player_section_info.is_enable = true
		end
		self.player_section_info_vector[i] = player_section_info
	end

	-- 游戏玩家的关卡数据
	local mission_info_vector = Mission_Data:getInstance():get_mission_info_vector()
	for i=1,#mission_info_vector do
		local player_mission_info = {
			mission_id = mission_info_vector[i].mission_id,
			is_enable = false,
			is_pass = false,
			is_max_star = false,  --判断是否是首次获得最高星数，如果是设置为true,播放相应动画，然后设置为flase
			star_count = 0,
			pass_count = 0,
			is_move_action = true,  -- 关卡移动动画
			max_score = 0,			--最高分
			fail_times = 0,			--失败次数
			is_last_level_get = false, --是否率先通关
		}
		if i == 1 then
			player_mission_info.is_enable = true
		end

		if UNLOCK_ALL_MISSION  == 1 then
			player_mission_info.is_pass = true
			player_mission_info.is_enable = true
		end

		self.player_mission_info_vector[i] = player_mission_info
	end

	-- 游戏玩家的星星奖励数据
	local star_reward_info_vector = Star_Reward_Data:getInstance():get_star_reward_info_vector()
	for i=1,#star_reward_info_vector do
		local player_star_reward_info = {
			reward_id = star_reward_info_vector[i].reward_id,
			is_get = false,
		}
		self.player_star_reward_info_vector[i] = player_star_reward_info
	end

	--游戏玩家的周赛数据
	local today_reward_info_vector = require "script/today_reward_info.lua"
	local week_reward_info_vector = require "script/week_reward_info.lua"
	self.player_weekly_challenge_info.today_challenge_num = 2
	self.player_weekly_challenge_info.go_to_play_times = 0
	self.player_weekly_challenge_info.add_friend_times = 0
	self.player_weekly_challenge_info.conch_count = 0
	self.player_weekly_challenge_info.conch_once_num = 0
    self.player_weekly_challenge_info.share_pic_times=0
	self.player_weekly_challenge_info.lase_challenge_day = 0
	self.player_weekly_challenge_info.lase_challenge_week = 0

	local today_reward_info = {}
	for i=1,#today_reward_info_vector do
		today_reward_info[i] = { 
			today_reward_id = today_reward_info_vector[i].today_reward_id,
			is_get = false,
		}
	end
	self.player_weekly_challenge_info.today_reward_info = today_reward_info
	local week_reward_info = {}
	for i=1,#week_reward_info_vector do
		week_reward_info[i] = { 
			week_reward_id = week_reward_info_vector[i].week_reward_id,
			is_get = false,
		}
	end
	self.player_weekly_challenge_info.week_reward_info = week_reward_info

	-- 游戏玩家的每日任务数据
	local daily_task_info_vector = Daily_Task_Data:getInstance():get_daily_task_info_vector()
	for i=1,#daily_task_info_vector do
		local player_daily_task_info = {
			task_id = daily_task_info_vector[i].task_id,
			finish_count = 0,
			is_get = false,
			is_choose = false,
		}
		self.player_daily_task_info_vector[i] = player_daily_task_info
	end

	-- 游戏玩家的成就任务数据
	local achv_info_vector = Achv_Data:getInstance():get_achv_info_vector()
	for i=1,#achv_info_vector do
		local player_achv_info = {
			achv_id = achv_info_vector[i].achv_id,
			finish_count = 0,
			stage_info_vector = {},
		}
		for j=1,5 do
			local stage_info = {
				stage_id = j,
				is_get = false,
			}
		
			player_achv_info.stage_info_vector[j] = stage_info
		end
		self.player_achv_info_vector[i] = player_achv_info
	end

	-- 游戏玩家的邀请奖励数据
	local invite_reward_info_vector = Invite_Reward_Data:getInstance():get_invite_reward_vector()
	for i=1,#invite_reward_info_vector do
		local invite_reward_info = {
			invite_id = invite_reward_info_vector[i].invite_id,
			is_get = false,
		}
		self.player_invite_reward_info_vector[i] = invite_reward_info
	end
end

-- 玩家当前选择角色的数据
function Player:get_player_total_atk()
	local skin_id = self.player_base_data.player_cur_skin_id
	local role_id = self.player_base_data.player_cur_role_id
	local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id)
	local player_role_info = Player:getInstance():get_player_role_info_by_id(role_id)
	local role_level_info = Role_Data:getInstance():get_role_level_by_id_level(role_id, player_role_info.role_level)
	local total_atk = skin_info.init_atk + role_level_info.atk_add
	return total_atk
end

function Player:get_player_score_add()
	local skin_id = self.player_base_data.player_cur_skin_id
	local role_id = self.player_base_data.player_cur_role_id
	local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id)
	local player_role_info = Player:getInstance():get_player_role_info_by_id(role_id)
	local role_level_info = Role_Data:getInstance():get_role_level_by_id_level(role_id, player_role_info.role_level)
	local score_add = skin_info.init_score_add + role_level_info.score_add
	return score_add
end

function Player:get_player_gold_add()
	local skin_id = self.player_base_data.player_cur_skin_id
	local role_id = self.player_base_data.player_cur_role_id
	local skin_info = Skin_Data:getInstance():get_skin_info_by_id(skin_id)
	local player_role_info = Player:getInstance():get_player_role_info_by_id(role_id)
	local role_level_info = Role_Data:getInstance():get_role_level_by_id_level(role_id, player_role_info.role_level)
	local gold_add = skin_info.init_gold_add + role_level_info.gold_add
	return gold_add
end

-- 玩家基础数据
function Player:get_player_base_data()
	return self.player_base_data
end

function Player:set_player_base_data(player_base_data)
	self.player_base_data = player_base_data
end

--8.22 签到接口
function Player:get_today_is_sign()
	return self.player_base_data.today_is_sign
end

function Player:init_today_is_sign(today_is_sign)
	self.player_base_data.today_is_sign =  today_is_sign
end

function Player:set_today_is_sign(today_is_sign)
	self.player_base_data.today_is_sign =  today_is_sign
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_num_sign()
	return self.player_base_data.num_sign
end

function Player:init_num_sign(num_sign)
	self.player_base_data.num_sign =  num_sign
end

function Player:set_num_sign(num_sign)
	self.player_base_data.num_sign =  num_sign
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_last_sign_day()
	return self.player_base_data.last_sign_day
end

function Player:init_last_sign_day(last_sign_day)
	self.player_base_data.last_sign_day =  last_sign_day
end

function Player:set_last_sign_day(last_sign_day)
	self.player_base_data.last_sign_day =  last_sign_day
	GameKernel:getInstance():write_player_base_data()
end
--8.22

--9.2 幸运大转盘接口
function Player:get_today_is_wheel()
	return self.player_base_data.today_is_wheel
end

function Player:init_today_is_wheel(today_is_wheel)
	self.player_base_data.today_is_wheel =  today_is_wheel
end

function Player:set_today_is_wheel(today_is_wheel)
	self.player_base_data.today_is_wheel =  today_is_wheel
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_num_wheel()
	return self.player_base_data.num_wheel
end

function Player:init_num_wheel(num_wheel)
	self.player_base_data.num_wheel =  num_wheel
end

function Player:set_num_wheel(num_wheel)
	self.player_base_data.num_wheel =  num_wheel
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_last_wheel_day()
	return self.player_base_data.last_wheel_day
end

function Player:init_last_wheel_day(last_wheel_day)
	self.player_base_data.last_wheel_day =  last_wheel_day
end

function Player:set_last_wheel_day(last_wheel_day)
	self.player_base_data.last_wheel_day =  last_wheel_day
	GameKernel:getInstance():write_player_base_data()
end

--
function Player:get_num_view()
	return self.player_base_data.num_view
end

function Player:init_num_view(num_view)
	self.player_base_data.num_view =  num_view
end

function Player:set_num_view(num_view)
	self.player_base_data.num_view =  num_view
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_last_view_time()
	return self.player_base_data.last_view_time
end

function Player:init_last_view_time(last_view_time)
	self.player_base_data.last_view_time =  last_view_time
end

function Player:set_last_view_time(last_view_time)
	self.player_base_data.last_view_time =  last_view_time
	GameKernel:getInstance():write_player_base_data()
end
--9.2
function Player:get_is_buy_fish_gift()
	return self.player_base_data.is_buy_fish_gift
end

function Player:init_is_buy_fish_gift(is_buy_fish_gift)
	self.player_base_data.is_buy_fish_gift =  is_buy_fish_gift
end

function Player:set_is_buy_fish_gift(is_buy_fish_gift)
	self.player_base_data.is_buy_fish_gift =  is_buy_fish_gift
	GameKernel:getInstance():write_player_base_data()
end
--

function Player:get_is_buy_springsale()
	return self.player_base_data.is_buy_springsale
end

function Player:init_is_buy_springsale(is_buy_springsale)
	self.player_base_data.is_buy_springsale =  is_buy_springsale
end

function Player:set_is_buy_springsale(is_buy_springsale)
	self.player_base_data.is_buy_springsale =  is_buy_springsale
	GameKernel:getInstance():write_player_base_data()
end

--
function Player:get_is_buy_limit_gift()
	return self.player_base_data.is_buy_limit_gift
end

function Player:init_is_buy_limit_gift(is_buy_limit_gift)
	self.player_base_data.is_buy_limit_gift =  is_buy_limit_gift
end

function Player:set_is_buy_limit_gift(is_buy_limit_gift)
	self.player_base_data.is_buy_limit_gift =  is_buy_limit_gift
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_last_daily_task_day()
	return self.player_base_data.last_daily_task_day
end

function Player:init_last_daily_task_day(last_daily_task_day)
	self.player_base_data.last_daily_task_day =  last_daily_task_day
end

function Player:set_last_daily_task_day(last_daily_task_day)
	self.player_base_data.last_daily_task_day =  last_daily_task_day
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_is_create_lucky_gift()
	return self.player_base_data.is_create_lucky_gift
end

function Player:init_is_create_lucky_gift(is_create_lucky_gift)
	self.player_base_data.is_create_lucky_gift =  is_create_lucky_gift
end

function Player:set_is_create_lucky_gift(is_create_lucky_gift)
	self.player_base_data.is_create_lucky_gift =  is_create_lucky_gift
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_continue_pass_stage()
	return self.player_base_data.continue_pass_stage
end

function Player:init_continue_pass_stage(continue_pass_stage)
	self.player_base_data.continue_pass_stage =  continue_pass_stage
end

function Player:set_continue_pass_stage(continue_pass_stage)
	self.player_base_data.continue_pass_stage =  continue_pass_stage
	GameKernel:getInstance():write_player_base_data()
end

--
function Player:get_springsale_start_time()
	return self.player_base_data.springsale_start_time
end

function Player:init_springsale_start_time(springsale_start_time)
	self.player_base_data.springsale_start_time =  springsale_start_time
end

function Player:set_springsale_start_time(springsale_start_time)
	self.player_base_data.springsale_start_time =  springsale_start_time
	-- GameKernel:getInstance():write_player_base_data()
end

--幸运大礼包接口
function Player:get_last_luckygift_day()
	return self.player_base_data.last_luckygift_day
end
function Player:init_last_luckygift_day(last_luckygift_day)
	self.player_base_data.last_luckygift_day =  last_luckygift_day
end
function Player:set_last_luckygift_day(last_luckygift_day)
	self.player_base_data.last_luckygift_day =  last_luckygift_day
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_num_luckygift_buy()
	return self.player_base_data.num_luckygift_buy
end
function Player:init_num_luckygift_buy(num_luckygift_buy)
	self.player_base_data.num_luckygift_buy =  num_luckygift_buy
end
function Player:set_num_luckygift_buy(num_luckygift_buy)
	self.player_base_data.num_luckygift_buy =  num_luckygift_buy
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_num_luckygift_again()
	return self.player_base_data.num_luckygift_again
end
function Player:init_num_luckygift_again(num_luckygift_again)
	self.player_base_data.num_luckygift_again =  num_luckygift_again
end
function Player:set_num_luckygift_again(num_luckygift_again)
	self.player_base_data.num_luckygift_again =  num_luckygift_again
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_player_toplimit_power()
	return self.player_toplimit_power
end
function Player:get_play_once_need_power()
	return self.play_once_need_power
end
function Player:get_player_once_up_max_power()
	return self.player_once_up_max_power
end
function Player:set_is_player_handle_in_game(flag)
	self.is_player_handle_in_game = flag
end

function Player:get_is_player_handle_in_game()
	return self.is_player_handle_in_game
end

function Player:get_open_luckygift_level()
	return self.open_luckygift_level
end

-- 金币接口
function Player:get_player_gold()
	return self.player_base_data.player_gold
end

function Player:init_player_gold(player_gold)
	self.player_base_data.player_gold =  player_gold
end

function Player:set_player_gold(player_gold)
	self.player_base_data.player_gold =  player_gold
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_gold_change, "change")
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_gold(add_count)
	if add_count > 0 then
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Addcoin_Audio"), false)
		--成就任务事件发送
	    local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
	    event.param = {achv_id = "achv_06", finish_count = add_count, func = function() end }
	    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	else
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Coin_Audio"), false)
	end
	self.player_base_data.player_gold = math.max(0, self.player_base_data.player_gold + add_count)
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_gold_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_gold_without_change_top_bar(add_count)
	if add_count > 0 then
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Addcoin_Audio"), false)
		--成就任务事件发送
	    local event = cc.EventCustom:new(NotificationUtil.EventType.achv_event)
	    event.param = {achv_id = "achv_06", finish_count = add_count, func = function() end }
	    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	else
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Coin_Audio"), false)
	end
	self.player_base_data.player_gold = math.max(0, self.player_base_data.player_gold + add_count)
	GameKernel:getInstance():write_player_base_data()
end

-- 宝石接口
function Player:get_player_jewel()
	return self.player_base_data.player_jewel
end

function Player:init_player_jewel(player_jewel)
	self.player_base_data.player_jewel = player_jewel
end

function Player:set_player_jewel(player_jewel)
	self.player_base_data.player_jewel = player_jewel
end

function Player:add_player_jewel(add_jewel)
	if add_jewel > 0 then
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Diamonds_Audio"), false)
	end
	self.player_base_data.player_jewel = math.max(0, self.player_base_data.player_jewel + add_jewel)
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_jewel_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_jewel_without_change_top_bar(add_jewel)
	if add_jewel > 0 then
		MusicManager:getInstance().play_effect(ResourceManager:getInstance():getAudioPathByKey("Diamonds_Audio"), false)
	end
	self.player_base_data.player_jewel = math.max(0, self.player_base_data.player_jewel + add_jewel)
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_currency_by_id(item_id, item_num)
	if item_id == "item_02" then
		--金币动画
        local size = cc.Director:getInstance():getVisibleSize()
        local collect = ResourceManager:getInstance():getSpineByKey("SPINE_COLLECT", 1.0)
        collect:setPosition(cc.p(size.width / 2, size.height / 2))
        collect:setAnimation(0, "shop_gold", false)
        collect:setTimeScale(0.6)
        cc.Director:getInstance():getRunningScene():addChild(collect,999)
        cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(17 * 0.016*3), cc.CallFunc:create(function()
            collect:removeFromParent()
            self:add_player_gold(item_num)
        end)))
	elseif item_id == "item_03" then
		--钻石动画
        local size = cc.Director:getInstance():getVisibleSize()
        local collect = ResourceManager:getInstance():getSpineByKey("SPINE_COLLECT", 1.0)
        collect:setPosition(cc.p(size.width / 2, size.height / 2))
        collect:setAnimation(0, "shop_jewel", false)
        collect:setTimeScale(0.6)
        cc.Director:getInstance():getRunningScene():addChild(collect,999)
        cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(17 * 0.016*3), cc.CallFunc:create(function()
            collect:removeFromParent()
            self:add_player_jewel(item_num)
        end)))
	end
end

-- 玩家体力接口
function Player:get_player_power()
	return self.player_base_data.player_power
end

function Player:init_player_power(player_power)
	self.player_base_data.player_power = player_power
end

function Player:set_player_power(player_power)
	self.player_base_data.player_power = player_power
	--7.19
	if self:is_full_power() then
		local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
		if is_Unlimit_Power then
			
		else
			self:set_player_left_cover_time(self:get_player_recover_time())
		end
		
	end
	--7.19
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_power_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_power(add_power)
	self.player_base_data.player_power = math.max(0, self.player_base_data.player_power + add_power)

	--7.15
	if self.player_base_data.player_power>self:get_player_max_power() then
		self.player_base_data.player_power = self:get_player_max_power()
	end
	--7.15
	local is_Unlimit_Power = cc.UserDefault:getInstance():getBoolForKey("is_Unlimit_Power", false)
	if self:is_full_power() and add_power < 0 then
		if is_Unlimit_Power then
			
		else
			self:set_player_left_cover_time(self:get_player_recover_time())
		end
		
	end
	if self:is_full_power() then
		if is_Unlimit_Power then
			
		else
			self:set_player_left_cover_time(self:get_player_recover_time())
		end
		
	end
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_power_change)
	GameKernel:getInstance():write_player_base_data()

end

-- 玩家恢复时间接口
function Player:set_player_recover_time(recover_time)
	self.player_recover_time = recover_time
end

function Player:get_player_recover_time()
	return self.player_recover_time
end

-- 剩余回复时间
function Player:get_player_left_recover_time()
	return self.player_base_data.player_left_recover_time
end

function Player:init_player_left_recover_time(left_time)
	self.player_base_data.player_left_recover_time = left_time
end

function Player:set_player_left_cover_time(left_time)
	self.player_base_data.player_left_recover_time = left_time
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_time_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:add_player_left_cover_time(add_time)
	self.player_base_data.player_left_recover_time = self.player_base_data.player_left_recover_time + add_time
	if self.player_base_data.player_left_recover_time <= 0 then
		self:add_player_left_cover_time(self:get_player_recover_time())
	end
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_time_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_player_last_time()
	return self.player_last_time
end

function Player:init_player_last_time(last_time)
	self.player_last_time = last_time
end

function Player:set_player_last_time(last_time)
	self.player_last_time = last_time
	cc.UserDefault:getInstance():setIntegerForKey("player_last_time", self.player_last_time)
end

function Player:set_player_max_power(max_power)
	--self.player_max_power = max_power
	--7.15
	local player_addition_max_power = max_power - self:get_player_max_power()
	self:set_player_addition_max_power(self:get_player_addition_max_power() + player_addition_max_power)
	--7.15
end

function Player:get_player_max_power()
	return self.player_max_power + self.player_base_data.player_addition_max_power 	--7.15
	--return self.player_max_power
end

function Player:is_full_power()
	if self.player_base_data.player_power >= self:get_player_max_power() then
		return true
	else
		return false
	end
end

-- 玩家当前选择的角色和皮肤
function Player:init_player_cur_skin_id(skin_id)
	self.player_base_data.player_cur_skin_id = skin_id
end

function Player:set_player_cur_skin_id(skin_id)
	self.player_base_data.player_cur_skin_id = skin_id
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_skin_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_player_cur_skin_id()
	return self.player_base_data.player_cur_skin_id
end

function Player:init_player_cur_role_id(role_id)
	self.player_base_data.player_cur_role_id = role_id
end

function Player:set_player_cur_role_id(role_id)
	self.player_base_data.player_cur_role_id = role_id
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_role_change)
	GameKernel:getInstance():write_player_base_data()
end

function Player:get_player_cur_role_id()
	return self.player_base_data.player_cur_role_id
end

function Player:init_player_head_id(head_id)
	self.player_base_data.player_head_id = head_id
end

function Player:get_player_head_id()
	return self.player_base_data.player_head_id
end

function Player:set_player_head_id(head_id)
	self.player_base_data.player_head_id = head_id
	GameKernel:getInstance():write_player_base_data()
end

function Player:init_player_nick_name(nick_name)
	self.player_base_data.player_nick_name = nick_name
end

function Player:get_player_nick_name()
	return self.player_base_data.player_nick_name
end

function Player:set_player_nick_name(nick_name)
	self.player_base_data.player_nick_name = nick_name
	GameKernel:getInstance():write_player_base_data()
end


function Player:init_player_card_unsee(card_unsee)
	self.player_base_data.player_card_unsee = card_unsee
end

function Player:set_player_card_unsee(card_unsee)
	self.player_base_data.player_card_unsee = card_unsee
	GameKernel:getInstance():write_player_base_data()
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_card_get)
	--mm
end

function Player:add_player_card_unsee(count)
	self.player_base_data.player_card_unsee = self.player_base_data.player_card_unsee + count
	GameKernel:getInstance():write_player_base_data()
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_card_get)
end

function Player:get_player_card_unsee()
	return self.player_base_data.player_card_unsee
end

function Player:init_player_addition_max_power(player_addition_max_power)
	self.player_base_data.player_addition_max_power = player_addition_max_power
end

function Player:set_player_addition_max_power(player_addition_max_power)
	self.player_base_data.player_addition_max_power = player_addition_max_power
	GameKernel:getInstance():write_player_base_data()
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_power_change)
end

function Player:get_player_addition_max_power()
	return self.player_base_data.player_addition_max_power
end

--炫耀次数
function Player:get_num_share()
	return self.player_base_data.num_share
end

function Player:set_num_share(num_share)
	self.player_base_data.num_share =  num_share
	GameKernel:getInstance():write_player_base_data()
end
-- last_share_day
function Player:get_last_share_day()
	return self.player_base_data.last_share_day
end

function Player:set_last_share_day(last_share_day)
	self.player_base_data.last_share_day =  last_share_day
	GameKernel:getInstance():write_player_base_data()
end


-- 玩家选择的当前关卡
function Player:get_player_current_level()
	return self.player_current_level
end

function Player:set_player_current_level(player_current_level)
	self.player_current_level = player_current_level
end

function Player:get_player_next_level()
	-- 获取下一关，当到达该章节的最后一关时，换到下一章的第一关，到了所有的最后时，没有下一关
	local player_current_level = self.player_current_level
	if Mission_Data:getInstance():is_last_level(player_current_level) then
		return self.player_current_level
	else
		local mission_info = Mission_Data:getInstance():get_next_mission_info_by_level(player_current_level)
		return mission_info.mission_level
	end
end

function Player:get_player_current_section()
	return self.player_current_section
end

function Player:set_player_current_section(player_current_section)
	self.player_current_section = player_current_section
end

function Player:get_section_star(mission_section)
	local star = 0
	for k,v in pairs(self.player_mission_info_vector) do
		if v.mission_section == mission_section then
			star = star + self:get_player_mission_info_by_id(section.mission_id).star_count
		end
	end
	return star
end

-- 玩家背包数据
function Player:get_player_bag_info_vector()
	return self.player_bag_info_vector
end

function Player:get_player_bag_info_show_vector()
	local player_bag_info_show_vector = {}
	local index = 1
	for i=1,#self.player_bag_info_vector do
		local bag_info = Bag_Data:getInstance():get_bag_info_by_id(self.player_bag_info_vector[i].item_id)
		if bag_info.is_show and self.player_bag_info_vector[i].item_num > 0  then
			player_bag_info_show_vector[index] = self.player_bag_info_vector[i]
			index = index + 1
		end
	end
	return player_bag_info_show_vector
end

--8.31获取限时道具vector
function Player:get_player_bag_info_limited_time_vector()
	local player_bag_info_limited_time_vector = {}
	local index = 1
	for i=1,#self.player_bag_info_vector do
		local bag_info = Bag_Data:getInstance():get_bag_info_by_id(self.player_bag_info_vector[i].item_id)
		if bag_info.is_limited_time and self.player_bag_info_vector[i].item_num > 0  then
			player_bag_info_limited_time_vector[index] = self.player_bag_info_vector[i]
			index = index + 1
		end
	end
	return player_bag_info_limited_time_vector
end	

function Player:set_player_bag_info_vector(player_bag_info_vector)
	self.player_bag_info_vector = player_bag_info_vector
end

function Player:get_player_bag_info_by_id(item_id)
	for k,v in pairs(self.player_bag_info_vector) do
		if v.item_id == item_id then
			return v
		end
	end
	return nil
end

function Player:set_player_bag_info_by_id(item_id, player_bag_info)
	for i=1,#self.player_bag_info_vector do
		if self.player_bag_info_vector[i].item_id == item_id then
			self.player_bag_info_vector[i] = player_bag_info
		end
	end
end

function Player:add_player_bag_info_by_id(item_id, item_num)
	if item_id == "item_01" then
		self:add_player_power(item_num)
	elseif item_id == "item_02" then
		--金币动画
        local size = cc.Director:getInstance():getVisibleSize()
        local collect = ResourceManager:getInstance():getSpineByKey("SPINE_COLLECT", 1.0)
        collect:setPosition(cc.p(size.width / 2, size.height / 2))
        collect:setAnimation(0, "main_gold", false)
        collect:setTimeScale(0.6)
        cc.Director:getInstance():getRunningScene():addChild(collect,999)
        cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(17 * 0.016*3), cc.CallFunc:create(function()
            collect:removeFromParent()
            self:add_player_gold(item_num)
        end)))    
        -- 		
	elseif item_id == "item_03" then
		--钻石动画
        local size = cc.Director:getInstance():getVisibleSize()
        local collect = ResourceManager:getInstance():getSpineByKey("SPINE_COLLECT", 1.0)
        collect:setPosition(cc.p(size.width / 2, size.height / 2))
        collect:setAnimation(0, "main_jewel", false)
        collect:setTimeScale(0.6)
        cc.Director:getInstance():getRunningScene():addChild(collect,999)
        cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(17 * 0.016*3), cc.CallFunc:create(function()
            collect:removeFromParent()
            self:add_player_jewel(item_num)
        end)))    
        --       		
	else		
		for i=1,#self.player_bag_info_vector do
			if self.player_bag_info_vector[i].item_id == item_id  then
				--限时道具
				if self.player_bag_info_vector[i].limited_time_item_vector then
					local now_time = os.time()
					table.insert(self.player_bag_info_vector[i].limited_time_item_vector, {num = item_num,get_time = now_time,})
					--table.remove(self.player_bag_info_vector[i].limited_time_item_vector,1)
					self.player_bag_info_vector[i].item_num = 0
					for k,v in pairs(self.player_bag_info_vector[i].limited_time_item_vector) do
						self.player_bag_info_vector[i].item_num = self.player_bag_info_vector[i].item_num + v.num
					end
				else
					self.player_bag_info_vector[i].item_num = self.player_bag_info_vector[i].item_num + item_num
				end
				
			end
		end
		cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_item_change)
		GameKernel:getInstance():write_player_bag_data()
	end
end

function Player:use_player_bag_info_by_id(item_id, item_num)
	for i=1,#self.player_bag_info_vector do
		if self.player_bag_info_vector[i].item_id == item_id  then
			--8.31限时道具
			if self.player_bag_info_vector[i].limited_time_item_vector then
				self.player_bag_info_vector[i].limited_time_item_vector[1].num = self.player_bag_info_vector[i].limited_time_item_vector[1].num + item_num
				if self.player_bag_info_vector[i].limited_time_item_vector[1].num <=0 then
					table.remove(self.player_bag_info_vector[i].limited_time_item_vector,1)
				end
				self.player_bag_info_vector[i].item_num = 0
				for k,v in pairs(self.player_bag_info_vector[i].limited_time_item_vector) do
					self.player_bag_info_vector[i].item_num = self.player_bag_info_vector[i].item_num + v.num
				end
			else
				self.player_bag_info_vector[i].item_num = self.player_bag_info_vector[i].item_num + item_num

				local bag_info = Bag_Data:getInstance():get_bag_info_by_id(item_id)
				local add_item_vector = bag_info.add_item
				for k,v in pairs(add_item_vector) do
					if v[1] == "item_01" then
						if item_id == "item_103" then
							Player:getInstance():set_player_power(self:get_player_max_power())
						else
							Player:getInstance():add_player_power(v[2] * (-item_num))
						end
					end
				end
			end
		end
	end
	GameKernel:getInstance():write_player_bag_data()
end

-- 玩家角色数据
function Player:get_player_role_info_vector( )
	return self.player_role_info_vector
end

function Player:set_player_role_info_vector(player_role_info_vector)
	self.player_role_info_vector = player_role_info_vector
end

function Player:get_player_current_role_score_bonus()

	local current_role_id = self:get_player_cur_role_id()

	for i=1,#self.player_role_info_vector do

		if self.player_role_info_vector[i].role_id == current_role_id then

			local role_level = self.player_role_info_vector[i].role_level
			local role_info = Role_Data:getInstance():get_role_level_by_id_level(current_role_id, role_level)
			local skin_id = self.player_role_info_vector[i].skin_id
			local skin_info = Skin_Data:getInstance():get_skin_info_by_id(current_skin_id)

			return skin_info.init_score_add + role_info.score_add

		end

	end

end

function Player:get_player_current_role_gold_bonus()

	local current_role_id = self:get_player_cur_role_id()

	for i=1,#self.player_role_info_vector do

		if self.player_role_info_vector[i].role_id == current_role_id then

			local role_level = self.player_role_info_vector[i].role_level
			local role_info = Role_Data:getInstance():get_role_level_by_id_level(current_role_id, role_level)
			local skin_id = self.player_role_info_vector[i].skin_id
			local skin_info = Skin_Data:getInstance():get_skin_info_by_id(current_skin_id)

			return skin_info.init_gold_add + role_info.gold_add

		end

	end

end

function Player:get_player_current_role_atk_bonus()

	local current_role_id = self:get_player_cur_role_id()

	for i=1,#self.player_role_info_vector do

		if self.player_role_info_vector[i].role_id == current_role_id then

			local role_level = self.player_role_info_vector[i].role_level
			local role_info = Role_Data:getInstance():get_role_level_by_id_level(current_role_id, role_level)
			local skin_id = self.player_role_info_vector[i].skin_id
			local skin_info = Skin_Data:getInstance():get_skin_info_by_id(current_skin_id)

			return skin_info.init_atk + role_info.atk_add

		end

	end

end

function Player:set_player_role_info_by_id(role_id, player_role_info)
	for i=1,#self.player_role_info_vector do
		if self.player_role_info_vector[i].role_id == role_id then
			self.player_role_info_vector[i] = player_role_info
		end
	end
end

function Player:get_player_role_info_by_id(role_id)
	for k,v in pairs(self.player_role_info_vector) do
		if v.role_id == role_id then
			return v
		end
	end
	return nil
end

function Player:upgrade_player_role(role_id, add_level)
	for i=1,#self.player_role_info_vector do
		if self.player_role_info_vector[i].role_id == role_id then
			self.player_role_info_vector[i].role_level = self.player_role_info_vector[i].role_level + add_level
		end
	end
	GameKernel:getInstance():write_player_role_data()
end

function Player:set_player_role_skin_map(role_id, skin_id)
		for i=1,#self.player_role_info_vector do
		if self.player_role_info_vector[i].role_id == role_id then
			self.player_role_info_vector[i].skin_id  = skin_id
		end
	end
	GameKernel:getInstance():write_player_role_data()
end

function Player:set_player_role_unlock(role_id)
		for i=1,#self.player_role_info_vector do
		if self.player_role_info_vector[i].role_id == role_id then
			self.player_role_info_vector[i].is_unlock  = true
		end
	end
	GameKernel:getInstance():write_player_role_data()
end

function Player:unlock_all_player_role()
	for i=1,#self.player_role_info_vector do
		self.player_role_info_vector[i].is_unlock  = true
		local skin_id = Role_Data:getInstance():get_first_skin_id_by_role_id(self.player_role_info_vector[i].role_id)
		self:set_player_skin_info_unlock(skin_id)
	end
	GameKernel:getInstance():write_player_role_data()
end

function Player:get_player_skill_level(role_id)
	print(role_id)
	local player_role_info = self:get_player_role_info_by_id(role_id)
	local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
	local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
	local level = 0
	for i=1,#skill_info.up_level do
		if skill_info.up_level[i] <= player_role_info.role_level then
			level = level + 1
		end
	end
	return level
end

function Player:is_player_up_skill_level(role_id)
	local player_role_info = self:get_player_role_info_by_id(role_id)
	local role_info = Role_Data:getInstance():get_role_info_by_id(role_id)
	local skill_info = Skill_Data:getInstance():get_skill_info_by_id(role_info.skill_id)
	for i=1,#skill_info.up_level do
		if skill_info.up_level[i] == player_role_info.role_level then
			return true
		end
	end
	return false
end

-- 玩家皮肤数据
function Player:get_player_skin_info_vector( )
	return self.player_skin_info_vector
end

function Player:set_player_skin_info_vector(player_skin_info_vector)
	self.player_skin_info_vector = player_skin_info_vector
end

function Player:set_player_skin_info_by_id(skin_id, player_skin_info)
	for i=1,#self.player_skin_info_vector do
		if self.player_skin_info_vector[i].skin_id == skin_id then
			self.player_skin_info_vector[i] = player_skin_info
		end
	end
end

function Player:get_player_skin_info_by_id(skin_id)
	for k,v in pairs(self.player_skin_info_vector) do
		if v.skin_id == skin_id then
			return v
		end
	end
	return nil
end

function Player:set_player_skin_info_unlock(skin_id)
	for i=1,#self.player_skin_info_vector do
		if self.player_skin_info_vector[i].skin_id == skin_id then
			self.player_skin_info_vector[i].is_unlock = true
		end
	end
	GameKernel:getInstance():write_player_skin_data()
end

function Player:unlock_all_player_skin()
	for i=1,#self.player_skin_info_vector do
		self.player_skin_info_vector[i].is_unlock = true
	end
	GameKernel:getInstance():write_player_skin_data()
end

-- 玩家的纪念册数据
function Player:get_player_book_info_vector()
	return self.player_book_info_vector
end

function Player:set_player_book_info_vector(player_book_info_vector)
	self.player_book_info_vector = player_book_info_vector
end

function Player:get_player_book_info_by_id(book_id)
		for k,v in pairs(self.player_book_info_vector) do
		if v.book_id == book_id then
			return v
		end
	end
	return nil
end

function Player:set_player_book_info_by_id(book_id, player_book_info)
	for i=1,#self.player_book_info_vector do
		if self.player_book_info_vector[i].book_id == book_id then
			self.player_book_info_vector[i] = player_book_info
		end
	end
end

function Player:set_player_book_is_get(book_id)
	for i=1,#self.player_book_info_vector do
		if self.player_book_info_vector[i].book_id == book_id then
			self.player_book_info_vector[i].is_get = true
			--self.player_book_info_vector[i].is_see = false
			self:add_player_card_unsee(1)
		end
	end
	GameKernel:getInstance():write_player_book_data()
end

-- 玩家章节数据
function Player:get_player_section_info_vector()
	return self.player_section_info_vector
end

function Player:set_player_section_info_vector(player_section_info_vector)
	self.player_section_info_vector = player_section_info_vector
end

function Player:get_player_section_info_by_id(section_id)
	for i=1,#self.player_section_info_vector do
		if self.player_section_info_vector[i].section_id == section_id then
			return self.player_section_info_vector[i]
		end
	end
end

function Player:set_player_section_info_by_id(section_id, player_section_info)
	for i=1,#self.player_section_info_vector do
		if self.player_section_info_vector[i].section_id == section_id then
			self.player_section_info_vector[i] = player_section_info
		end
	end
end

function Player:set_player_section_is_enable(section_id)
	for i=1,#self.player_section_info_vector do
		if self.player_section_info_vector[i].section_id == section_id then
			if self.player_section_info_vector[i].is_enable == false then
				self.player_section_info_vector[i].is_enable = true
				self:set_player_section_is_animation(section_id, true)
			end
		end
	end
end

function Player:set_player_section_is_animation(section_id, flag)
	for i=1,#self.player_section_info_vector do
		if self.player_section_info_vector[i].section_id == section_id then
			self.player_section_info_vector[i].is_animation = flag
		end
	end
	GameKernel:getInstance():write_player_section_data()
end

function Player:get_player_newest_section()
	local section_id = self.player_section_info_vector[1].section_id
	for i=1,#self.player_section_info_vector do
		if self.player_section_info_vector[i].is_enable then
			if self.player_section_info_vector[i].section_id > section_id then
				section_id = self.player_section_info_vector[i].section_id
			end
		end
	end
	return section_id
end

-- 玩家关卡数据
function Player:get_player_mission_info_vector()
	return self.player_mission_info_vector
end

function Player:set_player_mission_info_vector(player_mission_info_vector)
	self.player_mission_info_vector = player_mission_info_vector
end

function Player:get_player_mission_info_by_id(mission_id)
	-- local mission_info = Mission_Data:getInstance():get_mission_info_by_id(mission_id)
	-- if mission_info.mission_level<=0 then
	-- 	for k,v in pairs(self.player_mission_info_vector) do
	-- 		if v.mission_id == mission_id then
	-- 			return v
	-- 		end
	-- 	end
	-- end

	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			return self.player_mission_info_vector[i]
		end
	end
	return nil
end

function Player:set_player_mission_info_by_id(mission_id, player_mission_info)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i] = player_mission_info
		end
	end
end

function Player:set_player_mission_star_by_id(mission_id, star_count)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			if star_count > self.player_mission_info_vector[i].star_count then
				self:set_player_mission_is_max_star(mission_id, true)
				cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_star_get)
			end
			self.player_mission_info_vector[i].star_count = math.max(self.player_mission_info_vector[i].star_count, star_count)
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:get_player_mission_star_by_id(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			return self.player_mission_info_vector[i].star_count
		end
	end
	return nil
end

function Player:set_player_mission_score_by_id(mission_id, score)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			if score > self.player_mission_info_vector[i].max_score then
				self.player_mission_info_vector[i].max_score = math.max(self.player_mission_info_vector[i].max_score, score)
				GameKernel:getInstance():write_player_mission_data()
			end
		end
	end
end

function Player:set_player_mission_is_pass(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].is_pass = true
			if self.player_mission_info_vector[i+1] then
				self.player_mission_info_vector[i+1].is_enable = true
				local mission_info = Mission_Data:getInstance():get_mission_info_by_id(self.player_mission_info_vector[i+1].mission_id) 
				local section_id = mission_info.mission_section
				if self:get_player_section_info_by_id(section_id) then
					if self:get_player_section_info_by_id(section_id).is_enable == false then
						self:set_player_section_is_enable(section_id)
					end
				end
			end
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:unlock_all_player_mission()
	for i=1,#self.player_mission_info_vector do
		self.player_mission_info_vector[i].is_pass = true
		self.player_mission_info_vector[i].is_enable = true
		self.player_mission_info_vector[i].is_animation = false
		self.player_mission_info_vector[i].is_move_action = false 	--8.24
	end
	GameKernel:getInstance():write_player_mission_data()

	for i=1,#self.player_section_info_vector do
		self.player_section_info_vector[i].is_enable = true
	end
	GameKernel:getInstance():write_player_section_data()
end

function Player:set_player_mission_is_max_star(mission_id, flag)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].is_max_star = flag
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:get_player_star_count()
	local star_count = 0
	for i=1,#self.player_mission_info_vector do
		star_count = star_count + self.player_mission_info_vector[i].star_count
	end
	return star_count
end

function Player:get_player_section_star_count_by_section(section_id)
	local star_count = 0
	for i=1,#self.player_mission_info_vector do
		local mission_info = Mission_Data:getInstance():get_mission_info_by_id(self.player_mission_info_vector[i].mission_id)
		if mission_info.mission_section == section_id then
			star_count = star_count + self.player_mission_info_vector[i].star_count
		end
	end
	return star_count
end

function Player:get_player_mission_pass_count(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			return self.player_mission_info_vector[i].pass_count
		end
	end
end

function Player:add_player_mission_pass_count(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].pass_count = self.player_mission_info_vector[i].pass_count + 1
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:set_player_mission_move_action(mission_id, flag)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].is_move_action = flag
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:get_player_newest_mission_id()
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].is_enable and self.player_mission_info_vector[i].is_pass == false then
			return self.player_mission_info_vector[i].mission_id
		end
	end
	return self.player_mission_info_vector[#self.player_mission_info_vector].mission_id
end

function Player:get_player_pass_mission_count()
	local count = 0
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].is_pass then
			count = count + 1
		end
	end
	return count
end
--
function Player:get_player_mission_fail_times(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			return self.player_mission_info_vector[i].fail_times
		end
	end
end

function Player:set_player_mission_fail_times(mission_id, fail_times)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].fail_times = fail_times
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:add_player_mission_fail_times(mission_id)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].fail_times = self.player_mission_info_vector[i].fail_times + 1
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

function Player:set_player_mission_is_last_level_get(mission_id, is_last_level_get)
	for i=1,#self.player_mission_info_vector do
		if self.player_mission_info_vector[i].mission_id == mission_id then
			self.player_mission_info_vector[i].is_last_level_get = is_last_level_get
		end
	end
	GameKernel:getInstance():write_player_mission_data()
end

-- 星星奖励数据
function Player:get_player_star_reward_info_vector()
	return self.player_star_reward_info_vector
end

function Player:set_player_star_reward_info_vector(player_star_reward_info_vector)
	self.player_star_reward_info_vector = player_star_reward_info_vector
end

function Player:get_player_star_reward_info_by_id(reward_id)
	for i=1, #self.player_star_reward_info_vector do
		if self.player_star_reward_info_vector[i].reward_id == reward_id then
			return self.player_star_reward_info_vector[i]
		end
	end
end

function Player:set_player_star_reward_info_by_id(reward_id, player_star_reward_info)
	for i=1, #self.player_star_reward_info_vector do
		if self.player_star_reward_info_vector[i].reward_id == reward_id then
			self.player_star_reward_info_vector[i] = player_star_reward_info
		end
	end
end

function Player:set_player_star_reward_info_is_get(reward_id)
	for i=1, #self.player_star_reward_info_vector do
		if self.player_star_reward_info_vector[i].reward_id == reward_id then
			self.player_star_reward_info_vector[i].is_get = true
		end
	end
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.player_star_get)
	GameKernel:getInstance():write_player_star_reward_data()
end

function Player:get_unget_player_star_reward_info()
	for i=1, #self.player_star_reward_info_vector do
		if self.player_star_reward_info_vector[i].is_get == false then
			return self.player_star_reward_info_vector[i]
		end
	end
end

function Player:get_count_star_reward_can_get()
	local count = 0
	local player_star_count = self:get_player_star_count()
	for i=1, #self.player_star_reward_info_vector do
		if self.player_star_reward_info_vector[i].is_get == false then
			local reward_id = self.player_star_reward_info_vector[i].reward_id
			local star_reward_info = Star_Reward_Data:getInstance():get_star_reward_info_by_id(reward_id)
			if player_star_count >= star_reward_info.star_count then
				count = count + 1
			end
		end
	end

	return count
end

--周赛接口
function Player:get_player_weekly_challenge_info()
	return self.player_weekly_challenge_info
end

function Player:set_player_weekly_challenge_info(player_weekly_challenge_info)
	self.player_weekly_challenge_info = player_weekly_challenge_info
end

function Player:set_player_weekly_challenge_today_challenge_num(today_challenge_num)
	self.player_weekly_challenge_info.today_challenge_num = today_challenge_num
	cc.Director:getInstance():getEventDispatcher():dispatchCustomEvent(NotificationUtil.EventType.weekgame_image_mark_event)
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_today_challenge_num()
	return self.player_weekly_challenge_info.today_challenge_num
end

function Player:set_player_weekly_challenge_go_to_play_times(go_to_play_times)
	self.player_weekly_challenge_info.go_to_play_times = go_to_play_times
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_go_to_play_times()
	return self.player_weekly_challenge_info.go_to_play_times
end


function Player:set_player_weekly_challenge_share_pic_times(share_pic_times)
	self.player_weekly_challenge_info.share_pic_times = share_pic_times
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_share_pic_times()
	return self.player_weekly_challenge_info.share_pic_times
end


function Player:set_player_weekly_challenge_add_friend_times(add_friend_times)
	self.player_weekly_challenge_info.add_friend_times = add_friend_times
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_add_friend_times()
	return self.player_weekly_challenge_info.add_friend_times
end

function Player:set_player_weekly_challenge_conch_count(conch_count)
	self.player_weekly_challenge_info.conch_count = conch_count
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_conch_count()
	return self.player_weekly_challenge_info.conch_count
end

function Player:add_player_weekly_challenge_conch_count(count)
	self.player_weekly_challenge_info.conch_count = self.player_weekly_challenge_info.conch_count + count
	GameKernel:getInstance():write_player_weekly_challenge_data()
end

function Player:set_player_weekly_challenge_conch_once_num(conch_once_num)
	self.player_weekly_challenge_info.conch_once_num = conch_once_num
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:add_player_weekly_challenge_conch_once_num(conch_once_num)
	self.player_weekly_challenge_info.conch_once_num = self.player_weekly_challenge_info.conch_once_num + conch_once_num
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_conch_once_num()
	return self.player_weekly_challenge_info.conch_once_num
end

function Player:set_player_weekly_challenge_lase_challenge_day(lase_challenge_day)
	self.player_weekly_challenge_info.lase_challenge_day = lase_challenge_day
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_lase_challenge_day()
	return self.player_weekly_challenge_info.lase_challenge_day
end

function Player:set_player_weekly_challenge_lase_challenge_week(lase_challenge_week)
	self.player_weekly_challenge_info.lase_challenge_week = lase_challenge_week
	GameKernel:getInstance():write_player_weekly_challenge_data()
end
function Player:get_player_weekly_challenge_lase_challenge_week()
	return self.player_weekly_challenge_info.lase_challenge_week
end

function Player:set_player_weekly_challenge_today_reward_info_is_get_by_id(today_reward_id, flag)
	for i=1, #self.player_weekly_challenge_info.today_reward_info do
		if self.player_weekly_challenge_info.today_reward_info[i].today_reward_id == today_reward_id then
			self.player_weekly_challenge_info.today_reward_info[i].is_get = flag
		end
	end
	GameKernel:getInstance():write_player_weekly_challenge_data()
end

function Player:get_player_weekly_challenge_today_reward_info_is_get_by_id(today_reward_id)
	for i=1, #self.player_weekly_challenge_info.today_reward_info do
		if self.player_weekly_challenge_info.today_reward_info[i].today_reward_id == today_reward_id then
			return self.player_weekly_challenge_info.today_reward_info[i].is_get
		end
	end
end

function Player:set_player_weekly_challenge_today_reward_info(today_reward_info)
	self.player_weekly_challenge_info.today_reward_info = today_reward_info
	GameKernel:getInstance():write_player_weekly_challenge_data()
end

function Player:get_player_weekly_challenge_today_reward_info()
	return self.player_weekly_challenge_info.today_reward_info
end

function Player:set_player_weekly_challenge_week_reward_info_is_get_by_id(week_reward_id, flag)
	for i=1, #self.player_weekly_challenge_info.week_reward_info do
		if self.player_weekly_challenge_info.week_reward_info[i].week_reward_id == week_reward_id then
			self.player_weekly_challenge_info.week_reward_info[i].is_get = flag
		end
	end
	GameKernel:getInstance():write_player_weekly_challenge_data()
end

function Player:get_player_weekly_challenge_week_reward_info_is_get_by_id(week_reward_id)
	for i=1, #self.player_weekly_challenge_info.week_reward_info do
		if self.player_weekly_challenge_info.week_reward_info[i].week_reward_id == week_reward_id then
			return self.player_weekly_challenge_info.week_reward_info[i].is_get
		end
	end
end

function Player:set_player_weekly_challenge_week_reward_info(week_reward_info)
	self.player_weekly_challenge_info.week_reward_info = week_reward_info
	GameKernel:getInstance():write_player_weekly_challenge_data()
end

function Player:get_player_weekly_challenge_week_reward_info()
	return self.player_weekly_challenge_info.week_reward_info
end


-- 每日任务接口
function Player:get_player_daily_task_info_vector()
	return self.player_daily_task_info_vector
end

function Player:set_player_daily_task_info_vector(player_daily_task_info_vector)
	self.player_daily_task_info_vector = player_daily_task_info_vector
end

function Player:get_player_daily_task_info_by_id(task_id)
	for i=1, #self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			return self.player_daily_task_info_vector[i]
		end
	end
end

function Player:set_player_daily_task_info_by_id(task_id, player_daily_task_info)
	for i=1,#self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			self.player_daily_task_info_vector[i] = player_daily_task_info
		end
	end
end

function Player:set_player_daily_task_finish_count_by_id(task_id, finish_count)
	for i=1,#self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			self.player_daily_task_info_vector[i].finish_count = finish_count
		end
	end
	GameKernel:getInstance():write_player_daily_task_data()
end

function Player:get_player_daily_task_finish_count_by_id(task_id)
	for i=1,#self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			return self.player_daily_task_info_vector[i].finish_count
		end
	end
end

function Player:set_player_daily_task_reward_info_is_get_by_id(task_id, flag)
	for i=1, #self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			self.player_daily_task_info_vector[i].is_get = flag
		end
	end
	GameKernel:getInstance():write_player_daily_task_data()
end

function Player:get_player_daily_task_reward_info_is_get_by_id(task_id)
	for i=1, #self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			return self.player_daily_task_info_vector[i].is_get
		end
	end
end

function Player:set_player_daily_task_reward_info_is_choose_by_id(task_id, flag)
	for i=1, #self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			self.player_daily_task_info_vector[i].is_choose = flag
		end
	end
	GameKernel:getInstance():write_player_daily_task_data()
end

function Player:get_player_daily_task_reward_info_is_choose_by_id(task_id)
	for i=1, #self.player_daily_task_info_vector do
		if self.player_daily_task_info_vector[i].task_id == task_id then
			return self.player_daily_task_info_vector[i].is_choose
		end
	end
end


-- 成就任务接口

function Player:get_player_achv_info_vector()
	return self.player_achv_info_vector
end

function Player:set_player_achv_info_vector(player_achv_info_vector)
	self.player_achv_info_vector = player_achv_info_vector
end

function Player:get_player_achv_info_by_id(achv_id)
	for i=1, #self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			return self.player_achv_info_vector[i]
		end
	end
end

function Player:set_player_achv_info_by_id(achv_id, player_achv_info)
	for i=1,#self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			self.player_achv_info_vector[i] = player_achv_info
		end
	end
end

function Player:set_player_achv_finish_count_by_id(achv_id, finish_count)
	for i=1,#self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			self.player_achv_info_vector[i].finish_count = finish_count
		end
	end
	GameKernel:getInstance():write_player_achv_data()
end

function Player:get_player_achv_finish_count_by_id(achv_id)
	for i=1,#self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			return self.player_achv_info_vector[i].finish_count
		end
	end
end

function Player:set_player_achv_info_is_get_by_id_and_stage(achv_id, stage, flag)
	for i=1, #self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			for j=1,5 do
				if self.player_achv_info_vector[i].stage_info_vector[j].stage_id == stage then
					self.player_achv_info_vector[i].stage_info_vector[j].is_get = flag
				end
			end
		end
	end
	GameKernel:getInstance():write_player_achv_data()
end

function Player:get_player_achv_info_reward_info_is_get_by_id_and_stage(achv_id, stage)
	for i=1, #self.player_achv_info_vector do
		if self.player_achv_info_vector[i].achv_id == achv_id then
			for j=1,5 do
				if self.player_achv_info_vector[i].stage_info_vector[j].stage_id == stage then
					return self.player_achv_info_vector[i].stage_info_vector[j].is_get
				end
			end
		end
	end
end

-- 邀请奖励数据
function Player:get_player_invite_reward_info_vector()
	return self.player_invite_reward_info_vector
end

function Player:set_player_invite_reward_info_vector(player_invite_reward_info_vector)
	self.player_invite_reward_info_vector = player_invite_reward_info_vector
end

function Player:get_player_invite_reward_info_by_id(invite_id)
	for i=1, #self.player_invite_reward_info_vector do
		if self.player_invite_reward_info_vector[i].invite_id == invite_id then
			return self.player_invite_reward_info_vector[i]
		end
	end
end

function Player:set_player_invite_reward_info_by_id(invite_id, player_invite_reward_info)
	for i=1, #self.player_invite_reward_info_vector do
		if self.player_invite_reward_info_vector[i].invite_id == invite_id then
			self.player_invite_reward_info_vector[i] = player_invite_reward_info
		end
	end
end

function Player:set_player_invite_reward_info_is_get(invite_id)
	for i=1, #self.player_invite_reward_info_vector do
		if self.player_invite_reward_info_vector[i].invite_id == invite_id then
			self.player_invite_reward_info_vector[i].is_get = true
		end
	end
	GameKernel:getInstance():write_player_invite_reward_data()
end

function Player:get_is_all_get_player_invite_reward_info()
	local flag = true
	for i=1, #self.player_invite_reward_info_vector do
		if self.player_invite_reward_info_vector[i].is_get == false then
			flag = false
		end
	end
	return flag
end
--

function Player:check_is_buy_gift(callback)
	local function create_warningLayer()
		local warningLayer = WarningLayer:create()
        warningLayer:set_text_string(ResourceManager:getInstance():getTextStringByKey("needJewel"))
        LayerManager:getInstance():add_layer_to_scene(warningLayer)
	end
	if self:get_is_buy_springsale() then
        if self:get_is_buy_limit_gift() then
            callback()
        else
            local limitGiftLayer = LimitGiftLayer:create()
            LayerManager:getInstance():add_layer_to_scene(limitGiftLayer)
            create_warningLayer()
        end
    else
        local springsaleLayer = SpringsaleLayer:create()
        LayerManager:getInstance():add_layer_to_scene(springsaleLayer)
        create_warningLayer()
    end
end

function Player:getInstance()
	Player.instance = Player.instance or Player:create()
	return Player.instance
end

return Player 