Role_Data = class("Role_Data")

function Role_Data:ctor()
	self.role_info_vector = require "script/role_info.lua"
	self.role_info_vector_id = {}
	for k,v in pairs(self.role_info_vector) do
		self.role_info_vector_id[v.role_id] = v
	end

	self.role_level_vector = {}
	self.role_level_vector["role_101"] = require "script/role_101.lua"
	self.role_level_vector["role_201"] = require "script/role_201.lua"
	self.role_level_vector["role_301"] = require "script/role_301.lua"
	self.role_level_vector["role_401"] = require "script/role_401.lua"
	self.role_level_vector["role_501"] = require "script/role_501.lua"
end

function Role_Data:get_role_info_vector()
	return self.role_info_vector
end

function Role_Data:get_role_info_by_id(role_id)
	return self.role_info_vector_id[role_id]
end

function Role_Data:get_role_level_vector_by_id(role_id)
	return self.role_level_vector[role_id]
end

function Role_Data:get_role_level_by_id_level(role_id, level)
	level = math.max(level, 1)
	return self.role_level_vector[role_id][level]
end

function Role_Data:get_first_skin_id_by_role_id(role_id)
	local role_info = self.role_info_vector_id[role_id]
	return role_info.skin_id_list[1]
end

function Role_Data:getInstance()
	Role_Data.instance = Role_Data.instance or Role_Data:create()
	return Role_Data.instance
end

return Role_Data 