TalkingDataManager = class("TalkingDataManager")

function TalkingDataManager:ctor()
	self.JewelAmount = 0
end

function TalkingDataManager:getInstance()
    TalkingDataManager.instance = TalkingDataManager.instance or TalkingDataManager:create()
    return TalkingDataManager.instance
end

function TalkingDataManager:send(event_label, data_table)
    if TalkingData then
        TalkingData.send("", event_label, data_table)
    end
    
end

function TalkingDataManager:sendMissionInfo(type, missionId, cause)
    if cause == nil then
        cause = ""
    end

    if TalkingData then
        TalkingData.sendMissionInfo(type, missionId, cause)
    end 
end

function TalkingDataManager:sendOnChargeRequest(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
    if TalkingData then
        if virtualCurrencyAmount == 0 then
            virtualCurrencyAmount = self.JewelAmount
            self.JewelAmount = 0
        end
        TalkingData.sendOnChargeRequest(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
    end    
end

function TalkingDataManager:sendOnChargeSuccess(orderId)
    if TalkingData then
        TalkingData.sendOnChargeSuccess(orderId)
    end    
end

function TalkingDataManager:sendOnReward(amount, reason)
    if TalkingData then
        TalkingData.sendOnReward(amount, reason)
    end    
end

function TalkingDataManager:sendOnPurchase(item, itemNumber, price)
    if TalkingData then
        TalkingData.sendOnPurchase(item, itemNumber, price)
    end    
end

function TalkingDataManager:sendOnUse(item, itemNumber)
    if TalkingData then
        TalkingData.sendOnUse(item, itemNumber)
    end    
end

function TalkingDataManager:sendOrderJewelAmount(amount)
    if TalkingData then
        TalkingData.sendOrderJewelAmount(amount)
    end    
    self.JewelAmount = amount
end

function TalkingDataManager:getMd5()
    if TalkingData then
        return TalkingData.getMd5()
    end  
end

function TalkingDataManager:send_for_score(level_index, curScore)

    local str_score_scetion = "0~10"
    local stats_score_section_info_vector = require "script.stats_score_section_info"
    local count = get_table_length(stats_score_section_info_vector)
    for i=1,count do
        if curScore <= stats_score_section_info_vector[i].max_score then
            str_score_scetion = stats_score_section_info_vector[i].score_scetion
            break
        end
    end

    local str_level = "关卡"..level_index
    self:send("每关的分数段统计", {[str_level] = str_score_scetion})
    
end

function TalkingDataManager:send_for_finish_time(level_index, finish_time)
    
    local str_time_scetion = "0~10"
    local stats_finish_time_section_info_vector = require "script.stats_finish_time_section_info"
    local count = get_table_length(stats_finish_time_section_info_vector)
    for i=1,count do
        if finish_time <= stats_finish_time_section_info_vector[i].max_time then
            str_time_scetion = stats_finish_time_section_info_vector[i].time_scetion
            break
        end
    end

    local str_level = "关卡"..level_index
    self:send("每关的通关时间段统计", {[str_level] = str_time_scetion})
    
end

function TalkingDataManager:send_for_use_step(level_index, use_step)
    
    local str_step_scetion = "0"
    local stats_use_step_section_info_vector = require "script.stats_use_step_section_info"
    local count = get_table_length(stats_use_step_section_info_vector)
    for i=1,count do
        if use_step <= stats_use_step_section_info_vector[i].max_step then
            str_step_scetion = stats_use_step_section_info_vector[i].step_scetion
            break
        end
    end

    local str_level = "关卡"..level_index
    self:send("每关的使用步数段统计", {[str_level] = str_step_scetion})
    
end

function TalkingDataManager:send_for_surplus_step(level_index, surplus_step)
    
    local str_step_scetion = "0"
    local stats_surplus_step_section_info_vector = require "script.stats_surplus_step_section_info"
    local count = get_table_length(stats_surplus_step_section_info_vector)
    for i=1,count do
        if surplus_step <= stats_surplus_step_section_info_vector[i].max_step then
            str_step_scetion = stats_surplus_step_section_info_vector[i].step_scetion
            break
        end
    end

    local str_level = "关卡"..level_index
    self:send("每关的剩余步数段统计", {[str_level] = str_step_scetion})
    
end

function TalkingDataManager:send_for_boss_blood_remain(level_index, boss_blood_remain)
    
    local str_blood_scetion = "0~10"
    local stats_boss_blood_remain_section_info_vector = require "script.stats_boss_blood_remain_section_info"
    local count = get_table_length(stats_boss_blood_remain_section_info_vector)
    for i=1,count do
        if boss_blood_remain <= stats_boss_blood_remain_section_info_vector[i].max_blood then
            str_blood_scetion = stats_boss_blood_remain_section_info_vector[i].blood_scetion
            break
        end
    end

    local str_level = "关卡"..level_index
    self:send("每关BOSS血量段统计", {[str_level] = str_blood_scetion})
    
end

function TalkingDataManager:send_for_stats_conch_count(conch_count)
    
    local str_conch_count_scetion = "0"
    local stats_weekly_challenge_conch_count_section_info = require "script.stats_weekly_challenge_conch_count_section_info"
    local count = get_table_length(stats_weekly_challenge_conch_count_section_info)
    for i=1,count do
        if conch_count < stats_weekly_challenge_conch_count_section_info[i].max_count then
            str_conch_count_scetion = stats_weekly_challenge_conch_count_section_info[i].count_scetion
            break
        end
    end

    self:send("周赛贝壳数统计", {["贝壳总数"] = str_conch_count_scetion})
    
end

function TalkingDataManager:send_for_stats_conch_once_num(conch_once_num)
    
    local str_conch_once_num_scetion = "0"
    local stats_weekly_challenge_conch_once_num_section_info = require "script.stats_weekly_challenge_conch_once_num_section_info"
    local count = get_table_length(stats_weekly_challenge_conch_once_num_section_info)
    for i=1,count do
        if conch_once_num < stats_weekly_challenge_conch_once_num_section_info[i].max_once_num then
            str_conch_once_num_scetion = stats_weekly_challenge_conch_once_num_section_info[i].once_num_scetion
            break
        end
    end

    self:send("周赛贝壳数统计", {["单次贝壳数"] = str_conch_once_num_scetion})
    
end

return TalkingDataManager